# Alpine, a global solver for non-convex MINLPs

[![CI](https://github.com/lanl-ansi/Alpine.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/lanl-ansi/Alpine.jl/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/lanl-ansi/Alpine.jl/branch/master/badge.svg)](https://codecov.io/gh/lanl-ansi/Alpine.jl)
[![Documentation](https://github.com/lanl-ansi/Alpine.jl/actions/workflows/documentation.yml/badge.svg)](https://lanl-ansi.github.io/Alpine.jl/latest/) 
[![version](https://juliahub.com/docs/Alpine/version.svg)](https://juliahub.com/ui/Packages/Alpine/TRSJF)

ALPINE (glob(AL) o(P)timization for mixed-(I)nteger programs with (N)onlinear (E)quations), is a novel global optimization solver that uses an adaptive, piecewise convexification scheme and constraint programming methods to solve non-convex Mixed-Integer Non-Linear Programs (MINLPs) efficiently. MINLPs are typically "hard" optimization problems which appear in numerous applications (see [MINLPLib.jl](https://github.com/lanl-ansi/MINLPLib.jl)). 

Alpine is entirely built upon [JuMP](https://github.com/jump-dev/JuMP.jl) and [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl) in Julia, which provides incredible flexibility for usage and further development.

Alpine globally solves a given MINLP by:

* Analyzing the problem's expressions (objective & constraints) and applies appropriate convex relaxations and polyhedral outer-approximations

* Performing sequential optimization-based bound tightening (OBBT) and an iterative MIP-based adaptive partitioning scheme via piecewise polyhedral relaxations with a guarantee of global convergence

Upon Alpine's convergence, for a given relative gap tolerance `ε`, the user is guaranteed that the global optimal solution is in the `ε`-neighborhood of the solution found by the solver.

## Installation

Install Alpine using the Julia package manager:

```julia
import Pkg
Pkg.add("Alpine")
```

## Usage with JuMP

Use Alpine with [JuMP](https://github.com/jump-dev/JuMP.jl) as follows:

```julia
using JuMP, Alpine, Ipopt, HiGHS
ipopt = optimizer_with_attributes(Ipopt.Optimizer, "print_level" => 0)
highs = optimizer_with_attributes(HiGHS.Optimizer, "output_flag" => false)
model = Model(
    optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => ipopt,
        "mip_solver" => highs,
    ),
)
```

## Documentation

For more details, see the [online documentation](https://lanl-ansi.github.io/Alpine.jl/latest/).

## Support problem types

Alpine can currently handle MINLPs with polynomials in constraints and/or in the objective. Currently, there is no support for exponential cones and Positive Semi-Definite (PSD) cones in MINLPs. Alpine is also a good fit for subsets of the MINLP family, for example, Mixed-Integer Quadratically Constrained Quadratic Programs (MIQCQPs), Non-Linear Programs (NLPs), etc.

For more details, check out this [video](https://www.youtube.com/watch?v=mwkhiEIS5JA) on Alpine.jl at [JuMP-dev 2018](http://www.juliaopt.org/meetings/bordeaux2018/).

## Underlying solvers

Though an MIP-based bounding algorithm implemented in Alpine is quite involved, most of the computational bottleneck arises in the underlying MIP solvers. Since every iteration of Alpine solves an MIP sub-problem, which is typically a convex MILP/MIQCQP, Alpine's run time heavily depends on the run-time of these solvers. For the best performance of Alpine, we recommend using the commercial solver [Gurobi](https://www.gurobi.com), which is available [free](https://www.gurobi.com/academia/academic-program-and-licenses/) for academic purposes. However, due to the flexibility offered by [JuMP](https://github.com/jump-dev/JuMP.jl), the following MIP and NLP solvers are supported in Alpine: 


| Solver                                                                         | Julia Package                                                |
|--------------------------------------------------------------------------------|--------------------------------------------------------------|
| [Gurobi](http://gurobi.com/)                                                   | [Gurobi.jl](https://github.com/jump-dev/Gurobi.jl)           |
| [CPLEX](https://www.ibm.com/analytics/cplex-optimizer) | [CPLEX.jl](https://github.com/jump-dev/CPLEX.jl)             |
| [HiGHS](https://highs.dev/)            | [HiGHS.jl](https://github.com/jump-dev/HiGHS.jl)
| [Cbc](https://projects.coin-or.org/Cbc)                                        | [Cbc.jl](https://github.com/jump-dev/Cbc.jl)                 |
| [Ipopt](https://projects.coin-or.org/Ipopt)                                    | [Ipopt.jl](https://github.com/jump-dev/Ipopt.jl)             |
| [Bonmin](https://projects.coin-or.org/Bonmin)                                  | [Bonmin.jl](https://github.com/jump-dev/AmplNLWriter.jl)   |
| [Artelys KNITRO](http://artelys.com/en/optimization-tools/knitro)              | [KNITRO.jl](https://github.com/jump-dev/KNITRO.jl)           |
| [Xpress](https://www.fico.com/en/products/fico-xpress-optimization)            | [Xpress.jl](https://github.com/jump-dev/Xpress.jl)

## Bug reports and support

Please report any issues via the GitHub [issue tracker](https://github.com/lanl-ansi/Alpine.jl/issues).
All types of issues are welcome and encouraged; this includes bug reports, documentation typos, feature requests, etc. 

## Challenging Problems

We are seeking out hard benchmark instances for MINLPs. Please get in touch either by opening an issue or [privately](https://harshangrjn.github.io/#contact) if you would like to share any hard instances.

## Citing Alpine

If you find Alpine useful in your work, we kindly request that you cite the following papers ([PDF](http://harshangrjn.github.io/pdf/JOGO_2018.pdf), [PDF](http://harshangrjn.github.io/pdf/CP_2016.pdf))
```bibtex
@article{alpine_JOGO2019,
  title = {An adaptive, multivariate partitioning algorithm for global optimization of nonconvex programs},
  author = {Nagarajan, Harsha and Lu, Mowen and Wang, Site and Bent, Russell and Sundar, Kaarthik},
  journal = {Journal of Global Optimization},
  year = {2019},
  issn = {1573-2916},
  doi = {10.1007/s10898-018-00734-1},
}

@inproceedings{alpine_CP2016,
  title = {Tightening {McCormick} relaxations for nonlinear programs via dynamic multivariate partitioning},
  author = {Nagarajan, Harsha and Lu, Mowen and Yamangil, Emre and Bent, Russell},
  booktitle = {International Conference on Principles and Practice of Constraint Programming},
  pages = {369--387},
  year = {2016},
  organization = {Springer},
  doi = {10.1007/978-3-319-44953-1_24},
}
```

If you find the underlying piecewise polyhedral formulations implemented in Alpine useful in your work, we kindly request that you cite the following papers ([link-1](https://doi.org/10.1016/j.orl.2020.12.002), [link-2](http://www.optimization-online.org/DB_HTML/2022/07/8974.html)): 
```bibtex
@article{alpine_ORL2021,
  title = {Piecewise polyhedral formulations for a multilinear term},
  author = {Sundar, Kaarthik and Nagarajan, Harsha and Linderoth, Jeff and Wang, Site and Bent, Russell},
  journal = {Operations Research Letters},
  volume = {49},
  number = {1},
  pages = {144--149},
  year = {2021},
  publisher = {Elsevier}
}

@article{alpine_OptOnline2022,
  title={Piecewise Polyhedral Relaxations of Multilinear Optimization},
  author={Kim, Jongeun and Richard, Jean-Philippe P. and Tawarmalani, Mohit},
  eprinttype={Optimization Online},
  date={2022}
}
```

# Documentation for Alpine

## Installation
Alpine's documentation is generated using [Documenter.jl](https://github.com/JuliaDocs/Documenter.jl). To install it, run the following command in a Julia session:

```julia
Pkg.add("Documenter")
Pkg.add("DocumenterTools")
```

## Building the Docs
To preview the `html` output of the documents, run the following command:

```julia
julia --color=yes make.jl
```

You can then view the documents in `build/index.html`.

# Examples for Alpine
`run_examples.jl` file contains the main driver file which can be executed to compute global optimality for a non-convex MINLP of your choice. Multiple such JuMP models of MINLPs can be found inside the `examples/MINLPs` folder.

A few useful **hints** to explore within Alpine: 
* Try different integer values (>= 4) for `partition_scaling_factor` to potentially observe 
    better Alpine run times, which can be instance specific.
* Choose `presolve_bt` to `false` if you prefer the optimization-based bound tightening (OBBT) presolve to be turned off. 
* If you prefer to use Alpine for only OBBT presolve, without any paritioning applied to the 
    nonlinear terms, include option `"apply_partitioning"` and set it to `false` while initializing the 
    Alpine solver. 
* If the nonconvex instance you want to solve has binary variables (i.e., a MINLP like in [here](https://github.com/lanl-ansi/Alpine.jl/blob/32757b2568acfe71257e41ed4122a120717a6460/examples/MINLPs/blend.jl#LL1C1-L1C1), then include a local MINLP solver as an additional attribute while initializing `Alpine.Optimizer` in `run_examples.jl`. 

# Random families of non-convex QCQPs
Scripts for generating homogeneous families of nonconvex QCQP instances, useful for benchmarking ML-based models for tuning certain algorithmic parameters of global optimization, can be found [here](https://github.com/lanl-ansi/Alpine.jl/tree/master/examples/random_QCQPs). 

# Random families of non-convex QCQPs 
Scripts for generating a family of random non-convex quadratically-constrained quadratic programs (QCQPs) instances in Section 5 of the paper "Learning to Accelerate the Global Optimization of Quadratically-Constrained Quadratic Programs" by R. Kannan, H. Nagarajan, and D. Deka ([arXiv](https://arxiv.org/abs/2301.00306)). As discussed in the aforementioned paper, these homogeneous families of instances can be very useful for benchmarking machine learning-based models for tuning certain algorithmic parameters of global optimization.

Instances in the above paper were generated using Python 3.8.5 and NumPy 1.19.2.

To generate 1000 random bilinear instances with `N` variables (`N = 10, 20, 50`), run
```
python3 generate_bilinear_instances.py --numVariables N --numInstances 1000
```

To generate 1000 random QCQP instances (including both bilinear and univariate quadratic terms) with `N` variables (`N = 10, 20, 50`), run
```
python3 generate_qcqp_instances.py --numVariables N --numInstances 1000
```

To generate 1000 random pooling instances, run
```
python3 generate_pooling_instances.py --numInstances 1000
```
Additional data files for generating the pooling instances can be found within the `pooling` folder. These data files were generated using the scripts [here](https://github.com/poolinginstances/poolinginstances).


If you find these instances useful in your work, we kindly request that you cite the following paper [arXiv link](https://arxiv.org/abs/2301.00306):
```bibtex
@article{alpine_learning_2022,
  title={Learning to Accelerate the Global Optimization of Quadratically-Constrained Quadratic Programs},
  author={Kannan, Rohit and Nagarajan, Harsha and Deka, Deepjyoti},
  journal={arXiv preprint:2301.00306},
  url={https://arxiv.org/abs/2301.00306},
  year={2022}
}
```

using JuMP
using Test

import Alpine
import HiGHS
import Ipopt
import Juniper
import Pavito
import Random

const _EXAMPLES_DIR = joinpath(@__DIR__, "..", "examples", "MINLPs")
for file in readdir(_EXAMPLES_DIR)
    include(joinpath(_EXAMPLES_DIR, file))
end

const IPOPT = MOI.OptimizerWithAttributes(
    Ipopt.Optimizer,
    MOI.Silent() => true,
    "sb" => "yes",
    "max_iter" => 9999,
)

const HIGHS = MOI.OptimizerWithAttributes(
    HiGHS.Optimizer,
    "presolve" => "on",
    "log_to_console" => false,
    # "small_matrix_value" => 1e-12,
    # "allow_unbounded_or_infeasible" => true,
)

const JUNIPER = MOI.OptimizerWithAttributes(
    Juniper.Optimizer,
    MOI.Silent() => true,
    "mip_solver" => HIGHS,
    "nl_solver" => IPOPT,
)
const PAVITO = MOI.OptimizerWithAttributes(
    Pavito.Optimizer,
    MOI.Silent() => true,
    "mip_solver" => HIGHS,
    "cont_solver" => IPOPT,
    "mip_solver_drives" => false,
)

function _build(model::JuMP.Model)
    JuMP.set_optimize_hook(model, MOI.Utilities.attach_optimizer)
    JuMP.optimize!(model)
    JuMP.JuMP.set_optimize_hook(model, nothing)
    alpine = JuMP.backend(model).optimizer.model
    Alpine.load!(alpine)
    return alpine
end

# Perform Tests
@testset "Alpine tests" begin
    include(joinpath(@__DIR__, "test_solver.jl"))
    include(joinpath(@__DIR__, "test_expression.jl"))
    include(joinpath(@__DIR__, "test_algorithm.jl"))
    include(joinpath(@__DIR__, "test_utility.jl"))
end

# Reference: https://direct.mit.edu/evco/article/14/1/119/1232/A-Note-on-the-Extended-Rosenbrock-Function
# Global optimum = 0.0, arg min = (1,1)

function rosenbrock(; solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, -10 <= x <= 10)
    @variable(m, -10 <= y <= 10)

    @NLobjective(m, Min, 100 * (y - x^2)^2 + (1 - x)^2)

    return m
end

function basic_linear_lift(; verbose = false, solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, x[i = 1:3] >= 1) # At some point if an initial value is given, keep them
    @constraint(m, (x[1] - x[2]) * (3 * x[2] - x[3]) >= 111)
    @NLconstraint(m, (x[1] - x[2]) * (3 * x[2] - x[3]) >= 111)
    @NLconstraint(m, (x[1] - x[2])^2 >= 100)
    @NLconstraint(m, (x[1] - x[2]) * (3 * x[2] - x[3]) * (x[1] + x[3]) >= 111)
    @NLconstraint(m, (3 + x[1] + x[2] + x[3]) * (x[1] + x[2])^2 >= 111)

    # Next level goal
    # @NLconstraint(m, (9-x[1]-x[2]-x[3])^2 >= 111)

    @objective(m, Min, x[1] + x[2] + x[3])

    return m
end

"""
    Ranking of variables involved in nonlinear terms for piecewise adaptive partitioning:
    Ranked based on the absolute gap between each variable's solution from the lower-bounding MIP and the best feasible solution to the MINLP.
    Currently doesn't support recursive convexification
"""
function update_disc_cont_var(m::Optimizer)
    length(m.candidate_disc_vars) <= 15 && return   # Algorithm Separation Point

    var_idxs = copy(m.candidate_disc_vars)
    var_diffs = Vector{Float64}(
        undef,
        m.num_var_orig + length(keys(m.linear_terms)) + length(keys(m.nonconvex_terms)),
    )

    for i in 1:m.num_var_orig       # Original Variables
        var_diffs[i] = abs(m.best_sol[i] - m.best_bound_sol[i])
    end

    !isempty(m.linear_terms) && (var_diffs = _eval_var_diffs!(m.linear_terms, var_diffs))
    !isempty(m.nonconvex_terms) &&
        (var_diffs = _eval_var_diffs!(m.nonconvex_terms, var_diffs))

    distance = Dict(zip(var_idxs, var_diffs))
    weighted_min_vertex_cover(m, distance)

    (get_option(m, :log_level) > 100) &&
        println("updated partition var selection => $(m.disc_vars)")
    return
end

# Helper function for sequential evaluation to avoid dependency issue
function _eval_var_diffs!(terms::Dict{Any,Any}, var_diffs::Vector{Float64})
    for i in 1:length(keys(terms))
        for j in keys(terms)
            if terms[j][:id] == i
                var_diffs[terms[j][:lifted_var_ref].args[2]] =
                    terms[j][:evaluator](terms[j], var_diffs)
            end
        end
    end

    return var_diffs
end

const ALPINE_C_NLTERMS = [
    :BILINEAR,
    :MONOMIAL,
    :MULTILINEAR,
    :BININT,
    :BINLIN,
    :INTLIN,
    :BINPROD,
    :INTPROD,
    :cos,
    :sin,
]
const ALPINE_C_MONOMIAL = [:BILINEAR, :MONOMIAL, :MULTILINEAR]
const ALPINE_C_TRIGONOMETRIC = [:sin, :cos]

const STATUS_LIMIT = [
    MOI.ITERATION_LIMIT,
    MOI.TIME_LIMIT,
    MOI.NODE_LIMIT,
    MOI.SOLUTION_LIMIT,
    MOI.MEMORY_LIMIT,
    MOI.OBJECTIVE_LIMIT,
    MOI.NORM_LIMIT,
    MOI.OTHER_LIMIT,
]
const STATUS_OPT =
    [MOI.OPTIMAL, MOI.LOCALLY_SOLVED, MOI.ALMOST_OPTIMAL, MOI.ALMOST_LOCALLY_SOLVED]

const STATUS_WARM_START = [MOI.OPTIMIZE_NOT_CALLED]

const STATUS_INF = [MOI.INFEASIBLE, MOI.LOCALLY_INFEASIBLE]

function features_available(m::Optimizer)
    features = [:Grad, :Jac, :JacVec, :ExprGraph]
    if !m.disable_hessian
        push!(features, :Hess)
        push!(features, :HessVec)
    end

    return features
end

function load!(m::Optimizer)

    # Initialize NLP interface
    requested_features = features_available(m)
    if m.d_orig !== nothing
        MOI.initialize(m.d_orig, requested_features::Vector{Symbol})
    end
    for feat in requested_features
        if !(feat in features_available(m))
            error("Unsupported feature $feat")
        end
    end

    # Collect objective & constraint expressions
    if m.has_nl_objective
        m.obj_expr_orig =
            expr_isolate_const(_variable_index_to_index(MOI.objective_expr(m.d_orig))) # see in nlexpr.jl if this expr isolation has any issue
    elseif m.objective_function isa Nothing
        m.obj_expr_orig = Expr(:call, :+)
    else
        m.obj_expr_orig = _moi_function_to_expr(m.objective_function)
    end

    # Collect original variable type and build dynamic variable type space
    m.var_type = copy(m.var_type_orig)
    m.int_vars = [i for i in 1:m.num_var_orig if m.var_type[i] == :Int]
    m.bin_vars = [i for i in 1:m.num_var_orig if m.var_type[i] == :Bin]

    if !isempty(m.int_vars) || !isempty(m.bin_vars)
        (get_option(m, :minlp_solver) === nothing) && (error(
            "No MINLP local solver specified; use option 'minlp_solver' to specify a MINLP local solver",
        ))
    end

    m.num_constr_orig += length(m.nl_constraint_bounds_orig)
    m.num_nlconstr_orig += length(m.nl_constraint_bounds_orig)
    append!(m.constraint_bounds_orig, m.nl_constraint_bounds_orig)
    for i in eachindex(m.nl_constraint_bounds_orig)
        push!(
            m.constr_expr_orig,
            _variable_index_to_index(MOI.constraint_expr(m.d_orig, i)),
        )
        push!(m.constr_structure, :generic_nonlinear)
    end

    # Summarize constraints information in original model
    m.constr_type_orig = Array{Symbol}(undef, m.num_constr_orig)

    for i in 1:m.num_constr_orig
        if m.constraint_bounds_orig[i].lower > -Inf &&
           m.constraint_bounds_orig[i].upper < Inf
            m.constr_type_orig[i] = :(==)
        elseif m.constraint_bounds_orig[i].lower > -Inf
            m.constr_type_orig[i] = :(>=)
        else
            m.constr_type_orig[i] = :(<=)
        end
    end

    # Initialize recognizable structure properties with :none
    m.obj_structure = :none

    @assert m.num_constr_orig == m.num_nlconstr_orig + m.num_lconstr_orig
    m.is_obj_linear_orig =
        !m.has_nl_objective && m.objective_function isa MOI.ScalarAffineFunction{Float64}
    m.is_obj_linear_orig ? (m.obj_structure = :generic_linear) :
    (m.obj_structure = :generic_nonlinear)
    isa(m.obj_expr_orig, Number) && (m.obj_structure = :constant)

    # Populate data to create the bounding MIP model
    recategorize_var(m)             # Initial round of variable re-categorization

    # Solver-dependent detection
    _fetch_mip_solver_identifier(m)
    _fetch_nlp_solver_identifier(m)
    _fetch_minlp_solver_identifier(m)

    # Main Algorithmic Initialization
    process_expr(m)                         # Compact process of every expression
    init_tight_bound(m)                     # Initialize bounds for algorithmic processes
    resolve_var_bounds(m)                   # resolve lifted var bounds
    pick_disc_vars(m)                       # Picking variables to be discretized
    init_disc(m)                            # Initialize discretization dictionaries

    # Turn-on bt presolve if variables are not discrete
    if isempty(m.int_vars) &&
       length(m.bin_vars) <= 50 &&
       m.num_var_orig <= 10000 &&
       length(m.candidate_disc_vars) <= 300 &&
       get_option(m, :presolve_bt) == nothing
        set_option(m, :presolve_bt, true)
        println("Automatically turning on bound-tightening presolve")
    elseif get_option(m, :presolve_bt) == nothing  # If no use indication
        set_option(m, :presolve_bt, false)
    end

    if length(m.bin_vars) > 200 || m.num_var_orig > 2000
        println(
            "Automatically turning OFF 'partition_scaling_factor_branch' due to the size of the problem",
        )
        set_option(m, :partition_scaling_factor_branch, false)
    end

    # Initialize the solution pool
    m.bound_sol_pool = initialize_solution_pool(m, 0)  # Initialize the solution pool

    # Check if any illegal term exist in the warm-solution
    any(isnan, m.best_sol) && (m.best_sol = zeros(length(m.best_sol)))

    # Initialize log
    logging_summary(m)

    return
end

"""
   High-level Function
"""
function MOI.optimize!(m::Optimizer)
    load!(m)
    if getproperty(m, :presolve_infeasible)
        summary_status(m)
        return
    end

    presolve(m)

    if !check_exit(m) && get_option(m, :apply_partitioning)
        global_solve(m)
        get_option(m, :log_level) > 0 && logging_row_entry(m, finish_entry = true)
        println(
            "====================================================================================================",
        )
    end

    summary_status(m)

    return
end

"""
   global_solve(m::Optimizer)

Perform global optimization algorithm that is based on the adaptive piecewise convexification.
This iterative algorithm loops over [`bounding_solve`](@ref) and [`local_solve`](@ref) until the optimality gap between the lower bound (relaxed problem with min. objective) and the upper bound (feasible problem) is within the user prescribed limits.
Each [`bounding_solve`](@ref) provides a lower bound that serves as the partitioning point for the next iteration (this feature can be modified given a different `add_adaptive_partition`).
Each [`local_solve`](@ref) provides an incumbent feasible solution. The algorithm terminates when atleast one of these conditions are satisfied: time limit, optimality condition, or iteration limit.

"""
function global_solve(m::Optimizer)
    get_option(m, :log_level) > 0 && logging_head(m)
    get_option(m, :presolve_track_time) || reset_timer(m)
    while !check_exit(m)
        m.logs[:n_iter] += 1
        create_bounding_mip(m)                  # Build the relaxation model
        bounding_solve(m)                       # Solve the relaxation model
        update_opt_gap(m)                       # Update optimality gap
        check_exit(m) && break                  # Feasibility check
        get_option(m, :log_level) > 0 && logging_row_entry(m)  # Logging
        local_solve(m)                          # Solve local model for feasible solution
        update_opt_gap(m)                       # Update optimality gap
        check_exit(m) && break                  # Detect optimality termination
        algorithm_automation(m)                 # Automated adjustments
    end

    return
end

"""
   presolve(m::Optimizer)
"""
function presolve(m::Optimizer)
    start_presolve = time()
    get_option(m, :log_level) > 0 &&
        printstyled("PRESOLVE \n", color = :cyan, bold = true)
    get_option(m, :log_level) > 0 && println("  Doing local search")

    if get_option(m, :use_start_as_incumbent)
        # Check for bound feasibility of the warm start value
        if !(m.l_var_orig <= m.warm_start_value <= m.u_var_orig)
            error(
                "Provide a valid, feasible, warm starting point. Else, set use_start_as_incumbent to false",
            )
        end

        obj_warmval = if m.has_nl_objective
            MOI.eval_objective(m.d_orig, m.warm_start_value)
        else
            MOI.Utilities.eval_variables(
                vi -> m.warm_start_value[vi.value],
                m.objective_function,
            )
        end
        update_incumbent(m, obj_warmval, m.warm_start_value)
        m.status[:local_solve] = MOI.OPTIMIZE_NOT_CALLED
        get_option(m, :log_level) > 0 && println(
            "  Using warm starting point as a local incumbent solution with value $(round(m.best_obj, digits=4))",
        )
    else
        local_solve(m, presolve = true)
    end

    # Solver status
    if m.status[:local_solve] in union(STATUS_OPT, STATUS_LIMIT, STATUS_WARM_START)
        if !get_option(m, :use_start_as_incumbent)
            get_option(m, :log_level) > 0 && println(
                "  Local solver returns a feasible point with value $(round(m.best_obj, digits=4))",
            )
        end
        bound_tightening_wrapper(m, use_bound = true)    # performs bound-tightening with the local solve objective value
        get_option(m, :presolve_bt) && init_disc(m)            # Re-initialize discretization dictionary on tight bounds
        get_option(m, :partition_scaling_factor_branch) && (set_option(
            m,
            :partition_scaling_factor,
            update_partition_scaling_factor(m, true),
        ))

    elseif m.status[:local_solve] in STATUS_INF
        (get_option(m, :log_level) > 0) &&
            println("  Bound tightening without objective bounds (OBBT)")
        bound_tightening_wrapper(m, use_bound = false)                      # do bound tightening without objective value
        (get_option(m, :partition_scaling_factor_branch)) && (set_option(
            m,
            :partition_scaling_factor,
            update_partition_scaling_factor(m, true),
        ))
        get_option(m, :presolve_bt) && init_disc(m)

    elseif m.status[:local_solve] == MOI.INVALID_MODEL
        @warn " Warning: Presolve ends with local solver yielding $(m.status[:local_solve]). \n This may come from Ipopt's `:Not_Enough_Degrees_Of_Freedom`."
    elseif !get_option(m, :use_start_as_incumbent)
        @warn " Warning: Presolve ends with local solver yielding $(m.status[:local_solve])."
    end

    cputime_presolve = time() - start_presolve
    m.logs[:presolve_time] += cputime_presolve
    m.logs[:total_time] = m.logs[:presolve_time]
    m.logs[:time_left] -= m.logs[:presolve_time]

    if get_option(m, :presolve_bt)
        (get_option(m, :log_level) > 0) && println(
            "  Post-presolve optimality gap: $(round(m.presolve_best_rel_gap; digits = 3))%",
        )
    end
    (get_option(m, :log_level) > 0) &&
        println("  Completed presolve in $(round.(m.logs[:total_time]; digits = 2))s")

    return
end

"""
   A wrapper function that collects automated solver adjustments within the main while loop.
"""
function algorithm_automation(m::Optimizer)

    # Only if a feasible solution is detected
    if (get_option(m, :disc_var_pick) == 3) && m.detected_incumbent
        update_disc_cont_var(m)
    end

    if get_option(m, :partition_scaling_factor_branch)
        set_option(m, :partition_scaling_factor, update_partition_scaling_factor(m, true))    # Only perform for a maximum three times
    end

    return
end

"""
   Summarized function to determine whether to interrupt the main while loop.
"""
function check_exit(m::Optimizer)

    # constant objective with feasible local solve check
    if expr_isconst(m.obj_expr_orig) &&
       (m.status[:local_solve] == MOI.OPTIMAL || m.status == MOI.LOCALLY_SOLVED)
        m.best_bound = m.obj_expr_orig
        m.best_rel_gap = 0.0
        m.best_abs_gap = 0.0
        m.status[:bounding_solve] = MOI.OPTIMAL
        m.alpine_status = :Optimal
        m.detected_bound = true
        return true
    end

    # Infeasibility check
    m.status[:bounding_solve] == MOI.INFEASIBLE && return true

    # Unbounded check
    m.status[:bounding_solve] == MOI.DUAL_INFEASIBLE && return true

    # Optimality check
    if m.best_rel_gap <= get_option(m, :rel_gap)
        m.detected_bound = true
        return true
    end
    m.logs[:n_iter] >= get_option(m, :max_iter) && return true
    m.best_abs_gap <= get_option(m, :abs_gap) && return true

    # User-limits check
    m.logs[:time_left] < get_option(m, :tol) && return true

    return false
end

function load_nonlinear_model(m::Optimizer, model::MOI.ModelLike, l_var, u_var)
    x = MOI.add_variables(model, m.num_var_orig)
    for i in eachindex(x)
        set = _bound_set(l_var[i], u_var[i])
        if set !== nothing
            MOI.add_constraint(model, x[i], set)
        end
    end
    for (func, set) in m.lin_quad_constraints
        MOI.add_constraint(model, func, set)
    end
    MOI.set(model, MOI.ObjectiveSense(), m.sense_orig)
    if m.objective_function !== nothing
        MOI.set(
            model,
            MOI.ObjectiveFunction{typeof(m.objective_function)}(),
            m.objective_function,
        )
    end

    if m.d_orig !== nothing
        block =
            MOI.NLPBlockData(m.nl_constraint_bounds_orig, m.d_orig, m.has_nl_objective)
        MOI.set(model, MOI.NLPBlock(), block)
    end

    return x
end

function set_variable_type(model::MOI.ModelLike, xs, variable_types)
    for (x, variable_type) in zip(xs, variable_types)
        if variable_type == :Int
            MOI.add_constraint(model, x, MOI.Integer())
        elseif variable_type == :Bin
            MOI.add_constraint(model, x, MOI.ZeroOne())
        else
            @assert variable_type == :Cont
        end
    end
end

"""
   local_solve(m::Optimizer, presolve::Bool=false)

Perform a local NLP or MINLP solve to obtain a feasible solution.
The `presolve` option is set to `true` when the function is invoked in [`presolve`](@ref).
Otherwise, the function is invoked from [`bounding_solve`](@ref).

"""
function local_solve(m::Optimizer; presolve = false)
    local_nlp_status = :Unknown

    var_type_screener = [i for i in m.var_type_orig if i in [:Bin, :Int]]

    if presolve
        if !isempty(var_type_screener) && get_option(m, :minlp_solver) !== nothing
            local_solve_model =
                MOI.instantiate(get_option(m, :minlp_solver), with_bridge_type = Float64)
        elseif !isempty(var_type_screener)
            local_solve_model =
                MOI.instantiate(get_option(m, :nlp_solver), with_bridge_type = Float64)
        else
            local_solve_model =
                MOI.instantiate(get_option(m, :nlp_solver), with_bridge_type = Float64)
        end
    else
        local_solve_model =
            MOI.instantiate(get_option(m, :nlp_solver), with_bridge_type = Float64)
    end

    if presolve == false
        l_var, u_var = fix_domains(m)
    else
        l_var, u_var = m.l_var_tight[1:m.num_var_orig], m.u_var_tight[1:m.num_var_orig]
    end

    x = load_nonlinear_model(m, local_solve_model, l_var, u_var)
    if m.d_orig !== nothing
        MOI.initialize(m.d_orig, [:Grad, :Jac, :Hess, :HessVec, :ExprGraph]) # Safety scheme for sub-solvers re-initializing the NLPEvaluator
    end

    if !presolve
        warmval = m.best_sol[1:m.num_var_orig]
    else
        warmval = m.warm_start_value[1:m.num_var_orig]
    end
    MOI.set(local_solve_model, MOI.VariablePrimalStart(), x, warmval)

    # do_heuristic = false

    # The only case when MINLP solver is actually used
    if presolve && !isempty(var_type_screener)
        if get_option(m, :minlp_solver) === nothing
            error("Provide a valid MINLP solver")
            # do_heuristic = true
        else
            set_variable_type(local_solve_model, x, m.var_type_orig)
        end
    end

    start_local_solve = time()
    MOI.optimize!(local_solve_model)
    local_nlp_status = MOI.get(local_solve_model, MOI.TerminationStatus())

    # if !do_heuristic
    #     local_nlp_status = MOI.get(local_solve_model, MOI.TerminationStatus())
    # end

    cputime_local_solve = time() - start_local_solve
    m.logs[:total_time] += cputime_local_solve
    m.logs[:time_left] = max(0.0, get_option(m, :time_limit) - m.logs[:total_time])

    # if do_heuristic
    # m.status[:local_solve] = heu_basic_rounding(m, MOI.get(local_solve_model, MOI.VariablePrimal(), x))
    # return

    if local_nlp_status in STATUS_OPT || local_nlp_status in STATUS_LIMIT
        candidate_obj = MOI.get(local_solve_model, MOI.ObjectiveValue())
        sol_temp = MOI.get(local_solve_model, MOI.VariablePrimal(), x)
        candidate_sol = Vector{Float64}()

        feas_tol = 1E-5

        for i in 1:length(sol_temp)
            if (sol_temp[i] >= m.l_var_orig[i] - feas_tol) &&
               (sol_temp[i] <= m.l_var_orig[i] + feas_tol)
                push!(candidate_sol, m.l_var_orig[i])
            elseif (sol_temp[i] >= m.u_var_orig[i] - feas_tol) &&
                   (sol_temp[i] <= m.u_var_orig[i] + feas_tol)
                push!(candidate_sol, m.u_var_orig[i])
            else
                push!(candidate_sol, round(sol_temp[i], digits = 7))
            end
        end

        @assert length(candidate_sol) == length(sol_temp)
        update_incumbent(m, candidate_obj, candidate_sol)
        m.status[:local_solve] = local_nlp_status
        return

        # elseif local_nlp_status in STATUS_INF
        #     heu_pool_multistart(m) == MOI.LOCALLY_SOLVED && return
        #     push!(m.logs[:obj], "INF")
        #     m.status[:local_solve] = MOI.LOCALLY_INFEASIBLE
        #     return

    elseif local_nlp_status == MOI.DUAL_INFEASIBLE
        push!(m.logs[:obj], "U")
        m.status[:local_solve] = MOI.DUAL_INFEASIBLE
        if presolve
            @warn "  Warning: NLP local solve is unbounded."
        else
            @warn "  Warning: NLP local solve is unbounded."
        end
        return

    else
        push!(m.logs[:obj], "E")
        m.status[:local_solve] = MOI.OTHER_ERROR
        # if presolve
        #     @warn " Warning: NLP solve failure $(local_nlp_status)."
        # else
        #     @warn " Warning: NLP local solve failure."
        # end
        return
    end

    return
end

"""
   bounding_solve(m::Optimizer; kwargs...)

This step usually solves a convex MILP/MIQCP/MIQCQP problem for lower bounding the given minimization problem.
It solves the problem built upon a piecewise convexification based on the discretization sictionary of some variables.
See `create_bounding_mip` for more details of the problem solved here.
"""
function bounding_solve(m::Optimizer)
    convertor = Dict(MOI.MAX_SENSE => :<, MOI.MIN_SENSE => :>)

    # Updates time metric and the termination bounds
    set_mip_time_limit(m)
    # update_boundstop_options(m)

    # ================= Solve Start ================ #
    start_bounding_solve = time()
    JuMP.optimize!(m.model_mip)
    status = JuMP.termination_status(m.model_mip)
    m.logs[:total_time] += time() - start_bounding_solve
    m.logs[:time_left] = max(0.0, get_option(m, :time_limit) - m.logs[:total_time])
    # ================= Solve End ================ #

    if status in STATUS_OPT || status in STATUS_LIMIT
        candidate_bound =
            (status == MOI.OPTIMAL) ? JuMP.objective_value(m.model_mip) :
            JuMP.objective_bound(m.model_mip)
        candidate_bound_sol = [
            round.(JuMP.value(_index_to_variable_ref(m.model_mip, i)); digits = 7) for
            i in 1:(m.num_var_orig+m.num_var_linear_mip+m.num_var_nonlinear_mip)
        ]

        # Experimental code
        measure_relaxed_deviation(m, sol = candidate_bound_sol)
        if get_option(m, :disc_consecutive_forbid) > 0
            m.bound_sol_history[mod(
                m.logs[:n_iter] - 1,
                get_option(m, :disc_consecutive_forbid),
            )+1] = copy(candidate_bound_sol) # Requires proper offseting
        end
        push!(m.logs[:bound], candidate_bound)
        is_tighter = ifelse(
            m.sense_orig == MOI.MAX_SENSE,
            candidate_bound < m.best_bound,
            candidate_bound > m.best_bound,
        )
        if is_tighter
            m.best_bound = candidate_bound
            m.best_bound_sol = copy(candidate_bound_sol)
            m.status[:bounding_solve] = status
            m.detected_bound = true
        end

        # collect_lb_pool(m)    # Collect a pool of sub-optimal solutions - currently implemented for Gurobi only

    elseif status in STATUS_INF || status == MOI.INFEASIBLE_OR_UNBOUNDED
        push!(m.logs[:bound], "-")
        m.status[:bounding_solve] = MOI.INFEASIBLE
        @warn "  Warning: Infeasibility detected in the MIP solver"

        if ALPINE_DEBUG
            @warn "Use Alpine.print_iis_gurobi(m.model_mip) function in src/utility.jl (commented out code) for further investigation, if your MIP solver is Gurobi"
        end

    elseif status == :Unbounded
        m.status[:bounding_solve] = MOI.DUAL_INFEASIBLE
        @warn "  Warning: MIP solver returns unbounded"

    else
        error("  Warning: MIP solver failure $(status)")
    end

    return
end

"""
   pick_disc_vars(m::Optimizer)

This function helps pick the variables for discretization. The method chosen depends on user-inputs.
In case when `indices::Int` is provided, the method is chosen as built-in method. Currently,
there are two built-in options for users as follows:

* `max_cover (get_option(m, :disc_var_pick)=0, default)`: pick all variables involved in the non-linear term for discretization
* `min_vertex_cover (get_option(m, :disc_var_pick)=1)`: pick a minimum vertex cover for variables involved in non-linear terms so that each non-linear term is at least convexified

For advanced usage, `get_option(m, :disc_var_pick)` allows `::Function` inputs. User can provide his/her own function to choose the variables for discretization.

"""
function pick_disc_vars(m::Optimizer)
    disc_var_pick = get_option(m, :disc_var_pick)

    if isa(disc_var_pick, Function)
        disc_var_pick(m)
        length(m.disc_vars) == 0 &&
            length(m.nonconvex_terms) > 0 &&
            error(
                "[USER FUNCTION] must select at least one variable to perform discretization for convexificiation purpose",
            )
    elseif isa(disc_var_pick, Int)
        if disc_var_pick == 0
            get_candidate_disc_vars(m)
        elseif disc_var_pick == 1
            min_vertex_cover(m)
        elseif disc_var_pick == 2
            (length(m.candidate_disc_vars) > 15) ? min_vertex_cover(m) :
            get_candidate_disc_vars(m)
        elseif disc_var_pick == 3 # Initial
            (length(m.candidate_disc_vars) > 15) ? min_vertex_cover(m) :
            get_candidate_disc_vars(m)
        else
            error(
                "Unsupported default indicator for picking variables for discretization",
            )
        end
    else
        error(
            "Input for parameter :disc_var_pick is illegal. Should be either a Int for default methods indexes or functional inputs.",
        )
    end

    return
end

"""
 MOI_wrapper.jl defines the Alpine.Optimizer struct
 with all mandatory MOI functions overloaded
"""

"""
 Alpine.Optimizer struct
"""
mutable struct Optimizer <: MOI.AbstractOptimizer
    options::OptimizerOptions                                # Options set by user

    # Sub-solver identifier for customized solver option
    nlp_solver_id::String                                     # NLP Solver identifier string
    minlp_solver_id::String                                   # MINLP local solver identifier string
    mip_solver_id::String                                     # MIP solver identifier string

    # User inputs
    num_var_orig::Int                                        # Initial number of variables
    num_cont_var_orig::Int                                   # Initial number of continuous variables
    num_int_var_orig::Int                                    # Initial number of binary/integer variables
    num_constr_orig::Int                                     # Initial number of constraints
    num_lconstr_orig::Int                                    # Initial number of linear constraints
    num_nlconstr_orig::Int                                   # Initial number of non-linear constraints
    var_type_orig::Vector{Symbol}                            # Variable type vector on original variables (only :Bin, :Cont, :Int)
    var_start_orig::Vector{Float64}                          # Variable warm start vector on original variables
    constr_type_orig::Vector{Symbol}                         # Constraint type vector on original variables (only :(==), :(>=), :(<=))
    lin_quad_constraints::Vector{Any}                        # Constraint `func`-in-`set` values
    constr_expr_orig::Vector{Expr}                           # Constraint expressions
    obj_expr_orig::Union{Expr,Number}                        # Objective expression

    # Additional user inputs concerning local solves
    l_var_orig::Vector{Float64}                              # Variable lower bounds
    u_var_orig::Vector{Float64}                              # Variable upper bounds
    constraint_bounds_orig::Vector{MOI.NLPBoundsPair}        # Constraint lower bounds
    nl_constraint_bounds_orig::Vector{MOI.NLPBoundsPair}     # Constraint lower bounds
    sense_orig::MOI.OptimizationSense                        # Problem type (:Min, :Max)
    d_orig::Union{Nothing,MOI.AbstractNLPEvaluator}          # Instance of AbstractNLPEvaluator for evaluating gradient, Hessian-vector products, and Hessians of the Lagrangian
    disable_hessian::Bool                                    # Check if there are any user-defined operators, and disable hessians if necessary.
    has_nl_objective::Bool
    objective_function::Union{
        Nothing,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    }

    # Additional initial data
    is_obj_linear_orig::Bool                             # Boolean parameter for type of objective

    # Local solution model (extra data for each iteration)
    l_var::Vector{Float64}                               # Updated variable lower bounds for local solve
    u_var::Vector{Float64}                               # Updated variable upper bounds for local solve

    # MIP bounding model
    model_mip::JuMP.Model                                # JuMP's convex-MIP model for bounding

    num_var_linear_mip::Int                              # Number of linear lifted variables required
    num_var_nonlinear_mip::Int                           # Number of lifted variables
    num_var_disc_mip::Int                                # Number of variables which are discretized
    num_constr_convex::Int                               # Number of convex constraints

    # Expression-related and structural property placeholder
    linear_terms::Dict{Any,Any}                          # Dictionary containing details of lifted linear terms
    nonconvex_terms::Dict{Any,Any}                       # Dictionary containing details of lifted non-linear terms
    term_seq::Dict{Int,Any}                              # Vector-Dictionary for NL terms detection
    nonlinear_constrs::Dict{Any,Any}                     # Dictionary containing details of special constraints
    obj_structure::Symbol                                # A symbolic indicator of the expression type of objective function
    constr_structure::Vector{Symbol}                     # A vector indicating whether a constraint is with the special structure
    bounding_obj_expr_mip::Union{Expr,Number}            # Lifted objective expression; if linear, same as obj_expr_orig
    bounding_constr_expr_mip::Vector{Expr}               # Lifted constraints; if linear, same as corresponding constr_expr_orig
    bounding_obj_mip::Dict{Any,Any}                      # Lifted objective expression in affine form
    bounding_constr_mip::Vector{Dict{Any,Any}}           # Lifted constraint expressions in affine form

    # Discretization Related options
    candidate_disc_vars::Vector{Int}                  # A vector of all original variable indices that is involved in the nonlinear terms
    discretization::Dict{Any,Any}                     # Discretization points with variable keys
    disc_vars::Vector{Int}                            # Variables chosen for discretization
    int_vars::Vector{Int}                             # Index vector of integer variables
    bin_vars::Vector{Int}                             # Index vector of binary variables

    # Reformulated problem options
    l_var_tight::Vector{Float64}                        # Post-presolve variable upper bounds
    u_var_tight::Vector{Float64}                        # Post-presolve variable lower bounds
    var_type::Vector{Symbol}                            # Updated variable type for local solve

    # Solution information
    presolve_infeasible::Bool                            # Presolve infeasibility detection flag
    best_bound::Float64                                  # Best bound from MIP
    best_obj::Float64                                    # Best feasible objective value
    warm_start_value::Vector{Float64}                    # Warmstart values set to Alpine
    best_sol::Vector{Float64}                            # Best feasible solution
    best_bound_sol::Vector{Float64}                      # Best bound solution (arg-min)
    presolve_best_rel_gap::Float64                       # Post-OBBT relative optimality gap = |best_obj - best_bound|/|best_obj|*100
    best_rel_gap::Float64                                # Relative optimality gap = |best_obj - best_bound|/|best_obj|*100
    best_abs_gap::Float64                                # Absolute gap = |best_obj - best_bound|
    bound_sol_history::Vector{Vector{Float64}}           # History of bounding solutions limited by "parameter disc_consecutive_forbid"
    bound_sol_pool::Dict{Any,Any}                        # A pool of solutions from solving model_mip

    # Linking constraints info for Multilinear terms
    linking_constraints_info::Union{Nothing,Dict{Any,Any}}     # Stored multilinear linking constraints info

    # Logging information and status
    logs::Dict{Symbol,Any}                          # Logging information
    detected_incumbent::Bool
    detected_bound::Bool
    status::Dict{Symbol,MOI.TerminationStatusCode}   # Detailed status of every iteration in the algorithm
    alpine_status::MOI.TerminationStatusCode         # Current Alpine's status

    # Constructor for Alpine.Optimizer
    function Optimizer()
        m = new()
        m.options = get_default_options()
        MOI.empty!(m)
        return m
    end
end

struct NumberOfIterations <: MOI.AbstractModelAttribute end
MOI.is_set_by_optimize(::NumberOfIterations) = true
MOI.get(m::Optimizer, ::NumberOfIterations) = m.logs[:n_iter]

struct NumberOfPresolveIterations <: MOI.AbstractModelAttribute end
MOI.is_set_by_optimize(::NumberOfPresolveIterations) = true
MOI.get(m::Optimizer, ::NumberOfPresolveIterations) = m.logs[:bt_iter]

struct TightenedLowerBound <: MOI.AbstractVariableAttribute end
MOI.is_set_by_optimize(::TightenedLowerBound) = true
function MOI.get(m::Optimizer, ::TightenedLowerBound, vi::MOI.VariableIndex)
    return m.l_var_tight[vi.value]
end

struct TightenedUpperBound <: MOI.AbstractVariableAttribute end
MOI.is_set_by_optimize(::TightenedUpperBound) = true
function MOI.get(m::Optimizer, ::TightenedUpperBound, vi::MOI.VariableIndex)
    return m.u_var_tight[vi.value]
end

function MOI.get(m::Optimizer, ::MOI.RawStatusString)
    return "Alpine ended with status $(m.alpine_status)"
end

MOI.get(m::Optimizer, ::MOI.TerminationStatus) = m.alpine_status

function MOI.get(m::Optimizer, attr::MOI.PrimalStatus)
    if attr.result_index != 1
        return MOI.NO_SOLUTION
    end

    status = m.alpine_status
    if status == MOI.OPTIMAL
        return MOI.FEASIBLE_POINT
    elseif status == MOI.NEARLY_FEASIBLE_POINT
        return MOI.NEARLY_FEASIBLE_POINT
    elseif status == MOI.INFEASIBLE_POINT
        return MOI.INFEASIBLE_POINT
    elseif status == MOI.LOCALLY_SOLVED
        return MOI.FEASIBLE_POINT
    end

    return MOI.NO_SOLUTION
end

MOI.get(::Optimizer, ::MOI.DualStatus) = MOI.NO_SOLUTION

MOI.get(m::Optimizer, ::MOI.ObjectiveValue) = m.best_obj
MOI.get(m::Optimizer, ::MOI.ObjectiveBound) = m.best_bound
MOI.get(m::Optimizer, ::MOI.SolveTimeSec) = m.logs[:total_time]

function get_option(m::Optimizer, s::Symbol)
    return getproperty(m.options, s)
end

function set_option(m::Optimizer, s::Symbol, val)
    return setproperty!(m.options, s, val)
end

function MOI.is_empty(model::Optimizer)
    return iszero(model.num_var_orig)
end

function MOI.empty!(m::Optimizer)
    m.nlp_solver_id = ""
    m.minlp_solver_id = ""
    m.mip_solver_id = ""

    m.num_var_orig = 0
    m.num_cont_var_orig = 0
    m.num_int_var_orig = 0
    m.num_constr_orig = 0
    m.num_lconstr_orig = 0
    m.num_nlconstr_orig = 0
    m.var_type_orig = Symbol[]
    m.var_start_orig = Float64[]
    m.constr_type_orig = Symbol[]
    m.lin_quad_constraints = Any[]
    m.constr_expr_orig = Expr[]
    # m.num_lconstr_updated = 0
    # m.num_nlconstr_updated = 0
    # m.indices_lconstr_updated = Int[]

    m.l_var_orig = Float64[]
    m.u_var_orig = Float64[]
    m.constraint_bounds_orig = MOI.NLPBoundsPair[]
    m.nl_constraint_bounds_orig = MOI.NLPBoundsPair[]
    m.sense_orig = MOI.FEASIBILITY_SENSE

    m.d_orig = nothing
    m.has_nl_objective = false
    m.objective_function = nothing

    m.linear_terms = Dict()
    m.nonconvex_terms = Dict()
    m.term_seq = Dict()
    m.nonlinear_constrs = Dict()
    m.candidate_disc_vars = Int[]
    m.bounding_constr_expr_mip = []
    m.bounding_constr_mip = []
    m.disc_vars = []
    m.int_vars = []
    m.bin_vars = []
    m.discretization = Dict()
    m.num_var_linear_mip = 0
    m.num_var_nonlinear_mip = 0
    m.num_var_disc_mip = 0
    m.num_constr_convex = 0
    m.constr_structure = Symbol[]
    m.best_bound_sol = []
    m.bound_sol_history = []
    m.presolve_infeasible = false
    m.bound_sol_history =
        Vector{Vector{Float64}}(undef, m.options.disc_consecutive_forbid)

    m.best_obj = Inf
    m.warm_start_value = Float64[]
    m.best_sol = Float64[]
    m.best_bound = -Inf
    m.presolve_best_rel_gap = Inf
    m.best_rel_gap = Inf
    m.best_abs_gap = Inf
    m.alpine_status = MOI.OPTIMIZE_NOT_CALLED

    m.linking_constraints_info = nothing

    create_status!(m)
    return create_logs!(m)
end

MOI.supports_incremental_interface(::Optimizer) = true

function MOI.copy_to(model::Optimizer, src::MOI.ModelLike)
    return MOIU.default_copy_to(model, src)
end

MOI.get(::Optimizer, ::MOI.SolverName) = "Alpine"
MOI.get(::Optimizer, ::MOI.SolverVersion) = _ALPINE_VERSION

function MOI.set(model::Optimizer, param::MOI.RawOptimizerAttribute, value)
    return set_option(model, Symbol(param.name), value)
end
function MOI.get(model::Optimizer, param::MOI.RawOptimizerAttribute)
    return get_option(model, Symbol(param.name))
end

function MOI.add_variables(model::Optimizer, n::Int)
    return [MOI.add_variable(model) for i in 1:n]
end
function MOI.add_variable(model::Optimizer)
    model.num_var_orig += 1
    push!(model.l_var_orig, -Inf)
    push!(model.u_var_orig, Inf)
    push!(model.var_type_orig, :Cont)
    push!(model.warm_start_value, 0.0)
    push!(model.best_sol, 0.0)
    return MOI.VariableIndex(model.num_var_orig)
end

function MOI.supports(::Optimizer, ::MOI.VariablePrimalStart, ::Type{MOI.VariableIndex})
    return true
end
function MOI.set(
    model::Optimizer,
    ::MOI.VariablePrimalStart,
    vi::MOI.VariableIndex,
    value::Union{Real,Nothing},
)
    model.best_sol[vi.value] = model.warm_start_value[vi.value] = something(value, 0.0)
    return
end

const SCALAR_SET = Union{
    MOI.EqualTo{Float64},
    MOI.LessThan{Float64},
    MOI.GreaterThan{Float64},
    MOI.Interval{Float64},
}

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VariableIndex},
    ::Type{<:SCALAR_SET},
)
    return true
end

_lower(set::MOI.EqualTo) = set.value
_upper(set::MOI.EqualTo) = set.value
_lower(set::MOI.LessThan) = nothing
_upper(set::MOI.LessThan) = set.upper
_lower(set::MOI.GreaterThan) = set.lower
_upper(set::MOI.GreaterThan) = nothing
_lower(set::MOI.Interval) = set.lower
_upper(set::MOI.Interval) = set.upper

function MOI.add_constraint(model::Optimizer, vi::MOI.VariableIndex, set::SCALAR_SET)
    l = _lower(set)
    if l !== nothing
        model.l_var_orig[vi.value] = l
    end
    u = _upper(set)
    if u !== nothing
        model.u_var_orig[vi.value] = u
    end
    return MOI.ConstraintIndex{typeof(vi),typeof(set)}(vi.value)
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.ZeroOne},
)
    return true
end

function MOI.add_constraint(model::Optimizer, f::MOI.VariableIndex, set::MOI.ZeroOne)
    model.var_type_orig[f.value] = :Bin
    return MOI.ConstraintIndex{typeof(f),typeof(set)}(f.value)
end

function MOI.supports_constraint(
    model::Optimizer,
    ::Type{
        <:Union{MOI.ScalarAffineFunction{Float64},MOI.ScalarQuadraticFunction{Float64}},
    },
    ::Type{<:SCALAR_SET},
)
    return true
end

function MOI.add_constraint(
    model::Optimizer,
    f::Union{MOI.ScalarAffineFunction{Float64},MOI.ScalarQuadraticFunction{Float64}},
    set::SCALAR_SET,
)
    model.num_constr_orig += 1
    push!(
        model.constraint_bounds_orig,
        MOI.NLPBoundsPair(something(_lower(set), -Inf), something(_upper(set), Inf)),
    )
    iszero(f.constant) || throw(
        MOI.ScalarFunctionConstantNotZero{Float64,typeof(f),typeof(set)}(f.constant),
    )
    push!(model.lin_quad_constraints, (copy(f), copy(set)))
    push!(model.constr_expr_orig, _constraint_expr(_moi_function_to_expr(f), set))
    if f isa MOI.ScalarAffineFunction
        model.num_lconstr_orig += 1
        push!(model.constr_structure, :generic_linear)
    else
        model.num_nlconstr_orig += 1
        push!(model.constr_structure, :generic_nonlinear)
    end

    return MOI.ConstraintIndex{typeof(f),typeof(set)}(model.num_constr_orig)
end

function MOI.supports(
    model::Optimizer,
    ::Union{MOI.ObjectiveSense,MOI.ObjectiveFunction{F}},
) where {F<:Union{MOI.ScalarAffineFunction{Float64},MOI.ScalarQuadraticFunction{Float64}}}
    return true
end

is_min_sense(model::Optimizer) = model.sense_orig == MOI.MIN_SENSE
is_max_sense(model::Optimizer) = model.sense_orig == MOI.MAX_SENSE

function MOI.set(model::Optimizer, ::MOI.ObjectiveSense, sense)
    model.sense_orig = sense
    if is_max_sense(model)
        model.best_obj = -Inf
        model.best_bound = Inf
    elseif is_min_sense(model)
        model.best_obj = Inf
        model.best_bound = -Inf
    else
        error("Feasibility sense is not supported by Alpine.")
    end
end

function MOI.set(model::Optimizer, ::MOI.ObjectiveFunction{F}, func::F) where {F}
    return model.objective_function = func
end

function MOI.set(m::Optimizer, ::MOI.NLPBlock, block)
    m.d_orig = block.evaluator
    m.disable_hessian = !(
        (:Hess in MOI.features_available(block.evaluator)) &&
        (:HessVec in MOI.features_available(block.evaluator))
    )
    m.has_nl_objective = block.has_objective

    # We cache it to add it in `load!` as we cannot call `MOI.constraint_expr` yet
    # so we will add the nonlinear `constr_expr_orig` at the end so we need
    # to add the bounds at the end too.
    # So we can consider that the nonlinear constraints are the
    # `length(m.nl_constraint_bounds_orig)` last ones.
    return m.nl_constraint_bounds_orig = block.constraint_bounds
end

# In JuMP v0.18/MathProgBase, the 5th decision variable would be `:(x[5])`.
# In JuMP v0.19/MathOptInterface, it is now `:(x[MOI.VariableIndex(5)])`.
# To ease the transition, we simply transform it back to what it used to be.
_variable_index_to_index(expr::Union{Number,Symbol}) = expr
_variable_index_to_index(expr::MOI.VariableIndex) = expr.value
function _variable_index_to_index(expr::Expr)
    for i in eachindex(expr.args)
        expr.args[i] = _variable_index_to_index(expr.args[i])
    end
    return expr
end

function _index_to_variable_ref(m::JuMP.Model, idx::Int64)
    return JuMP.VariableRef(m, MOI.VariableIndex(idx))
end

function MOI.get(model::Optimizer, attr::MOI.VariablePrimal, vi::MOI.VariableIndex)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, vi)

    return model.best_sol[vi.value]
end

function MOI.get(model::Optimizer, ::MOI.ResultCount)
    return model.alpine_status == MOI.OPTIMIZE_NOT_CALLED ? 0 : 1
end

function MOI.is_valid(model::Alpine.Optimizer, vi::MOI.VariableIndex)
    return 1 <= vi.value <= model.num_var_orig
end

function _get_bound_set(model::Alpine.Optimizer, vi::MOI.VariableIndex)
    if !MOI.is_valid(model, vi)
        throw(MOI.InvalidIndex(vi))
    end
    return _bound_set(model.l_var_orig[vi.value], model.u_var_orig[vi.value])
end

function MOI.is_valid(
    model::Alpine.Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S<:SCALAR_SET}
    set = _get_bound_set(model, MOI.VariableIndex(ci.value))
    return set isa S
end

function MOI.get(
    model::Alpine.Optimizer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S<:SCALAR_SET}
    if !MOI.is_valid(model, ci)
        throw(MOI.InvalidIndex(ci))
    end
    return _get_bound_set(model, MOI.VariableIndex(ci.value))
end

# Taken from MatrixOptInterface.jl
@enum ConstraintSense EQUAL_TO GREATER_THAN LESS_THAN INTERVAL
_sense(::Type{<:MOI.EqualTo}) = EQUAL_TO
_sense(::Type{<:MOI.LessThan}) = LESS_THAN
_sense(::Type{<:MOI.GreaterThan}) = GREATER_THAN
_sense(::Type{<:MOI.Interval}) = INTERVAL

_no_upper(bound) = bound != typemax(bound)
_no_lower(bound) = bound != typemin(bound)

function _bound_set(lb::T, ub::T) where {T}
    if _no_upper(ub)
        if _no_lower(lb)
            if ub == lb
                return MOI.EqualTo(lb)
            else
                return MOI.Interval(lb, ub)
            end
        else
            return MOI.LessThan(ub)
        end
    else
        if _no_lower(lb)
            return MOI.GreaterThan(lb)
        else
            return
        end
    end
end

#=
function _bound_sense(lb::T, ub::T) where T
    if _no_upper(ub)
        if _no_lower(lb)
            if lb == ub
                return EQUAL_TO
            else
                return INTERVAL
            end
        else
            return LESS_THAN
        end
    else
        if _no_lower(lb)
            return GREATER_THAN
        else
            return
        end
    end
end
=#

# Create dictionary of logs for timing and iteration counts
function create_logs!(m)
    logs = Dict{Symbol,Any}()

    # Timers
    logs[:presolve_time] = 0.0                           # Total presolve-time of the algorithm
    logs[:total_time] = 0.0                              # Total run-time of the algorithm
    logs[:time_left] = get_option(m, :time_limit)    # Total remaining time of the algorithm if time-out is specified

    # Values
    logs[:obj] = []                 # Iteration-based objective
    logs[:bound] = []               # Iteration-based objective bound

    # Counters
    logs[:n_iter] = 0               # Number of iterations
    logs[:n_feas] = 0               # Number of times a new feasible solution is obtained
    logs[:ub_incumb_cnt] = 0        # Number of incumbents detected in the upper bound
    logs[:lb_incumb_cnt] = 0        # Number of incumebnts detected in the lower bound
    logs[:bt_iter] = 0

    return m.logs = logs
end

function reset_timer(m::Optimizer)
    m.logs[:total_time] = 0.0
    m.logs[:time_left] = get_option(m, :time_limit)
    return m
end

function logging_summary(m::Optimizer)
    if get_option(m, :log_level) > 0
        printstyled("\nPROBLEM STATISTICS\n", color = :cyan, bold = true)
        is_min_sense(m) && (println("  Objective sense = Min"))
        is_max_sense(m) && (println("  Objective sense = Max"))
        println(
            "  # Variables = ",
            length([i for i in 1:m.num_var_orig if m.var_type[i] == :Cont]) +
            length([i for i in 1:m.num_var_orig if m.var_type[i] == :Bin]) +
            length([i for i in 1:m.num_var_orig if m.var_type[i] == :Int]),
        )
        println(
            "  # Bin-Int Variables = ",
            length([i for i in 1:m.num_var_orig if m.var_type[i] == :Bin]) + length([i for i in 1:m.num_var_orig if m.var_type[i] == :Int]),
        )
        println("  # Constraints = ", m.num_constr_orig)
        println("  # NL Constraints = ", m.num_nlconstr_orig)
        println("  # Linear Constraints = ", m.num_lconstr_orig)
        get_option(m, :recognize_convex) && println(
            "  # Detected convex constraints = $(length([i for i in m.constr_structure if i == :convex]))",
        )
        println("  # Detected nonlinear terms = ", length(m.nonconvex_terms))
        println(
            "  # Variables involved in nonlinear terms = ",
            length(m.candidate_disc_vars),
        )
        println("  # Potential variables for partitioning = ", length(m.disc_vars))

        printstyled("SUB-SOLVERS USED BY ALPINE\n", color = :cyan, bold = true)
        if get_option(m, :minlp_solver) === nothing
            println("  NLP local solver = ", m.nlp_solver_id)
        else
            println("  MINLP local solver = ", m.minlp_solver_id)
        end
        println("  MIP solver = ", m.mip_solver_id)

        printstyled("ALPINE CONFIGURATION\n", color = :cyan, bold = true)
        project = read(joinpath(dirname(@__DIR__), "Project.toml"), String)
        m_version = match(r"version \= \"(.+?)\"", project)
        println("  Alpine version = ", m_version[1])
        if is_min_sense(m)
            println(
                "  Maximum iterations (lower-bounding MIPs) = ",
                get_option(m, :max_iter),
            )
        elseif is_max_sense(m)
            println(
                "  Maximum iterations (upper-bounding MIPs) = ",
                get_option(m, :max_iter),
            )
        else
            println("  Maximum iterations (bounding MIPs) =  ", get_option(m, :max_iter))
        end

        println("  Relative global optimality gap = ", get_option(m, :rel_gap) * 100, "%")

        if get_option(m, :disc_var_pick) == 0
            println("  Potential variables chosen for partitioning = All")
        elseif get_option(m, :disc_var_pick) == 1
            println(
                "  Potential variables chosen for partitioning = Minimum vertex cover",
            )
        end

        if get_option(m, :partition_scaling_factor_branch)
            println("  Partition scaling factor branch activated")
        else
            println(
                "  Partition scaling factor = ",
                get_option(m, :partition_scaling_factor),
            )
        end
        (get_option(m, :convhull_ebd)) && println("  Using convhull_ebd formulation")
        (get_option(m, :convhull_ebd)) &&
            println("  Encoding method = $(get_option(m, :convhull_ebd_encode))")
        (get_option(m, :convhull_ebd)) && println(
            "  Independent branching scheme = $(get_option(m, :convhull_ebd_ibs))",
        )
        println("  Bound-tightening presolve = ", get_option(m, :presolve_bt))
        get_option(m, :presolve_bt) && println(
            "  Maximum iterations (OBBT) = ",
            get_option(m, :presolve_bt_max_iter),
        )
    end
end

function logging_head(m::Optimizer)
    if !is_max_sense(m)
        printstyled("LOWER-BOUNDING ITERATIONS", color = :cyan, bold = true)
        UB_iter = "Incumbent"
        UB = "Best Incumbent"
        LB = "Lower Bound"
    else
        printstyled("UPPER-BOUNDING ITERATIONS", color = :cyan, bold = true)
        UB_iter = "Incumbent"
        UB = "Best Incumbent"
        LB = "Upper Bound"
    end
    println(
        "\n====================================================================================================",
    )
    if m.logs[:time_left] < Inf
        printstyled(
            bold = true,
            "| Iter   | $UB_iter       | $UB      | $LB        | Gap (%)         | Time      \n",
        )
    end
end

function logging_row_entry(m::Optimizer; kwargs...)
    options = Dict(kwargs)

    b_len = 16
    if !isempty(m.logs[:obj]) && isa(m.logs[:obj][end], Float64)
        objstr = string(round(m.logs[:obj][end]; digits = 4))
        spc = max(0, b_len - length(objstr))
    else
        objstr = string("-")
        spc = max(0, b_len - length(objstr))
    end
    UB_block = string(" ", objstr, " "^spc)
    if m.obj_expr_orig == :(+())
        bdstr = 0.0
        spc = b_len - 1
    elseif expr_isconst(m.obj_expr_orig)
        # This eval is okay because expr_isconst is true
        bdstr = eval(m.obj_expr_orig)
        spc = b_len - length(bdstr)
    elseif isa(m.logs[:bound][end], Float64)
        bdstr = string(round(m.logs[:bound][end]; digits = 4))
        spc = max(0, b_len - length(bdstr))
    else
        bdstr = string(m.logs[:bound][end])
        spc = b_len - length(bdstr)
    end
    LB_block = string(" ", bdstr, " "^spc)

    bobjstr = string(round(m.best_obj; digits = 4))
    spc = max(0, b_len + 4 - length(bobjstr))
    incumb_UB_block = string(" ", bobjstr, " "^spc)

    bbdstr = string(round(m.best_bound; digits = 4))
    spc = max(0, b_len + 3 - length(bbdstr))
    incumb_LB_block = string(" ", bbdstr, " "^spc)

    rel_gap = round(m.best_rel_gap * 100, digits = 3)
    rel_gap > 999 ? rel_gap = "LARGE" : rel_gap = string(rel_gap)
    GAP_block = string(" ", rel_gap, " "^(b_len - length(rel_gap)))

    UTIME_block = string(
        " ",
        round(m.logs[:total_time]; digits = 2),
        "s",
        " "^(b_len - 1 - length(string(round(m.logs[:total_time]; digits = 2)))),
    )

    if m.logs[:time_left] < Inf
        LTIME_block = " "
    end

    haskey(options, :finish_entry) ? (ITER_block = string(" ", "finish ")) :
    (ITER_block = string(" ", m.logs[:n_iter], " "^(7 - length(string(m.logs[:n_iter])))))

    println(
        "|",
        ITER_block,
        "|",
        UB_block,
        "|",
        incumb_UB_block,
        "|",
        incumb_LB_block,
        "|",
        GAP_block,
        "|",
        UTIME_block,
        LTIME_block,
    )
    return
end

#Logging and printing functions

# Create dictionary of statuses for Alpine algorithm
function create_status!(m)
    status = Dict{Symbol,MOI.TerminationStatusCode}()

    status[:local_solve] = MOI.OPTIMIZE_NOT_CALLED # Status of local solve
    status[:bounding_solve] = MOI.OPTIMIZE_NOT_CALLED # Status of bounding solve
    m.detected_incumbent = false
    m.detected_bound = false

    return m.status = status
end

"""
This function summarizes the eventual solver status based on all available information
recorded in the solver. The output status is self-defined which requires users to
read our documentation to understand the details behind every status symbols.
"""
function summary_status(m::Optimizer)

    # Alpine Solver Status Definition
    # :Optimal : normal termination with optimality gap closed within time limits
    # :UserLimits : any non-optimal termination related to user-defined parameters
    # :Infeasible : termination with relaxation proven infeasible or detection of
    #               variable bound conflicts
    # :Heuristic : termination with feasible solution found but not bounds detected
    #               happens when lower bound problem is extremely hard to solve
    # :Unknown : termination with no exception recorded

    if m.detected_bound && m.detected_incumbent
        m.alpine_status =
            m.best_rel_gap > get_option(m, :rel_gap) ? MOI.OTHER_LIMIT : MOI.OPTIMAL
    elseif m.status[:bounding_solve] == MOI.INFEASIBLE
        m.alpine_status = MOI.INFEASIBLE
    elseif m.detected_bound && !m.detected_incumbent
        m.alpine_status = MOI.OTHER_LIMIT
    elseif !m.detected_bound && m.detected_incumbent
        m.alpine_status = MOI.LOCALLY_SOLVED
    else
        @warn "  [EXCEPTION] Indefinite Alpine status. Please report your instance (& solver configuration) as an issue (https://github.com/lanl-ansi/Alpine.jl/issues) to help us make Alpine better."
    end

    raw = MOI.get(m, MOI.RawStatusString())
    printstyled("\n*** $raw ***\n")

    return
end

# Some useful logging details:

# for i in ALPINE_C_NLTERMS
#     cnt = length([1 for j in keys(m.nonconvex_terms) if m.nonconvex_terms[j][:nonlinear_type] == i])
#     cnt > 0 && println("\tTerm $(i) Count = $(cnt) ")
# end
# println("  Maximum solution time = ", get_option(m, :time_limit))
# println("  Basic bound propagation = ", get_option(m, :presolve_bp))
# println("  Conseuctive solution rejection = after ", get_option(m, :disc_consecutive_forbid), " times")
# get_option(m, :presolve_bt) && println("bound tightening presolve algorithm = ", get_option(m, :presolve_bt)_algo)
# get_option(m, :presolve_bt) && println("bound tightening presolve width tolerance = ", get_option(m, :presolve_bt)_width_tol)
# get_option(m, :presolve_bt) && println("bound tightening presolve output tolerance = ", get_option(m, :presolve_bt)_output_tol)
# get_option(m, :presolve_bt) && println("bound tightening presolve relaxation = ", get_option(m, :presolve_bt)_relax)
# get_option(m, :presolve_bt) && println("bound tightening presolve mip regulation time = ", get_option(m, :presolve_bt)_mip_time_limit)

#---------------------------;
# MIP solvers - commercial  ;
#---------------------------;
# https://github.com/jump-dev/Gurobi.jl
function get_gurobi()
    GRB_ENV = Gurobi.Env()
    return optimizer_with_attributes(
        () -> Gurobi.Optimizer(GRB_ENV), # To avoid printing License info multiple times
        MOI.Silent() => true,
        "Presolve" => 1,
    )
end

# https://github.com/jump-dev/CPLEX.jl
function get_cplex()
    return optimizer_with_attributes(
        CPLEX.Optimizer,
        MOI.Silent() => true,
        "CPX_PARAM_PREIND" => 1,
    )
end

#---------------------------;
# MIP solvers - open-source
#---------------------------;
# https://github.com/jump-dev/HiGHS.jl
function get_highs()
    return JuMP.optimizer_with_attributes(
        HiGHS.Optimizer,
        "presolve" => "on",
        "log_to_console" => false,
    )
end

# https://github.com/jump-dev/Cbc.jl
function get_cbc()
    return optimizer_with_attributes(Cbc.Optimizer, MOI.Silent() => true)
end

#---------------------------;
# Continuous local solver   ; 
#---------------------------;
# https://github.com/jump-dev/Ipopt.jl
function get_ipopt()
    return optimizer_with_attributes(
        Ipopt.Optimizer,
        MOI.Silent() => true,
        "sb" => "yes",
        "max_iter" => Int(1E4),
    )
end

#----------------------;
# Convex MINLP solver  ;
#----------------------;
# https://github.com/jump-dev/Pavito.jl
function get_pavito(mip_solver, cont_solver)
    return optimizer_with_attributes(
        Pavito.Optimizer,
        MOI.Silent() => true,
        "mip_solver" => mip_solver,
        "cont_solver" => cont_solver,
        "mip_solver_drives" => false,
    )
end

#-------------------------------;
# Non-convex Local MINLP solver ;
#-------------------------------;
# https://github.com/lanl-ansi/Juniper.jl
function get_juniper(mip_solver, nl_solver)
    return optimizer_with_attributes(
        Juniper.Optimizer,
        MOI.Silent() => true,
        "mip_solver" => mip_solver,
        "nl_solver" => nl_solver,
    )
end

"""
    expr_term_parsing(expr, m::Optimizer, level=0)

Recognize and process nonlinear terms in an expression
"""
function expr_term_parsing(expr::Any, constr_id::Int, m::Optimizer, level = 0; options...)
    isa(expr, Number) && return expr
    cnt = 0
    for node in expr.args
        cnt += 1
        if isa(node, Float64) || isa(node, Int64) || isa(node, Symbol)
            continue
        elseif node.head == :call
            expr.args[cnt] = expr_term_parsing(node, constr_id, m, level + 1)
        elseif node.head == :ref
            continue
        else
            error("Type issue during expression parsing. ")
        end
    end

    return detect_nonconvex_terms(expr, constr_id, m)
end

"""
    detect_nonconvex_terms(expr, m::Optimizer)

This function recognizes, stores, and replaces a sub-tree `expr` with available
user-defined/built-in structures patterns. The procedure creates the required number
of lifted variables based on the patterns that it is trying to recognize.
Then, it goes through all built-in structures and performs operatins to convexify the problem.

Specific structure pattern information will be described formally.
"""
function detect_nonconvex_terms(expr::Any, constr_id::Int, m::Optimizer; kwargs...)

    # First process user-defined structures in-cases of over-ride
    # for i in 1:length(get_option(m, :term_patterns))
    #     skip, expr = get_option(m, :term_patterns)[i](expr, constr_id, m)
    #     skip && return expr
    # end

    # NOTE :: Sequence of which term to detect matters here
    #         More specific term should be detected first to reduce the size of relaxation
    #         model. For example, power-2 or bilinear term should be detected before
    #         general multilinear terms to apply better outter approxiamtion.

    # LEVEL 1 : : Recognize all built-in structural patterns
    skip, expr = detect_discretemulti_term(expr, constr_id, m)     #L1 : General case : discrete variables * continous variables
    skip && return expr

    skip, expr = detect_binprod_term(expr, constr_id, m)           #L1 : binprod = binary products
    skip && return expr

    # LEVEL 2 : : Recognize all built-in structural patterns
    skip, expr = detect_bilinear_term(expr, constr_id, m)          #L2
    skip && return expr

    skip, expr = detect_monomial_term(expr, constr_id, m)          #L2 : must go before multilinear
    skip && return expr

    skip, expr = detect_multilinear_term(expr, constr_id, m)       #L2
    skip && return expr

    return expr # if no structure is detected, simply return the original tree
end

function store_nonconvex_term(
    m::Optimizer,
    nl_key::Any,
    var_idxs::Any,
    term_type::Symbol,
    operator::Symbol,
    evaluator::Function,
    bd_resolver::Function,
    discvar_collector::Function,
)
    l_cnt = length(keys(m.linear_terms))
    nl_cnt = length(keys(m.nonconvex_terms))

    y_idx = m.num_var_orig + nl_cnt + l_cnt + 1   # y is always lifted var
    lifted_var_ref = Expr(:ref, :x, y_idx)
    lifted_constr_ref = build_constr_block(y_idx, var_idxs, operator)

    m.nonconvex_terms[nl_key] = Dict(
        :lifted_var_ref => lifted_var_ref,
        :id => nl_cnt + 1,
        :y_idx => y_idx,
        :y_type =>
            resolve_lifted_var_type([m.var_type[k] for k in var_idxs], operator),
        :var_idxs => var_idxs,
        :ref => nl_key,
        :evaluator => evaluator,
        :lifted_constr_ref => lifted_constr_ref,
        :constr_id => Set(),
        :nonlinear_type => term_type,
        :convexified => false,
        :bound_resolver => bd_resolver,
        :discvar_collector => discvar_collector,
    )

    m.term_seq[nl_cnt+l_cnt+1] = nl_key                              # Assistive information

    # push!(m.var_type, :Cont)  # TODO check if this replacement is good since additional constraints should be able to sufficiently constraint the type
    push!(m.var_type, m.nonconvex_terms[nl_key][:y_type])            # Keep track of the lifted var type
    get_option(m, :log_level) > 199 &&
        println("found lifted $(term_type) term $(lifted_constr_ref)")
    return y_idx
end

function store_linear_term(m::Optimizer, term_key::Any, expr::Any)#, bound_resolver::Function)
    l_cnt = length(keys(m.linear_terms))
    nl_cnt = length(keys(m.nonconvex_terms))

    y_idx = m.num_var_orig + nl_cnt + l_cnt + 1

    lifted_var_ref = Expr(:ref, :x, y_idx)
    lifted_constr_ref = Expr(:call, :(==), lifted_var_ref, expr)

    m.linear_terms[term_key] = Dict(
        :lifted_var_ref => lifted_var_ref,
        :id => length(keys(m.linear_terms)) + 1,
        :ref => term_key,
        :y_idx => y_idx,
        :y_type => resolve_lifted_var_type(
            [m.var_type[k[2]] for k in term_key[:coef_var]],
            :+,
        ),
        :evaluator => linear,
        :lifted_constr_ref => lifted_constr_ref,
        :constr_id => Set(),
        :bound_resolver => nothing,
    )

    m.term_seq[l_cnt+nl_cnt+1] = term_key
    push!(m.var_type, m.linear_terms[term_key][:y_type]) # Keep track of the lifted var type
    get_option(m, :log_level) > 199 &&
        println("found lifted linear term $(lifted_var_ref) = $expr")

    return y_idx
end

function lift_nonconvex_term(m::Optimizer, nl_key, constr_id::Int, scalar = 1.0)
    push!(m.nonconvex_terms[nl_key][:constr_id], constr_id)

    if scalar == 1.0
        return m.nonconvex_terms[nl_key][:lifted_var_ref]
    else
        return Expr(:call, :*, m.nonconvex_terms[nl_key][:lifted_var_ref], scalar)
    end
end

function lift_linear_term(m::Optimizer, term_key, constr_id::Int)
    push!(m.linear_terms[term_key][:constr_id], constr_id)
    return m.linear_terms[term_key][:lifted_var_ref]

    return
end

function detect_linear_term(expr::Any, constr_id::Int, m::Optimizer)
    @assert (expr.head == :call || expr.head == :ref)
    coef_fetch = Dict(:+ => 1.0, :- => -1.0)

    # Re-process the expression sub-tree [REQUIRED]
    expr_resolve_const(expr)
    expr_resolve_sign(expr)
    expr_flatten(expr)

    if expr.args[1] in [:+, :-]
        scalar = 0.0
        coef_var = Set()
        for i in 2:length(expr.args)  # TODO: Consider recursive operation
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                (i == 2) ? scalar = expr.args[i] :
                scalar += coef_fetch[expr.args[1]] * expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue #should never happen
            if (expr.args[i].head == :ref) && isa(expr.args[i].args[2], Int)
                (i == 2) ? push!(coef_var, (1.0, expr.args[i].args[2])) :
                push!(coef_var, (coef_fetch[expr.args[1]], expr.args[i].args[2]))
                continue
            end

            # Specical Check
            if expr.args[i].head == :call &&
               expr.args[i].args[1] == :* &&
               length(expr.args[i].args) == 3
                sub_coef =
                    [j for j in expr.args[i].args if (isa(j, Int) || isa(j, Float64))]
                sub_vars = [
                    j.args[2] for j in expr.args[i].args if
                    ((:head in fieldnames(typeof(j))) && j.head == :ref)
                ]
                (isempty(sub_coef) || isempty(sub_vars)) && return false, expr
                (length(sub_coef) != 1 || length(sub_vars) != 1) && return false, expr
                (i == 2) ? push!(coef_var, (1.0 * sub_coef[1], sub_vars[1])) :
                push!(coef_var, (coef_fetch[expr.args[1]] * sub_coef[1], sub_vars[1]))
                continue
            end

            # General Check
            if expr.args[i].head == :call &&
               expr.args[i].args[1] in [:-, :+] &&
               length(expr.args[i].args) == 2 # resolve -(2) or -(x) terms
                expr.args[i].args[1] == :+ ? sub_coef = [1.0] : sub_coef = [-1.0]
                sub_vars = [
                    j.args[2] for j in expr.args[i].args if
                    ((:head in fieldnames(typeof(j))) && j.head == :ref)
                ]
                isempty(sub_vars) && return false, expr
                length(sub_vars) != 1 && return false, expr
                (i == 2) ? push!(coef_var, (1.0 * sub_coef[1], sub_vars[1])) :
                push!(coef_var, (coef_fetch[expr.args[1]] * sub_coef[1], sub_vars[1]))
            else
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)  # Recursive detection
                down_check ? expr.args[i] = linear_lift_var : return false, expr
                push!(coef_var, (1.0, expr.args[i].args[2]))
            end
        end
        # By reaching here, it is already certain that we have found the term, always treat with :+
        term_key = Dict(:scalar => scalar, :coef_var => coef_var, :sign => :+)
        term_key in keys(m.linear_terms) || store_linear_term(m, term_key, expr)
        return true, lift_linear_term(m, term_key, constr_id)
    elseif expr.args[1] in [:*] && length(expr.args) == 3
        # For terms like (3*x)*y
        scalar = 0.0
        coef_var = Set()

        sub_coef = [i for i in expr.args if (isa(i, Int) || isa(i, Float64))]
        sub_vars = [
            i.args[2] for
            i in expr.args if ((:head in fieldnames(typeof(i))) && i.head == :ref)
        ]
        (isempty(sub_coef) || isempty(sub_vars)) && return false, expr
        (length(sub_coef) != 1 || length(sub_vars) != 1) && return false, expr
        push!(coef_var, (1.0 * sub_coef[1], sub_vars[1]))

        # By reaching here, it is already certain that we have found the term, always treat with :+
        term_key = Dict(:scalar => scalar, :coef_var => coef_var, :sign => :+)
        term_key in keys(m.linear_terms) || store_linear_term(m, term_key, expr)
        return true, lift_linear_term(m, term_key, constr_id)
    end

    return false, expr
end

function basic_linear_bounds(m::Optimizer, k::Any, linear_terms = nothing)
    linear_terms === nothing ? linear_terms = m.linear_terms : linear_term = linear_terms

    lifted_idx = linear_terms[k][:y_idx]
    ub = 0.0
    lb = 0.0
    for j in linear_terms[k][:ref][:coef_var]
        (j[1] > 0.0) ? ub += abs(j[1]) * m.u_var_tight[j[2]] :
        ub -= abs(j[1]) * m.l_var_tight[j[2]]
        (j[1] > 0.0) ? lb += abs(j[1]) * m.l_var_tight[j[2]] :
        lb -= abs(j[1]) * m.u_var_tight[j[2]]
    end
    lb += linear_terms[k][:ref][:scalar]
    ub += linear_terms[k][:ref][:scalar]
    if lb > m.l_var_tight[lifted_idx] + get_option(m, :tol)
        m.l_var_tight[lifted_idx] = lb
    end
    if ub < m.u_var_tight[lifted_idx] - get_option(m, :tol)
        m.u_var_tight[lifted_idx] = ub
    end

    return
end

function basic_linear_bounds(m::Optimizer, k::Any, d::Dict)
    lifted_idx = m.linear_terms[k][:y_idx]
    ub = 0.0
    lb = 0.0
    for j in m.linear_terms[k][:ref][:coef_var]
        (j[1] > 0.0) ? ub += abs(j[1]) * d[j[2]][end] : ub -= abs(j[1]) * d[j[2]][1]
        (j[1] > 0.0) ? lb += abs(j[1]) * d[j[2]][1] : lb -= abs(j[1]) * d[j[2]][end]
    end
    lb += m.linear_terms[k][:ref][:scalar]
    ub += m.linear_terms[k][:ref][:scalar]

    if lb > d[lifted_idx][1] + get_option(m, :tol)
        d[lifted_idx][1] = lb
    end
    if ub < d[lifted_idx][end] - get_option(m, :tol)
        d[lifted_idx][end] = ub
    end

    return d
end

## Evaluators ##
bpml(k, vec) = prod([vec[i] for i in k[:var_idxs]])
discretemulti(k, vec) = prod([vec[i] for i in k[:var_idxs]])
binprod(k, vec) = prod([vec[i] for i in k[:var_idxs]])
binlin(k, vec) = prod([vec[i] for i in k[:var_idxs]])
bilinear(k, vec) = prod([vec[i] for i in k[:var_idxs]])
multilinear(k, vec) = prod([vec[i] for i in k[:var_idxs]])
monomial(k, vec) = vec[k[:var_idxs][1]]^2
function linear(k, vec)
    return k[:ref][:scalar] .+ sum([i[1] * vec[i[2]] for i in k[:ref][:coef_var]])
end

"""
    Recognize prodcuts of binary variables and multilinear products

        General Case : x1 * x2 .. * xN * y1 * y2 .. * yM
            where x are binary variables, y are continous variables

    Leads to BINLIN terms, with BINPROD, INTPROD, INTLIN if necessary
"""
function detect_discretemulti_term(expr::Any, constr_id::Int, m::Optimizer)

    # Always construct the binlin term after lifting
    @assert (expr.head == :call || expr.head == :ref)

    if (expr.args[1] == :*)
        # Pattern: coefficients * x * y * z ..., where x, y, z are all binary variables
        var_idxs = []
        var_types = []
        scalar = 1.0
        for i in 1:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                scalar *= expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_types, m.var_type[expr.args[i].args[2]])
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                push!(var_types, m.var_type[linear_lift_var.args[2]])
                continue
            end
        end

        # term_key = [Expr(:ref, :x, idx) for idx in var_idxs]

        cont_var_idxs = [idx for idx in var_idxs if m.var_type[idx] == :Cont]
        bin_var_idxs = [idx for idx in var_idxs if m.var_type[idx] == :Bin]
        int_var_idxs = [idx for idx in var_idxs if m.var_type[idx] == :Int]

        # Must carry at both discrete and continous variables
        isempty(int_var_idxs) && isempty(bin_var_idxs) && return false, expr
        isempty(cont_var_idxs) && return false, expr

        # Lift clusters of continous variables multiplication if necessary
        if length(cont_var_idxs) > 1
            # ml_term_key = [Expr(:ref, :x, idx) for idx in cont_var_idxs]
            ml_term_expr = Expr(:call, :*)
            for idx in cont_var_idxs
                push!(ml_term_expr.args, Expr(:ref, :x, idx))
            end
            ml_lift_term = detect_nonconvex_terms(ml_term_expr, constr_id, m)
            ml_idx = ml_lift_term.args[2]
        else
            ml_idx = cont_var_idxs[1]
        end

        # Lift clusters of binary vars multiplication if necessary
        if length(bin_var_idxs) > 1
            bp_term_key = [Expr(:ref, :x, idx) for idx in bin_var_idxs]
            bp_term_expr = Expr(:call, :*)
            for idx in bin_var_idxs
                push!(bp_term_expr.args, Expr(:ref, :x, idx))
            end
            bp_lift_term = detect_nonconvex_terms(bp_term_expr, constr_id, m)
            bp_idx = bp_lift_term.args[2]
        else
            isempty(bin_var_idxs) ? bp_idx = -1 : bp_idx = bin_var_idxs[1]
        end

        # lift clusters of integer variables multiplication if necessary
        if length(int_var_idxs) > 1
            ip_term_key = [Expr(:ref, :x, idx) for idx in int_var_idxs]
            ip_term_expr = Expr(:call, :*)
            for idx in int_var_idxs
                push!(ip_term_expr.args, Expr(:ref, :x, idx))
            end
            ip_lift_term = detect_nonconvex_terms(ip_term_expr, constr_id, m)
            ip_idx = ip_lift_term.args[2]
        else
            isempty(int_var_idxs) ? ip_idx = -1 : ip_idx = int_var_idxs[1]
        end

        if ip_idx < 0 # binlin term if no integer variable
            binlin_key = [Expr(:ref, :x, bp_idx), Expr(:ref, :x, ml_idx)]
            binlin_idxs = [bp_idx; ml_idx]
            binlin_key in keys(m.nonconvex_terms) || store_nonconvex_term(
                m,
                binlin_key,
                binlin_idxs,
                :BINLIN,
                :*,
                binlin,
                basic_binlin_bounds,
                collect_binlin_discvar,
            )
            return true, lift_nonconvex_term(m, binlin_key, constr_id, scalar)
        end

        # binlin_key = [Expr(:ref, :x, bp_idx), Expr(:ref, :x, intlin_idx)]
        binlin_key = [Expr(:ref, :x, bp_idx)]
        # binlin_idxs = [bp_idx; intlin_idx]
        binlin_idxs = [bp_idx]
        binlin_key in keys(m.nonconvex_terms) || store_nonconvex_term(
            m,
            binlin_key,
            binlin_idxs,
            :BINLIN,
            :*,
            binlin,
            basic_binlin_bounds,
            collect_binlin_discvar,
        )
        return true, lift_nonconvex_term(m, binlin_key, constr_id, scalar)
    end

    return false, expr
end

function basic_binlin_bounds(m::Optimizer, k::Any)
    lifted_idx = m.nonconvex_terms[k][:y_idx]

    prod_idxs = [i for i in m.nonconvex_terms[k][:var_idxs] if m.var_type[i] == :Cont]
    @assert length(prod_idxs) == 1
    lin_idx = prod_idxs[1]

    if m.l_var_tight[lin_idx] > 0.0
        m.l_var_tight[lifted_idx] = 0.0
        m.u_var_tight[lifted_idx] = m.u_var_tight[lin_idx]
    elseif m.u_var_tight[lin_idx] < 0.0
        m.u_var_tight[lifted_idx] = 0.0
        m.l_var_tight[lifted_idx] = m.l_var_tight[lin_idx]
    else
        m.u_var_tight[lifted_idx] = m.u_var_tight[lin_idx]
        m.l_var_tight[lifted_idx] = m.l_var_tight[lin_idx]
    end

    return
end

function basic_binlin_bounds(m::Optimizer, k::Any, d::Dict)
    lifted_idx = m.nonconvex_terms[k][:y_idx]

    prod_idxs = [i for i in m.nonconvex_terms[k][:var_idxs] if m.var_type[i] == :Cont]
    @assert length(prod_idxs) == 1
    lin_idx = prod_idxs[1]

    if d[lin_idx][1] > 0.0
        d[lifted_idx][1] = 0.0
        d[lifted_idx][end] = d[lin_idx][end]
    elseif d[lin_idx][end] < 0.0
        d[lifted_idx][end] = 0.0
        d[lifted_idx][1] = d[lin_idx][1]
    else
        d[lifted_idx][end] = d[lin_idx][end]
        d[lifted_idx][1] = d[lin_idx][1]
    end

    return d
end

function collect_binlin_discvar(m::Optimizer, k::Any; var_bowl = nothing)
    # Exact linearization exists
    return
end

"""
    Recognize products of binary variables : x1 * x2 * .. * xN
"""
function detect_binprod_term(expr::Any, constr_id::Int, m::Optimizer)
    @assert (expr.head == :call || expr.head == :ref)
    if (expr.args[1] == :*)
        # Pattern: coefficients * x * y * z ..., where x, y, z are all binary variables
        var_idxs = []
        scalar = 1.0
        for i in 1:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                scalar *= expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            !isempty(var_idxs) && m.var_type[var_idxs[end]] != :Bin && return false, expr
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                m.var_type[linear_lift_var.args[2]] != :Bin && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                continue
            end
        end
        if length(var_idxs) >= 2
            term_key = [Expr(:ref, :x, idx) for idx in var_idxs]
            term_key in keys(m.nonconvex_terms) || store_nonconvex_term(
                m,
                term_key,
                var_idxs,
                :BINPROD,
                :*,
                binprod,
                basic_binprod_bounds,
                collect_binprod_discvar,
            )
            return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
        end
    elseif (expr.args[1] == :^) && length(expr.args) == 3
        # Pattern: (x)^(>2), where x is binary variable
        var_idxs = []
        power_scalar = 0
        scalar = 1.0
        for i in 2:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                power_scalar += expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            !isempty(var_idxs) && m.var_type[var_idxs[end]] != :Bin && return false, expr
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                m.var_type[linear_lift_var.args[2]] != :Bin && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                continue
            end
        end
        if length(var_idxs) == 1 && power_scalar > 2.0 && mod(power_scalar, 1.0) == 0.0
            term_key = [Expr(:ref, :x, var_idxs[1]) for i in 1:power_scalar]
            term_key in keys(m.nonconvex_terms) || store_nonconvex_term(
                m,
                term_key,
                var_idxs,
                :BINPROD,
                :*,
                binprod,
                basic_binprod_bounds,
                collect_binprod_discvar,
            )
            return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
        end
    end

    return false, expr
end

function basic_binprod_bounds(m::Optimizer, k::Any)
    lifted_idx = m.nonconvex_terms[k][:lifted_var_ref].args[2]
    m.l_var_tight[lifted_idx] = 0
    m.u_var_tight[lifted_idx] = 1

    return
end

function basic_binprod_bounds(m::Optimizer, k::Any, d::Dict)
    lifted_idx = m.nonconvex_terms[k][:lifted_var_ref].args[2]
    d[lifted_idx][1] = 0
    d[lifted_idx][end] = 1

    return d
end

function collect_binprod_discvar(m::Optimizer, k::Any; var_bowl = nothing)
    # Exact linearization exists
    return
end

"""
    Future MONOMIAL Cluster
    Recognize bilinear terms: x * y, where x and y are continous variables
    Recognize multilinear terms: x1 * x2 * .. * xN, where all x_i ∀ i are continous variables
    Recognize monomial terms: x^2 or x * x, where x is continuous
"""
function detect_bilinear_term(expr::Any, constr_id::Int, m::Optimizer)
    @assert (expr.head == :call || expr.head == :ref)
    if (expr.args[1] == :*)  # confirm head (:*)
        # ----- Pattern : coefficient * x * y  ------ #
        # Collect children information for checking
        scalar = 1.0
        var_idxs = []
        for i in 2:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                scalar *= expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            !isempty(var_idxs) &&
                m.var_type[var_idxs[end]] in [:Bin, :Int] &&
                return false, expr    # Don't consider the discrete variable
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                m.var_type[var_idxs[end]] in [:Bin, :Int] && return false, expr  # Don't consider the discrete variable
                continue
            end
        end

        # Confirm detection of patter A and perform store & lifting procedures
        if (length(var_idxs) == 2) && length(Set(var_idxs)) == 2
            term_key = [Expr(:ref, :x, var_idxs[1]), Expr(:ref, :x, var_idxs[2])]
            if term_key in keys(m.nonconvex_terms) ||
               reverse(term_key) in keys(m.nonconvex_terms)
                term_key in keys(m.nonconvex_terms) ? term_key = term_key :
                term_key = reverse(term_key)
                return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
            else
                store_nonconvex_term(
                    m,
                    term_key,
                    var_idxs,
                    :BILINEAR,
                    :*,
                    bilinear,
                    basic_monomial_bounds,
                    collect_monomial_discvar,
                )
                return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
            end
        end
    end

    return false, expr
end

function detect_multilinear_term(expr::Any, constr_id::Int, m::Optimizer)
    @assert (expr.head == :call || expr.head == :ref)
    if (expr.args[1] == :*) # Pattern: coefficients * x * y * z ...
        var_idxs = []
        scalar = 1.0
        for i in 1:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                scalar *= expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            !isempty(var_idxs) &&
                m.var_type[var_idxs[end]] in [:Bin, :Int] &&
                return false, expr
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                m.var_type[var_idxs[end]] in [:Bin, :Int] && return false, expr
                continue
            end
        end
        if length(var_idxs) > 2
            term_key = [Expr(:ref, :x, idx) for idx in var_idxs]
            term_key in keys(m.nonconvex_terms) || store_nonconvex_term(
                m,
                term_key,
                var_idxs,
                :MULTILINEAR,
                :*,
                multilinear,
                basic_monomial_bounds,
                collect_monomial_discvar,
            )
            return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
        end
    elseif (expr.args[1] == :^) && length(expr.args) == 3 # Pattern: (x)^(>2)
        var_idxs = []
        power_scalar = 0
        scalar = 1.0
        for i in 2:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                power_scalar += expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            !isempty(var_idxs) &&
                m.var_type[var_idxs[end]] in [:Bin, :Int] &&
                return false, expr # Avoid fetching terms with discrete variables
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                m.var_type[var_idxs[end]] in [:Bin, :Int] && return false, expr
                continue
            end
        end
        if length(var_idxs) == 1 && power_scalar > 2.0 && mod(power_scalar, 1.0) == 0.0
            term_key = [Expr(:ref, :x, var_idxs[1]) for i in 1:power_scalar]
            term_key in keys(m.nonconvex_terms) || store_nonconvex_term(
                m,
                term_key,
                var_idxs,
                :MULTILINEAR,
                :*,
                multilinear,
                basic_monomial_bounds,
                collect_monomial_discvar,
            )
            return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
        end
    end

    return false, expr
end

function detect_monomial_term(expr::Any, constr_id::Int, m::Optimizer)
    if (expr.args[1] == :^) && length(expr.args) == 3
        # Pattern: (x)^(2)
        var_idxs = []
        power_scalar = 0
        scalar = 1.0
        for i in 2:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                power_scalar += expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            !isempty(var_idxs) &&
                m.var_type[var_idxs[end]] in [:Bin, :Int] &&
                return false, expr # Avoid fetching terms with discrete variables
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                m.var_type[var_idxs[end]] in [:Bin, :Int] && return false, expr # Avoid fetching terms with discrete variables
                continue
            end
        end

        # Detect 1.0 in the exponent and return only the variable
        if length(var_idxs) == 1 && power_scalar == 1.0
            return false, Expr(:call, expr.args[2])
        end

        if length(var_idxs) == 1 && power_scalar == 2.0
            term_key = [Expr(:ref, :x, var_idxs[1]) for i in 1:2]
            term_key in keys(m.nonconvex_terms) || store_nonconvex_term(
                m,
                term_key,
                var_idxs,
                :MONOMIAL,
                :*,
                monomial,
                basic_monomial_bounds,
                collect_monomial_discvar,
            )
            return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
        end
    end

    # Type 2 monomial term : x * x
    if (expr.args[1] == :*)  # confirm head (:*)
        # ----- Pattern : coefficient * x * y  ------ #
        scalar = 1.0
        var_idxs = []
        for i in 2:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                scalar *= expr.args[i]
                continue
            end
            (isa(expr.args[i], Symbol)) && continue
            (expr.args[i].head == :ref) &&
                isa(expr.args[i].args[2], Int) &&
                push!(var_idxs, expr.args[i].args[2])
            !isempty(var_idxs) &&
                m.var_type[var_idxs[end]] in [:Bin, :Int] &&
                return false, expr # Avoid fetching terms with discrete variables
            if (expr.args[i].head == :call)
                down_check, linear_lift_var =
                    detect_linear_term(expr.args[i], constr_id, m)
                !down_check && return false, expr
                push!(var_idxs, linear_lift_var.args[2])
                m.var_type[var_idxs[end]] in [:Bin, :Int] && return false, expr # Avoid fetching terms with discrete variables
                continue
            end
        end
        # Confirm detection of pattern A and perform store & lifting procedures
        if (length(var_idxs) == 2) && (length(Set(var_idxs)) == 1)
            term_key = [Expr(:ref, :x, var_idxs[1]) for i in 1:2]
            term_key in keys(m.nonconvex_terms) || store_nonconvex_term(
                m,
                term_key,
                var_idxs,
                :MONOMIAL,
                :*,
                monomial,
                basic_monomial_bounds,
                collect_monomial_discvar,
            )
            return true, lift_nonconvex_term(m, term_key, constr_id, scalar)
        end
    end

    return false, expr
end

function basic_monomial_bounds(m::Optimizer, k::Any)
    lifted_idx = m.nonconvex_terms[k][:lifted_var_ref].args[2]
    cnt = 0
    bound = []
    for var in k
        cnt += 1
        var_idx = var.args[2]
        var_bounds = [m.l_var_tight[var_idx], m.u_var_tight[var_idx]]
        if cnt == 1
            bound = copy(var_bounds)
        elseif cnt == 2
            bound = bound * var_bounds'
        else
            bound = vec(bound) * var_bounds'
        end
    end
    if minimum(bound) > m.l_var_tight[lifted_idx] + get_option(m, :tol)
        m.l_var_tight[lifted_idx] = minimum(bound)
        if m.nonconvex_terms[k][:nonlinear_type] == :MONOMIAL
            m.l_var_tight[lifted_idx] = 0.0
        end
    end
    if maximum(bound) < m.u_var_tight[lifted_idx] - get_option(m, :tol)
        m.u_var_tight[lifted_idx] = maximum(bound)
    end

    return
end

function basic_monomial_bounds(m::Optimizer, nlk::Any, d::Dict)
    lifted_idx = m.nonconvex_terms[nlk][:lifted_var_ref].args[2]
    cnt = 0
    bound = []
    for var in nlk
        cnt += 1
        var_idx = var.args[2]
        var_bounds = [d[var_idx][1], d[var_idx][end]]
        if cnt == 1
            bound = copy(var_bounds)
        elseif cnt == 2
            bound = bound * var_bounds'
        else
            bound = vec(bound) * var_bounds'
        end
    end

    if minimum(bound) > d[lifted_idx][1] + get_option(m, :tol)
        d[lifted_idx][1] = minimum(bound)
    end

    if maximum(bound) < d[lifted_idx][end] - get_option(m, :tol)
        d[lifted_idx][end] = maximum(bound)
    end

    return d
end

function collect_monomial_discvar(m::Optimizer, k::Any; var_bowl = nothing)
    for var in k
        @assert isa(var.args[2], Int)
        if var_bowl === nothing
            var.args[2] in m.candidate_disc_vars ||
                push!(m.candidate_disc_vars, var.args[2])
        else
            var.args[2] in var_bowl || push!(var_bowl, var.args[2])
        end
    end
    return
end

"""
    Recognize convex constraints
    A catch for type-A convex constraint expression
"""
function resolve_convex_constr(
    expr::Any,
    m::Optimizer = nothing,
    idx::Int = 0,
    scalar_bin = [],
    idxs_bin = [],
    power_bin = [],
    rhs = 0.0,
)
    if expr.args[1] in [:(<=), :(>=)] && idx > 0
        expr_orig = :constr
        sense = expr.args[1]
        rhs = expr.args[3]
        subs, rhs_strip = expr_strip_const(expr.args[2])  # Focus on the regularized subtree (stripped with constants)
        rhs += rhs_strip                                      # TODO: check if sign is flipped
    elseif expr.args[1] == :(==)
        return false
    elseif idx == 0
        expr_orig = :obj
        subs, rhs = expr_strip_const(expr)               # Focus on the regularized subtree (stripped with constants)
    end

    for sub in subs
        (isa(sub, Float64) || isa(sub, Int) || isa(sub, Symbol)) && return false
        !(sub.args[1] in [:+, :-, :*]) && return false
        (sub.head == :ref) && return false
        (sub.head == :call) && (length(sub.args) < 3) && return false
        if sub.args[1] in [:-, :+]
            for i in 2:length(sub.args)
                if isa(sub.args[i], Float64) || isa(sub.args[i], Int)
                    (sub.args[1] == [:-]) &&
                        ((i == 1) ? rhs += sub.args[i] : rhs -= sub.args[i])
                    (sub.args[1] == [:+]) && (rhs += sub.args[i])
                elseif (sub.args[i].head == :ref)
                    return false
                elseif (sub.args[i].head == :call)
                    scalar, idxs, powers = expr_is_axn(sub.args[i])
                    (scalar === nothing) && return false
                    if length(Set(idxs)) == 1
                        push!(idxs_bin, idxs[1])
                        push!(power_bin, sum(powers))
                    else
                        return false
                    end
                    (sub.args[1] == :-) && (
                        (i == 2) ? push!(scalar_bin, scalar) : push!(scalar_bin, -scalar)
                    )
                    (sub.args[1] == :+) && (push!(scalar_bin, scalar))
                end
            end
        elseif sub.args[1] in [:*]
            scalar, idxs, powers = expr_is_axn(sub)
            (scalar === nothing) && return false
            if length(Set(idxs)) == 1
                push!(idxs_bin, idxs[1])
                push!(power_bin, sum(powers))
            else
                return false
            end
            push!(scalar_bin, scalar)
        else
            return false    # don't support other operators
        end

        scalar_sign = sign(scalar_bin[1])
        if length(scalar_bin) > 1
            for i in 2:length(scalar_bin)
                !(scalar_sign == sign(scalar_bin[i])) && return false
            end
        end

        !(length(Set(power_bin)) == 1) && return false
        (expr.args[1] == :(<=)) && !(scalar_sign >= 0.0 && rhs >= 0.0) && return false
        (expr.args[1] == :(>=)) && !(scalar_sign <= 0.0 && rhs <= 0.0) && return false
        (expr.args[1] == :(<=)) && (scalar_sign <= 0.0) && return false
        (expr.args[1] == :(>=)) && (scalar_sign >= 0.0) && return false
    end

    if expr_orig == :constr
        # For anything reaches this point, we've detected most common attributes of a convex expression
        # Now, we should use the differences to indicate different types of convex expression
        convex_type = :Unknown

        power_check = [(i > 1.0) && mod(i, 2) == 0 for i in power_bin]    # Special case for linear constraints within @NLconstraint
        isempty(power_check) && return false

        # Convex constraint Type-A
        # sum_i (c_i*x_i^p) <= K (K > 0, p is an even positive integer and x_i \in R)   => Convex
        power_check = [(i > 1.0) && mod(i, 2) == 0 for i in power_bin]
        (convex_type == :Unknown) && prod(power_check) && (convex_type = :convexA)

        # Type-B: Convex constraint
        # sum_i (c_i*x_i^p) <= K (K > 0, p >= 1 and x_i >= 0)                           => Convex
        lb_check = [m.l_var_orig[i.args[2]] >= 0.0 for i in idxs_bin]
        power_check = [i > 1.0 for i in power_bin]
        (convex_type == :Unknown) &&
            prod(lb_check) &&
            prod(power_check) &&
            (convex_type = :convexB)

        # Convex constraint Type-C
        # sum_i (c_i*x_i^p) >= K (K > 0, 0 < p < 1 and x_i >= 0)                        => Convex
        power_check = [i < 1 && i > 0.0 for i in power_bin]
        lb_check = [m.l_var_orig[i.args[2]] >= 0.0 for i in idxs_bin]
        (convex_type == :Unknown) &&
            prod(power_check) &&
            prod(power_check) &&
            (convex_type = :convexC)

        # Convex constraint Type-D
        # sum_i (c_i*x_i^p) <= K (K > 0, p <= 0 and x_i > 0)                            => Convex
        power_check = [i <= 0.0 for i in power_bin]
        lb_check = [m.l_var_orig[i.args[2]] >= 0.0 for i in idxs_bin]
        (convex_type == :Unknown) &&
            prod(power_check) &&
            prod(power_check) &&
            (convex_type = :convexD)

        # If we really cannot figure out what is going on...
        (convex_type == :Unknown) && return false

        # Recording the nonlinear info
        m.nonlinear_constrs[idx] = Dict(
            :expr_idx => idx,
            :convex_type => convex_type,
            :nonlinear_type => :convex,
            :expr_orig => :constraints,
            :expr_ref => deepcopy(expr),
            :convexified => false,
        )

        # Recording the un-changed expression
        m.bounding_constr_expr_mip[idx] = expr

        # Recording structural identifier
        m.constr_structure[idx] = :convex

        # Recording the function for adding constraints
        m.bounding_constr_mip[idx] = Dict(
            :idx => idx,
            :expr => expr,
            :sense => sense,
            :coefs => scalar_bin,
            :vars => idxs_bin,
            :rhs => rhs,
            :cnt => length(idxs_bin),
            :powers => power_bin,
        )

        get_option(m, :log_level) > 99 && println("CONVEX Constraint $(idx): $(expr)")

        return true
    elseif expr_orig == :obj
        minimum
        convex_type = :Unknown
        (expr_isconst(m.obj_expr_orig)) && return true
        # Follows the same mapping to convex constraints

        # Important: This is a fix to return obj is non-convex if the exponents have value greater than 2.
        # This is needs to be removed once outer-approximation for convex functions is implemented
        (maximum(power_bin) > 2) && return false

        # Type-A: Convex objective function
        # sum_i (c_i*x_i^p) (p is an even positive integer and x_i \in R)   => Convex
        power_check = [i > 1.0 && mod(i, 2) == 0 for i in power_bin]
        (convex_type == :Unknown) && prod(power_check) && (convex_type = :convexA)

        # Type-B: Convex objective function
        # sum_i (c_i*x_i^p) (p >= 1 and x_i >= 0)                           => Convex
        lb_check = [m.l_var_orig[i.args[2]] >= 0.0 for i in idxs_bin]
        power_check = [i > 1.0 for i in power_bin]
        (convex_type == :Unknown) &&
            prod(lb_check) &&
            prod(power_check) &&
            (convex_type = :convexB)

        # Type-D: Convex objective function
        # sum_i (c_i*x_i^p) (p <= 0 and x_i > 0) => Convex
        power_check = [i <= 0.0 for i in power_bin]
        lb_check = [m.l_var_orig[i.args[2]] >= 0.0 for i in idxs_bin]
        (convex_type == :Unknown) &&
            prod(power_check) &&
            prod(power_check) &&
            (convex_type = :convexD)

        convex_type == :Unknown && return false

        # Recording the nonlinear info
        m.nonlinear_constrs[idx] = Dict(
            :expr_orig => :objective,
            :expr_idx => idx,
            :convex_type => convex_type,
            :nonlinear_type => :convex,
            :expr_ref => deepcopy(expr),
            :convexified => false,
        )

        # Recording the un-changed expression
        m.bounding_obj_expr_mip = expr

        # Recording structural identifier
        m.obj_structure = :convex

        # Record a function that can be used to add objective function
        m.bounding_obj_mip = Dict(
            :sense => nothing,
            :coefs => scalar_bin,
            :vars => idxs_bin,
            :rhs => -rhs,
            :cnt => length(idxs_bin),
            :powers => power_bin,
        )

        get_option(m, :log_level) > 99 && println("CONVEX Objective: $(expr)")
        return true
    end

    return false
end

# println("--------------------------------------------------------------------------")
# println("Multi4/N - exprmode 1 -> X1 * X2 * X3 * X4")
# println("Multi4/N - exprmode 2 -> (X1*X2) * (X3*X4)")
# println("Multi4/N - exprmode 3 -> (X1*X2) * X3 * X4")
# println("Multi4/N - exprmode 4 -> X1 * X2 * (X3*X4)")
# println("Multi4/N - exprmode 5 -> ((X1*X2) * X3) * X4")
# println("Multi4/N - exprmode 6 -> (X1*X2*X3) *X4")
# println("Multi4/N - exprmode 7 -> X1 * (X2 * (X3*X4))")
# println("Multi4/N - exprmode 8 -> X1 * (X2*X3) * X4")
# println("Multi4/N - exprmode 9 -> X1 * (X2*X3*X4)")
# println("Multi4/N - exprmode 10 -> X1 * ((X2*X3) * X4)")
# println("Multi4/N - exprmode 11 -> (X1 * (X2*X3)) * X4")
# println("--------------------------------------------------------------------------")
# println("Multi3/N - exprmode 1 -> X1 * X2 * X3")
# println("Multi3/N - exprmode 2 -> (X1*X2) * X3")
# println("Multi3/N - exprmode 3 -> X1 * (X2*X3)")
# println("--------------------------------------------------------------------------")
# println("                                Options")
# println("N | K | convhull | exprmode | unifrom | randomub | sos2 | presolve | delta")
# println("--------------------------------------------------------------------------")

function multi4(; verbose = false, solver = nothing, exprmode = 1)
    m = JuMP.Model(solver)

    Random.seed!(1)
    @variable(m, 0.1 <= x[1:4] <= rand() * 100)
    if exprmode == 1
        @NLobjective(m, Max, x[1] * x[2] * x[3] * x[4])
    elseif exprmode == 2
        @NLobjective(m, Max, (x[1] * x[2]) * (x[3] * x[4]))
    elseif exprmode == 3
        @NLobjective(m, Max, (x[1] * x[2]) * x[3] * x[4])
    elseif exprmode == 4
        @NLobjective(m, Max, x[1] * x[2] * (x[3] * x[4]))
    elseif exprmode == 5
        @NLobjective(m, Max, (((x[1] * x[2]) * x[3]) * x[4]))
    elseif exprmode == 6
        @NLobjective(m, Max, (x[1] * x[2] * x[3]) * x[4])
    elseif exprmode == 7
        @NLobjective(m, Max, x[1] * (x[2] * (x[3] * x[4])))
    elseif exprmode == 8
        @NLobjective(m, Max, x[1] * (x[2] * x[3]) * x[4])
    elseif exprmode == 9
        @NLobjective(m, Max, x[1] * (x[2] * x[3] * x[4]))
    elseif exprmode == 10
        @NLobjective(m, Max, x[1] * ((x[2] * x[3]) * x[4]))
    elseif exprmode == 11
        @NLobjective(m, Max, (x[1] * (x[2] * x[3])) * x[4])
    else
        error("exprmode argument only taks from 1-7")
    end
    @constraint(m, sum(x[i] for i in 1:4) <= 4)

    if verbose
        print(m)
    end

    return m
end

function multi3(; verbose = false, solver = nothing, exprmode = 1)
    m = JuMP.Model(solver)

    Random.seed!(1)
    ub = rand()
    @variable(m, 0.1 <= x[1:3] <= ub * 1000)
    if exprmode == 1
        @NLobjective(m, Max, x[1] * x[2] * x[3])
    elseif exprmode == 2
        @NLobjective(m, Max, (x[1] * x[2]) * x[3])
    elseif exprmode == 3
        @NLobjective(m, Max, x[1] * (x[2] * x[3]))
    else
        error("exprmode argument only taks from 1-7")
    end

    @constraint(m, sum(x[i] for i in 1:3) <= 3)

    if verbose
        print(m)
    end

    return m
end

function multi2(; verbose = false, solver = nothing)
    # Global solution: 0.92906489 (arg min: [0.7336635, 1.266336])

    m = JuMP.Model(solver)

    Random.seed!(1)
    @variable(m, 0.1 <= x[1:2] <= rand() * 10)
    @NLobjective(m, Max, x[1] * x[2])
    @constraint(m, sum(x[i] for i in 1:2) <= 2)

    if verbose
        print(m)
    end

    return m
end

function multi4N(;
    verbose = false,
    exprmode = 1,
    solver = nothing,
    N = 1,
    randomub = true,
)
    m = JuMP.Model(solver)

    M = 1 + 3 * N
    Random.seed!(100)
    isa(randomub, Bool) ? @variable(m, 0.1 <= x[1:M] <= 100 * rand()) :
    @variable(m, 0.1 <= x[1:M] <= randomub)

    if exprmode == 1
        @NLobjective(m, Max, sum(x[i] * x[i+1] * x[i+2] * x[i+3] for i in 1:3:(M-1)))
    elseif exprmode == 2
        @NLobjective(m, Max, sum((x[i] * x[i+1]) * (x[i+2] * x[i+3]) for i in 1:3:(M-1)))
    elseif exprmode == 3
        @NLobjective(m, Max, sum((x[i] * x[i+1]) * x[i+2] * x[i+3] for i in 1:3:(M-1)))
    elseif exprmode == 4
        @NLobjective(m, Max, sum(x[i] * x[i+1] * (x[i+2] * x[i+3]) for i in 1:3:(M-1)))
    elseif exprmode == 5
        @NLobjective(
            m,
            Max,
            sum((((x[i] * x[i+1]) * x[i+2]) * x[i+3]) for i in 1:3:(M-1))
        )
    elseif exprmode == 6
        @NLobjective(m, Max, sum((x[i] * x[i+1] * x[i+2]) * x[i+3] for i in 1:3:(M-1)))
    elseif exprmode == 7
        @NLobjective(m, Max, sum(x[i] * (x[i+1] * (x[i+2] * x[i+3])) for i in 1:3:(M-1)))
    elseif exprmode == 8
        @NLobjective(m, Max, sum(x[i] * (x[i+1] * x[i+2]) * x[i+3] for i in 1:3:(M-1)))
    elseif exprmode == 9
        @NLobjective(m, Max, sum(x[i] * (x[i+1] * x[i+2] * x[i+3]) for i in 1:3:(M-1)))
    elseif exprmode == 10
        @NLobjective(m, Max, sum(x[i] * ((x[i+1] * x[i+2]) * x[i+3]) for i in 1:3:(M-1)))
    elseif exprmode == 11
        @NLobjective(m, Max, sum((x[i] * (x[i+1] * x[i+2])) * x[i+3] for i in 1:3:(M-1)))
    else
        error("exprmode argument only taks from 1-7")
    end

    @constraint(m, [i in 1:3:(M-1)], x[i] + x[i+1] + x[i+2] + x[i+3] <= 4)

    if verbose
        print(m)
    end

    return m
end

function multi3N(;
    verbose = false,
    randomub = nothing,
    solver = nothing,
    exprmode = 1,
    N = 1,
    delta = 4,
)
    m = JuMP.Model(solver)

    M = 1 + 2 * N
    Random.seed!(100)
    isa(randomub, Int) ? @variable(m, 0.1 <= x[1:M] <= randomub) :
    @variable(m, 0.1 <= x[1:M] <= rand() * 100)
    if exprmode == 1
        @NLobjective(m, Max, sum(x[i] * x[i+1] * x[i+2] for i in 1:2:(M-1)))
    elseif exprmode == 2
        @NLobjective(m, Max, sum((x[i] * x[i+1]) * x[i+2] for i in 1:2:(M-1)))
    elseif exprmode == 3
        @NLobjective(m, Max, sum(x[i] * (x[i+1] * x[i+2]) for i in 1:2:(M-1)))
    else
        error("exprmode argument only taks from 1-7")
    end

    @constraint(m, [i in 1:2:(M-1)], x[i] + x[i+1] + x[i+2] <= 3)

    if verbose
        print(m)
    end

    return m
end

function multiKND(;
    verbose = false,
    solver = nothing,
    exprmode = 1,
    randomub = true,
    N = 1,
    K = 2,
    D = 1,
)
    m = JuMP.Model(solver)

    M = K + (K - D) * (N - 1)
    Random.seed!(100)
    isa(randomub, Int) ? @variable(m, 0.1 <= x[1:M] <= randomub) :
    @variable(m, 0.1 <= x[1:M] <= rand() * 100)
    @NLobjective(m, Max, sum(prod(x[i+k] for k in 0:(K-1)) for i in 1:(K-D):(M-D)))
    @constraint(m, [i in 1:(K-D):(M-D)], sum(x[i+k] for k in 0:(K-1)) <= K)

    verbose && print(m)

    return m
end

module Alpine

using JuMP

import Combinatorics
import Statistics

const ALPINE_DEBUG = false

include("const.jl")

# Engine for high-level algorithmic control and user-interface

include("solver_options.jl")
include("MOI_wrapper/MOI_wrapper.jl")
include("MOI_wrapper/MOI_function2expr.jl")

# Engine for expression handling
include("nlexpr.jl")
include("operators.jl")

# Main algorithm
include("main_algorithm.jl")
include("presolve.jl")
include("bounding_model.jl")
include("embedding.jl")
include("heuristics.jl")

# Convexification
include("relaxations.jl")
include("multilinear.jl")

# Model manipulation and utilities
include("variable_bounds.jl")
include("utility.jl")

# Logging
include("log.jl")

end # module

@testset "Optimizer loading tests" begin
    # Random Model 1
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )
    m = operator_c(solver = test_solver)

    alpine = _build(m)
    @test isa(alpine, Alpine.Optimizer)

    # Expression Model 1
    m = exprstest(solver = test_solver)
    alpine = _build(m)
    @test isa(alpine, Alpine.Optimizer)
end

@testset "Partitioning variable selection tests :: nlp3" begin
    # Select all NL variable
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 0,
        "disc_uniform_rate" => 10,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "max_iter" => 1,
        "log_level" => 100,
    )

    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(JuMP.objective_value(m), 7049.2478976; atol = 1e-3)
    @test length(alpine.candidate_disc_vars) == 8
    @test length(alpine.disc_vars) == 8
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 0

    # Select all NL variable
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 2,
        "disc_uniform_rate" => 10,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "max_iter" => 1,
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(JuMP.objective_value(m), 7049.2478976; atol = 1e-3)
    @test length(alpine.candidate_disc_vars) == 8
    @test length(alpine.disc_vars) == 8
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 2

    # Minimum vertex cover algorithm
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 1,
        "disc_uniform_rate" => 10,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "max_iter" => 1,
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(JuMP.objective_value(m), 7049.2478976; atol = 1e-3)
    @test length(alpine.candidate_disc_vars) == 8
    @test length(alpine.disc_vars) == 3
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 1

    # Adaptive variable selection scheme :: disc_var_pick = 3
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 3,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "max_iter" => 2,
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(JuMP.objective_value(m), 7049.2478976; atol = 1e-3)
    @test length(alpine.candidate_disc_vars) == 8
    @test length(alpine.disc_vars) == 8
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 3
end

@testset "Partitioning variable selection tests :: castro2m2" begin

    # Select all NL variables
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 0,
        "disc_uniform_rate" => 10,
        "presolve_bt" => false,
        "max_iter" => 0,
    )

    m = castro2m2(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.LOCALLY_SOLVED

    @test length(alpine.candidate_disc_vars) == 10
    @test length(alpine.disc_vars) == 10
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 0

    # Select minimum vertex cover
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 1,
        "disc_uniform_rate" => 10,
        "presolve_bt" => false,
        "max_iter" => 0,
    )

    m = castro2m2(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.LOCALLY_SOLVED
    @test length(alpine.candidate_disc_vars) == 10
    @test length(alpine.disc_vars) == 4
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 1

    # Criteria 15 static selection
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 2,
        "disc_uniform_rate" => 15,
        "presolve_bt" => false,
        "max_iter" => 0,
    )

    m = castro2m2(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.LOCALLY_SOLVED

    @test length(alpine.candidate_disc_vars) == 10
    @test length(alpine.disc_vars) == 10
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 2
end

@testset "Partitioning variable selection tests :: blend029" begin

    # Select all NL variable
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => PAVITO,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 0,
        "disc_uniform_rate" => 10,
        "presolve_bt" => false,
        "max_iter" => 1,
        "log_level" => 100,
    )

    m = blend029_gl(solver = test_solver)
    alpine = _build(m)

    @test length(alpine.candidate_disc_vars) == 26
    @test Set(alpine.candidate_disc_vars) == Set([
        26,
        27,
        29,
        30,
        32,
        33,
        35,
        36,
        37,
        38,
        39,
        40,
        41,
        42,
        43,
        44,
        45,
        46,
        47,
        48,
        55,
        56,
        57,
        58,
        59,
        60,
    ])
    @test length(alpine.disc_vars) == 26
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 0

    # Minimum vertex cover
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => PAVITO,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 1,
        "disc_uniform_rate" => 10,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "max_iter" => 1,
        "log_level" => 100,
    )

    m = blend029_gl(solver = test_solver)
    alpine = _build(m)

    @test length(alpine.candidate_disc_vars) == 26
    @test Set(alpine.candidate_disc_vars) == Set([
        26,
        27,
        29,
        30,
        32,
        33,
        35,
        36,
        37,
        38,
        39,
        40,
        41,
        42,
        43,
        44,
        45,
        46,
        47,
        48,
        55,
        56,
        57,
        58,
        59,
        60,
    ])
    @test length(alpine.disc_vars) == 10
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 1

    # Adaptive Scheme vertex cover
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => PAVITO,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_var_pick" => 2,
        "disc_uniform_rate" => 10,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "max_iter" => 1,
        "log_level" => 100,
    )

    m = blend029_gl(solver = test_solver)
    alpine = _build(m)

    @test length(alpine.candidate_disc_vars) == 26
    @test length(Set(alpine.candidate_disc_vars)) == 26
    # TODO provide a check to see if candidate_disc_vars are all covered
    @test length(alpine.disc_vars) == 10
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 2
end

@testset "Partitioning variable selection tests :: castro6m2" begin

    # Dynamic Scheme step 1
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        # We don't use the default HiGHS because it struggles with the numerical
        # scaling of this example.
        # "mip_solver" => HIGHS,
        "mip_solver" => optimizer_with_attributes(
            HiGHS.Optimizer,
            MOI.Silent() => true,
            "presolve" => "off",
        ),
        "disc_var_pick" => 3,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "max_iter" => 2,
        "log_level" => 100,
    )

    m = castro6m2(solver = test_solver)
    JuMP.optimize!(m)
    alpine = JuMP.backend(m).optimizer.model

    @test JuMP.termination_status(m) == MOI.OTHER_LIMIT
    @test JuMP.objective_value(m) <= 228.87

    @test length(alpine.candidate_disc_vars) == 24
    @test length(Set(alpine.candidate_disc_vars)) == 24
    @test length(alpine.disc_vars) == 12
    @test length(Set(alpine.disc_vars)) == 12
    @test MOI.get(m, MOI.RawOptimizerAttribute("disc_var_pick")) == 3
end

@testset "Hessians disabled with user-defined multivariate functions" begin
    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )
    m = Model(test_solver)
    my_f(x, y) = (x - 1)^2 + (y - 2)^2
    JuMP.register(m, :my_f, 2, my_f, autodiff = true)
    @variable(m, x[1:2])
    @NLobjective(m, Min, my_f(x[1], x[2]))

    JuMP.set_optimize_hook(m, MOI.Utilities.attach_optimizer)
    JuMP.optimize!(m)
    JuMP.set_optimize_hook(m, nothing)
    alpine = JuMP.backend(m).optimizer.model
    @test !(:Hess in Alpine.features_available(alpine))
end

"""
process_expr(expr; kwargs...)

High-level wrapper for processing expression with sub-tree operators
"""
function process_expr(m::Optimizer)
    expr_initialization(m)      # S0 : initialize the space for parsing and analyzing
    expr_preprocess(m)          # S1 : pre-process the negative sign in expressions
    expr_parsing(m)             # S2 : parsing the expressions for nonlinear information
    expr_conversion(m)          # S3 : convert lifted(linear) expressions into affine function
    expr_finalized(m)           # S4 : finalize process by extracting some measurements

    return
end

"""
STEP 1: initialize the expression/ space
"""
function expr_initialization(m::Optimizer)

    # 0 : deepcopy data into mip lifted expr place holders
    m.bounding_obj_expr_mip = deepcopy(m.obj_expr_orig)
    m.bounding_obj_mip = Dict()

    for i in 1:m.num_constr_orig
        push!(m.bounding_constr_expr_mip, deepcopy(m.constr_expr_orig[i]))
        push!(m.bounding_constr_mip, Dict())
    end

    return
end

"""
STEP 2: preprocess expression for trivial sub-trees and nasty pieces for easier later process
"""
function expr_preprocess(m::Optimizer)
    expr_resolve_const(m.bounding_obj_expr_mip)
    expr_resolve_sign(m.bounding_obj_expr_mip)
    expr_flatten(m.bounding_obj_expr_mip)
    for i in 1:m.num_constr_orig
        expr_resolve_const(m.bounding_constr_expr_mip[i])
        expr_resolve_sign(m.bounding_constr_expr_mip[i])
        expr_flatten(m.bounding_constr_expr_mip[i].args[2])
    end

    return
end

"""
STEP 3: parse expression for patterns on either the generic level or term level
"""
function expr_parsing(m::Optimizer)

    # Throw an error if the objective expression has fractional exponents
    expr_is_fractional_exponent(m.bounding_obj_expr_mip)
    is_structural = expr_constr_parsing(m.bounding_obj_expr_mip, m)

    if !is_structural
        m.bounding_obj_expr_mip = expr_term_parsing(m.bounding_obj_expr_mip, 0, m)
        m.obj_structure = :generic_linear
    end
    (get_option(m, :log_level) > 199) && println("[OBJ] $(m.obj_expr_orig)")

    for i in 1:m.num_constr_orig
        expr = m.bounding_constr_expr_mip[i]

        # Throw an error if the constraint expression has fractional exponents
        if expr.args[1] in [:(<=), :(>=), :(==)]
            expr_is_fractional_exponent(expr.args[2])
        end

        is_structural = expr_constr_parsing(expr, m, i)
        if !is_structural
            m.bounding_constr_expr_mip[i] = expr_term_parsing(expr, i, m)
            m.constr_structure[i] = :generic_linear
        end
        (get_option(m, :log_level) > 199) && println("[CONSTR] $(m.constr_expr_orig[i])")
    end

    return
end

"""
STEP 4: convert the parsed expressions into affine-based function that can be used for adding JuMP constraints
"""
function expr_conversion(m::Optimizer)
    if m.obj_structure == :generic_linear
        m.bounding_obj_mip = expr_linear_to_affine(m.bounding_obj_expr_mip)
        m.obj_structure = :affine
    end
    get_option(m, :log_level) > 199 && println("type :: ", m.obj_structure)
    get_option(m, :log_level) > 199 && println("lifted ::", m.bounding_obj_expr_mip)
    get_option(m, :log_level) > 199 && println("coeffs ::", m.bounding_obj_mip[:coefs])
    get_option(m, :log_level) > 199 && println("vars ::", m.bounding_obj_mip[:vars])
    get_option(m, :log_level) > 199 && println("sense ::", m.bounding_obj_mip[:sense])
    get_option(m, :log_level) > 199 && println("rhs ::", m.bounding_obj_mip[:rhs])
    get_option(m, :log_level) > 199 && println("----------------")

    for i in 1:m.num_constr_orig
        if m.constr_structure[i] == :generic_linear
            m.bounding_constr_mip[i] =
                expr_linear_to_affine(m.bounding_constr_expr_mip[i])
            m.constr_structure[i] = :affine
        end
        get_option(m, :log_level) > 199 && println("type :: ", m.constr_structure[i])
        get_option(m, :log_level) > 199 &&
            println("lifted ::", m.bounding_constr_expr_mip[i])
        get_option(m, :log_level) > 199 &&
            println("coeffs ::", m.bounding_constr_mip[i][:coefs])
        get_option(m, :log_level) > 199 &&
            println("vars ::", m.bounding_constr_mip[i][:vars])
        get_option(m, :log_level) > 199 &&
            println("sense ::", m.bounding_constr_mip[i][:sense])
        get_option(m, :log_level) > 199 &&
            println("rhs ::", m.bounding_constr_mip[i][:rhs])
        get_option(m, :log_level) > 199 && println("----------------")
    end

    return
end

"""
STEP 5: collect information as needed for handy operations in the algorithm section
"""
function expr_finalized(m::Optimizer)
    collect_nonconvex_vars(m)
    m.candidate_disc_vars = sort(m.candidate_disc_vars)
    m.num_var_linear_mip = length(m.linear_terms)
    m.num_var_nonlinear_mip = length(m.nonconvex_terms)
    m.num_constr_convex = length([i for i in m.constr_structure if i == :convex])

    return m
end

function collect_nonconvex_vars(m::Optimizer)

    # Walk through all nonconvex terms
    for i in keys(m.nonconvex_terms)
        m.nonconvex_terms[i][:discvar_collector](m, i)
    end

    # TODO : reconsider how to structure this
    # NOTE : Walk through all integer variables that didn't appear in any nonconvex terms
    for i in 1:m.num_var_orig
        if !(i in m.candidate_disc_vars) && m.var_type[i] == :Int
            push!(m.candidate_disc_vars, i)
        end
    end

    return
end

function isa_variable_index(expr::Expr)
    return length(expr.args == 2) && expr.args[2] == :(MathOptInterface.VariableIndex)
end
get_index(expr::Expr) = expr.args[2]

function expr_strip_const(expr, subs = [], rhs = 0.0)
    exhaust_const = [
        !(expr.args[1] in [:+, :-]) ||
        !(isa(expr.args[i], Float64) || isa(expr.args[i], Int)) for
        i in 2:length(expr.args)
    ]
    if prod(exhaust_const)
        push!(subs, expr)
        return subs, rhs
    end

    for i in 2:length(expr.args)
        if (
            isa(expr.args[i], Float64) ||
            isa(expr.args[i], Int) ||
            isa(expr.args[i], Symbol)
        )
            (expr.args[1] == :+) && (rhs -= expr.args[i])
            (expr.args[1] == :-) && ((i == 2) ? rhs -= expr.args[i] : rhs += expr.args[i])
        elseif expr.args[i].head == :ref
            continue
        elseif expr.args[i].head == :call
            subs, rhs = expr_strip_const(expr.args[i], subs, rhs)
        end
    end

    return subs, rhs
end

"""
This utility function builds a constraint reference by repeating one
operator with a vector variable references.
For example,
input => y, x[1,2,3], :+
output => (y = x[1] + x[2] + x[3])::Expr
"""
function build_constr_block(y_idx::Int, var_idxs::Vector, operator::Symbol)
    expr_l_block = Expr(:call, :(==), Meta.parse("x[$(y_idx)]"))
    expr_r_block = Expr(:call, operator)
    for j in 1:length(var_idxs)
        push!(expr_r_block.args, Meta.parse("x[$(var_idxs[j])]"))
    end
    push!(expr_l_block.args, expr_r_block)

    return expr_l_block
end

"""
expr_constr_parsing(expr, m::Optimizer)

Recognize structural constraints.
"""
function expr_constr_parsing(expr::Expr, m::Optimizer, idx::Int = 0)

    # First process user-defined structures in-cases of over-ride
    # for i in 1:length(get_option(m, :constr_patterns))
    #    is_structural = get_option(m, :constr_patterns)[i](expr, m, idx)
    #    return
    # end

    isa(expr, Number) && return false
    # Recognize built-in special structural pattern
    if get_option(m, :recognize_convex)
        is_convex = resolve_convex_constr(expr, m, idx)
        is_convex && return true
    end

    # More structural patterns go here
    return false
end

function expr_is_axn(expr, scalar = 1.0, var_idxs = [], power = []; N = nothing)
    expr.args[1] in [:*, :^] || return nothing, nothing, nothing         # Limited Area

    if expr.args[1] == :*
        for i in 2:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                scalar *= expr.args[i]
            elseif (expr.args[i].head == :ref)
                @assert isa(expr.args[i].args[2], Int)
                push!(var_idxs, expr.args[i])
                push!(power, 1)
            elseif (expr.args[i].head == :call)
                scalar, var_idxs, power =
                    expr_is_axn(expr.args[i], scalar, var_idxs, power)
                scalar === nothing && return nothing, nothing, nothing
            end
        end
    elseif expr.args[1] == :^
        for i in 2:length(expr.args)
            if isa(expr.args[i], Float64) || isa(expr.args[i], Int)
                push!(power, expr.args[i])
                continue
            elseif (expr.args[i].head == :ref)
                push!(var_idxs, expr.args[i])
                continue
            elseif (expr.args[i].head == :call)
                return nothing, nothing, nothing
            end
        end
    end

    # If the user wants a specific N
    !(N === nothing) && !(length(var_idxs) == N) && return nothing, nothing, nothing
    (var_idxs === nothing) &&
        (scalar === nothing) &&
        (power === nothing) &&
        return nothing, nothing, nothing # Unrecognized sub-structure

    @assert length(var_idxs) == length(power)
    return scalar, var_idxs, power
end

"""
This function takes a constraint/objective expression and converts it into a affine expression data structure
Use the function to traverse linear expressions traverse_expr_linear_to_affine()
"""
function expr_linear_to_affine(expr)

    # The input should follow :(<=, LHS, RHS)
    affdict = Dict()
    isa(expr, Number) && return affdict

    if expr.args[1] in [:(==), :(>=), :(<=)] # For a constraint expression
        @assert isa(expr.args[3], Float64) || isa(expr.args[3], Int)
        @assert isa(expr.args[2], Expr)
        # non are buffer spaces, not used anywhere
        lhscoeff, lhsvars, rhs, non, non = traverse_expr_linear_to_affine(expr.args[2])
        rhs = -rhs + expr.args[3]
        affdict[:sense] = expr.args[1]

    elseif expr.head == :ref  # For single variable objective expression
        lhscoeff = [1.0]
        lhsvars = [expr]
        rhs = 0
        affdict[:sense] = nothing

    else # For an objective expression
        lhscoeff, lhsvars, rhs, non, non = traverse_expr_linear_to_affine(expr)
        affdict[:sense] = nothing
    end

    affdict[:coefs] = lhscoeff
    affdict[:vars] = lhsvars
    affdict[:rhs] = rhs
    @assert length(affdict[:coefs]) == length(affdict[:vars])
    affdict[:cnt] = length(affdict[:coefs])

    return affdict
end

"""

traverse_expr_linear_to_affine(expr, lhscoeffs=[], lhsvars=[], rhs=0.0, bufferVal=0.0, bufferVar=nothing, sign=1.0, level=0)

This function traverses the left hand side tree to collect affine terms.
Updated status : possible to handle (x-(x+y(t-z))) cases where signs are handled properly
"""
function traverse_expr_linear_to_affine(
    expr,
    lhscoeffs = [],
    lhsvars = [],
    rhs = 0.0,
    bufferVal = nothing,
    bufferVar = nothing,
    sign = 1.0,
    coef = 1.0,
    level = 0,
)

    # reversor = Dict(true => -1.0, false => 1.0)
    function sign_convertor(subexpr, pos)
        if length(subexpr.args) == 2 && subexpr.args[1] == :-
            return -1.0
        elseif length(subexpr.args) > 2 && subexpr.args[1] == :- && pos > 2
            return -1.0
        end
        return 1.0
    end

    if isa(expr, Number) # Capture any coefficients or right hand side
        (bufferVal !== nothing) ? bufferVal *= expr : bufferVal = expr * coef
        return lhscoeffs, lhsvars, rhs, bufferVal, bufferVar
    elseif expr in [:+, :-]    # TODO: what is this condition?
        if bufferVal !== nothing && bufferVar !== nothing
            push!(lhscoeffs, bufferVal)
            push!(lhsvars, bufferVar)
            bufferVal = 0.0
            bufferVar = nothing
        end
        return lhscoeffs, lhsvars, rhs, bufferVal, bufferVar
    elseif expr in [:*]
        return lhscoeffs, lhsvars, rhs, bufferVal, bufferVar
    elseif expr in [:(<=), :(==), :(>=)]
        return lhscoeffs, lhsvars, rhs, bufferVal, bufferVar
    elseif expr.head == :ref
        bufferVar = expr
        return lhscoeffs, lhsvars, rhs, bufferVal, bufferVar
    end

    # PATCH : Special Structure Recognition
    start_pos = 1
    if (expr.args[1] == :*) && (length(expr.args) == 3)
        if (isa(expr.args[2], Float64) || isa(expr.args[2], Int)) &&
           (expr.args[3].head == :call)
            (coef != 0.0) ? coef = expr.args[2] * coef : coef = expr.args[2]# Patch
            # coef = expr.args[2]
            start_pos = 3
            # @warn "Special expression structure detected [*, coef, :call, ...]. Currently using a beta fix..."
        end
    end

    for i in start_pos:length(expr.args)
        lhscoeff, lhsvars, rhs, bufferVal, bufferVar = traverse_expr_linear_to_affine(
            expr.args[i],
            lhscoeffs,
            lhsvars,
            rhs,
            bufferVal,
            bufferVar,
            sign * sign_convertor(expr, i),
            coef,
            level + 1,
        )
        if expr.args[1] in [:+, :-]  # Term segmentation [:-, :+], see this and wrap-up the current (linear) term
            if bufferVal !== nothing && bufferVar !== nothing  # (sign) * (coef) * (var) => linear term
                push!(lhscoeffs, sign * sign_convertor(expr, i) * bufferVal)
                push!(lhsvars, bufferVar)
                bufferVal = nothing
                bufferVar = nothing
            end
            if bufferVal !== nothing && bufferVar === nothing  # (sign) * (coef) => right-hand-side term
                rhs += sign * sign_convertor(expr, i) * bufferVal
                bufferVal = nothing
            end
            if bufferVal === nothing && bufferVar !== nothing && expr.args[1] == :+
                push!(lhscoeffs, sign * 1.0 * coef)
                push!(lhsvars, bufferVar)
                bufferVar = nothing
            end
            if bufferVal === nothing && bufferVar !== nothing && expr.args[1] == :-
                push!(lhscoeffs, sign * sign_convertor(expr, i) * coef)
                push!(lhsvars, bufferVar)
                bufferVar = nothing
            end
        elseif expr.args[1] in [:(<=), :(==), :(>=)]
            rhs = expr.args[end]
        end
    end

    if level == 0
        if bufferVal !== nothing && bufferVar !== nothing
            push!(lhscoeffs, bufferVal)
            push!(lhsvars, bufferVar)
            bufferVal = nothing
            bufferVar = nothing
        end
    end

    return lhscoeffs, lhsvars, rhs, bufferVal, bufferVar
end

"""
This function is treats the sign in expression trees by cleaning the following structure:
args
::+ || ::-
::Call || ::ref
By separating the structure with some dummy treatments
"""
function expr_resolve_sign(expr, level = 0; kwargs...)
    isa(expr, Number) && return
    resolver = Dict(:- => -1, :+ => 1)
    for i in 2:length(expr.args)
        if !isa(expr.args[i], Float64) && !isa(expr.args[i], Int) # Skip the coefficients
            if length(expr.args[i].args) == 2 && expr.args[i].head == :call
                if expr.args[i].args[1] == :- # Treatment for :(-x), replace with :(x*-1)
                    if expr.args[1] in [:*] # Only perform the treatment when connected with *
                        push!(expr.args, resolver[expr.args[i].args[1]])
                        expr.args[i] = expr.args[i].args[2]
                    elseif expr.args[1] in [:+, :-, :(==), :(<=), :(>=)]
                        expr.args[i] = expr.args[i]
                    else
                        error("Unexpected operator $(expr.args[i]) during resolving sign")
                    end
                elseif expr.args[i].args[1] == :+ # Treatment for :(+x) replace with :x
                    expr.args[i] = expr.args[i].args[2]
                end
            elseif expr.args[i].head == :call
                expr_resolve_sign(expr.args[i], level + 1)
            end
        end
    end

    return
end

"""
Recursively pre-process the expression by treating the coefficients
TODO: this function requires a lot of refining.
Most issues can be caused by this function.
"""
function expr_flatten(expr, level = 0; kwargs...)
    isa(expr, Number) && return
    if level > 0  # No trivial constraint is allowed "3>5"
        flat = expr_arrangeargs(expr.args)
        if isa(flat, Number)
            return flat
        else
            expr.args = flat
        end
    end

    for i in 2:length(expr.args)
        if isa(expr.args[i], Expr) && expr.args[i].head == :call
            expr.args[i] = expr_flatten(expr.args[i], level + 1)
        end
    end

    if level > 0  #Root level process, no additional processes
        expr.args = expr_arrangeargs(expr.args)
    end

    return expr
end

"""
Re-arrange children by their type.
Only consider 3 types: coefficients(Int64, Float64), :ref, :calls
Sequence arrangement is dependent on operator
"""
function expr_arrangeargs(args::Array; kwargs...)
    # A mapping used for operator treatments
    reverter = Dict(true => :-, false => :+)
    operator_coefficient_base =
        Dict{Symbol,Float64}(:+ => 0.0, :- => 0.0, :/ => 1.0, :* => 1.0, :^ => 1.0)

    # Treatment => Flatten pure number sub-tree
    allFloats = [i for i in 2:length(args) if isa(args[i], Float64)]
    if length(allFloats) == length(args) - 1
        val = args[2]
        for i in 3:length(args)
            val = eval(args[1])(val, args[i])
        end
        return val
    end

    if args[1] in [:^]
        return args
    elseif args[1] in [:/]
        # error("Alpine does not currently support `$(args[1])` operator")
        if (typeof(args[3]) == Float64) || (typeof(args[3]) == Int64)
            args = expr_resolve_const_denominator(args)
        else
            error(
                "Alpine does not currently support `$(args[1])` operator with a variable in the denominator",
            )
        end
    elseif args[1] in [:*, :+, :-]
        # Such generic operators can be handled
    else
        error(
            "Alpine does not currently support `$(args[1])` operator acting on a variable",
        )
    end

    if args[1] in [:*, :+, :-]
        val = operator_coefficient_base[args[1]] # initialize
        exprs = []
        refs = []

        valinit = false  # what is first children : needs consideration with :(-)
        refinit = false
        callinit = false

        for i in 2:length(args)
            if isa(args[i], Float64) || isa(args[i], Int)
                valinit += (i == 2)
                val = eval(args[1])(val, eval(reverter[(i==2)&&(args[1]==:-)])(args[i])) # Revert the first sigh if (-)
            elseif typeof(args[i]) == Expr
                if args[i].head == :ref
                    refinit += (i == 2)
                    push!(refs, args[i])
                elseif args[i].head == :call
                    callinit += (i == 2)
                    push!(exprs, args[i])
                else
                    error("Unkown expression head")
                end
            else
                error("Unkown argument type")
            end
        end

        # Treatment for 0.0 coefficients
        if val == operator_coefficient_base[args[1]] && val == 0.0
            val = []
        end

        # Re-arrange children :: without actually doing anything on them
        if args[1] in [:*]
            return [args[1]; val; refs; exprs]
        elseif args[1] in [:+, :-]
            if Bool(valinit)
                return [args[1]; val; refs; exprs]
            elseif Bool(refinit)
                return [args[1]; refs; val; exprs]
            elseif Bool(callinit)
                return [args[1]; exprs; refs; val]
            else
                error("Unexpected condition encountered...")
            end
        end
    else
        error("Unsupported expression arguments $args")
    end

    return
end

"""
Check if it is a sample of `+()`
"""
expr_is_emptysum(expr) = expr == :(+())

"""
Check if a sub-tree is a constant or not
"""
function expr_resolve_const(expr)
    isa(expr, Number) && return
    for i in 1:length(expr.args)
        if isa(expr.args[i], Number) || isa(expr.args[i], Symbol)
            continue
        elseif expr.args[i].head == :call
            if expr_is_emptysum(expr.args[i])
                expr.args[i] = :(0)
            end
            (expr_isconst(expr.args[i])) && (expr.args[i] = eval(expr.args[i]))
            if isa(expr.args[i], Number) || isa(expr.args[i], Symbol)
                continue
            else
                expr_resolve_const(expr.args[i])
            end
        end
    end

    return
end

"""
If the expression's fraction has a constant denominator, then replace the expression as product of a constant and the expression
"""
function expr_resolve_const_denominator(args)
    @assert args[1] == :/
    @assert length(args) == 3
    resolvable = true

    for i in 3:length(args)
        resolvable *= expr_isconst(args[i])
    end

    if resolvable
        for i in 3:length(args)
            args[i] = 1 / eval(args[i])
        end
        args[1] = :*
    end

    return args
end

"""
Check if a sub-tree(:call) is totally composed of constant values
"""
function expr_isconst(expr)
    (isa(expr, Number) || isa(expr, Symbol)) && return true

    (expr.head == :ref) && return false
    const_tree = true
    for i in 1:length(expr.args)
        if isa(expr.args[i], Number) || isa(expr.args[i], Symbol)
            continue
        elseif expr.args[i].head == :call
            const_tree *= expr_isconst(expr.args[i])
        elseif expr.args[i].head == :ref
            return false
        end
    end

    return const_tree
end

"""
Check if a sub-tree(:call) is contains any non-integer exponent values
"""
function expr_is_fractional_exponent(expr)
    if expr.head == :call
        if length(expr.args) == 3 && expr.args[1] == :^
            if !(isinteger(expr.args[3])) || !(expr.args[3] >= 0)
                error(
                    "Alpine currently supports `^` operator in constraints and/or objective with only positive integer exponents",
                )
            end
        end
        for i in 1:length(expr.args)
            if typeof(expr.args[i]) == Expr
                expr_is_fractional_exponent(expr.args[i]) # Recursively search for fractional exponents
            end
        end
    end
end

# Returns true if the expression is a constant, linear or affine
function expr_isaffine(expr)
    expr_isconst(expr) && return true
    expr.head == :ref && return true

    is_affine = false
    if expr.head == :call
        k = 0
        for i in 1:length(expr.args)
            if isa(expr.args[i], Number)
                k += 1
                continue
            end
            if isa(expr.args[i], Symbol)
                (expr.args[i] in [:+, :-]) && (k += 1)
                continue
            end
            if expr.args[i].head == :ref
                k += 1
            elseif expr.args[i].head == :call
                status = expr_isaffine(expr.args[i])
                status && (k += 1)
            end
        end
        (k == length(expr.args)) && (is_affine = true)
    end
    return is_affine
end

"""
Converts ((a_1*x[1])^2 + (a_2*x[2])^2 + ... + (a_n*x[n])^2) to (a_1^2*x[1]^2 + a_2^2*x[2]^2 + ... + a_n^2*x[n]^2)
Signs in the summation can be +/-
Note: This function does not support terms of type (a*(x[1] + x[2]))^2 yet.
"""
function expr_isolate_const(expr)
    expr_isaffine(expr) && return expr

    # Check nonlinear expressions
    if (expr.head == :call && expr.args[1] in [:+, :-])
        expr_array = Any[]
        for i in 2:length(expr.args)
            ind = 0

            # Handle negative sign in the first term
            if (!isa(expr.args[i], Number)) &&
               (expr.args[i].args[1] == :-) &&
               (length(expr.args[i].args) == 2)
                expr_i = expr.args[i].args[2]
                ind = 1
            else
                expr_i = expr.args[i]
            end

            # Handle constant and linear terms
            if (isa(expr_i, Number)) || (expr_i.head == :ref)
                if ((expr.args[1] == :-) && (i > 2)) || (ind == 1)
                    push!(expr_array, :(-$(expr_i)))
                else
                    push!(expr_array, :($(expr_i)))
                end

                # Handle nonlinear terms with coefficients within the exponent
            elseif (
                expr.args[i].head == :call &&
                expr_i.args[1] == :^ &&
                expr_i.args[2].head == :call &&
                isa(expr_i.args[2].args[2], Number) &&
                isa(expr_i.args[3], Number)
            )
                expr_tmp = Expr(:call, :^, expr_i.args[2].args[3], expr_i.args[3])
                if ((expr.args[1] == :-) && (i > 2)) || (ind == 1)
                    push!(
                        expr_array,
                        Expr(:call, :*, -expr_i.args[2].args[2]^expr_i.args[3], expr_tmp),
                    )
                else
                    push!(
                        expr_array,
                        Expr(:call, :*, expr_i.args[2].args[2]^expr_i.args[3], expr_tmp),
                    )
                end

                # Handle no-coefficients case
            elseif expr_i.args[1] == :^ && expr_i.args[2].head == :ref
                if (expr.args[1] == :- && (i > 2)) || (ind == 1)
                    push!(expr_array, Expr(:call, :*, -1, expr_i))
                else
                    push!(expr_array, expr_i)
                end

                # Handle coefficients which are not part of the exponent
            elseif expr_i.args[1] == :* && isa(expr_i.args[2], Number)
                if ((expr.args[1] == :-) && (i > 2)) || (ind == 1)
                    #push!(expr_array, Expr(:call, :*, -expr_i.args[2], expr_i.args[3]))
                    push!(expr_array, Expr(:call, :*, -1, expr_i))
                else
                    push!(expr_array, expr_i)
                end

                # Handle negative sign in the remaining terms
            elseif (expr_i.args[1] in [:+, :-]) && (length(expr.args[i].args) > 2)
                expr_rec = expr_isolate_const(expr_i) #recursion
                push!(expr_array, expr_rec)

                # For any other terms
            else
                if (expr.args[1] == :- && (i > 2)) || (ind == 1)
                    push!(expr_array, Expr(:call, :*, -1, expr_i))
                else
                    push!(expr_array, expr_i)
                end
            end
        end

        # Construct the expression from the array
        if length(expr_array) == 1
            return expr_array[1]
        else
            expr_n = Expr(:call, :+, expr_array[1], expr_array[2])
            if length(expr_array) >= 3
                for i in 3:length(expr_array)
                    expr_n = Expr(:call, :+, expr_n, expr_array[i])
                end
            end
            return (expr_n)
        end

    elseif (
        expr.head == :call &&
        expr.args[1] == :^ &&
        expr.args[2].head == :call &&
        isa(expr.args[2].args[2], Number) &&
        isa(expr.args[3], Number)
    )
        expr_tmp = Expr(:call, :^, expr.args[2].args[3], expr.args[3])
        return (Expr(:call, :*, expr.args[2].args[2]^expr.args[3], expr_tmp))
    else
        return expr
    end
end

@testset "Utility Function Tests: Solver identifier fetch" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => PAVITO,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bp" => true,
        "disc_var_pick" => 1,
        "log_level" => 100,
        "max_iter" => 2,
    )

    m = blend029_gl(solver = test_solver)
    alpine = JuMP.backend(m).optimizer.model

    Alpine._fetch_mip_solver_identifier(
        alpine;
        override = "Gurobi.GurobiSolver(nothing, Any[])",
    )
    @test alpine.mip_solver_id == "Gurobi"
    Alpine._fetch_mip_solver_identifier(alpine; override = "CPLEX.CplexSolver(Any[])")
    @test alpine.mip_solver_id == "CPLEX"
    Alpine._fetch_nlp_solver_identifier(alpine; override = "Ipopt.IpoptSolver(Any[])")
    @test alpine.nlp_solver_id == "Ipopt"
end

@testset "Solver Funtion Tests :: Embedding" begin
    ebdmap = Alpine.embedding_map(5)
    @test ebdmap[:L] == 2
    @test ebdmap[:H] == [[0, 0], [0, 1], [1, 1], [1, 0]]
    @test ebdmap[1] == Set([4, 5])
    @test ebdmap[2] == Set([3])
    @test ebdmap[3] == Set([2, 1])
    @test ebdmap[4] == Set([5, 1])

    ebdmap = Alpine.embedding_map(9)
    @test ebdmap[:L] == 3
    @test ebdmap[:H_orig] == ["000", "001", "011", "010", "110", "111", "101", "100"]
    @test ebdmap[:H] == [
        [0, 0, 0],
        [0, 0, 1],
        [0, 1, 1],
        [0, 1, 0],
        [1, 1, 0],
        [1, 1, 1],
        [1, 0, 1],
        [1, 0, 0],
    ]
    @test ebdmap[1] == Set([7, 9, 8, 6])
    @test ebdmap[2] == Set([4, 5, 6])
    @test ebdmap[3] == Set([7, 3])
    @test ebdmap[4] == Set([4, 3, 2, 1])
    @test ebdmap[5] == Set([9, 2, 8, 1])
    @test ebdmap[6] == Set([9, 5, 1])

    ebdmap = Alpine.embedding_map(12)
    @test ebdmap[:L] == 4
    @test ebdmap[:H_orig] == [
        "0000",
        "0001",
        "0011",
        "0010",
        "0110",
        "0111",
        "0101",
        "0100",
        "1100",
        "1101",
        "1111",
        "1110",
        "1010",
        "1011",
        "1001",
        "1000",
    ]
    @test ebdmap[:H] == [
        [0, 0, 0, 0],
        [0, 0, 0, 1],
        [0, 0, 1, 1],
        [0, 0, 1, 0],
        [0, 1, 1, 0],
        [0, 1, 1, 1],
        [0, 1, 0, 1],
        [0, 1, 0, 0],
        [1, 1, 0, 0],
        [1, 1, 0, 1],
        [1, 1, 1, 1],
        [1, 1, 1, 0],
        [1, 0, 1, 0],
        [1, 0, 1, 1],
        [1, 0, 0, 1],
        [1, 0, 0, 0],
    ]
    @test ebdmap[1] == Set([10, 11, 12])
    @test ebdmap[2] == Set([7, 9, 10, 11, 8, 6, 12])
    @test ebdmap[3] == Set([4, 5, 6, 12])
    @test ebdmap[4] == Set([7, 3, 11, 12])
    @test ebdmap[5] == Set([7, 4, 2, 3, 5, 8, 6, 1])
    @test ebdmap[6] == Set([4, 2, 3, 1])
    @test ebdmap[7] == Set([9, 10, 2, 8, 1])
    @test ebdmap[8] == Set([9, 5, 1])
end

@testset "Utility Function Tests: check_solution_history test" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        "presolve_bt" => false,
        "partition_scaling_factor" => 10,
        "disc_consecutive_forbid" => false,
    )

    m1 = mathopt(solver = test_solver)
    JuMP.optimize!(m1)
    alpine1 = JuMP.backend(m1).optimizer.model

    Alpine.variable_values(m1)

    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        "presolve_bt" => false,
        "partition_scaling_factor" => 10,
        "disc_consecutive_forbid" => true,
    )

    m2 = mathopt(solver = test_solver)
    JuMP.optimize!(m2)
    alpine2 = JuMP.backend(m2).optimizer.model

    @test termination_status(m1) == MOI.OPTIMAL
    @test termination_status(m2) == MOI.OPTIMAL
    @test alpine1.logs[:n_iter] >= alpine2.logs[:n_iter]
    @test isapprox(JuMP.objective_value(m1), JuMP.objective_value(m2), atol = 1E-5)
end

# - Necessary - #
using Alpine
using JuMP
using Gurobi
using Ipopt
using Juniper

# - Additional - #
# using CPLEX
# using HiGHS
# using Pavito

include("JuMP_models.jl")
include("optimizers.jl")

# Choose underlying solvers for Alpine
nlp_solver = get_ipopt() # local continuous solver
mip_solver = get_gurobi() # convex mip solver
minlp_solver = get_juniper(mip_solver, nlp_solver) # local mixed-intger solver

#= Global solver
 Hints: 
 => Try different integer values (>=4) for `partition_scaling_factor` to potentially observe 
    better Alpine run times (can be instance specific).
 => Choose `presolve_bt` to `false` if you prefer the bound tightening (OBBT) presolve to be turned off. 
 => If you prefer to use Alpine for only OBBT presolve, without any paritioning applied to the 
    nonlinear terms, include option "apply_partitioning" below and set it to false. 
=#

const alpine = JuMP.optimizer_with_attributes(
    Alpine.Optimizer,
    # "minlp_solver" => minlp_solver,
    "nlp_solver" => nlp_solver,
    "mip_solver" => mip_solver,
    "presolve_bt" => true,
    "apply_partitioning" => true,
    "partition_scaling_factor" => 10,
)

m = nlp3(solver = alpine)

JuMP.optimize!(m)
# Alpine.variable_values(m)

# Optimizer struct and user-defined options (with default settings) to tune Alpine solver

mutable struct OptimizerOptions
    # Parameters for tuning Alpine

    # Basic solver parameters
    log_level::Int                                              # Verbosity flag: 0 for quiet, 1 for basic solve info, 2 for iteration info
    time_limit::Float64                                         # Time limit for algorithm (in seconds)
    max_iter::Int                                               # Maximum bound on number of iterations for the partitioning algorithm
    rel_gap::Float64                                            # Relative optimality gap for termination condition
    abs_gap::Float64                                            # Absolute optimality gap for termination condition
    tol::Float64                                                # Numerical tol used in algorithms
    large_bound::Float64                                        # Large bounds for problems with unbounded variables

    # All the solver options
    nlp_solver::Union{MOI.OptimizerWithAttributes,Nothing}      # Local continuous NLP solver for solving NLPs at each iteration
    minlp_solver::Union{MOI.OptimizerWithAttributes,Nothing}    # Local MINLP solver for solving MINLPs at each iteration
    mip_solver::Union{MOI.OptimizerWithAttributes,Nothing}      # MIP solver for successive lower bound solves

    # Convexification methods
    recognize_convex::Bool                                      # Recognize convex expressions in parsing objective functions and constraints

    # Expression-based user-inputs
    # method_convexification :: Array{Function}                 # Array of functions that user can choose to convexify specific non-linear terms : no over-ride privilege

    # Parameters used in Alpine's MIP-based partitioning algorithm
    apply_partitioning::Bool                                    # Apply the partitioning algorithm only if thhis true, else terminate after presolve
    disc_var_pick::Any                                          # Algorithm for choosing the variables for partitioning: 0 for all variables, 1 for minimum vertex cover, 3 for weighted minimum vertex cover
    partition_scaling_factor::Int                               # Partition scaling parameter, which is critical for convergence (using a fixed value for now, later switch to a function)
    disc_uniform_rate::Int                                      # Discretization rate parameter when using uniform partitions
    disc_add_partition_method::Any                              # Additional methods to add discretization
    disc_divert_chunks::Int                                     # How many uniform partitions to construct
    disc_abs_width_tol::Float64                                 # Absolute tolerance used when setting up a partition
    disc_rel_width_tol::Float64                                 # Relative width tolerance when setting up a partition
    disc_consecutive_forbid::Int                                # Prevent bounding model to add partitions consecutively in the same region when bounds do not improve
    partition_scaling_factor_branch::Bool                       # Branching tests for picking fixed discretization ratio

    # MIP formulation parameters
    convhull_formulation::String                                # MIP Formulation for the relaxation
    convhull_ebd::Bool                                          # Enable embedding formulation
    convhull_ebd_encode::Any                                    # Encoding method used for convhull_ebd
    convhull_ebd_ibs::Bool                                      # Enable independent branching scheme
    convhull_ebd_link::Bool                                     # Linking constraints between x and α, type 1 uses hierarchical and type 2 uses big-m
    convhull_warmstart::Bool                                    # Warm start the bounding MIP
    linking_constraints::Bool                                   # Multilinear linking constraint feature
    linking_constraints_degree_limit::Int64                     # Degree of shared multilinear terms up to which the linking constraints are built and added

    # Presolve and bound-tightening parameters
    presolve_track_time::Bool                                   # Account presolve time for total time usage
    presolve_bt::Bool                                           # Perform bound tightening procedure before the main algorithm (default: true)
    presolve_bt_time_limit::Float64                             # Time limit for presolving (seconds)
    presolve_bt_max_iter::Int                                   # Maximum iterations allowed to perform presolve
    presolve_bt_width_tol::Float64                              # Width tolerance for bound-tightening
    presolve_bt_improv_tol::Float64                             # Improvement tolerance for average reduction of variable ranges
    presolve_bt_bound_tol::Float64                              # Variable bounds truncation precicision tol
    presolve_bt_obj_bound_tol::Float64                          # Objective upper bound truncation tol
    presolve_bt_algo::Any                                       # Method used for bound tightening procedures, can either be an index of default methods or functional inputs
    presolve_bt_relax_integrality::Bool                         # Relax the MIP solved in built-in relaxation scheme for time performance
    presolve_bt_mip_time_limit::Float64                         # Time limit for a single MIP solved in the built-in bound tightening algorithm (with partitions)
    use_start_as_incumbent::Bool                           # Use starting value as a local incumbent solution for presolve without invoking a local solver

    # Domain Reduction
    presolve_bp::Bool                                           # Conduct basic bound propagation
end

function get_default_options()
    log_level = 1
    time_limit = 1E6
    max_iter = 99
    rel_gap = 1e-4
    abs_gap = 1e-6
    tol = 1e-6
    large_bound = 1E6

    nlp_solver = nothing
    minlp_solver = nothing
    mip_solver = nothing

    recognize_convex = true

    apply_partitioning = true
    disc_var_pick = 2                # By default, uses the 15-variable selective rule
    partition_scaling_factor = 10
    disc_uniform_rate = 2
    disc_add_partition_method = "adaptive"
    disc_divert_chunks = 5
    disc_abs_width_tol = 1e-4
    disc_rel_width_tol = 1e-6
    disc_consecutive_forbid = false
    partition_scaling_factor_branch = false

    convhull_formulation = "sos2"
    convhull_ebd = false
    convhull_ebd_encode = "default"
    convhull_ebd_ibs = false
    convhull_ebd_link = false
    convhull_warmstart = true
    linking_constraints = true
    linking_constraints_degree_limit = 4 # check up to quadrilinear sharing across terms

    presolve_track_time = true
    presolve_bt = true
    presolve_bt_time_limit = 900
    presolve_bt_max_iter = 25
    presolve_bt_width_tol = 1e-2
    presolve_bt_improv_tol = 1e-3
    presolve_bt_bound_tol = 1e-4
    presolve_bt_obj_bound_tol = 1e-2
    presolve_bt_algo = 1
    presolve_bt_relax_integrality = false
    presolve_bt_mip_time_limit = Inf
    use_start_as_incumbent = false
    presolve_bp = false

    return OptimizerOptions(
        log_level,
        time_limit,
        max_iter,
        rel_gap,
        abs_gap,
        tol,
        large_bound,
        nlp_solver,
        minlp_solver,
        mip_solver,
        recognize_convex,
        apply_partitioning,
        disc_var_pick,
        partition_scaling_factor,
        disc_uniform_rate,
        disc_add_partition_method,
        disc_divert_chunks,
        disc_abs_width_tol,
        disc_rel_width_tol,
        disc_consecutive_forbid,
        partition_scaling_factor_branch,
        convhull_formulation,
        convhull_ebd,
        convhull_ebd_encode,
        convhull_ebd_ibs,
        convhull_ebd_link,
        convhull_warmstart,
        linking_constraints,
        linking_constraints_degree_limit,
        presolve_track_time,
        presolve_bt,
        presolve_bt_time_limit,
        presolve_bt_max_iter,
        presolve_bt_width_tol,
        presolve_bt_improv_tol,
        presolve_bt_bound_tol,
        presolve_bt_obj_bound_tol,
        presolve_bt_algo,
        presolve_bt_relax_integrality,
        presolve_bt_mip_time_limit,
        use_start_as_incumbent,
        presolve_bp,
    )
end

function amp_post_convhull(m::Optimizer; kwargs...)
    options = Dict(kwargs)
    haskey(options, :use_disc) ? d = options[:use_disc] : d = m.discretization

    # Variable holders
    λ = Dict()  # Extreme points and multipliers
    α = Dict()  # Partitioning Variables
    β = Dict()  # Lifted variables for exact formulation

    # Convexification for non-convex terms
    contains_multilinear = false
    for k in keys(m.nonconvex_terms)
        nl_type = m.nonconvex_terms[k][:nonlinear_type]
        if ((nl_type == :MULTILINEAR) || (nl_type == :BILINEAR)) &&
           (m.nonconvex_terms[k][:convexified] == false)
            λ, α = amp_convexify_multilinear(m, k, λ, α, d)
            contains_multilinear = true
        elseif nl_type == :MONOMIAL && !m.nonconvex_terms[k][:convexified]
            λ, α = amp_convexify_quadratic_univariate(m, k, λ, α, d)
        elseif nl_type == :BINLIN && !m.nonconvex_terms[k][:convexified]
            β = amp_convexify_binlin(m, k, β)
        elseif nl_type == :BINPROD && !m.nonconvex_terms[k][:convexified]
            β = amp_convexify_multilinear_binary(m, k, β)
        end
    end

    # Add lambda linking constraints
    if m.options.linking_constraints && contains_multilinear
        _add_multilinear_linking_constraints(m, λ)
    end

    # Code for warm starting bounding MIP iterations
    get_option(m, :convhull_warmstart) &&
        !isempty(m.best_bound_sol) &&
        amp_warmstart_α(m, α)

    return
end

function amp_convexify_multilinear(
    m::Optimizer,
    k::Any,
    λ::Dict,
    α::Dict,
    discretization::Dict,
)
    m.nonconvex_terms[k][:convexified] = true  # Bookeeping the convexified terms

    ml_indices, dim, extreme_point_cnt = amp_convhull_prepare(m, discretization, k)   # convert key to easy read mode
    λ = amp_convhull_λ(m, k, ml_indices, λ, extreme_point_cnt, dim)
    λ = populate_convhull_extreme_values(
        m,
        discretization,
        ml_indices,
        λ,
        dim,
        ones(Int, length(dim)),
    )
    α = amp_convhull_α(m, ml_indices, α, dim, discretization)
    amp_post_convhull_constrs(m, λ, α, ml_indices, dim, extreme_point_cnt, discretization)

    return λ, α
end

function amp_convexify_quadratic_univariate(
    m::Optimizer,
    k::Any,
    λ::Dict,
    α::Dict,
    discretization::Dict,
)
    m.nonconvex_terms[k][:convexified] = true  # Bookeeping the convexified terms

    monomial_index, dim, extreme_point_cnt =
        amp_convhull_prepare(m, discretization, k, monomial = true)
    λ = amp_convhull_λ(m, k, monomial_index, λ, extreme_point_cnt, dim)
    λ = populate_convhull_extreme_values(m, discretization, monomial_index, λ, 2)
    α = amp_convhull_α(m, [monomial_index], α, dim, discretization)
    amp_post_convhull_constrs(m, λ, α, monomial_index, discretization)

    return λ, α
end

function amp_convexify_binlin(m::Optimizer, k::Any, β::Dict)
    m.nonconvex_terms[k][:convexified] = true  # Bookeeping the convexified terms

    @assert length(m.nonconvex_terms[k][:var_idxs]) == 2

    lift_idx = m.nonconvex_terms[k][:y_idx]

    if haskey(β, lift_idx)
        return β
    else
        β[lift_idx] = _index_to_variable_ref(m.model_mip, lift_idx)
    end

    bin_idx = [i for i in m.nonconvex_terms[k][:var_idxs] if m.var_type[i] == :Bin]
    cont_idx = [i for i in m.nonconvex_terms[k][:var_idxs] if m.var_type[i] != :Bin]

    @assert length(bin_idx) == length(cont_idx) == 1

    bin_idx = bin_idx[1]
    cont_idx = cont_idx[1]

    relaxation_bilinear(
        m.model_mip,
        _index_to_variable_ref(m.model_mip, lift_idx),
        _index_to_variable_ref(m.model_mip, bin_idx),
        _index_to_variable_ref(m.model_mip, cont_idx),
        0,
        1,
        m.l_var_tight[cont_idx],
        m.u_var_tight[cont_idx],
    )

    return β
end

function amp_convexify_multilinear_binary(m::Optimizer, k::Any, β::Dict)
    m.nonconvex_terms[k][:convexified] = true  # Bookeeping the convexified terms

    lift_idx = m.nonconvex_terms[k][:y_idx]
    if haskey(β, lift_idx)
        return β    # Already constructed
    else
        β[lift_idx] = _index_to_variable_ref(m.model_mip, lift_idx)
    end

    z = _index_to_variable_ref(m.model_mip, m.nonconvex_terms[k][:y_idx])
    x = [_index_to_variable_ref(m.model_mip, i) for i in m.nonconvex_terms[k][:var_idxs]]

    if length(x) >= 1
        relaxation_multilinear_binary(m.model_mip, z, x)
    end

    return β
end

"""
    Method for general nonlinear terms
"""
function amp_convhull_prepare(m::Optimizer, d::Dict, nonlinear_key::Any; monomial = false)
    counted_var = []                # Keep both vector and set for collection sake
    id = Set()                      # Coverting the nonlinear indices into a set

    if isa(nonlinear_key, Vector)
        for var in nonlinear_key        # This output regulates the sequence of how composing variable should be arranged
            @assert isa(var, Expr)
            m.var_type[var.args[2]] in [:Cont, :Int] && push!(id, var.args[2])
            m.var_type[var.args[2]] in [:Cont, :Int] && push!(counted_var, var.args[2])
        end
    elseif isa(nonlinear_key, Dict)
        for var in nonlinear_key[:vars]
            @assert isa(var, Int)
            m.var_type[var] in [:Cont, :Int] && push!(id, var)
            m.var_type[var] in [:Cont, :Int] && push!(counted_var, var)
        end
    end

    if length(id) < length(counted_var) # Got repeating terms, now the sequence matters
        id = []
        for var in nonlinear_key
            m.var_type[var.args[2]] in [:Cont, :Int] && push!(id, var.args[2])
        end
    end

    dim = [length(d[i]) for i in id]

    monomial && return id[1], tuple(dim[1]), dim[1]   # One less dimension is required
    return id, tuple([i for i in dim]...), prod(dim)
end

"""
    Method for integers
"""
function amp_convhull_prepare(m::Optimizer, d::Dict, idx::Int)
    return [idx], tuple(length(d[idx])), length(d[idx])
end

"""
    Method for general nonlinear terms
"""
function amp_convhull_λ(
    m::Optimizer,
    nonlinear_key::Any,
    indices::Any,
    λ::Dict,
    ext_cnt::Int,
    dim::Tuple,
)
    y_idx = m.nonconvex_terms[nonlinear_key][:y_idx]

    @assert !(y_idx in keys(λ))
    λ[indices] = Dict(
        :dim => dim,
        :lifted_var_idx => y_idx,
        :indices => reshape([1:ext_cnt;], dim),
        :vars => JuMP.@variable(
            m.model_mip,
            [1:ext_cnt],
            lower_bound = 0,
            base_name = "L$(y_idx)"
        ),
        :vals => ones(dim),
    )

    return λ
end

"""
    Method for power terms
"""
function populate_convhull_extreme_values(
    m::Optimizer,
    d::Dict,
    mono_idx::Int,
    λ::Dict,
    p::Int,
)
    λ[mono_idx][:vals] = [d[mono_idx][i]^p for i in 1:length(d[mono_idx])]
    return λ
end

"""
    Method for regular multilinear terms
"""
function populate_convhull_extreme_values(
    m::Optimizer,
    discretization::Dict,
    indices::Any,
    λ::Dict,
    dim::Tuple,
    locator::Array,
    level::Int = 1,
)
    if level > length(dim)
        @assert length(indices) == length(dim)
        @assert length(indices) == length(locator)
        val = 1.0
        k = 0
        for i in indices
            k += 1
            val *= discretization[i][locator[k]]                      # Calculate extreme point z-value
        end
        λ[indices][:vals][CartesianIndex(tuple([i for i in locator]...))] = val  # Value assignment
        return λ                                                         # finished with last dimension
    else
        for i in 1:dim[level]
            locator[level] = i
            λ = populate_convhull_extreme_values(
                m,
                discretization,
                indices,
                λ,
                dim,
                locator,
                level + 1,
            )
        end
    end

    return λ
end

"""
    General Method for all term
"""
function amp_convhull_α(
    m::Optimizer,
    indices::Any,
    α::Dict,
    dim::Tuple,
    discretization::Dict,
)
    for i in indices
        if !(i in keys(α))
            lambda_cnt = length(discretization[i])
            partition_cnt = length(discretization[i]) - 1
            if get_option(m, :convhull_ebd) && partition_cnt > 2
                αCnt = Int(ceil(log(2, partition_cnt)))
                α[i] = JuMP.@variable(
                    m.model_mip,
                    [1:αCnt],
                    Bin,
                    base_name = string("YL", i)
                )
            else
                α[i] = JuMP.@variable(
                    m.model_mip,
                    [1:partition_cnt],
                    Bin,
                    base_name = "A$(i)"
                )
                JuMP.@constraint(m.model_mip, sum(α[i]) == 1)
                JuMP.@constraint(
                    m.model_mip,
                    _index_to_variable_ref(m.model_mip, i) >=
                    sum(α[i][j] * discretization[i][j] for j in 1:lambda_cnt-1)
                ) # Add x = f(α) for regulating the domains
                JuMP.@constraint(
                    m.model_mip,
                    _index_to_variable_ref(m.model_mip, i) <=
                    sum(α[i][j-1] * discretization[i][j] for j in 2:lambda_cnt)
                )
            end
        end
    end

    return α
end

function amp_convhull_α(m::Optimizer, idx::Int, α::Dict, dim, d::Dict)
    return amp_convhull_α(m, [idx], α, dim, d)
end

function amp_warmstart_α(m::Optimizer, α::Dict)
    d = m.discretization

    if m.bound_sol_pool[:cnt] >= 2 # can only warm-start the problem when pool is large enough
        ws_idx = -1
        is_min_sense(m) ? ws_obj = Inf : ws_obj = -Inf
        comp_opr = Dict(MOI.MIN_SENSE => :<, MOI.MAX_SENSE => :>)

        # Search for the pool for incumbent warm starter
        for i in 1:m.bound_sol_pool[:cnt]
            m.bound_sol_pool[:stat][i] == :Warmstarter &&
                (m.bound_sol_pool[:stat][i] = :Alive)   # reset the status if not dead
            if m.bound_sol_pool[:stat][i] == :Dead
                continue
            end
            is_better = ifelse(
                m.sense_orig == MOI.MAX_SENSE,
                m.bound_sol_pool[:obj][i] > ws_obj,
                m.bound_sol_pool[:obj][i] < ws_obj,
            )
            if is_better
                ws_idx = i
                ws_obj = m.bound_sol_pool[:obj][i]
            end
        end

        if ws_idx > 0 # If a warm starter is found
            for v in m.bound_sol_pool[:vars]
                partition_cnt = length(d[v]) - 1
                active_j =
                    get_active_partition_idx(d, m.bound_sol_pool[:sol][ws_idx][v], v)
                for j in 1:partition_cnt
                    j == active_j ? JuMP.set_start_value(α[v][j], 1.0) :
                    JuMP.set_start_value(α[v][j], 0.0)
                end
            end
            m.bound_sol_pool[:stat][ws_idx] = :Warmstarter
            get_option(m, :log_level) > 0 && println(
                "!! WARM START bounding MIP using POOL SOL $(ws_idx) OBJ=$(m.bound_sol_pool[:obj][ws_idx])",
            )
        end
    end

    return
end

"""
    Method for general multilinear terms
"""
function amp_post_convhull_constrs(
    m::Optimizer,
    λ::Dict,
    α::Dict,
    indices::Any,
    dim::Tuple,
    ext_cnt::Int,
    d::Dict,
)

    # Adding λ constraints
    JuMP.@constraint(m.model_mip, sum(λ[indices][:vars]) == 1)
    JuMP.@constraint(
        m.model_mip,
        _index_to_variable_ref(m.model_mip, λ[indices][:lifted_var_idx]) ==
        λ[indices][:vars]' * reshape(λ[indices][:vals], ext_cnt)
    )

    # Add links on each dimension
    for (cnt, i) in enumerate(indices)
        l_cnt = length(d[i])
        if m.var_type[i] == :Cont
            amp_post_inequalities_cont(m, d, λ, α, indices, dim, i, cnt)        # Add links between λ and α
        else
            error("EXCEPTION: unexpected variable type during integer related realxation")
        end
        sliced_indices =
            [collect_indices(λ[indices][:indices], cnt, [k], dim) for k in 1:l_cnt] # Add x = f(λ) for convex representation of x value
        JuMP.@constraint(
            m.model_mip,
            _index_to_variable_ref(m.model_mip, i) == sum(
                (repeat([d[i][k]], length(k_indices))' * λ[indices][:vars][k_indices]) for
                (k, k_indices) in enumerate(sliced_indices)
            )
        )
    end

    return
end

"""
    Constraints for univariate quadratic terms
"""
function amp_post_convhull_constrs(
    m::Optimizer,
    λ::Dict,
    α::Dict,
    monomial_idx::Int,
    discretization::Dict,
)
    partition_cnt = length(discretization[monomial_idx]) - 1
    lambda_cnt = length(discretization[monomial_idx])

    # Adding λ constraints
    JuMP.@constraint(m.model_mip, sum(λ[monomial_idx][:vars]) == 1)
    JuMP.@constraint(
        m.model_mip,
        _index_to_variable_ref(m.model_mip, λ[monomial_idx][:lifted_var_idx]) <=
        λ[monomial_idx][:vars]' * λ[monomial_idx][:vals]
    )
    JuMP.@constraint(
        m.model_mip,
        _index_to_variable_ref(m.model_mip, λ[monomial_idx][:lifted_var_idx]) >=
        _index_to_variable_ref(m.model_mip, monomial_idx)^2
    )

    # Add SOS-2 Constraints with basic encoding
    if get_option(m, :convhull_ebd) && partition_cnt > 2
        ebd_map = embedding_map(
            lambda_cnt,
            get_option(m, :convhull_ebd_encode),
            get_option(m, :convhull_ebd_ibs),
        )
        YCnt = Int(ebd_map[:L])
        @assert YCnt == length(α[monomial_idx])
        for i in 1:YCnt
            JuMP.@constraint(
                m.model_mip,
                sum(λ[monomial_idx][:vars][collect(ebd_map[i])]) <= α[monomial_idx][i]
            )
            JuMP.@constraint(
                m.model_mip,
                sum(λ[monomial_idx][:vars][collect(ebd_map[i+YCnt])]) <=
                1 - α[monomial_idx][i]
            )
        end
    else
        for i in 1:lambda_cnt
            if i == 1
                JuMP.@constraint(
                    m.model_mip,
                    λ[monomial_idx][:vars][i] <= α[monomial_idx][i]
                )
            elseif i == lambda_cnt
                JuMP.@constraint(
                    m.model_mip,
                    λ[monomial_idx][:vars][i] <= α[monomial_idx][i-1]
                )
            else
                JuMP.@constraint(
                    m.model_mip,
                    λ[monomial_idx][:vars][i] <=
                    α[monomial_idx][i-1] + α[monomial_idx][i]
                )
            end
        end
        # Add x = f(α) for regulating the domains
        JuMP.@constraint(
            m.model_mip,
            _index_to_variable_ref(m.model_mip, monomial_idx) >= sum(
                α[monomial_idx][j] * discretization[monomial_idx][j] for
                j in 1:lambda_cnt-1
            )
        )
        JuMP.@constraint(
            m.model_mip,
            _index_to_variable_ref(m.model_mip, monomial_idx) <= sum(
                α[monomial_idx][j-1] * discretization[monomial_idx][j] for
                j in 2:lambda_cnt
            )
        )
    end

    # Add x = f(λ) for convex representation
    JuMP.@constraint(
        m.model_mip,
        _index_to_variable_ref(m.model_mip, monomial_idx) ==
        λ[monomial_idx][:vars]' * discretization[monomial_idx]
    )

    return
end

"""
    Method for multilinear terms with only continuous variables
"""
function amp_post_inequalities_cont(
    m::Optimizer,
    discretization::Dict,
    λ::Dict,
    α::Dict,
    ml_indices::Any,
    dim::Tuple,
    var_ind::Int,
    cnt::Int,
)
    lambda_cnt = length(discretization[var_ind])
    partition_cnt = lambda_cnt - 1

    # Embedding formulation
    if get_option(m, :convhull_formulation) == "sos2" &&
       get_option(m, :convhull_ebd) &&
       partition_cnt > 2
        ebd_map = embedding_map(
            lambda_cnt,
            get_option(m, :convhull_ebd_encode),
            get_option(m, :convhull_ebd_ibs),
        )
        YCnt = Int(ebd_map[:L])
        @assert YCnt == length(α[var_ind])
        for i in 1:YCnt
            p_sliced_indices =
                collect_indices(λ[ml_indices][:indices], cnt, collect(ebd_map[i]), dim)
            n_sliced_indices = collect_indices(
                λ[ml_indices][:indices],
                cnt,
                collect(ebd_map[i+YCnt]),
                dim,
            )
            JuMP.@constraint(
                m.model_mip,
                sum(λ[ml_indices][:vars][p_sliced_indices]) <= α[var_ind][i]
            )
            JuMP.@constraint(
                m.model_mip,
                sum(λ[ml_indices][:vars][n_sliced_indices]) <= 1 - α[var_ind][i]
            )
        end
        get_option(m, :convhull_ebd_link) && ebd_link_xα(
            m,
            α[var_ind],
            lambda_cnt,
            discretization[var_ind],
            ebd_map[:H_orig],
            var_ind,
        )
        return
    end

    # SOS-2 Formulation
    if get_option(m, :convhull_formulation) == "sos2"
        for j in 1:lambda_cnt
            sliced_indices = collect_indices(λ[ml_indices][:indices], cnt, [j], dim)
            if (j == 1)
                JuMP.@constraint(
                    m.model_mip,
                    sum(λ[ml_indices][:vars][sliced_indices]) <= α[var_ind][j]
                )
            elseif (j == lambda_cnt)
                JuMP.@constraint(
                    m.model_mip,
                    sum(λ[ml_indices][:vars][sliced_indices]) <=
                    α[var_ind][partition_cnt]
                )
            else
                JuMP.@constraint(
                    m.model_mip,
                    sum(λ[ml_indices][:vars][sliced_indices]) <= sum(α[var_ind][(j-1):j])
                )
            end
        end
        return
    elseif get_option(m, :convhull_formulation) == "facet"
        for j in 1:(partition_cnt-1) # Constraint cluster of α >= f(λ)
            sliced_indices = collect_indices(λ[ml_indices][:indices], cnt, [1:j;], dim)
            JuMP.@constraint(
                m.model_mip,
                sum(α[var_ind][1:j]) >= sum(λ[ml_indices][:vars][sliced_indices])
            )
        end
        for j in 1:(partition_cnt-1) # Constraint cluster of α <= f(λ)
            sliced_indices =
                collect_indices(λ[ml_indices][:indices], cnt, [1:(j+1);], dim)
            JuMP.@constraint(
                m.model_mip,
                sum(α[var_ind][1:j]) <= sum(λ[ml_indices][:vars][sliced_indices])
            )
        end
        return
    else
        error("Must indicate a choice of convex hull formulation: sos2, facet")
    end

    return
end

function collect_indices(l::Array, fixed_dim::Int, fixed_partition::Array, dim::Tuple)
    k = 0
    indices =
        Vector{Int}(undef, Int(prod(dim) / dim[fixed_dim] * length(fixed_partition)))
    for i in 1:prod(dim)
        ind = Tuple(CartesianIndices(l)[i])
        if ind[fixed_dim] in fixed_partition
            k += 1
            indices[k] = i
        end
    end

    return indices
end

"""
    _add_multilinear_linking_constraints(m::Optimizer, λ::Dict)

This internal function adds linking constraints between λ multipliers corresponding to multilinear terms
that share more than two variables and are partitioned. For example, suppose we have λ[i], λ[j], and
λ[k] where i=(1,2,3), j=(1,2,4), and k=(1,2,5). λ[i] contains all multipliers for the extreme points
in the space of (x1,x2,x3). λ[j] contains all multipliers for the extreme points in the space of (x1,x2,x4).
λ[k] contains all multipliers for the extreme points in the space of (x1,x2,x5).

Using λ[i], λ[j], or λ[k], we can express multilinear function x1*x2.
We define a linking variable μ(1,2) that represents the value of x1*x2.
Linking constraints are
    μ(1,2) == convex combination expr for x1*x2 using λ[i],
    μ(1,2) == convex combination expr for x1*x2 using λ[j], and
    μ(1,2) == convex combination expr for x1*x2 using λ[k].

Thus, these constraints link between λ[i], λ[j], and λ[k] variables.

Reference: J. Kim, J.P. Richard, M. Tawarmalani, Piecewise Polyhedral Relaxations of Multilinear Optimization,
http://www.optimization-online.org/DB_HTML/2022/07/8974.html
"""
function _add_multilinear_linking_constraints(m::Optimizer, λ::Dict)
    if isnothing(m.linking_constraints_info)
        m.linking_constraints_info = _get_shared_multilinear_terms_info(
            λ,
            m.options.linking_constraints_degree_limit,
        )
    end

    if isnothing(m.linking_constraints_info)
        return
    end

    # Additional linking variables (μ) to the MIP model to keep the constraints sparse
    linking_variables =
        JuMP.@variable(m.model_mip, [i in keys(m.linking_constraints_info)])

    # Add linking constraints to the MIP model
    for (shared_multilinear_idx, multilinear_terms_idx) in m.linking_constraints_info,
        (i, multilinear_idx) in enumerate(multilinear_terms_idx)

        var_location = [findfirst(multilinear_idx .== i) for i in shared_multilinear_idx]

        lambda_expr = JuMP.AffExpr()
        for idx in Iterators.product([1:d for d in λ[multilinear_idx][:dim]]...)
            var = λ[multilinear_idx][:vars][λ[multilinear_idx][:indices][idx...]]
            partitions_info = prod(
                m.discretization[i][idx[j]] for
                (i, j) in zip(shared_multilinear_idx, var_location)
            )
            JuMP.add_to_expression!(lambda_expr, partitions_info, var)
        end

        JuMP.@constraint(
            m.model_mip,
            linking_variables[shared_multilinear_idx] == lambda_expr
        )
    end
end

"""
    _get_shared_multilinear_terms_info(λ, linking_constraints_degree_limit)

This function checks to see if linking constraints are
necessary for a given vector of each multilinear terms and returns the approapriate
linking constraints information.
"""
function _get_shared_multilinear_terms_info(
    λ::Dict,
    linking_constraints_degree_limit::Union{Nothing,T} where {T<:Int64} = nothing,
)

    # Compute maximum degree of multilinear terms and return if bilinear
    max_degree = maximum([length(k) for k in keys(λ)])

    if max_degree <= 2
        return (linking_constraints_info = nothing)
    end

    # Limit the linking constraints to a prescribed multilinear degree
    if !isnothing(linking_constraints_degree_limit) &&
       (linking_constraints_degree_limit < max_degree)
        max_degree = linking_constraints_degree_limit
    end

    # Collect all variable indices appearing in multilinear terms
    all_variables_idx = collect(union((keys(λ) |> collect)...)) |> sort

    linking_constraints_info = Dict(
        shared_multilinear_idx =>
            filter(r -> issubset(shared_multilinear_idx, r), keys(λ)) for
        deg in 2:(max_degree-1) for
        shared_multilinear_idx in Combinatorics.combinations(all_variables_idx, deg)
    )

    filter!(r -> length(r.second) >= 2, linking_constraints_info)
    if isempty(linking_constraints_info)
        return (linking_constraints_info = nothing)
    end

    return (linking_constraints_info = linking_constraints_info)
end

function binprod_nlp3(; solver = nothing)
    m = JuMP.Model(solver)

    LB = [100, 1000, 1000, 10, 10, 10, 10, 10]
    UB = [10000, 10000, 10000, 1000, 1000, 1000, 1000, 1000]

    @variable(m, LB[i] <= x[i = 1:8] <= UB[i])
    @variable(m, 0 <= y[1:5] <= 1, Bin)

    @constraint(m, 0.0025 * (x[4] * y[1] + x[6] * y[2]) <= 1)
    @constraint(m, 0.0025 * (x[5] - x[4] * y[1] + x[7]) <= 1)
    @constraint(m, 0.01(x[8] - x[5] * y[3]) <= 1)
    @NLconstraint(
        m,
        100 * x[1] - x[1] * x[6] * y[1] + 833.33252 * x[4] * y[1] <= 83333.333
    )
    @NLconstraint(m, x[2] * x[4] * y[4] - x[2] * x[7] - 1250 * x[4] + 1250 * x[5] <= 0)
    @NLconstraint(
        m,
        x[3] * x[5] * y[2] * y[5] - x[3] * x[8] * y[5] - 2500 * x[5] * y[1] * y[4] +
        1250000 <= 0
    )

    @NLconstraint(m, y[1] * y[2] * y[3] <= 0)
    @NLconstraint(m, y[2] * y[3] >= y[4] * y[5])
    @NLconstraint(m, y[1] * y[5] <= y[2] * y[4])

    @objective(m, Min, x[1] + x[2] + x[3])

    return m
end

function circlebin(; verbose = false, solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, 0 <= x[1:5] <= 1, Bin)
    @NLconstraint(m, x[1]^2 + x[2]^2 >= 2)
    @objective(m, Min, x[1] + x[2])

    return m
end

function bpml(; verbose = false, solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, 0 <= x[1:5] <= 1, Bin)
    @variable(m, y[1:5] >= 0)

    @NLconstraint(m, x[1] * y[1] >= 10)
    @NLconstraint(m, x[1] * x[2] * y[1] >= 10)
    @NLconstraint(m, x[1] * x[2] * x[3] * y[1] >= 10)
    @NLconstraint(m, x[1] * y[1] * y[2] >= 10)
    @NLconstraint(m, x[1] * y[1] * y[2] * y[3] >= 10)
    @NLconstraint(m, x[1] * x[2] * x[3] * y[1] * y[2] * y[3] >= 10)
    @NLconstraint(m, x[1] * x[2] * x[3] * x[4] * x[5] >= 1)
    @NLconstraint(m, y[1] * y[2] * y[4] * y[5] * y[1] >= 99)

    @objective(m, Min, x[1] + x[2] + x[3])

    return m
end

function bmpl_linearlifting(; solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, 0 <= x[1:5] <= 1, Bin)
    @variable(m, y[1:5] >= 0)

    @NLconstraint(m, 15 * x[1] * (2 * y[1] + y[2]) >= 10)
    @NLconstraint(m, 15 * (x[1] + x[2] * y[1]) * (y[1] + y[2] * x[1] * x[2]) + 10 >= 10)
    @NLconstraint(m, 15 * x[2] * (y[1] + y[2] * x[3] * y[5] * x[4]) + 50 >= 10)

    @NLobjective(m, Min, x[1] * (y[1] * y[2] * y[3] + x[2] * x[3]))

    return m
end

function bpml_lnl(; solver = nothing)
    m = JuMP.Model(solver)

    Random.seed!(10)
    @variable(m, 0 <= X[1:5] <= 1, Bin)
    @variable(m, 0.1 <= Y[1:5] <= 0.1 + 10 * rand())
    @constraint(m, sum(X) >= 3)
    @NLobjective(m, Min, sum(X[i] * Y[i] for i in 1:5))

    return m
end

function bpml_binl(; solver = nothing)
    m = JuMP.Model(solver)

    Random.seed!(10)
    @variable(m, 0 <= X[1:5] <= 1, Bin)
    @variable(m, 50 <= Y[1:5] <= 50 + 100 * rand() * rand())
    @constraint(m, sum(X) >= 3)
    @NLobjective(m, Max, sum(X[i] * Y[i] * Y[i+1] for i in 1:4) - X[5] * Y[5] * Y[1])

    return m
end

function bpml_monl(; solver = nothing)
    m = JuMP.Model(solver)

    Random.seed!(10)
    @variable(m, 0 <= X[1:5] <= 1, Bin)
    @variable(m, 50 <= Y[1:5] <= 50 + 100 * rand() * rand())
    @constraint(m, sum(X) >= 3)
    @NLobjective(m, Max, sum(X[i] * Y[i] * Y[i] for i in 1:5))

    return m
end

function bpml_negative(; solver = nothing)
    m = JuMP.Model(solver)

    Random.seed!(10)
    @variable(m, 0 <= X[1:5] <= 1, Bin)
    @variable(m, 50 <= Y[1:5] <= 50 + 100 * rand() * rand())
    JuMP.set_lower_bound(Y[1], -10)
    JuMP.set_upper_bound(Y[1], -1)
    JuMP.set_lower_bound(Y[2], -40)
    JuMP.set_lower_bound(Y[3], -30)
    JuMP.set_lower_bound(Y[4], -50)
    @constraint(m, sum(X) >= 3)
    @NLobjective(m, Max, sum(X[i] * Y[i] * Y[i+1] for i in 1:4) - X[5] * Y[5] * Y[1])

    return m
end

function intprod_basic(; solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, 1 <= Z[1:10] <= 10, Int)
    @NLconstraint(m, (Z[1] + Z[2]) * (Z[3] + Z[4]) >= 25)
    @NLconstraint(m, Z[1] * (Z[2] + Z[3]) * Z[4] >= 25)
    @NLconstraint(m, Z[1] - Z[2] * Z[3] * Z[4] + 15 >= 25)
    @NLconstraint(m, Z[5] * (Z[2] - Z[3]) * Z[5]^2 >= 40)
    @NLobjective(m, Min, sum(Z[i] for i in 1:5) * Z[2])

    return m
end

function discretemulti_basic(; solver = nothing)
    m = JuMP.Model(solver)

    Random.seed!(10)
    @variable(m, 0 <= X[1:5] <= 1, Bin)
    @variable(m, 0.1 <= Y[1:5] <= 0.1 + 10 * rand())
    @variable(m, 1 <= Z[1:5] <= 10, Int)
    @constraint(m, sum(X) >= 3)
    @constraint(m, sum(Z) >= 10)
    @NLobjective(m, Min, sum(X[i] * Y[i] for i in 1:5))
    @NLconstraint(m, sum(X[i] * Z[i] for i in 1:5) >= 8)
    @NLconstraint(m, [i in 1:5], Y[i] * Z[i] >= 17.1)
    @NLconstraint(m, [i in 1:4], Y[i] * Z[i] * Z[i+1] >= 18.6)
    @NLconstraint(m, [i in 1:5], X[i] * Y[i] * Z[i] <= 28.1)
    @NLconstraint(m, [i in 1:4], X[i] * X[i+1] * Y[i] * Y[i+1] * Z[i] * Z[i+1] <= 33.2)

    return m
end

function _constraint_expr(expr, set::MOI.Interval)
    return Expr(:comparison, set.lower, :(<=), expr, :(<=), set.upper)
end

_sense(::MOI.EqualTo) = :(==)
_sense(::MOI.LessThan) = :(<=)
_sense(::MOI.GreaterThan) = :(>=)
function _constraint_expr(expr, set)
    return Expr(:call, _sense(set), expr, MOI.constant(set))
end

_variable_index_to_expr(v::MOI.VariableIndex) = Expr(:ref, :x, v.value)

function _add_constant(expr::Expr, constant)
    if !iszero(constant)
        push!(expr.args, constant)
    end
end

function _term_to_expr(t::MOI.ScalarAffineTerm)
    return Expr(:call, :*, t.coefficient, _variable_index_to_expr(t.variable))
end

function _term_to_expr(t::MOI.ScalarQuadraticTerm)
    coef = t.coefficient
    if t.variable_1 == t.variable_2
        coef /= 2
    end
    return Expr(
        :call,
        :*,
        coef,
        _variable_index_to_expr(t.variable_1),
        _variable_index_to_expr(t.variable_2),
    )
end

function _add_terms(expr::Expr, terms::Vector)
    for term in terms
        push!(expr.args, _term_to_expr(term))
    end
end

function _moi_function_to_expr(f::MOI.ScalarAffineFunction)
    iszero(f) && return 0 # Similar to `JuMP.affToExpr` in JuMP v0.18 and earlier
    expr = Expr(:call, :+)
    _add_terms(expr, f.terms)
    _add_constant(expr, f.constant)
    return expr
end

function _moi_function_to_expr(t::MOI.ScalarQuadraticTerm)
    return Expr(
        :call,
        :*,
        MOI.coefficient(t),
        _variable_index_to_expr(t.variable_1),
        _variable_index_to_expr(t.variable_2),
    )
end

function _moi_function_to_expr(f::MOI.ScalarQuadraticFunction)
    iszero(f) && return 0 # Similar to `JuMP.quadToExpr` in JuMP v0.18 and earlier
    expr = Expr(:call, :+)
    _add_terms(expr, f.quadratic_terms)
    _add_terms(expr, f.affine_terms)
    _add_constant(expr, f.constant)
    return expr
end

function nlp1(; solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, 1 <= x[1:2] <= 4)
    @NLconstraint(m, x[1] * x[2] >= 8)
    @NLobjective(m, Min, 6 * x[1]^2 + 4 * x[2]^2 - 2.5 * x[1] * x[2])

    return m
end

function nlp2(; solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, -500 <= x[1:2] <= 500)
    @NLobjective(m, Min, sum((x[i]^2 - i)^2 for i in 1:2))

    return m
end

function max_cover_var_picker(m::Alpine.Optimizer)
    nodes = Set()
    for pair in keys(m.nonconvex_terms)
        for i in pair
            @assert isa(i.args[2], Int)
            push!(nodes, i.args[2])
        end
    end
    nodes = collect(nodes)
    m.num_var_disc_mip = length(nodes)
    m.disc_vars = nodes
    return
end

function mathopt(; solver = nothing)
    # Modified based on `mathopt` instances from MINLPLib
    # Global solution: -1004.73094034, arg min: [ -10.0, 15.2543377, -3.2034701]

    m = JuMP.Model(solver)

    LB = [-10, -15, -10]
    UB = [20, 20, 20]
    @variable(m, LB[i] <= x[i = 1:3] <= UB[i])
    @NLobjective(m, Min, 10 * (x[1] * x[2] - x[2] * x[3]) + x[1] * x[3])
    @NLconstraint(m, x[1] * x[2] + x[2] * x[3]^2 >= 4)
    @constraint(m, 3 * x[1] + 4 * x[2] + 5 * x[3] <= 15)

    return m
end

function nlp3(; solver = nothing)
    m = JuMP.Model(solver)

    LB = [100, 1000, 1000, 10, 10, 10, 10, 10]
    UB = [10000, 10000, 10000, 1000, 1000, 1000, 1000, 1000]

    @variable(m, LB[i] <= x[i = 1:8] <= UB[i])

    @constraint(m, 0.0025 * (x[4] + x[6]) <= 1)
    @constraint(m, 0.0025 * (x[5] - x[4] + x[7]) <= 1)
    @constraint(m, 0.01(x[8] - x[5]) <= 1)
    @NLconstraint(m, 100 * x[1] - x[1] * x[6] + 833.33252 * x[4] <= 83333.333)
    @NLconstraint(m, x[2] * x[4] - x[2] * x[7] - 1250 * x[4] + 1250 * x[5] <= 0)
    @NLconstraint(m, x[3] * x[5] - x[3] * x[8] - 2500 * x[5] + 1250000 <= 0)

    @objective(m, Min, x[1] + x[2] + x[3])

    return m
end

# Functions in this file are not tested until support for trigonometric functions is added. 

function sincos_p1(; solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, 0.1 <= x[1:10] <= 10)
    @NLconstraint(m, [i in 1:9], x[i] * x[i+1] * sin(x[i]) >= 0.32)
    @NLconstraint(m, [i in 1:9], x[i] * x[i+1] * sin(x[i]) <= 0.42)
    @NLobjective(m, Min, sum(cos(x[i]) + sin(x[i]) for i in 1:10))

    return m
end

function trig(; solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, objvar)
    x_Idx = Any[1]
    @variable(m, x[x_Idx])
    JuMP.set_lower_bound(x[1], -2.0)
    JuMP.set_upper_bound(x[1], 5.0)

    @NLconstraint(
        m,
        e1,
        -(sin(11 * x[1]) + cos(13 * x[1]) - sin(17 * x[1]) - cos(19 * x[1])) + objvar ==
        0.0
    )
    @NLconstraint(m, e2, 5 * sin(x[1]) - x[1] <= 0.0)

    @objective(m, Min, objvar)

    return m
end

function specialopts(; verbose = false, solver = nothing)
    m = JuMP.Model(solver)

    @variable(m, x[i = 1:6])

    @NLconstraint(m, sin(x[1]) + cos(x[2]) >= 1)
    @NLconstraint(m, sin(x[1]) * x[2] >= 1)
    @NLconstraint(m, sin(x[1]) * cos(x[2]) >= 1)
    #
    @NLconstraint(m, sin(x[1] * x[2]) >= 0.5)
    @NLconstraint(m, cos(x[1] + x[2]) >= 0.5)
    @NLconstraint(m, cos(x[1] / 2) >= 0.5)
    @NLconstraint(m, cos(x[1] * x[2] / 5) >= 0.5)
    @NLconstraint(m, sin(x[1] / 5 + x[2] / 5) >= 0.5)

    return m
end

"""
   update_opt_gap(m::Optimizer)

Updates Alpine model's relative & absolute optimality gaps.

The relative gap calculation is

```math
\\textbf{Gap} = \\frac{|UB-LB|}{ϵ+|UB|}
```

The absolute gap calculation is
```
|UB-LB|
```
"""
function update_opt_gap(m::Optimizer)
    tol = get_option(m, :tol)

    if m.best_obj in [Inf, -Inf]
        m.best_rel_gap = Inf
        return
    else
        p = convert(Int, round(abs(log(10, get_option(m, :rel_gap)))))
        n = round(abs(m.best_obj - m.best_bound); digits = p)
        # dn = round(abs(1e-12+abs(m.best_obj)); digits=p)
        if isapprox(n, 0.0; atol = tol) && isapprox(m.best_obj, 0.0; atol = tol)
            m.best_rel_gap = 0.0
            return
        end

        if is_min_sense(m)
            m.best_rel_gap = eval_opt_gap(m, m.best_bound, m.best_obj)
        elseif is_max_sense(m)
            m.best_rel_gap = eval_opt_gap(m, m.best_obj, m.best_bound)
        end
    end

    m.best_abs_gap = abs(m.best_obj - m.best_bound)

    return
end

function eval_opt_gap(m::Optimizer, lower_bound::Number, upper_bound::Number)
    tol = get_option(m, :tol)

    if isinf(lower_bound) || isinf(upper_bound)
        error("Infinite bounds detected in optimality gap evalutation")

    else
        m.best_rel_gap = _eval_best_rel_gap(lower_bound, upper_bound, tol)

        # If LB > UB
        if (m.best_rel_gap > get_option(m, :rel_gap)) &&
           ((lower_bound - upper_bound) > 1E-1)
            error(
                "Lower bound cannot exceed the upper bound in optimality gap evaluation",
            )
        end
    end

    return m.best_rel_gap
end

function _eval_best_rel_gap(lower_bound::Number, upper_bound::Number, tol::Number)
    if isapprox(lower_bound, upper_bound, atol = tol)
        return 0.0

    elseif isapprox(upper_bound, 0.0; atol = tol) # zero upper bound case
        eps = 1 # shift factor
        return abs((upper_bound + eps) - (lower_bound + eps)) /
               (tol + abs(upper_bound) + eps)

    else
        return abs(upper_bound - lower_bound) / (tol + abs(upper_bound))
    end
end

function measure_relaxed_deviation(m::Optimizer; sol = nothing)
    sol = something(sol, m.best_bound_sol)

    isempty(sol) && return

    dev = []
    for k in keys(m.nonconvex_terms)
        y_idx = m.nonconvex_terms[k][:y_idx]
        y_hat = sol[y_idx]
        y_val = m.nonconvex_terms[k][:evaluator](m.nonconvex_terms[k], sol)
        push!(
            dev,
            (y_idx, abs(y_hat - y_val), y_hat, y_val, m.nonconvex_terms[k][:var_idxs]),
        )
    end

    sort!(dev, by = x -> x[1])

    for i in dev
        get_option(m, :log_level) > 199 && println(
            "Y-VAR$(i[1]): DIST=$(i[2]) || Y-hat = $(i[3]), Y-val = $(i[4]) || COMP $(i[5])",
        )
    end

    return
end

"""
   discretization_to_bounds(d::Dict, l::Int)

Same as [`update_var_bounds`](@ref)
"""
discretization_to_bounds(d::Dict, l::Int) = update_var_bounds(d, len = l)

"""
Update the data structure with feasible solution and its associated objective (if better)
"""
function update_incumbent(m::Optimizer, objval::Float64, sol::Vector)
    push!(m.logs[:obj], objval)
    if m.sense_orig == MOI.MAX_SENSE ? objval > m.best_obj : objval < m.best_obj
        m.best_obj = objval
        m.best_sol = sol
        m.detected_incumbent = true
    end
    return
end

"""
   variable_values(m::JuMP.Model)

Prints values of all the variables after optimizing the original JuMP model.
"""
function variable_values(m::JuMP.Model)
    for var in all_variables(m)
        if isapprox(abs(JuMP.value(var)), 0, atol = 1E-6)
            println("$var = 0.0")
        else
            println("$var = $(round(JuMP.value(var), digits = 5))")
        end
    end

    return
end

"""
Mention the variable type of the lifted term.
This function is with limited functionality

"""
function resolve_lifted_var_type(var_types::Vector{Symbol}, operator::Symbol)
    if operator == :+
        detector = [i in [:Bin, :Int] ? true : false for i in var_types]
        if length(detector) == 1 && detector[1] # Special case
            if :Bin in var_types
                return :Bin
            else
                return :Int
            end
        end
        prod(detector) && return :Int
        # o/w continous variables

    elseif operator == :*
        detector = [i == :Bin ? true : false for i in var_types]
        prod(detector) && return :Bin
        detector = [i in [:Bin, :Int] ? true : false for i in var_types]
        prod(detector) && return :Int
        # o/w continous variables

    end

    return :Cont
end

"""
   check_solution_history(m::Optimizer, ind::Int)

Check if the solution is always the same within the last disc_consecutive_forbid iterations. Return `true` if solution has stalled.
"""
function check_solution_history(m::Optimizer, ind::Int)
    get_option(m, :disc_consecutive_forbid) == 0 && return false
    ((m.logs[:n_iter] - 1) < get_option(m, :disc_consecutive_forbid)) && return false

    sol_val = m.bound_sol_history[mod(
        m.logs[:n_iter] - 2,
        get_option(m, :disc_consecutive_forbid),
    )+1][ind]
    for i in 1:(get_option(m, :disc_consecutive_forbid)-1)
        search_pos =
            mod(m.logs[:n_iter] - 2 - i, get_option(m, :disc_consecutive_forbid)) + 1
        !isapprox(
            sol_val,
            m.bound_sol_history[search_pos][ind];
            atol = get_option(m, :disc_rel_width_tol),
        ) && return false
    end

    get_option(m, :log_level) > 99 &&
        println("Consecutive bounding solution on VAR$(ind) obtained. Diverting...")

    return true
end

"""
   fix_domains(m::Optimizer)

This function is used to fix variables to certain domains during the local solve process in the [`global_solve`](@ref).
More specifically, it is used in [`local_solve`](@ref) to fix binary and integer variables to lower bound solutions
and discretizing variables to the active domain according to lower bound solution.
"""
function fix_domains(m::Optimizer; discrete_sol = nothing, use_orig = false)
    discrete_sol !== nothing && @assert length(discrete_sol) >= m.num_var_orig

    l_var = [m.l_var_tight[i] for i in 1:m.num_var_orig]
    u_var = [m.u_var_tight[i] for i in 1:m.num_var_orig]

    for i in 1:m.num_var_orig
        if i in m.disc_vars && m.var_type[i] == :Cont
            point = if discrete_sol === nothing
                m.best_bound_sol[i]
            else
                discrete_sol[i]
            end
            PCnt = length(m.discretization[i]) - 1
            for j in 1:PCnt
                if point >= (m.discretization[i][j] - get_option(m, :tol)) &&
                   (point <= m.discretization[i][j+1] + get_option(m, :tol))
                    @assert j < length(m.discretization[i])
                    use_orig ? l_var[i] = m.discretization[i][1] :
                    l_var[i] = m.discretization[i][j]
                    use_orig ? u_var[i] = m.discretization[i][end] :
                    u_var[i] = m.discretization[i][j+1]
                    break
                end
            end
        elseif m.var_type[i] == :Bin || m.var_type[i] == :Int
            if discrete_sol === nothing
                l_var[i] = round(m.best_bound_sol[i])
                u_var[i] = round(m.best_bound_sol[i])
            else
                l_var[i] = round(discrete_sol[i])
                u_var[i] = round(discrete_sol[i])
            end
        end
    end

    return l_var, u_var
end

"""
   _is_fully_convexified(m::Optimizer)
"""
function _is_fully_convexified(m::Optimizer)

    # Other more advanced convexification check goes here
    for term in keys(m.nonconvex_terms)
        if !m.nonconvex_terms[term][:convexified]
            @warn "  Warning: Detected terms that is not convexified $(term[:lifted_constr_ref]), bounding model solver may report a error due to this"
            return
        else
            m.nonconvex_terms[term][:convexified] = false    # Reset status for next iteration
        end
    end

    return
end

"""
Collect active partition idx
Need to be careful with the diverted point
"""
function get_active_partition_idx(
    discretization::Dict,
    val::Float64,
    idx::Int;
    tol = 1e-6,
)
    for j in 1:length(discretization[idx])-1
        if val > discretization[idx][j] - tol && val < discretization[idx][j+1] + tol
            return j
        end
    end

    @warn "  Warning: Activate parition not found [VAR$(idx)]. Returning default partition 1."
    return 1
end

"""
   get_candidate_disc_vars(m:Optimizer)

   A built-in method for selecting variables for discretization. This function selects all candidate variables in the nonlinear terms for discretization,
   if under a threshold value of the number of nonlinear terms.
"""
function get_candidate_disc_vars(m::Optimizer; getoutput = false)

    # Pick variables that is bound width more than tolerance length
    if getoutput
        return [i for i in m.candidate_disc_vars]
    else
        m.disc_vars = [i for i in m.candidate_disc_vars]
        m.num_var_disc_mip = length(m.disc_vars)
    end

    return
end

function initialize_solution_pool(m::Optimizer, cnt::Int)
    s = Dict()

    s[:cnt] = cnt

    # Column dimension changing variable
    s[:len] = m.num_var_orig + m.num_var_linear_mip + m.num_var_nonlinear_mip

    # !! Be careful with the :vars when utilizing the dynamic discretization variable selection !!
    s[:vars] = [i for i in m.candidate_disc_vars if length(m.discretization[i]) > 2]

    s[:sol] = Vector{Vector}(undef, cnt)                   # Solution value
    s[:obj] = Vector{Float64}(undef, cnt)                  # Objecitve value
    s[:disc] = Vector{Dict}(undef, cnt)                    # Discretization
    s[:stat] = [:Alive for i in 1:cnt]              # Solution status
    s[:iter] = [m.logs[:n_iter] for i in 1:cnt]     # Iteration collected
    s[:ubstart] = [false for i in 1:cnt]            # Solution used for ub multistart

    return s
end

"""
Reconsideration required
"""
function ncvar_collect_arcs(m::Optimizer, nodes::Vector)
    arcs = Set()

    for k in keys(m.nonconvex_terms)
        if m.nonconvex_terms[k][:nonlinear_type] == :BILINEAR
            arc = [i.args[2] for i in k]
            length(arc) == 2 && push!(arcs, sort(arc))

        elseif m.nonconvex_terms[k][:nonlinear_type] == :MONOMIAL
            @assert isa(m.nonconvex_terms[k][:var_idxs][1], Int)
            varidx = m.nonconvex_terms[k][:var_idxs][1]
            push!(arcs, [varidx; varidx])

        elseif m.nonconvex_terms[k][:nonlinear_type] == :MULTILINEAR
            varidxs = m.nonconvex_terms[k][:var_idxs]
            for i in 1:length(varidxs)
                for j in 1:length(varidxs)
                    if i != j
                        push!(arcs, sort([varidxs[i]; varidxs[j]]))
                    end
                end
            end
            if length(varidxs) == 1
                push!(arcs, sort([varidxs[1]; varidxs[1]]))
            end

            # elseif m.nonconvex_terms[k][:nonlinear_type] in [:cos, :sin]
            #    @assert length(m.nonconvex_terms[k][:var_idxs]) == 1
            #    var_idx = m.nonconvex_terms[k][:var_idxs][1]
            #    push!(arcs, [var_idx; var_idx])

        elseif m.nonconvex_terms[k][:nonlinear_type] in [:BININT, :BINLIN, :BINPROD]
            continue
        else
            error(
                "[EXCEPTION] Unexpected nonlinear term when building interaction graphs for min. vertex cover.",
            )
        end
    end

    return arcs
end

"""
"""
function build_discvar_graph(m::Optimizer)

    # Collect the information of nonlinear terms in terms of arcs and nodes
    nodes = get_candidate_disc_vars(m, getoutput = true)
    arcs = ncvar_collect_arcs(m, nodes)

    # Collect integer variables
    for i in 1:m.num_var_orig
        if !(i in nodes) && m.var_type[i] == :Int
            push!(nodes, i)
            push!(arcs, [i; i])
        end
    end

    nodes = collect(nodes)
    arcs = collect(arcs)

    return nodes, arcs
end

"""
   min_vertex_cover(m::Optimizer)

`min_vertex_cover` chooses the variables based on the minimum vertex cover algorithm for the interaction graph of
nonlinear terms which are adaptively partitioned for global optimization. This option can be activated by
setting `disc_var_pick = 1`.
"""
function min_vertex_cover(m::Optimizer)
    nodes, arcs = build_discvar_graph(m)

    # Set up minimum vertex cover problem
    minvertex = Model(get_option(m, :mip_solver))
    MOI.set(minvertex, MOI.TimeLimitSec(), 60.0) # Time limit for min vertex cover formulation
    JuMP.@variable(minvertex, 0 <= x[nodes] <= 1, Bin)
    JuMP.@constraint(minvertex, [a in arcs], x[a[1]] + x[a[2]] >= 1)
    JuMP.@objective(minvertex, Min, sum(x))

    JuMP.optimize!(minvertex)
    # status = MOI.get(minvertex, MOI.TerminationStatus())
    xVal = JuMP.value.(x)

    # Collecting required information
    m.num_var_disc_mip = Int(sum(xVal))
    m.disc_vars = [
        i for i in nodes if xVal[i] > get_option(m, :tol) &&
        abs(m.u_var_tight[i] - m.l_var_tight[i]) >= get_option(m, :tol)
    ]

    return
end

function weighted_min_vertex_cover(m::Optimizer, distance::Dict)

    # Collect the graph information
    nodes, arcs = build_discvar_graph(m)

    # A little bit redundancy before
    disvec = [distance[i] for i in keys(distance) if i in m.candidate_disc_vars]
    disvec = abs.(disvec[disvec.>0.0])
    isempty(disvec) ? heavy = 1.0 : heavy = 1 / minimum(disvec)
    weights = Dict()
    for i in m.candidate_disc_vars
        isapprox(distance[i], 0.0; atol = 1e-6) ? weights[i] = heavy :
        (weights[i] = (1 / distance[i]))
        (get_option(m, :log_level) > 100) &&
            println("VAR$(i) WEIGHT -> $(weights[i]) ||| DISTANCE -> $(distance[i])")
    end

    # Set up minimum vertex cover problem
    minvertex = Model(get_option(m, :mip_solver))
    MOI.set(minvertex, MOI.TimeLimitSec(), 60.0)  # Set a timer to avoid waste of time in proving optimality
    JuMP.@variable(minvertex, 0 <= x[nodes] <= 1, Bin)
    for arc in arcs
        JuMP.@constraint(minvertex, x[arc[1]] + x[arc[2]] >= 1)
    end
    JuMP.@objective(minvertex, Min, sum(weights[i] * x[i] for i in nodes))

    # Solve the minimum vertex cover
    JuMP.optimize!(minvertex)

    xVal = JuMP.value.(x)
    m.num_var_disc_mip = Int(sum(xVal))
    m.disc_vars = [
        i for i in nodes if
        xVal[i] > 0 && abs(m.u_var_tight[i] - m.l_var_tight[i]) >= get_option(m, :tol)
    ]
    get_option(m, :log_level) >= 99 &&
        println("UPDATED DISC-VAR COUNT = $(length(m.disc_vars)) : $(m.disc_vars)")

    return
end

function _fetch_mip_solver_identifier(m::Optimizer; override = "")
    (get_option(m, :mip_solver) === nothing) && return
    m.mip_solver_id = _get_solver_name(m, :mip_solver, override)
    return
end

function _fetch_nlp_solver_identifier(m::Optimizer; override = "")
    (get_option(m, :nlp_solver) === nothing) && return
    m.nlp_solver_id = _get_solver_name(m, :nlp_solver, override)
    return
end

function _fetch_minlp_solver_identifier(m::Optimizer; override = "")
    (get_option(m, :minlp_solver) === nothing) && return
    m.minlp_solver_id = _get_solver_name(m, :minlp_solver, override)
    return
end

function _get_solver_name(m::Optimizer, key::Symbol, override::String)
    solver_string = override
    if isempty(override)
        solver = MOI.instantiate(get_option(m, key))
        solver_string = try
            MOI.get(solver, MOI.SolverName())
        catch
            "$(typeof(solver))"
        end
    end
    for name in ("Ipopt", "Gurobi", "CPLEX", "Juniper")
        if occursin(name, solver_string)
            return name
        end
    end
    return solver_string
end

"""
    set_mip_time_limit(m::Optimizer)

An utility function used to dynamically regulate MILP solver time limits to fit Alpine solver's time limits.
"""
function set_mip_time_limit(m::Optimizer)
    time_limit = max(0.0, get_option(m, :time_limit) - m.logs[:total_time])
    return MOI.set(m.model_mip, MOI.TimeLimitSec(), time_limit)
end

"""
Follow the definition of terms to calculate the value of lifted terms
"""
function resolve_lifted_var_value(m::Optimizer, sol_vec::Array)
    @assert length(sol_vec) == m.num_var_orig
    sol_vec = [sol_vec; fill(NaN, m.num_var_linear_mip + m.num_var_nonlinear_mip)]

    for i in 1:length(m.term_seq)
        k = m.term_seq[i]
        if haskey(m.nonconvex_terms, k)
            lvar_idx = m.nonconvex_terms[k][:y_idx]
            sol_vec[lvar_idx] =
                m.nonconvex_terms[k][:evaluator](m.nonconvex_terms[k], sol_vec)
        elseif haskey(m.linear_terms, k)
            lvar_idx = m.linear_terms[k][:y_idx]
            sol_vec[lvar_idx] = m.linear_terms[k][:evaluator](m.linear_terms[k], sol_vec)
        else
            error("[RARE] Found homeless term key $(k) during bound resolution.")
        end
    end

    return sol_vec
end

# Unused functions
# function amp_post_λ_upperbound(
#     m::Optimizer,
#     λ::Dict,
#     indices::Any,
#     dim::Tuple,
#     d::Dict,
#     tregions::Vector,
#     reg = [],
#     level = 0,
# )
#     if level == length(indices)
#         isempty(tregions[level]) && return
#         sliced_indices =
#             Set(collect_indices(λ[indices][:indices], 1, [reg[1]; reg[1] + 1], dim))
#         for i in 2:length(reg)
#             sliced_indices = intersect(
#                 sliced_indices,
#                 Set(collect_indices(λ[indices][:indices], i, [reg[i], reg[i] + 1], dim)),
#             )
#         end
#         for i in sliced_indices
#             JuMP.set_upper_bound(λ[indices][:vars][i], (1 / 2)^level)
#         end
#         return
#     end

#     for i in 1:length(tregions[level+1])
#         push!(reg, tregions[level+1][i])
#         amp_post_λ_upperbound(m, λ, indices, dim, d, tregions, reg, level + 1)
#         length(reg) < level && error("Something is wrong")
#         length(reg) > level && pop!(reg)
#     end

#     return
# end

# function amp_post_λ_upperbound(m::Optimizer, λ::Dict, indices::Any, ub::Float64)
#     for i in λ[indices][:vars]
#         JuMP.set_upper_bound(i, ub)
#     end

#     return
# end

# function amp_no_good_cut_α(m::Optimizer, α::Dict)
#     println("Global Incumbent solution objective = $(m.best_obj)")

#     for i in 1:m.bound_sol_pool[:cnt]
#         (m.bound_sol_pool[:stat][i] == :Cutoff) && (m.bound_sol_pool[:stat][i] = :Alive)
#         if m.best_obj < m.bound_sol_pool[:obj][i] && m.bound_sol_pool[:stat][i] == :Alive
#             no_good_idxs = keys(m.bound_sol_pool[:disc][i])
#             no_good_size = length(no_good_idxs) - 1
#             JuMP.@constraint(
#                 m.model_mip,
#                 sum(α[v][m.bound_sol_pool[:disc][i][v]] for v in no_good_idxs) <=
#                 no_good_size
#             )
#             get_option(m, :log_level) > 0 && println(
#                 "!! GLOBAL cuts off POOL_SOL-$(i) POOL_OBJ=$(m.bound_sol_pool[:obj][i])!",
#             )
#             m.bound_sol_pool[:stat][i] = :Cutoff
#         end
#     end

#     return
# end

@testset " Validation Test || AMP-TMC || basic solve || examples/nlp3.jl (2 iterations)" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => false,
        # "monomial_convexhull" => false,
        "presolve_bp" => true,
        "max_iter" => 2,
        "presolve_bt_width_tol" => 1e-3,
        "presolve_bt" => false,
        "partition_scaling_factor" => 10,
        "disc_var_pick" => 0,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT

    @test isapprox(objective_value(m), 7049.247897696512; atol = 1e-4)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 2
end

@testset " Validation Test || AMP-TMC || minimum-vertex solving || examples/nlp3.jl (3 iterations)" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => false,
        # "monomial_convexhull" => false,
        "presolve_bp" => true,
        "disc_var_pick" => 1,
        "max_iter" => 2,
        "partition_scaling_factor" => 10,
        "presolve_bt_width_tol" => 1e-3,
        "presolve_bt" => false,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 7049.247897696512; atol = 1e-4)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 2
end

@testset " Validation Test || BT-AMP-TMC || basic solve || examples/nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => false,
        "log_level" => 100,
        "max_iter" => 2,
        "partition_scaling_factor" => 10,
        "presolve_bt_width_tol" => 1e-3,
        "presolve_bt_bound_tol" => 1e-1,
        "presolve_bt" => true,
        "presolve_bt_algo" => 1,
        "presolve_bp" => true,
        "presolve_bt_max_iter" => 2,
        "presolve_track_time" => true,
        "disc_var_pick" => max_cover_var_picker,
    )
    m = nlp3(solver = test_solver)

    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test MOI.get(m, Alpine.NumberOfIterations()) == 2
    @test MOI.get(m, Alpine.NumberOfPresolveIterations()) == 2

    vars = all_variables(m)
    LB = [100, 1000, 1000, 10, 150.2, 10, 35.4, 168]
    UB = [4573.6, 5547.8, 5913.3, 332.4, 551, 390, 571.1, 638.7]
    @test isapprox(MOI.get.(m, Alpine.TightenedLowerBound(), vars), LB, atol = 1E-6)
    @test isapprox(MOI.get.(m, Alpine.TightenedUpperBound(), vars), UB, atol = 1E-6)
end

# FIXME Pavito terminates with `NUMERICAL_ERROR` on Julia v1.0:
@testset " Validation Test || PBT-AMP-TMC || basic solve || examples/nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => false,
        "log_level" => 100,
        "max_iter" => 2,
        "partition_scaling_factor" => 10,
        "presolve_bt" => true,
        "presolve_bt_width_tol" => 1e-3,
        "presolve_bt_bound_tol" => 1e-1,
        "presolve_bt_algo" => 2,
        "presolve_bp" => true,
        "presolve_bt_max_iter" => 2,
        "disc_var_pick" => max_cover_var_picker,
    )

    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)
    @test termination_status(m) == MOI.OTHER_LIMIT
    @test MOI.get(m, Alpine.NumberOfIterations()) == 2
end

@testset " Validation Test || AMP-CONV || basic solve || examples/nlp1.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => true,
        "partition_scaling_factor" => 12,
        "max_iter" => 1,
    )
    m = nlp1(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 58.38367169858795; atol = 1e-5)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
end

@testset " Validation Test || AMP-CONV || basic solve || examples/nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => false,
        "partition_scaling_factor" => 14,
        "max_iter" => 4,
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 7049.24789; atol = 1e-4)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 4
end

@testset " Validation Test || AMP || basic solve || examples/circle.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        "disc_abs_width_tol" => 1e-3,
        "partition_scaling_factor" => 8,
        "max_iter" => 6,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = circle(solver = test_solver)
    # This is fixed in Alpine - TODO (odow): cycling detected in Pavito when disc_abs_width_tol = 1E-2
    JuMP.optimize!(m)
    @test isapprox(objective_value(m), 1.4142135534556992; atol = 1e-3)
end

@testset " Validation Test || AMP-CONV-FACET || basic solve || examples/nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => true,
        "convhull_formulation" => "facet",
        "max_iter" => 3,
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test isapprox(objective_value(m), 7049.247897696188; atol = 1e-4)
    @test 6650 <= objective_bound(m) <= 7049
    @test MOI.get(m, Alpine.NumberOfIterations()) == 3
end

@testset " Validation Test || AMP || multi4N || N = 2 || exprmode=1:11" begin
    n_instances = 5
    objValVec = 2.0 * ones(n_instances)

    for i in 1:n_instances
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "disc_abs_width_tol" => 1e-2,
            "max_iter" => 4,
            "partition_scaling_factor" => 4,
            "presolve_bp" => false,
            "presolve_bt" => false,
            "log_level" => 1,
        )

        m = multi4N(solver = test_solver, N = 2, exprmode = i)
        JuMP.optimize!(m)

        @test termination_status(m) == MOI.OTHER_LIMIT
        @test isapprox(objective_value(m), objValVec[i]; atol = 1e-3)
    end
end

@testset " Validation Test || AMP || multi2 || exprmode=1:11" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "max_iter" => 5,
        "presolve_bt" => false,
        "log_level" => 1,
    )

    m = multi2(solver = test_solver)
    JuMP.optimize!(m)
    @test termination_status(m) == MOI.OPTIMAL
    @test primal_status(m) == MOI.FEASIBLE_POINT
    @test dual_status(m) == MOI.NO_SOLUTION
    @test raw_status(m) isa String
    @test isapprox(objective_value(m), 0.92906489; atol = 1e-3)
end

@testset " Validation Test || AMP || multi3N || N = 2 || exprmode=1:11" begin
    n_instances = 3
    objValVec = 2.0 * ones(n_instances)

    objBoundVec = Any[2.97186, 3.85492, 4.23375]

    for i in 1:n_instances
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "disc_abs_width_tol" => 1e-2,
            "max_iter" => 4,
            "partition_scaling_factor" => 4,
            "presolve_bp" => false,
            "presolve_bt" => false,
            "log_level" => 1,
        )

        m = multi3N(solver = test_solver, N = 2, exprmode = i)
        JuMP.optimize!(m)

        @test termination_status(m) == MOI.OTHER_LIMIT
        @test isapprox(objective_value(m), objValVec[i]; atol = 1e-3)
        @test objective_bound(m) <= objBoundVec[i] + 1e-3
    end
end

@testset " Validation Test || AMP || multiKND || K = 3, N = 3, D = 0 " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "max_iter" => 3,
        "partition_scaling_factor" => 4,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "log_level" => 1,
    )

    m = multiKND(solver = test_solver, randomub = 50, K = 3, N = 3, D = 0)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 3.0000000824779454; atol = 1e-3)
    @test isapprox(objective_bound(m), 12.054604248046875; atol = 1e-3)
end

@testset " Validation Test || AMP-CONV-FACET || basic solve || examples/nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => false,
        "max_iter" => 3,
        "partition_scaling_factor" => 4,
        "convhull_formulation" => "facet",
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 7049.247897696188; atol = 1e-4)
    @test isapprox(objective_bound(m), 5871.530692199214; atol = 1E-5)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 3
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR || examples/nlp3.jl " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => false,
        "partition_scaling_factor" => 18,
        "max_iter" => 1,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 18
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR-BRANCH || examples/nlp3.jl " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => true,
        "max_iter" => 1,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 14
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR-BRANCH || examples/castro2m2.jl " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => true,
        "max_iter" => 1,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = castro2m2(solver = test_solver)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 8
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR-BRANCH || examples/multi3N.jl exprmode=2" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => true,
        "max_iter" => 1,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = multi3N(solver = test_solver, N = 3, exprmode = 1)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 16
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR-BRANCH || examples/multi3N.jl exprmode=2" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => true,
        "max_iter" => 1,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = multi3N(solver = test_solver, N = 3, exprmode = 1)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 20
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR-BRANCH || examples/multi4N.jl exprmode=1" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => true,
        "max_iter" => 1,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = multi4N(solver = test_solver, N = 2, exprmode = 1)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 12
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR-BRANCH || examples/multi4N.jl exprmode=2" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => true,
        "max_iter" => 1,
        "presolve_bp" => false,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = multi4N(solver = test_solver, N = 2, exprmode = 1)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 20
end

@testset " Validation Test || AMP || PARTITION-SCALING-FACTOR-BRANCH || examples/multi4N.jl exprmode=2" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_abs_width_tol" => 1e-2,
        "partition_scaling_factor_branch" => true,
        "max_iter" => 1,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = multi4N(solver = test_solver, N = 2, exprmode = 2)
    JuMP.optimize!(m)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test MOI.get(m, MOI.RawOptimizerAttribute("partition_scaling_factor")) == 20
end

@testset "Operator :: bmpl && binlin && binprod solve test I" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => PAVITO,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bt" => false,
        "log_level" => 100,
    )

    m = bpml_lnl(solver = test_solver)
    JuMP.optimize!(m)
    @test isapprox(objective_value(m), 0.3; atol = 1e-6)
    alpine = JuMP.backend(m).optimizer.model
    @test haskey(alpine.nonconvex_terms, Expr[:(x[1]), :(x[6])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[2]), :(x[7])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[3]), :(x[8])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[4]), :(x[9])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[5]), :(x[10])])

    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[6])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[7])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[8])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[9])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[10])]][:nonlinear_type] == :BINLIN
end

@testset "Operator :: bmpl && binlin && binprod solve test II" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => JUNIPER,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bt" => false,
        "partition_scaling_factor" => 4,
        "log_level" => 100,
    )

    m = bpml_binl(solver = test_solver)

    # FIXME: Deactivating this until Juniper v0.9.0's numerical issues are fixed.
    # JuMP.optimize!(m)
    # @test isapprox(JuMP.objective_value(m), 22812.76415926; atol=1e-6)
    # alpine = JuMP.backend(m).optimizer.model

    alpine = _build(m)
    @test haskey(alpine.nonconvex_terms, Expr[:(x[6]), :(x[7])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[7]), :(x[8])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[8]), :(x[9])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[9]), :(x[10])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[10]), :(x[6])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[1]), :(x[11])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[2]), :(x[13])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[3]), :(x[15])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[4]), :(x[17])])
    @test haskey(alpine.nonconvex_terms, Expr[:(x[5]), :(x[19])])

    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[7])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[7]), :(x[8])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[8]), :(x[9])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[6])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[11])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[13])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[15])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[17])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[19])]][:nonlinear_type] == :BINLIN
end

@testset "Embedding Test || AMP-CONV || basic solve || examples/nlp1.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => true,
        "convhull_ebd" => true,
        "max_iter" => 1,
        "partition_scaling_factor" => 4,
        "log_level" => 100,
    )

    m = nlp1(solver = test_solver)
    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 58.38367169858795; atol = 1e-4)
    @test isapprox(alp.best_bound, 52.9702, atol = 1E-4)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
end

@testset "Embedding IBS Test || AMP-CONV || basic solve || examples/nlp1.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => true,
        "convhull_ebd" => true,
        "convhull_ebd_ibs" => true,
        "partition_scaling_factor" => 8,
        "max_iter" => 1,
        "log_level" => 100,
    )
    m = nlp1(solver = test_solver)
    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 58.38367169858795; atol = 1e-5)
    @test isapprox(alp.best_bound, 57.012, atol = 1E-4)

    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
end

@testset "Embedding IBS Test || AMP-CONV || basic solve || examples/nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => false,
        "convhull_ebd" => true,
        "convhull_ebd_ibs" => true,
        "max_iter" => 3,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 7049.247897696188; atol = 1e-5)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 3
    @test isapprox(alp.best_bound, 6893.2067, atol = 1E-4)
end

@testset "Embedding IBS Test || AMP || special problem || ... " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        "disc_abs_width_tol" => 1e-3,
        "partition_scaling_factor" => 8,
        "max_iter" => 6,
        "presolve_bt" => false,
        "presolve_bp" => true,
        "presolve_bt_algo" => 1,
        "presolve_bt_bound_tol" => 1e-1,
        "convhull_ebd" => true,
        "convhull_ebd_ibs" => true,
        "log_level" => 100,
    )

    m = circle(solver = test_solver)
    # This is fixed in Alpine - TODO(odow): mixed-integer cycling detected, terminating Pavito
    JuMP.optimize!(m)
    @test isapprox(objective_value(m), 1.41421355; atol = 1e-3)
end

@testset "Embedding LINK Test || AMP-CONV || basic solve || examples/nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bt" => false,
        "presolve_bp" => false,
        "convhull_ebd" => true,
        "convhull_ebd_link" => true,
        "partition_scaling_factor" => 10,
        "max_iter" => 3,
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 7049.247897696188; atol = 1e-4)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 3
end

@testset "Algorithm Logic Test || castro4m2 || 1 iteration || Error case" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "max_iter" => 1,
        "presolve_bt" => false,
        "partition_scaling_factor" => 10,
        "log_level" => 100,
    )

    m = castro4m2(solver = test_solver)
    JuMP.optimize!(m)
    @test termination_status(m) == MOI.OTHER_LIMIT
end

@testset " Algorithm Logic Test || blend029_gl || 3 iterations || Infeasible Case" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => PAVITO,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bp" => true,
        "disc_var_pick" => 1,
        "log_level" => 100,
        "max_iter" => 3,
        "partition_scaling_factor" => 10,
        "presolve_bt_width_tol" => 1e-3,
        "presolve_bt" => false,
    )
    m = blend029_gl(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test MOI.get(m, Alpine.NumberOfIterations()) == 3
    @test objective_bound(m) <= 14.0074
end

@testset "Convex Model Solve" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        "max_iter" => 1,
        "presolve_bt" => false,
        "log_level" => 100,
    )
    m = convex_solve(solver = test_solver)
    JuMP.optimize!(m)
    @test termination_status(m) == MOI.OPTIMAL
end

@testset "Uniform partitioning" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "disc_add_partition_method" => "uniform",
        "disc_uniform_rate" => 10,
        "max_iter" => 1,
        "presolve_bt" => false,
        "time_limit" => 100000,
        "log_level" => 100,
    )
    m = nlp3(solver = test_solver)
    JuMP.optimize!(m)
    @test isapprox(objective_bound(m), 6561.7841; atol = 1e-3)
end

@testset "Algorithm Test with binprod terms" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => PAVITO,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        # "bilinear_convexhull" => true,
        # "monomial_convexhull" => true,
        "presolve_bp" => true,
        "presolve_bt" => false,
        "partition_scaling_factor" => 10,
        "log_level" => 100,
    )
    m = binprod_nlp3(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OPTIMAL
    @test isapprox(objective_value(m), 3651.020370626844; rtol = 1e-4)
    @test isapprox(objective_bound(m), 3650.786358471944; rtol = 1e-4)

    alpine = JuMP.backend(m).optimizer.model
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4])]][:y_idx] == 19
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4])]][:id] == 6
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4])]][:lifted_constr_ref] ==
          :(x[19] == x[2] * x[4])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[8])]][:y_idx] == 25
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[8])]][:id] == 12
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[8])]][:lifted_constr_ref] ==
          :(x[25] == x[3] * x[8])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[8])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5])]][:y_idx] == 22
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5])]][:id] == 9
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5])]][:lifted_constr_ref] ==
          :(x[22] == x[3] * x[5])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[19])]][:y_idx] == 20
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[19])]][:id] == 7
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[19])]][:lifted_constr_ref] ==
          :(x[20] == x[12] * x[19])
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[19])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[4])]][:y_idx] == 14
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[4])]][:id] == 1
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[4])]][:lifted_constr_ref] ==
          :(x[14] == x[9] * x[4])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[4])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[6])]][:y_idx] == 17
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[6])]][:id] == 4
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[6])]][:lifted_constr_ref] ==
          :(x[17] == x[1] * x[6])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[6])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[11]), :(x[5])]][:y_idx] == 16
    @test alpine.nonconvex_terms[Expr[:(x[11]), :(x[5])]][:id] == 3
    @test alpine.nonconvex_terms[Expr[:(x[11]), :(x[5])]][:lifted_constr_ref] ==
          :(x[16] == x[11] * x[5])
    @test alpine.nonconvex_terms[Expr[:(x[11]), :(x[5])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[11])]][:y_idx] == 30
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[11])]][:id] == 17
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[11])]][:lifted_constr_ref] ==
          :(x[30] == x[10] * x[11])
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[11])]][:nonlinear_type] == :BINPROD
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[11])]][:y_idx] == 29
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[11])]][:id] == 16
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[11])]][:lifted_constr_ref] ==
          :(x[29] == x[9] * x[10] * x[11])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[11])]][:nonlinear_type] ==
          :BINPROD
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[7])]][:y_idx] == 21
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[7])]][:id] == 8
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[7])]][:lifted_constr_ref] ==
          :(x[21] == x[2] * x[7])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[7])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[13])]][:y_idx] == 32
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[13])]][:id] == 19
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[13])]][:lifted_constr_ref] ==
          :(x[32] == x[9] * x[13])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[13])]][:nonlinear_type] == :BINPROD
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[6])]][:y_idx] == 15
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[6])]][:id] == 2
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[6])]][:lifted_constr_ref] ==
          :(x[15] == x[10] * x[6])
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[6])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[12])]][:y_idx] == 33
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[12])]][:id] == 20
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[12])]][:lifted_constr_ref] ==
          :(x[33] == x[10] * x[12])
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[12])]][:nonlinear_type] == :BINPROD
    @test alpine.nonconvex_terms[Expr[:(x[27]), :(x[5])]][:y_idx] == 28
    @test alpine.nonconvex_terms[Expr[:(x[27]), :(x[5])]][:id] == 15
    @test alpine.nonconvex_terms[Expr[:(x[27]), :(x[5])]][:lifted_constr_ref] ==
          :(x[28] == x[27] * x[5])
    @test alpine.nonconvex_terms[Expr[:(x[27]), :(x[5])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[25])]][:y_idx] == 26
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[25])]][:id] == 13
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[25])]][:lifted_constr_ref] ==
          :(x[26] == x[13] * x[25])
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[25])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[12])]][:y_idx] == 27
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[12])]][:id] == 14
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[12])]][:lifted_constr_ref] ==
          :(x[27] == x[9] * x[12])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[12])]][:nonlinear_type] == :BINPROD
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[13])]][:y_idx] == 23
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[13])]][:id] == 10
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[13])]][:lifted_constr_ref] ==
          :(x[23] == x[10] * x[13])
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[13])]][:nonlinear_type] == :BINPROD
    @test alpine.nonconvex_terms[Expr[:(x[23]), :(x[22])]][:y_idx] == 24
    @test alpine.nonconvex_terms[Expr[:(x[23]), :(x[22])]][:id] == 11
    @test alpine.nonconvex_terms[Expr[:(x[23]), :(x[22])]][:lifted_constr_ref] ==
          :(x[24] == x[23] * x[22])
    @test alpine.nonconvex_terms[Expr[:(x[23]), :(x[22])]][:nonlinear_type] == :BINLIN
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[13])]][:y_idx] == 31
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[13])]][:id] == 18
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[13])]][:lifted_constr_ref] ==
          :(x[31] == x[12] * x[13])
    @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[13])]][:nonlinear_type] == :BINPROD
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[17])]][:y_idx] == 18
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[17])]][:id] == 5
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[17])]][:lifted_constr_ref] ==
          :(x[18] == x[9] * x[17])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[17])]][:nonlinear_type] == :BINLIN
    @test alpine.bounding_constr_mip[1][:rhs] == 1.0
    @test alpine.bounding_constr_mip[1][:vars] == Any[:(x[14]), :(x[15])]
    @test alpine.bounding_constr_mip[1][:coefs] == Any[0.0025, 0.0025]
    @test alpine.bounding_constr_mip[1][:sense] == :(<=)
    @test alpine.bounding_constr_mip[1][:cnt] == 2
    @test alpine.bounding_constr_mip[2][:rhs] == 1.0
    @test alpine.bounding_constr_mip[2][:vars] == Any[:(x[14]), :(x[5]), :(x[7])]
    @test alpine.bounding_constr_mip[2][:coefs] == Any[-0.0025, 0.0025, 0.0025]
    @test alpine.bounding_constr_mip[2][:sense] == :(<=)
    @test alpine.bounding_constr_mip[2][:cnt] == 3
    @test alpine.bounding_constr_mip[3][:rhs] == 1.0
    @test alpine.bounding_constr_mip[3][:vars] == Any[:(x[16]), :(x[8])]
    @test alpine.bounding_constr_mip[3][:coefs] == Any[-0.01, 0.01]
    @test alpine.bounding_constr_mip[3][:sense] == :(<=)
    @test alpine.bounding_constr_mip[3][:cnt] == 2
    @test alpine.bounding_constr_mip[4][:rhs] == 83333.333
    @test alpine.bounding_constr_mip[4][:vars] == Any[:(x[1]), :(x[18]), :(x[14])]
    @test alpine.bounding_constr_mip[4][:sense] == :(<=)
    @test alpine.bounding_constr_mip[4][:cnt] == 3
    @test alpine.bounding_constr_mip[5][:rhs] == 0.0
    @test alpine.bounding_constr_mip[5][:vars] ==
          Any[:(x[20]), :(x[21]), :(x[4]), :(x[5])]
    @test alpine.bounding_constr_mip[5][:coefs] == Any[1.0, -1.0, -1250.0, 1250.0]
    @test alpine.bounding_constr_mip[5][:sense] == :(<=)
    @test alpine.bounding_constr_mip[5][:cnt] == 4
    @test alpine.bounding_constr_mip[6][:rhs] == -1.25e6
    @test alpine.bounding_constr_mip[6][:vars] == Any[:(x[24]), :(x[26]), :(x[28])]
    @test alpine.bounding_constr_mip[6][:coefs] == Any[1.0, -1.0, -2500.0]
    @test alpine.bounding_constr_mip[6][:sense] == :(<=)
    @test alpine.bounding_constr_mip[6][:cnt] == 3
    @test alpine.bounding_constr_mip[7][:rhs] == 0.0
    @test alpine.bounding_constr_mip[7][:vars] == Any[:(x[29])]
    @test alpine.bounding_constr_mip[7][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[7][:sense] == :(<=)
    @test alpine.bounding_constr_mip[7][:cnt] == 1
    @test alpine.bounding_constr_mip[8][:rhs] == 0.0
    @test alpine.bounding_constr_mip[8][:vars] == Any[:(x[30]), :(x[31])]
    @test alpine.bounding_constr_mip[8][:coefs] == Any[1.0, -1.0]
    @test alpine.bounding_constr_mip[8][:sense] == :(>=)
    @test alpine.bounding_constr_mip[8][:cnt] == 2
    @test alpine.bounding_constr_mip[9][:rhs] == 0.0
    @test alpine.bounding_constr_mip[9][:vars] == Any[:(x[32]), :(x[33])]
    @test alpine.bounding_constr_mip[9][:coefs] == Any[1.0, -1.0]
    @test alpine.bounding_constr_mip[9][:sense] == :(<=)
    @test alpine.bounding_constr_mip[9][:cnt] == 2
end

@testset "TESTS for closing the optimality gap in OBBT" begin
    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        "presolve_bt" => true,
        "presolve_bt_max_iter" => 2,
        "log_level" => 1,
    )
    m = JuMP.Model(test_solver)

    # From issue #108
    @variable(m, -2 <= x[1:2] <= 2)
    @variable(m, -10 <= y[1:3] <= 10)
    @NLobjective(m, Min, y[2] + y[1] * y[2] * y[3])
    @constraint(m, y[1] == x[1])
    @constraint(m, y[2] == x[2])
    @NLconstraint(m, y[3] == x[2]^2)

    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model
    @test isapprox(JuMP.objective_value(m), -18, atol = 1E-6)
    @test isapprox(value.(m[:x]), [2, -2], atol = 1E-6)
    @test alp.logs[:n_iter] == 0
    @test MOI.get(m, Alpine.NumberOfIterations()) == 0
end

@testset "Linking constraints for multilinear terms" begin

    # Without linking constraints
    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bt" => false,
        "apply_partitioning" => true,
        "linking_constraints" => false,
    )
    m = linking_constraints_testing(solver = test_solver)
    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model
    @test isapprox(JuMP.objective_value(m), -0.5294000135, atol = 1E-5)
    @test isnothing(alp.linking_constraints_info)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 2

    # With linking constraints
    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bt" => false,
        "apply_partitioning" => true,
        "linking_constraints" => true,
    )
    m = linking_constraints_testing(solver = test_solver)
    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model
    @test isapprox(JuMP.objective_value(m), -0.5294000135, atol = 1E-5)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 1
    @test in(Set{Any}([1, 2]), alp.linking_constraints_info[[1, 2]])
    @test in(Set{Any}([1, 2, 3]), alp.linking_constraints_info[[1, 2]])
    @test in(Set{Any}([1, 2, 4]), alp.linking_constraints_info[[1, 2]])
    @test in(Set{Any}([1, 3]), alp.linking_constraints_info[[1, 3]])
    @test in(Set{Any}([1, 2, 3]), alp.linking_constraints_info[[1, 3]])
    @test in(Set{Any}([1, 3, 4]), alp.linking_constraints_info[[1, 3]])
    @test in(Set{Any}([1, 4]), alp.linking_constraints_info[[1, 4]])
    @test in(Set{Any}([1, 2, 4]), alp.linking_constraints_info[[1, 4]])
    @test in(Set{Any}([1, 3, 4]), alp.linking_constraints_info[[1, 4]])
end

@testset "Warm start value used as the incumbent solution" begin
    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bt" => false,
        "max_iter" => 1,
        "use_start_as_incumbent" => false,
    )
    sol = [
        579.30669,
        1359.97066,
        5109.97054,
        182.0177,
        295.60118,
        217.9823,
        286.41653,
        395.60118,
    ]

    m = nlp3(solver = test_solver)
    for i in 1:length(m[:x])
        JuMP.set_start_value(m[:x][i], sol[i])
    end

    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(objective_value(m), 7049.247897696512, atol = 1e-6)
    @test isapprox(alp.best_bound, 3834.978106740535, atol = 1E-6)
    @test alp.options.use_start_as_incumbent == false

    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bt" => true,
        "max_iter" => 1,
        "use_start_as_incumbent" => true,
    )

    m = nlp3(solver = test_solver)
    for i in 1:length(m[:x])
        JuMP.set_start_value(m[:x][i], sol[i])
    end

    JuMP.optimize!(m)
    alp = JuMP.backend(m).optimizer.model

    @test termination_status(m) == MOI.OTHER_LIMIT
    @test isapprox(alp.best_bound, 4810.212866711817, atol = 1E-3)
    @test alp.warm_start_value == sol
    @test alp.options.use_start_as_incumbent == true
end

@testset "Test binary multilinear product linearization" begin
    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "minlp_solver" => JUNIPER,
        "presolve_bt" => false,
    )

    m = hmittelman(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OPTIMAL
    @test isapprox(objective_value(m), 13; atol = 1e-4)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 1

    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "minlp_solver" => JUNIPER,
        "presolve_bt" => true,
    )

    m = hmittelman(solver = test_solver)
    JuMP.optimize!(m)

    @test termination_status(m) == MOI.OPTIMAL
    @test isapprox(objective_value(m), 13; atol = 1e-4)
    @test MOI.get(m, Alpine.NumberOfIterations()) == 0
end

@testset "Test integer variable support via IntegerToZeroOneBridge" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "minlp_solver" => JUNIPER,
    )
    model = JuMP.Model(test_solver)
    @variable(model, -10 <= x <= 20, Int)
    @objective(model, Min, x)
    JuMP.optimize!(model)
    @test termination_status(model) == MOI.OPTIMAL
    @test isapprox(objective_value(model), -10; atol = 1e-4)
    @test isapprox(value(x), -10, atol = 1e-6)
    @test MOI.get(model, Alpine.NumberOfIterations()) == 0
end

@testset "Test integer variable support 0" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "minlp_solver" => JUNIPER,
    )
    model = JuMP.Model(test_solver)
    @variable(model, x, Int)
    @objective(model, Min, x)
    @test_throws(
        ErrorException(
            "Unable to use IntegerToZeroOneBridge because the variable MOI.VariableIndex(1) has a non-finite domain",
        ),
        JuMP.optimize!(model),
    )
end

@testset "Test integer variable support 1" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "minlp_solver" => JUNIPER,
    )
    model = JuMP.Model(test_solver)
    @variable(model, -10 <= x, Int)
    @objective(model, Min, x)
    @test_throws(
        ErrorException(
            "Unable to use IntegerToZeroOneBridge because the variable MOI.VariableIndex(1) has a non-finite domain",
        ),
        JuMP.optimize!(model),
    )
end

@testset "Test integer variable support 2" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "minlp_solver" => JUNIPER,
    )
    model = JuMP.Model(test_solver)
    @variable(model, x <= 20, Int)
    @objective(model, Min, x)
    @test_throws(
        ErrorException(
            "Unable to use IntegerToZeroOneBridge because the variable MOI.VariableIndex(1) has a non-finite domain",
        ),
        JuMP.optimize!(model),
    )
end

include("MINLPs/nlp.jl")
include("MINLPs/bnlp.jl")
include("MINLPs/blend.jl")
include("MINLPs/brainpc3.jl")
include("MINLPs/castro.jl")
include("MINLPs/circle.jl")
include("MINLPs/convex.jl")
include("MINLPs/discretemulti.jl")
include("MINLPs/div.jl")
include("MINLPs/exprstest.jl")
include("MINLPs/linearlift.jl")
include("MINLPs/multi.jl")
include("MINLPs/mult3.jl")
include("MINLPs/mult4.jl")
include("MINLPs/rosenbrock.jl")

"""
	This function creates a mapping dictionary to link the right λ to the right bineary variables
	based on how many partitions are required and a given encoding method.
"""
function embedding_map(λCnt::Int, encoding::Any = ebd_gray, ibs::Bool = false)
    map = Dict()

    encoding = resolve_encoding_key(encoding)
    L = Int(ceil(log(2, λCnt - 1)))
    for i in 1:L*2
        map[i] = Set()
    end
    H = [encoding(i, L) for i in 0:max(1, (2^L - 1))]
    map[:H_orig] = H
    map[:H] = [ebd_support_binary_vec(H[i]) for i in 1:length(H)] # Store the map
    map[:L] = L

    !is_compatible_encoding(H) && error("Encodign method is not SOS-2 compatible...")

    # Mapping SOS-2 :: Aλ <= x  &&  A'λ <=  1-x
    # |x| = L : Flip  1 -> bCnt : bCnt + 1 -> bCnt + bCnt
    J = Set(collect(1:(2^L+1)))
    J_s = Set(collect(1:λCnt))
    for l in 1:L
        if ibs
            L_constr = Set()
            R_constr = Set()
            for j in 0:2^L
                prod([(l in ebd_σ(H[i])) for i in ebd_I(j, 2^L + 1)]) && push!(L_constr, j + 1)
                prod([!(l in ebd_σ(H[i])) for i in ebd_I(j, 2^L + 1)]) && push!(R_constr, j + 1)
            end
            L_branch = intersect(J_s, setdiff(J, L_constr))
            R_branch = intersect(J_s, setdiff(J, R_constr))
            map[l] = setdiff(J_s, L_branch)
            map[l+L] = setdiff(J_s, R_branch)
        else
            for j in 0:(λCnt-1)
                prod([(l in ebd_σ(H[i])) for i in ebd_I(j, λCnt)]) && push!(map[l], j + 1)
                prod([!(l in ebd_σ(H[i])) for i in ebd_I(j, λCnt)]) && push!(map[l+L], j + 1)
            end
        end
    end

    return map
end

"""
	This function parse the encoding key string and return the built-in encoding function.
"""
function resolve_encoding_key(encoding::Any)
    isa(encoding, Function) && return encoding
    encoding == "default" && return ebd_gray
    return error("Must specify a encoding method when using convhull_ebd formulation")
end

"""
	This function is the same σ() function described in Vielma and Nemhauser 2011.
"""
function ebd_σ(b::String)
    sv = ebd_support_bool_vec(b)
    return [i for i in 1:length(sv) if sv[i]]
end

"""
	This function is the same I() function described in Vielma and Nemhauser 2011.
"""
function ebd_I(j, λCnt)
    return [i for i in collect(1:Int((λCnt - 1))) if j in [i - 1, i]] #Page 52
end

"""
	This function is the same S() function described in Vielma and Nemhauser 2011.
"""
function ebd_S(i)
    (i <= 0) && error("Embedding utility S_[i] doesn't take i<=0")
    return [i, i - 1]
end

"""
	This function checks whether the encoding method is compatible or not to obtain a valid mapping.
"""
function is_compatible_encoding(code_seq::Vector)
    for i in 1:(length(code_seq)-1)
        sum(
            abs.(ebd_support_bool_vec(code_seq[i]) - ebd_support_bool_vec(code_seq[i+1])),
        ) != 1 && return false
    end
    return true
end

"""
	This is a utility function that convert the binary string into bool vector
"""
function ebd_support_bool_vec(s::String)
    v = Vector{Bool}(undef, length(s))
    for i in 1:length(s)
        s[i] == '1' ? v[i] = true : v[i] = false
    end
    return v
end

"""
	This is a utility function that convert the binary string into 0/1 vector
"""
function ebd_support_binary_vec(s::String)
    v = Vector{Int}(undef, length(s))
    for i in 1:length(s)
        s[i] == '1' ? v[i] = 1 : v[i] = 0
    end
    return v
end

"""
	This is the function that translate the bounding constraints (α¹b⁰+α²b¹ <= x <= α¹b¹+α²b²)
	with log # of binary variables, i.e., generate these constraints using log # of binary variables.
"""
function ebd_link_xα(
    m::Optimizer,
    α::Vector,
    λCnt::Int,
    disc_vec::Vector,
    code_seq::Vector,
    var_idx::Int,
)
    lifters = Dict()
    exprs = Dict()
    L = Int(ceil(log(2, λCnt - 1)))
    P = length(disc_vec) - 1

    # Expression expansion
    for i in 1:P
        code_vec = ebd_support_bool_vec(code_seq[i])
        lifters, exprs = ebd_link_expression(code_vec, lifters, exprs, i)
    end

    # Construct Variable Vector
    α_A = JuMP.@variable(
        m.model_mip,
        [1:length(keys(lifters))],
        lower_bound = 0.0,
        upper_bound = 1.0,
        base_name = "αA$(var_idx)"
    )
    for i in keys(lifters) # Build first-level evaluation
        relaxation_multilinear_binary(m.model_mip, α_A[lifters[i]-L], [α[j] for j in i])
    end

    α_R = [α; α_A] # Initialize/re-arrgange the variable sequence

    for i in 1:P # Start populating sub-expressions
        exprs[i][:expr] = JuMP.@expression(
            m.model_mip,
            sum(
                exprs[i][:coefs][j] * α_R[exprs[i][:vars][j]] for
                j in 1:exprs[i][:length] if exprs[i][:vars][j] != 0
            ) + exprs[i][:vals]
        )
    end

    # Contructing final constraints
    JuMP.@constraint(
        m.model_mip,
        _index_to_variable_ref(m.model_mip, var_idx) >=
        sum(exprs[j][:expr] * disc_vec[j] for j in 1:P)
    )
    JuMP.@constraint(
        m.model_mip,
        _index_to_variable_ref(m.model_mip, var_idx) <=
        sum(exprs[j-1][:expr] * disc_vec[j] for j in 2:(P+1))
    )

    return
end

"""
	This is a utility function used in ebd_link_xα() that constructing the mapping that links partitions with
	combinations of binary variables.
"""
function ebd_link_expression(code::Vector, lift_dict::Dict, link_dict::Dict, p_idx::Int)
    L = length(code)

    # Strickly mapping p_idx -> x
    code[1] ? coefs = Any[1] : coefs = Any[1, -1]
    code[1] ? vars = Any[1] : vars = Any[0, 1]
    prod(.!code) ? vals = 1.0 : vals = 0.0  # Marks the eventual expression is going have 1 or not

    for i in 2:L
        if code[i]
            for j in 1:length(coefs)
                (vars[j] == 0) ? vars[j] = i : vars[j] = [vars[j]; i] # Update vars
                @assert length(vars) == length(coefs)
            end
        else
            for j in 1:length(coefs)
                (vars[j] == 0) ? push!(vars, i) : push!(vars, [vars[j]; i]) # Update vars with variable multiplier (ADDING)
                (vars[j] == 0) ? push!(coefs, -1) : push!(coefs, coefs[j] * -1) # Update the coeffs with -1 (ADDING)
            end
        end
    end
    @assert length(coefs) == length(vars)

    # Maintaining the dictionary of lifted variables and swp
    for i in 1:length(vars)
        if isa(vars[i], Vector)
            !haskey(lift_dict, vars[i]) &&
                (lift_dict[vars[i]] = L + length(keys(lift_dict)) + 1)
            vars[i] = lift_dict[vars[i]]
        end
    end

    # Maintain the expression dictionary
    link_dict[p_idx] = Dict(
        :p_idx => p_idx,
        :coefs => coefs,
        :vars => vars,
        :vals => vals,
        :length => length(coefs),
    )

    return lift_dict, link_dict
end

"""
	Built-in Encoding methods: binary encoding
	This is a compatible encoding
"""
ebd_binary(n, idx) = string(n, base = 2, pad = idx)

"""
	Built-in Encoding methods: gray encoding
	This is a compatible encoding
"""
function ebd_gray(n, idx)
    code_decimal = xor(n, n >> 1)
    return string(code_decimal, base = 2, pad = idx)
end

@testset "Expression Parsing || bilinear || Affine || exprs.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )

    m = exprstest(solver = test_solver)

    alpine = _build(m)

    ex = alpine.bounding_constr_expr_mip[1]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [-1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[1][:coefs]
    @test affdict[:vars] == [:(x[1])]
    @test affdict[:vars] == alpine.bounding_constr_mip[1][:vars]
    @test isapprox(affdict[:rhs], 109.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[1][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[1][:sense]

    ex = alpine.bounding_constr_expr_mip[2]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [3.0, 3.0, 3.0, 3.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[2][:coefs]
    @test affdict[:vars] == [:(x[8]), :(x[9]), :(x[10]), :(x[11])]
    @test affdict[:vars] == alpine.bounding_constr_mip[2][:vars]
    @test isapprox(affdict[:rhs], 111.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[2][:rhs]
    @test affdict[:sense] == :(>=)
    @test affdict[:sense] == alpine.bounding_constr_mip[2][:sense]

    ex = alpine.bounding_constr_expr_mip[3]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [-1.0, 20.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[3][:coefs]
    @test affdict[:vars] == [:(x[12]), :(x[13])]
    @test affdict[:vars] == alpine.bounding_constr_mip[3][:vars]
    @test isapprox(affdict[:rhs], 222.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[3][:rhs]
    @test affdict[:sense] == :(>=)
    @test affdict[:sense] == alpine.bounding_constr_mip[3][:sense]

    # 1.0 * x[12] - 115.0 >= 0.0
    ex = alpine.bounding_constr_expr_mip[4]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [-1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[4][:coefs]
    @test affdict[:vars] == [:(x[12])]
    @test affdict[:vars] == alpine.bounding_constr_mip[4][:vars]
    @test isapprox(affdict[:rhs], 115.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[4][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[4][:sense]

    # 1.0 * x[12] - 115.0 <= 0.0
    ex = alpine.bounding_constr_expr_mip[5]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[5][:coefs]
    @test affdict[:vars] == [:(x[12])]
    @test affdict[:vars] == alpine.bounding_constr_mip[5][:vars]
    @test isapprox(affdict[:rhs], 115.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[5][:rhs]
    @test affdict[:sense] == :(>=)
    @test affdict[:sense] == alpine.bounding_constr_mip[5][:sense]

    # -1.0 * x[12] - 115.0 >= 0.0
    ex = alpine.bounding_constr_expr_mip[6]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [-1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[6][:coefs]
    @test affdict[:vars] == [:(x[12])]
    @test affdict[:vars] == alpine.bounding_constr_mip[6][:vars]
    @test isapprox(affdict[:rhs], 115.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[6][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[6][:sense]

    # (x[1] + 1.0 * x[14]) - 555.0 >= 0.0
    ex = alpine.bounding_constr_expr_mip[7]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [1.0, 1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[7][:coefs]
    @test affdict[:vars] == [:(x[1]), :(x[14])]
    @test affdict[:vars] == alpine.bounding_constr_mip[7][:vars]
    @test isapprox(affdict[:rhs], 555.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[7][:rhs]
    @test affdict[:sense] == :(>=)
    @test affdict[:sense] == alpine.bounding_constr_mip[7][:sense]

    # ((x[8] - 7.0 * x[9]) + x[10] + x[4]) - 6666.0 <= 0.0
    ex = alpine.bounding_constr_expr_mip[8]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [1.0, -7.0, 1.0, 1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[8][:coefs]
    @test affdict[:vars] == [:(x[8]), :(x[9]), :(x[10]), :(x[4])]
    @test affdict[:vars] == alpine.bounding_constr_mip[8][:vars]
    @test isapprox(affdict[:rhs], 6666.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[8][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[8][:sense]

    # ((13.0 * x[1] - x[2]) + 30.0 * x[3] + x[4]) - 77.0 >= 0.0
    ex = alpine.bounding_constr_expr_mip[9]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [13.0, -1.0, 30.0, 1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[9][:coefs]
    @test affdict[:vars] == [:(x[1]), :(x[2]), :(x[3]), :(x[4])]
    @test affdict[:vars] == alpine.bounding_constr_mip[9][:vars]
    @test isapprox(affdict[:rhs], 77.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[9][:rhs]
    @test affdict[:sense] == :(>=)
    @test affdict[:sense] == alpine.bounding_constr_mip[9][:sense]
end

@testset "Expression Parsing || bilinear || Affine || nlp1.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )
    m = nlp1(solver = test_solver)

    alpine = _build(m)

    ex = alpine.bounding_constr_expr_mip[1]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [1.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[1][:coefs]
    @test affdict[:vars] == [:(x[5])]
    @test affdict[:vars] == alpine.bounding_constr_mip[1][:vars]
    @test isapprox(affdict[:rhs], 8.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[1][:rhs]
    @test affdict[:sense] == :(>=)
    @test affdict[:sense] == alpine.bounding_constr_mip[1][:sense]
end

@testset "Expression Parsing || bilinear || Affine || nlp3.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )

    m = nlp3(solver = test_solver)

    alpine = _build(m)

    ex = alpine.bounding_constr_expr_mip[1]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [0.0025, 0.0025]
    @test affdict[:coefs] == alpine.bounding_constr_mip[1][:coefs]
    @test affdict[:vars] == [:(x[4]), :(x[6])]
    @test affdict[:vars] == alpine.bounding_constr_mip[1][:vars]
    @test isapprox(affdict[:rhs], 1.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[1][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[1][:sense]

    ex = alpine.bounding_constr_expr_mip[2]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [-0.0025, 0.0025, 0.0025]
    @test affdict[:coefs] == alpine.bounding_constr_mip[2][:coefs]
    @test affdict[:vars] == [:(x[4]), :(x[5]), :(x[7])]
    @test affdict[:vars] == alpine.bounding_constr_mip[2][:vars]
    @test isapprox(affdict[:rhs], 1.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[2][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[2][:sense]

    ex = alpine.bounding_constr_expr_mip[3]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [-0.01, 0.01]
    @test affdict[:coefs] == alpine.bounding_constr_mip[3][:coefs]
    @test affdict[:vars] == [:(x[5]), :(x[8])]
    @test affdict[:vars] == alpine.bounding_constr_mip[3][:vars]
    @test isapprox(affdict[:rhs], 1.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[3][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[3][:sense]

    ex = alpine.bounding_constr_expr_mip[4]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test (affdict[:coefs] .== [100.0, -1.0, 833.33252]) == [true, true, true]
    @test affdict[:coefs] == alpine.bounding_constr_mip[4][:coefs]
    @test affdict[:vars] == [:(x[1]), :(x[9]), :(x[4])]
    @test affdict[:vars] == alpine.bounding_constr_mip[4][:vars]
    @test isapprox(affdict[:rhs], 83333.333; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[4][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[4][:sense]

    ex = alpine.bounding_constr_expr_mip[5]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [1.0, -1.0, -1250.0, 1250.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[5][:coefs]
    @test affdict[:vars] == [:(x[10]), :(x[11]), :(x[4]), :(x[5])]
    @test affdict[:vars] == alpine.bounding_constr_mip[5][:vars]
    @test isapprox(affdict[:rhs], 0.0; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[5][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[5][:sense]

    ex = alpine.bounding_constr_expr_mip[6]
    affdict = Alpine.expr_linear_to_affine(ex)
    @test affdict[:coefs] == [1.0, -1.0, -2500.0]
    @test affdict[:coefs] == alpine.bounding_constr_mip[6][:coefs]
    @test affdict[:vars] == [:(x[12]), :(x[13]), :(x[5])]
    @test affdict[:vars] == alpine.bounding_constr_mip[6][:vars]
    @test isapprox(affdict[:rhs], -1.25e6; atol = 1e-3)
    @test affdict[:rhs] == alpine.bounding_constr_mip[6][:rhs]
    @test affdict[:sense] == :(<=)
    @test affdict[:sense] == alpine.bounding_constr_mip[6][:sense]
end

@testset "Expression Parsing || bilinear || Simple || bi1.jl " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )

    m = operator_c(solver = test_solver)

    alpine = _build(m) # Setup internal model

    @test length(keys(alpine.nonconvex_terms)) == 8
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 1), Expr(:ref, :x, 1)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 2), Expr(:ref, :x, 2)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 3), Expr(:ref, :x, 3)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 4), Expr(:ref, :x, 4)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 2), Expr(:ref, :x, 3)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 3), Expr(:ref, :x, 4)])

    # TODO setup detailed check on this problem
end
@testset "Expression Parsing || bilinear || Complex || blend029.jl " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => JUNIPER,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )

    m = blend029(solver = test_solver)

    alpine = _build(m) # Setup internal model

    @test length(keys(alpine.nonconvex_terms)) == 28
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 37), Expr(:ref, :x, 55)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 38), Expr(:ref, :x, 56)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 37), Expr(:ref, :x, 26)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 43), Expr(:ref, :x, 26)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 47), Expr(:ref, :x, 59)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 48), Expr(:ref, :x, 60)])
    @test haskey(alpine.nonconvex_terms, [Expr(:ref, :x, 47), Expr(:ref, :x, 36)])

    @test alpine.bounding_constr_mip[1][:rhs] == 1.0
    @test alpine.bounding_constr_mip[1][:vars] ==
          Any[:(x[1]), :(x[4]), :(x[7]), :(x[10]), :(x[49])]
    @test alpine.bounding_constr_mip[1][:sense] == :(==)
    @test alpine.bounding_constr_mip[1][:coefs] == Any[1.0, 1.0, 1.0, 1.0, 1.0]
    @test alpine.bounding_constr_mip[1][:cnt] == 5

    @test alpine.bounding_constr_mip[4][:rhs] == 0.1
    @test alpine.bounding_constr_mip[4][:vars] ==
          Any[:(x[4]), :(x[16]), :(x[25]), :(x[34]), :(x[58])]
    @test alpine.bounding_constr_mip[4][:sense] == :(==)
    @test alpine.bounding_constr_mip[4][:coefs] == Any[-1.0, -1.0, -1.0, 1.0, 1.0]
    @test alpine.bounding_constr_mip[4][:cnt] == 5

    @test alpine.bounding_constr_mip[17][:rhs] == -0.14
    @test alpine.bounding_constr_mip[17][:vars] ==
          Any[:(x[11]), :(x[23]), :(x[32]), :(x[64]), :(x[65])]
    @test alpine.bounding_constr_mip[17][:sense] == :(==)
    @test alpine.bounding_constr_mip[17][:coefs] == Any[-1.0, -1.0, -1.0, -1.0, 1.0]
    @test alpine.bounding_constr_mip[17][:cnt] == 5

    @test alpine.bounding_constr_mip[31][:rhs] == 0.0
    @test alpine.bounding_constr_mip[31][:vars] == Any[:(x[13])]
    @test alpine.bounding_constr_mip[31][:sense] == :(>=)
    @test alpine.bounding_constr_mip[31][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[31][:cnt] == 1

    @test alpine.bounding_constr_mip[145][:rhs] == 1.0
    @test alpine.bounding_constr_mip[145][:vars] == Any[:(x[73])]
    @test alpine.bounding_constr_mip[145][:sense] == :(<=)
    @test alpine.bounding_constr_mip[145][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[145][:cnt] == 1

    @test alpine.bounding_constr_mip[67][:rhs] == -1.0
    @test alpine.bounding_constr_mip[67][:vars] == Any[:(x[73])]
    @test alpine.bounding_constr_mip[67][:sense] == :(>=)
    @test alpine.bounding_constr_mip[67][:coefs] == Any[-1.0]
    @test alpine.bounding_constr_mip[67][:cnt] == 1

    @test alpine.bounding_constr_mip[187][:rhs] == 1.0
    @test alpine.bounding_constr_mip[187][:vars] == Any[:(x[79]), :(x[94])]
    @test alpine.bounding_constr_mip[187][:sense] == :(<=)
    @test alpine.bounding_constr_mip[187][:coefs] == Any[1.0, 1.0]
    @test alpine.bounding_constr_mip[187][:cnt] == 2

    @test alpine.bounding_constr_mip[202][:rhs] == 0.04
    @test alpine.bounding_constr_mip[202][:vars] ==
          Any[:(x[103]), :(x[1]), :(x[13]), :(x[25]), :(x[28]), :(x[31])]
    @test alpine.bounding_constr_mip[202][:sense] == :(==)
    @test alpine.bounding_constr_mip[202][:coefs] == Any[1.0, -0.6, -0.2, 0.2, 0.2, 0.2]
    @test alpine.bounding_constr_mip[202][:cnt] == 6

    @test alpine.nonconvex_terms[[:(x[37]), :(x[55])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[37]), :(x[55])]][:lifted_var_ref] == :(x[103])
    @test alpine.nonconvex_terms[[:(x[37]), :(x[55])]][:convexified] == false
    @test alpine.nonconvex_terms[[:(x[37]), :(x[55])]][:nonlinear_type] == :BILINEAR

    @test alpine.bounding_constr_mip[206][:rhs] == 0.0
    @test alpine.bounding_constr_mip[206][:vars] ==
          Any[:(x[107]), :(x[103]), :(x[108]), :(x[109]), :(x[110]), :(x[2]), :(x[14])]
    @test alpine.bounding_constr_mip[206][:sense] == :(==)
    @test alpine.bounding_constr_mip[206][:coefs] ==
          Any[1.0, -1.0, 1.0, 1.0, 1.0, -0.6, -0.2]
    @test alpine.bounding_constr_mip[206][:cnt] == 7

    @test alpine.nonconvex_terms[[:(x[38]), :(x[56])]][:id] == 5
    @test alpine.nonconvex_terms[[:(x[38]), :(x[56])]][:lifted_var_ref] == :(x[107])
    @test alpine.nonconvex_terms[[:(x[38]), :(x[56])]][:convexified] == false
    @test alpine.nonconvex_terms[[:(x[38]), :(x[56])]][:nonlinear_type] == :BILINEAR

    @test alpine.nonconvex_terms[[:(x[37]), :(x[26])]][:id] == 6
    @test alpine.nonconvex_terms[[:(x[37]), :(x[26])]][:lifted_var_ref] == :(x[108])
    @test alpine.nonconvex_terms[[:(x[37]), :(x[26])]][:convexified] == false
    @test alpine.nonconvex_terms[[:(x[37]), :(x[26])]][:nonlinear_type] == :BILINEAR

    @test alpine.nonconvex_terms[[:(x[37]), :(x[32])]][:id] == 8
    @test alpine.nonconvex_terms[[:(x[37]), :(x[32])]][:lifted_var_ref] == :(x[110])
    @test alpine.nonconvex_terms[[:(x[37]), :(x[32])]][:convexified] == false
    @test alpine.nonconvex_terms[[:(x[37]), :(x[32])]][:nonlinear_type] == :BILINEAR

    @test alpine.bounding_constr_mip[213][:rhs] == 0.0
    @test alpine.bounding_constr_mip[213][:vars] ==
          Any[:(x[129]), :(x[127]), :(x[124]), :(x[130]), :(x[6]), :(x[18])]
    @test alpine.bounding_constr_mip[213][:sense] == :(==)
    @test alpine.bounding_constr_mip[213][:coefs] == Any[1.0, -1.0, -1.0, 1.0, -0.4, -0.4]
    @test alpine.bounding_constr_mip[213][:cnt] == 6

    @test alpine.nonconvex_terms[[:(x[48]), :(x[60])]][:id] == 27
    @test alpine.nonconvex_terms[[:(x[48]), :(x[60])]][:lifted_var_ref] == :(x[129])
    @test alpine.nonconvex_terms[[:(x[48]), :(x[60])]][:convexified] == false
    @test alpine.nonconvex_terms[[:(x[48]), :(x[60])]][:nonlinear_type] == :BILINEAR

    @test alpine.nonconvex_terms[[:(x[47]), :(x[59])]][:id] == 25
    @test alpine.nonconvex_terms[[:(x[47]), :(x[59])]][:lifted_var_ref] == :(x[127])
    @test alpine.nonconvex_terms[[:(x[47]), :(x[59])]][:convexified] == false
    @test alpine.nonconvex_terms[[:(x[47]), :(x[59])]][:nonlinear_type] == :BILINEAR

    @test alpine.nonconvex_terms[[:(x[47]), :(x[36])]][:id] == 28
    @test alpine.nonconvex_terms[[:(x[47]), :(x[36])]][:lifted_var_ref] == :(x[130])
    @test alpine.nonconvex_terms[[:(x[47]), :(x[36])]][:convexified] == false
    @test alpine.nonconvex_terms[[:(x[47]), :(x[36])]][:nonlinear_type] == :BILINEAR
end

@testset "Expression Parsing || multilinear || Simple || multi.jl " begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )

    m = multi3(solver = test_solver, exprmode = 1)

    alpine = _build(m) # Setup internal model

    @test length(keys(alpine.nonconvex_terms)) == 1
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3])]][:lifted_var_ref] == :(x[4])
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3])]][:nonlinear_type] ==
          :MULTILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[4])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    @test alpine.bounding_constr_mip[1][:rhs] == 3.0
    @test alpine.bounding_constr_mip[1][:vars] == Any[:(x[1]), :(x[2]), :(x[3])]
    @test alpine.bounding_constr_mip[1][:sense] == :(<=)
    @test alpine.bounding_constr_mip[1][:coefs] == Any[1.0, 1.0, 1.0]
    @test alpine.bounding_constr_mip[1][:cnt] == 3

    m = multi3(solver = test_solver, exprmode = 2)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:lifted_var_ref] ==
          :(x[4])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 4), Expr(:ref, :x, 3)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 4), Expr(:ref, :x, 3)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 4), Expr(:ref, :x, 3)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[5])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi3(solver = test_solver, exprmode = 3)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:lifted_var_ref] ==
          :(x[4])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 4)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 4)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 4)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[5])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 1)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 1

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[5])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:nonlinear_type] ==
          :MULTILINEAR

    @test alpine.bounding_constr_mip[1][:rhs] == 4.0
    @test alpine.bounding_constr_mip[1][:vars] == Any[:(x[1]), :(x[2]), :(x[3]), :(x[4])]
    @test alpine.bounding_constr_mip[1][:sense] == :(<=)
    @test alpine.bounding_constr_mip[1][:coefs] == Any[1.0, 1.0, 1.0, 1.0]
    @test alpine.bounding_constr_mip[1][:cnt] == 4

    m = multi4(solver = test_solver, exprmode = 2)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 3

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:lifted_var_ref] ==
          :(x[6])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 5), Expr(:ref, :x, 6)]][:id] == 3
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 5), Expr(:ref, :x, 6)]][:lifted_var_ref] ==
          :(x[7])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 5), Expr(:ref, :x, 6)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[7])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 3)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 2

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[:(x[5]), :(x[3]), :(x[4])]][:id] == 2
    @test alpine.nonconvex_terms[[:(x[5]), :(x[3]), :(x[4])]][:lifted_var_ref] == :(x[6])
    @test alpine.nonconvex_terms[[:(x[5]), :(x[3]), :(x[4])]][:nonlinear_type] ==
          :MULTILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[6])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 4)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 2

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[5])]][:id] == 2
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[5])]][:lifted_var_ref] == :(x[6])
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[5])]][:nonlinear_type] ==
          :MULTILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[6])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[6])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 5)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 3

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 5)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 5)]][:lifted_var_ref] ==
          :(x[6])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 5)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 6), Expr(:ref, :x, 4)]][:id] == 3
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 6), Expr(:ref, :x, 4)]][:lifted_var_ref] ==
          :(x[7])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 6), Expr(:ref, :x, 4)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[7])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[7])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 6)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 2

    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3])]][:lifted_var_ref] == :(x[5])
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 5), Expr(:ref, :x, 4)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 5), Expr(:ref, :x, 4)]][:lifted_var_ref] ==
          :(x[6])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 5), Expr(:ref, :x, 4)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[6])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 7)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 3

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 3), Expr(:ref, :x, 4)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 5)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 5)]][:lifted_var_ref] ==
          :(x[6])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 5)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 6)]][:id] == 3
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 6)]][:lifted_var_ref] ==
          :(x[7])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 6)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[7])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 8)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 2

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[:(x[1]), :(x[5]), :(x[4])]][:id] == 2
    @test alpine.nonconvex_terms[[:(x[1]), :(x[5]), :(x[4])]][:lifted_var_ref] == :(x[6])
    @test alpine.nonconvex_terms[[:(x[1]), :(x[5]), :(x[4])]][:nonlinear_type] ==
          :MULTILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[6])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 9)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 2

    @test alpine.nonconvex_terms[[:(x[2]), :(x[3]), :(x[4])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[2]), :(x[3]), :(x[4])]][:lifted_var_ref] == :(x[5])
    @test alpine.nonconvex_terms[[:(x[2]), :(x[3]), :(x[4])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 5)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 5)]][:lifted_var_ref] ==
          :(x[6])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 5)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[6])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 10)

    alpine = _build(m)
    @test length(keys(alpine.nonconvex_terms)) == 3

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 4), Expr(:ref, :x, 5)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 4), Expr(:ref, :x, 5)]][:lifted_var_ref] ==
          :(x[6])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 4), Expr(:ref, :x, 5)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 6)]][:id] == 3
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 6)]][:lifted_var_ref] ==
          :(x[7])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 6)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[7])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing

    m = multi4(solver = test_solver, exprmode = 11)

    alpine = _build(m)

    @test length(keys(alpine.nonconvex_terms)) == 3

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 3)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 5)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 5)]][:lifted_var_ref] ==
          :(x[6])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 5)]][:nonlinear_type] ==
          :BILINEAR
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 6), Expr(:ref, :x, 4)]][:id] == 3
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 6), Expr(:ref, :x, 4)]][:lifted_var_ref] ==
          :(x[7])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 6), Expr(:ref, :x, 4)]][:nonlinear_type] ==
          :BILINEAR

    @test alpine.bounding_obj_mip[:rhs] == 0
    @test alpine.bounding_obj_mip[:vars] == Expr[:(x[7])]
    @test alpine.bounding_obj_mip[:coefs] == [1.0]
    @test alpine.bounding_obj_mip[:cnt] == 1
    @test alpine.bounding_obj_mip[:sense] === nothing
end

@testset "Expression Parsing || bilinear || Complex-div || div.jl" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )

    m = div(solver = test_solver)

    alpine = _build(m) # Setup internal model

    @test length(keys(alpine.nonconvex_terms)) == 3
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 1)]][:id] == 1
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 1)]][:lifted_var_ref] ==
          :(x[3])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 1)]][:nonlinear_type] ==
          :MONOMIAL

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 2)]][:id] == 2
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 2)]][:lifted_var_ref] ==
          :(x[4])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 2), Expr(:ref, :x, 2)]][:nonlinear_type] ==
          :MONOMIAL

    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:id] == 3
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:lifted_var_ref] ==
          :(x[5])
    @test alpine.nonconvex_terms[[Expr(:ref, :x, 1), Expr(:ref, :x, 2)]][:nonlinear_type] ==
          :BILINEAR

    aff_mip = alpine.bounding_constr_mip

    @test aff_mip[1][:rhs] == 0.0
    @test aff_mip[1][:vars] == Any[:(x[1])]
    @test aff_mip[1][:sense] == :(>=)
    @test round(aff_mip[1][:coefs][1]; digits = 1) == -3.0
    @test aff_mip[1][:cnt] == 1

    @test aff_mip[2][:rhs] == 0.0
    @test aff_mip[2][:vars] == Any[:(x[2])]
    @test aff_mip[2][:sense] == :(>=)
    @test aff_mip[2][:coefs] == Any[0.25]
    @test aff_mip[2][:cnt] == 1

    @test aff_mip[3][:rhs] == 0.0
    @test aff_mip[3][:vars] == Any[:(x[2])]
    @test aff_mip[3][:sense] == :(>=)
    @test aff_mip[3][:coefs] == Any[5.0]
    @test aff_mip[3][:cnt] == 1

    @test aff_mip[4][:rhs] == 0.0
    @test aff_mip[4][:vars] == Any[:(x[2])]
    @test aff_mip[4][:sense] == :(>=)
    @test aff_mip[4][:coefs] == Any[-120.0]
    @test aff_mip[4][:cnt] == 1

    @test aff_mip[5][:rhs] == 0.0
    @test aff_mip[5][:vars] == Any[:(x[2])]
    @test aff_mip[5][:sense] == :(>=)
    @test aff_mip[5][:coefs] == Any[72000.0]
    @test aff_mip[5][:cnt] == 1

    @test aff_mip[6][:rhs] == 0.0
    @test aff_mip[6][:vars] == Any[:(x[1])]
    @test aff_mip[6][:sense] == :(>=)
    @test aff_mip[6][:coefs] == Any[72000.0]
    @test aff_mip[6][:cnt] == 1

    @test aff_mip[7][:rhs] == 8.0
    @test aff_mip[7][:vars] == Any[:(x[5])]
    @test aff_mip[7][:sense] == :(>=)
    @test aff_mip[7][:coefs] == Any[0.6]
    @test aff_mip[7][:cnt] == 1

    @test aff_mip[8][:rhs] == 0.0
    @test aff_mip[8][:vars] == Any[:(x[2]), :(x[5])]
    @test aff_mip[8][:sense] == :(>=)
    @test aff_mip[8][:coefs] == Any[5.6, -72000.0]
    @test aff_mip[8][:cnt] == 2

    @test aff_mip[9][:rhs] == 0.0
    @test aff_mip[9][:vars] == Any[:(x[2]), :(x[5])]
    @test aff_mip[9][:sense] == :(>=)
    @test aff_mip[9][:coefs] == Any[5.6, -36000.0]
    @test aff_mip[9][:cnt] == 2

    @test aff_mip[10][:rhs] == 0.0
    @test aff_mip[10][:vars] == Any[:(x[2]), :(x[5]), :(x[2])]
    @test aff_mip[10][:sense] == :(>=)
    @test aff_mip[10][:coefs] == Any[5.6, -300.0, -1.75]
    @test aff_mip[10][:cnt] == 3

    @test aff_mip[11][:rhs] == 0.0
    @test aff_mip[11][:vars] == Any[:(x[2]), :(x[1]), :(x[5])]
    @test aff_mip[11][:sense] == :(>=)
    @test aff_mip[11][:coefs] == Any[5.6, -0.5, 0.5]
    @test aff_mip[11][:cnt] == 3
end

@testset "Expression Parsing || part1 " begin
    m = Model(
        optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        ),
    )
    @variable(m, x[1:4] >= 0)
    @NLconstraint(m, x[1]^2 >= 1)    # Basic monomial x[5]=x[1]^2
    @NLconstraint(m, x[1] * x[2] <= 1)  # x[6] <= 1 : x[6] = x[1]*x[2]
    @NLconstraint(m, x[1]^2 * x[2]^2 <= 1)          # x[5] + x[7] <= 1 : x[7] = x[2]^2
    @NLconstraint(m, x[1] * (x[2] * x[3]) >= 1)         # x[9] >= 1 : x[8] = x[2] * x[3] && x[9] = x[1]*x[8]
    @NLconstraint(m, x[1]^2 * (x[2]^2 * x[3]^2) <= 1) # x[12] <= 1 : x[10] = x[3] ^ 2 && x[11] = x[7] * x[10] && x[12] = x[11]*[5]

    alpine = _build(m)

    @test alpine.bounding_constr_expr_mip[1] == :(x[5] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[2] == :(x[6] - 1.0 <= 0.0)
    @test alpine.bounding_constr_expr_mip[3] == :(x[8] - 1.0 <= 0.0)
    @test alpine.bounding_constr_expr_mip[4] == :(x[10] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[5] == :(x[13] - 1.0 <= 0.0)
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[1])])
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2])])
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[2])])
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[3])])
    @test haskey(alpine.nonconvex_terms, [:(x[5]), :(x[7])])
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[9])])
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[3])])
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2])])
    @test haskey(alpine.nonconvex_terms, [:(x[5]), :(x[12])])

    @test alpine.nonconvex_terms[[:(x[1]), :(x[1])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2])]][:id] == 2
    @test alpine.nonconvex_terms[[:(x[2]), :(x[2])]][:id] == 3
    @test alpine.nonconvex_terms[[:(x[5]), :(x[7])]][:id] == 4
    @test alpine.nonconvex_terms[[:(x[2]), :(x[3])]][:id] == 5
    @test alpine.nonconvex_terms[[:(x[1]), :(x[9])]][:id] == 6
    @test alpine.nonconvex_terms[[:(x[3]), :(x[3])]][:id] == 7
    @test alpine.nonconvex_terms[[:(x[7]), :(x[11])]][:id] == 8
    @test alpine.nonconvex_terms[[:(x[5]), :(x[12])]][:id] == 9
end

@testset "Expression Parsing || part2" begin
    m = Model(
        optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        ),
    )

    @variable(m, x[1:4] >= 0)
    @NLconstraint(m, (x[1] * x[2]) * x[3] >= 1)
    @NLconstraint(m, (x[1]^2 * x[2]^2) * x[3]^2 <= 1)

    @NLconstraint(m, x[1] * (x[2]^2 * x[3]^2) >= 1)
    @NLconstraint(m, (x[1]^2 * x[2]) * x[3]^2 <= 1)
    @NLconstraint(m, x[1]^2 * (x[2] * x[3]) >= 1)
    @NLconstraint(m, (x[1] * x[2]^2) * x[3] <= 1)

    alpine = _build(m)

    @test alpine.bounding_constr_expr_mip[1] == :(x[6] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[2] == :(x[11] - 1.0 <= 0.0)
    @test alpine.bounding_constr_expr_mip[3] == :(x[13] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[4] == :(x[15] - 1.0 <= 0.0)
    @test alpine.bounding_constr_expr_mip[5] == :(x[17] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[6] == :(x[19] - 1.0 <= 0.0)

    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2])]) #5
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[5])]) #6
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[1])]) #7
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[2])]) #8
    @test haskey(alpine.nonconvex_terms, [:(x[7]), :(x[8])]) #9
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[3])]) #10
    @test haskey(alpine.nonconvex_terms, [:(x[9]), :(x[10])]) #11
    @test haskey(alpine.nonconvex_terms, [:(x[8]), :(x[10])]) #12
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[12])]) #13
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[7])])  #14
    @test haskey(alpine.nonconvex_terms, [:(x[14]), :(x[10])]) #15
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[3])]) #16
    @test haskey(alpine.nonconvex_terms, [:(x[7]), :(x[16])]) #17
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[8])]) #18
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[18])]) #19

    @test alpine.nonconvex_terms[[:(x[1]), :(x[2])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[3]), :(x[5])]][:id] == 2
    @test alpine.nonconvex_terms[[:(x[1]), :(x[1])]][:id] == 3
    @test alpine.nonconvex_terms[[:(x[2]), :(x[2])]][:id] == 4
    @test alpine.nonconvex_terms[[:(x[7]), :(x[8])]][:id] == 5
    @test alpine.nonconvex_terms[[:(x[3]), :(x[3])]][:id] == 6
    @test alpine.nonconvex_terms[[:(x[9]), :(x[10])]][:id] == 7
    @test alpine.nonconvex_terms[[:(x[8]), :(x[10])]][:id] == 8
    @test alpine.nonconvex_terms[[:(x[1]), :(x[12])]][:id] == 9
    @test alpine.nonconvex_terms[[:(x[2]), :(x[7])]][:id] == 10
    @test alpine.nonconvex_terms[[:(x[14]), :(x[10])]][:id] == 11
    @test alpine.nonconvex_terms[[:(x[2]), :(x[3])]][:id] == 12
    @test alpine.nonconvex_terms[[:(x[7]), :(x[16])]][:id] == 13
    @test alpine.nonconvex_terms[[:(x[1]), :(x[8])]][:id] == 14
    @test alpine.nonconvex_terms[[:(x[3]), :(x[18])]][:id] == 15
end

@testset "Expression Parsing || part3" begin
    m = Model(
        optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        ),
    )

    @variable(m, x[1:4] >= 0)
    @NLconstraint(m, ((x[1] * x[2]) * x[3]) * x[4] >= 1)
    @NLconstraint(m, ((x[1]^2 * x[2]) * x[3]) * x[4] <= 1)
    @NLconstraint(m, ((x[1] * x[2]^2) * x[3]) * x[4] >= 1)
    @NLconstraint(m, ((x[1] * x[2]) * x[3]^2) * x[4] <= 1)
    @NLconstraint(m, ((x[1] * x[2]) * x[3]) * x[4]^2 >= 1)
    @NLconstraint(m, ((x[1]^2 * x[2]^2) * x[3]^2) * x[4]^2 <= 1)

    alpine = _build(m)

    @test alpine.bounding_constr_expr_mip[1] == :(x[7] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[2] == :(x[11] - 1.0 <= 0.0)
    @test alpine.bounding_constr_expr_mip[3] == :(x[15] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[4] == :(x[18] - 1.0 <= 0.0)
    @test alpine.bounding_constr_expr_mip[5] == :(x[20] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[6] == :(x[23] - 1.0 <= 0.0)

    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2])]) #5
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[5])]) #6
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[6])]) #7
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[1])]) #8
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[8])]) #9
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[9])]) #10
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[10])]) #11
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[2])]) #12
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[12])])  #13
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[13])]) #14
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[14])]) #15
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[3])]) #16
    @test haskey(alpine.nonconvex_terms, [:(x[5]), :(x[16])]) #17
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[17])]) #18
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[4])]) #19
    @test haskey(alpine.nonconvex_terms, [:(x[6]), :(x[19])]) #20
    @test haskey(alpine.nonconvex_terms, [:(x[8]), :(x[12])]) #21
    @test haskey(alpine.nonconvex_terms, [:(x[21]), :(x[16])]) #22
    @test haskey(alpine.nonconvex_terms, [:(x[22]), :(x[19])]) #23

    @test alpine.nonconvex_terms[[:(x[1]), :(x[2])]][:id] == 1
    @test alpine.nonconvex_terms[[:(x[3]), :(x[5])]][:id] == 2
    @test alpine.nonconvex_terms[[:(x[4]), :(x[6])]][:id] == 3
    @test alpine.nonconvex_terms[[:(x[1]), :(x[1])]][:id] == 4
    @test alpine.nonconvex_terms[[:(x[2]), :(x[8])]][:id] == 5
    @test alpine.nonconvex_terms[[:(x[3]), :(x[9])]][:id] == 6
    @test alpine.nonconvex_terms[[:(x[4]), :(x[10])]][:id] == 7
    @test alpine.nonconvex_terms[[:(x[2]), :(x[2])]][:id] == 8
    @test alpine.nonconvex_terms[[:(x[1]), :(x[12])]][:id] == 9
    @test alpine.nonconvex_terms[[:(x[3]), :(x[13])]][:id] == 10
    @test alpine.nonconvex_terms[[:(x[4]), :(x[14])]][:id] == 11
    @test alpine.nonconvex_terms[[:(x[3]), :(x[3])]][:id] == 12
    @test alpine.nonconvex_terms[[:(x[5]), :(x[16])]][:id] == 13
    @test alpine.nonconvex_terms[[:(x[4]), :(x[17])]][:id] == 14
    @test alpine.nonconvex_terms[[:(x[4]), :(x[4])]][:id] == 15
    @test alpine.nonconvex_terms[[:(x[6]), :(x[19])]][:id] == 16
    @test alpine.nonconvex_terms[[:(x[8]), :(x[12])]][:id] == 17
    @test alpine.nonconvex_terms[[:(x[21]), :(x[16])]][:id] == 18
    @test alpine.nonconvex_terms[[:(x[22]), :(x[19])]][:id] == 19
end

@testset "Expression Parsing || part7" begin
    m = Model(
        optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        ),
    )
    @variable(m, x[1:4] >= 0)

    @NLconstraint(m, x[1] * x[2] * x[3] * x[4] >= 1)
    @NLconstraint(m, x[1]^2 * x[2] * x[3] * x[4] >= 1)
    @NLconstraint(m, x[1] * x[2]^2 * x[3] * x[4] >= 1)
    @NLconstraint(m, x[1] * x[2] * x[3]^2 * x[4]^2 >= 1)
    @NLconstraint(m, x[1] * x[2]^2 * x[3]^2 * x[4] >= 1)
    @NLconstraint(m, x[1]^2 * x[2] * x[3] * x[4]^2 >= 1)
    @NLconstraint(m, x[1]^2 * x[2]^2 * x[3]^2 * x[4]^2 >= 1)

    alpine = _build(m)

    @test alpine.bounding_constr_expr_mip[1] == :(x[5] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[2] == :(x[7] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[3] == :(x[9] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[4] == :(x[12] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[5] == :(x[13] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[6] == :(x[14] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[7] == :(x[15] - 1.0 >= 0.0)

    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2]), :(x[3]), :(x[4])]) #5
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[1])]) #6
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[3]), :(x[4]), :(x[6])]) #7
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[2])]) #8
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[3]), :(x[4]), :(x[8])]) #9
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[3])]) #10
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[4])]) #11
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2]), :(x[10]), :(x[11])]) #12
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[4]), :(x[8]), :(x[10])]) #13
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[3]), :(x[6]), :(x[11])]) #14
    @test haskey(alpine.nonconvex_terms, [:(x[6]), :(x[8]), :(x[10]), :(x[11])]) #15

    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:id] == 1 #5
    @test alpine.nonconvex_terms[[:(x[1]), :(x[1])]][:id] == 2 #6
    @test alpine.nonconvex_terms[[:(x[2]), :(x[3]), :(x[4]), :(x[6])]][:id] == 3 #7
    @test alpine.nonconvex_terms[[:(x[2]), :(x[2])]][:id] == 4 #8
    @test alpine.nonconvex_terms[[:(x[1]), :(x[3]), :(x[4]), :(x[8])]][:id] == 5 #9
    @test alpine.nonconvex_terms[[:(x[3]), :(x[3])]][:id] == 6 #10
    @test alpine.nonconvex_terms[[:(x[4]), :(x[4])]][:id] == 7 #11
    @test alpine.nonconvex_terms[[:(x[1]), :(x[2]), :(x[10]), :(x[11])]][:id] == 8  #12
    @test alpine.nonconvex_terms[[:(x[1]), :(x[4]), :(x[8]), :(x[10])]][:id] == 9 #13
    @test alpine.nonconvex_terms[[:(x[2]), :(x[3]), :(x[6]), :(x[11])]][:id] == 10 #14
    @test alpine.nonconvex_terms[[:(x[6]), :(x[8]), :(x[10]), :(x[11])]][:id] == 11 #15
end

@testset "Expression Parsing || part8" begin
    m = Model(
        optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        ),
    )
    @variable(m, x[1:4] >= 0)

    @NLconstraint(m, (x[1] * x[2] * x[3]) * x[4] >= 1)
    @NLconstraint(m, (x[1]^2 * x[2] * x[3]) * x[4] >= 1)
    @NLconstraint(m, x[1] * (x[2]^2 * x[3]) * x[4] >= 1)
    @NLconstraint(m, x[1] * (x[2] * x[3]^2) * x[4] >= 1)
    @NLconstraint(m, (x[1] * x[2]^2) * x[3] * x[4] >= 1)
    @NLconstraint(m, (x[1] * x[2]) * x[3]^2 * x[4] >= 1)
    @NLconstraint(m, (x[1] * x[2]) * x[3] * x[4]^2 >= 1)
    @NLconstraint(m, (x[1] * x[2]) * x[3]^2 * x[4]^2 >= 1)
    @NLconstraint(m, (x[1]^2 * x[2]^2 * x[3]^2) * x[4]^2 >= 1)

    alpine = _build(m)

    @test alpine.bounding_constr_expr_mip[1] == :(x[6] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[2] == :(x[9] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[3] == :(x[12] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[4] == :(x[15] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[5] == :(x[17] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[6] == :(x[19] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[7] == :(x[21] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[8] == :(x[22] - 1.0 >= 0.0)
    @test alpine.bounding_constr_expr_mip[9] == :(x[24] - 1.0 >= 0.0)

    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2]), :(x[3])]) #5
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[5])]) #6
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[1])]) #7
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[3]), :(x[7])]) #8
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[8])]) #9
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[2])]) #10
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[10])]) #11
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[4]), :(x[11])]) #12
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[3])]) #13
    @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[13])]) #14
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[4]), :(x[14])]) #15
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[10])]) #16
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[4]), :(x[16])]) #17
    @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[2])]) #18
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[18]), :(x[13])]) #19
    @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[4])]) #20
    @test haskey(alpine.nonconvex_terms, [:(x[3]), :(x[18]), :(x[20])]) #21
    @test haskey(alpine.nonconvex_terms, [:(x[18]), :(x[13]), :(x[20])]) #22
    @test haskey(alpine.nonconvex_terms, [:(x[7]), :(x[10]), :(x[13])]) #23
    @test haskey(alpine.nonconvex_terms, [:(x[23]), :(x[20])]) #24
end

@testset "Expression Parsing || Convex" begin
    @testset "Convex Parsing :: PART I" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        )
        m = convex_test(solver = test_solver)

        alpine = _build(m)

        @test alpine.num_constr_convex == 19

        # 0 : OBJ
        @test alpine.obj_structure == :convex
        @test alpine.nonlinear_constrs[0][:expr_orig] == :objective
        @test alpine.nonlinear_constrs[0][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[0][:convexified] == false

        @test alpine.bounding_obj_mip[:sense] === nothing
        @test alpine.bounding_obj_mip[:coefs] == [1.0, 1.0]
        @test alpine.bounding_obj_mip[:vars] == [:(x[1]), :(x[3])]
        @test alpine.bounding_obj_mip[:rhs] == 0.0
        @test alpine.bounding_obj_mip[:powers] == [2, 2]
        @test alpine.bounding_obj_mip[:cnt] == 2

        # 1
        @test alpine.constr_structure[1] == :convex
        @test alpine.nonlinear_constrs[1][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[1][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[1][:convexified] == false
        @test alpine.bounding_constr_mip[1][:sense] == :(<=)
        @test alpine.bounding_constr_mip[1][:coefs] == [3.0, 4.0]
        @test alpine.bounding_constr_mip[1][:vars] == [:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[1][:rhs] == 25.0
        @test alpine.bounding_constr_mip[1][:powers] == [2, 2]
        @test alpine.bounding_constr_mip[1][:cnt] == 2

        # 2
        @test alpine.constr_structure[2] == :convex
        @test alpine.nonlinear_constrs[2][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[2][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[2][:convexified] == false
        @test alpine.bounding_constr_mip[2][:sense] == :(<=)
        @test alpine.bounding_constr_mip[2][:coefs] == [3.0, 4.0]
        @test alpine.bounding_constr_mip[2][:vars] == [:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[2][:rhs] == 25.0
        @test alpine.bounding_constr_mip[2][:powers] == [2, 2]
        @test alpine.bounding_constr_mip[2][:cnt] == 2

        # 4
        @test alpine.constr_structure[4] == :convex
        @test alpine.nonlinear_constrs[4][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[4][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[4][:convexified] == false
        @test alpine.bounding_constr_mip[4][:sense] == :(<=)
        @test alpine.bounding_constr_mip[4][:coefs] == [3.0, 4.0]
        @test alpine.bounding_constr_mip[4][:vars] == [:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[4][:rhs] == 10.0
        @test alpine.bounding_constr_mip[4][:powers] == [2, 2]
        @test alpine.bounding_constr_mip[4][:cnt] == 2

        # 5
        @test alpine.constr_structure[5] == :convex
        @test alpine.nonlinear_constrs[5][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[5][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[5][:convexified] == :false
        @test alpine.bounding_constr_mip[5][:sense] == :(<=)
        @test alpine.bounding_constr_mip[5][:coefs] == [3.0, 4.0, 6.0]
        @test alpine.bounding_constr_mip[5][:vars] == [:(x[1]), :(x[2]), :(x[3])]
        @test alpine.bounding_constr_mip[5][:rhs] == 10.0
        @test alpine.bounding_constr_mip[5][:powers] == [2, 2, 2]
        @test alpine.bounding_constr_mip[5][:cnt] == 3

        #6,7 excluded 

        # 8
        @test alpine.constr_structure[8] == :convex
        @test alpine.nonlinear_constrs[8][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[8][:convex_type] == :convexB
        @test alpine.nonlinear_constrs[8][:convexified] == :false
        @test alpine.bounding_constr_mip[8][:sense] == :(<=)
        @test alpine.bounding_constr_mip[8][:coefs] == [3.0, 1.0, 5.0]
        @test alpine.bounding_constr_mip[8][:vars] == [:(x[1]), :(x[2]), :(x[3])]
        @test alpine.bounding_constr_mip[8][:rhs] == 200.0
        @test alpine.bounding_constr_mip[8][:powers] == [3.0, 3.0, 3.0]
        @test alpine.bounding_constr_mip[8][:cnt] == 3

        # 9
        @test alpine.constr_structure[9] == :convex
        @test alpine.nonlinear_constrs[9][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[9][:convex_type] == :convexB
        @test alpine.nonlinear_constrs[9][:convexified] == :false
        @test alpine.bounding_constr_mip[9][:sense] == :(<=)
        @test alpine.bounding_constr_mip[9][:coefs] == [1.0, 1.0, 1.0, 100.0]
        @test alpine.bounding_constr_mip[9][:vars] == [:(x[1]), :(x[2]), :(x[3]), :(x[4])]
        @test alpine.bounding_constr_mip[9][:rhs] == 200.0
        @test alpine.bounding_constr_mip[9][:powers] == [3, 3, 3, 3]
        @test alpine.bounding_constr_mip[9][:cnt] == 4

        # 11
        @test alpine.constr_structure[11] == :convex
        @test alpine.nonlinear_constrs[11][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[11][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[11][:convexified] == :false
        @test alpine.bounding_constr_mip[11][:sense] == :(<=)
        @test alpine.bounding_constr_mip[11][:coefs] == [3.0, 4.0]
        @test alpine.bounding_constr_mip[11][:vars] == [:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[11][:rhs] == 25.0
        @test alpine.bounding_constr_mip[11][:powers] == [2, 2]
        @test alpine.bounding_constr_mip[11][:cnt] == 2

        # 14
        @test alpine.constr_structure[14] == :convex
        @test alpine.nonlinear_constrs[14][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[14][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[14][:convexified] == :false
        @test alpine.bounding_constr_mip[14][:sense] == :(<=)
        @test alpine.bounding_constr_mip[14][:coefs] == [3.0, 5.0]
        @test alpine.bounding_constr_mip[14][:vars] == [:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[14][:rhs] == 25.0
        @test alpine.bounding_constr_mip[14][:powers] == [2, 2]
        @test alpine.bounding_constr_mip[14][:cnt] == 2

        # 15
        @test alpine.constr_structure[15] == :convex
        @test alpine.nonlinear_constrs[15][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[15][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[15][:convexified] == :false
        @test alpine.bounding_constr_mip[15][:sense] == :(<=)
        @test alpine.bounding_constr_mip[15][:coefs] == [3.0, 5.0, 1.0]
        @test alpine.bounding_constr_mip[15][:vars] == [:(x[1]), :(x[2]), :(x[4])]
        @test alpine.bounding_constr_mip[15][:rhs] == 25.0
        @test alpine.bounding_constr_mip[15][:powers] == [2, 2, 2]
        @test alpine.bounding_constr_mip[15][:cnt] == 3

        # 19
        @test alpine.constr_structure[19] == :convex
        @test alpine.nonlinear_constrs[19][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[19][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[19][:convexified] == :false
        @test alpine.bounding_constr_mip[19][:sense] == :(<=)
        @test alpine.bounding_constr_mip[19][:coefs] == [3.0, 16.0]
        @test alpine.bounding_constr_mip[19][:vars] == [:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[19][:rhs] == 40.0
        @test alpine.bounding_constr_mip[19][:powers] == [2, 2]
        @test alpine.bounding_constr_mip[19][:cnt] == 2

        # 22
        @test alpine.constr_structure[22] == :convex
        @test alpine.nonlinear_constrs[22][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[22][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[22][:convexified] == :false
        @test alpine.bounding_constr_mip[22][:sense] == :(<=)
        @test alpine.bounding_constr_mip[22][:coefs] == [3.0, 4.0, 5.0, 6.0]
        @test alpine.bounding_constr_mip[22][:vars] ==
              [:(x[1]), :(x[2]), :(x[3]), :(x[4])]
        @test alpine.bounding_constr_mip[22][:rhs] == 15.0
        @test alpine.bounding_constr_mip[22][:powers] == [2, 2, 2, 2]
        @test alpine.bounding_constr_mip[22][:cnt] == 4

        # 25
        @test alpine.constr_structure[25] == :convex
        @test alpine.nonlinear_constrs[25][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[25][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[25][:convexified] == :false
        @test alpine.bounding_constr_mip[25][:sense] == :(<=)
        @test alpine.bounding_constr_mip[25][:coefs] == [1.0, 1.0, 1.0, 1.0, 1.0]
        @test alpine.bounding_constr_mip[25][:vars] ==
              [:(x[1]), :(x[2]), :(x[3]), :(x[4]), :(x[5])]
        @test alpine.bounding_constr_mip[25][:rhs] == 99999.0
        @test alpine.bounding_constr_mip[25][:powers] == [2, 2, 2, 2, 2]
        @test alpine.bounding_constr_mip[25][:cnt] == 5

        # 26
        @test alpine.constr_structure[26] == :convex
        @test alpine.nonlinear_constrs[26][:expr_orig] == :constraints
        @test alpine.nonlinear_constrs[26][:convex_type] == :convexA
        @test alpine.nonlinear_constrs[26][:convexified] == :false
        @test alpine.bounding_constr_mip[26][:sense] == :(<=)
        @test alpine.bounding_constr_mip[26][:coefs] == [3.0, 4.0]
        @test alpine.bounding_constr_mip[26][:vars] == [:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[26][:rhs] == 200.0
        @test alpine.bounding_constr_mip[26][:powers] == [4, 4]
        @test alpine.bounding_constr_mip[26][:cnt] == 2
    end
end

@testset "Expression Prasing || Linear Lifting" begin
    @testset "Expression Parsing || Linear Lifting || nlp2" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "partition_scaling_factor" => 8,
            "log_level" => 100,
        )

        m = nlp2(solver = test_solver)

        alpine = _build(m)

        @test length(alpine.linear_terms) == 2
        @test length(alpine.nonconvex_terms) == 4

        lk = Vector{Any}(undef, 2)
        lk[1] = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, -1.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3)])),
        )
        lk[2] = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, -2.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 6)])),
        )

        @test length(keys(alpine.linear_terms)) == 2
        yids = [4, 7]
        for i in 1:length(keys(alpine.linear_terms))
            for j in keys(alpine.linear_terms)
                if alpine.linear_terms[j][:id] == i
                    @test j == lk[i]
                    @test j[:sign] == :+
                    @test j[:scalar] == lk[i][:scalar]
                    @test j[:coef_var] == lk[i][:coef_var]
                    @test alpine.linear_terms[j][:y_idx] == yids[i]
                end
            end
        end

        @test haskey(alpine.linear_terms, lk[1])
        @test haskey(alpine.linear_terms, lk[2])

        @test haskey(alpine.nonconvex_terms, [:(x[2]), :(x[2])])
        @test haskey(alpine.nonconvex_terms, [:(x[4]), :(x[4])])
        @test haskey(alpine.nonconvex_terms, [:(x[7]), :(x[7])])
        @test haskey(alpine.nonconvex_terms, [:(x[1]), :(x[1])])
        @test alpine.nonconvex_terms[[:(x[1]), :(x[1])]][:id] == 1
        @test alpine.nonconvex_terms[[:(x[2]), :(x[2])]][:id] == 3
        @test alpine.nonconvex_terms[[:(x[4]), :(x[4])]][:id] == 2
        @test alpine.nonconvex_terms[[:(x[7]), :(x[7])]][:id] == 4
        @test alpine.nonconvex_terms[[:(x[1]), :(x[1])]][:lifted_var_ref].args[2] == 3
        @test alpine.nonconvex_terms[[:(x[2]), :(x[2])]][:lifted_var_ref].args[2] == 6
        @test alpine.nonconvex_terms[[:(x[4]), :(x[4])]][:lifted_var_ref].args[2] == 5
        @test alpine.nonconvex_terms[[:(x[7]), :(x[7])]][:lifted_var_ref].args[2] == 8
    end

    @testset "Expression Parsing || Linear Lifting || general" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        )

        m = basic_linear_lift(solver = test_solver)

        alpine = _build(m) # Setup internal model

        lk = Vector{Any}(undef, 5)
        lk[1] = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 1), (-1.0, 2)])),
        )
        lk[2] = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(3.0, 2), (-1.0, 3)])),
        )
        lk[3] = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 1), (1.0, 3)])),
        )
        lk[4] = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 2), (1.0, 1)])),
        )
        lk[5] = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 3.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 2), (1.0, 1), (1.0, 3)])),
        )

        @test length(keys(alpine.linear_terms)) == 5
        yids = [8, 9, 12, 14, 16]
        for i in 1:length(keys(alpine.linear_terms))
            for j in keys(alpine.linear_terms)
                if alpine.linear_terms[j][:id] == i
                    @test j == lk[i]
                    @test j[:sign] == :+
                    @test j[:scalar] == lk[i][:scalar]
                    @test j[:coef_var] == lk[i][:coef_var]
                    @test alpine.linear_terms[j][:y_idx] == yids[i]
                end
            end
        end

        nlk1 = [:(x[8]), :(x[9]), :(x[12])]
        nlk2 = [:(x[2]), :(x[2])]
        nlk3 = [:(x[2]), :(x[3])]
        nlk4 = [:(x[8]), :(x[8])]
        nlk5 = [:(x[1]), :(x[3])]
        nlk6 = [:(x[8]), :(x[9])]
        nlk7 = [:(x[1]), :(x[2])]
        nlk8 = [:(x[16]), :(x[15])]
        nlk9 = [:(x[14]), :(x[14])]

        @test alpine.nonconvex_terms[nlk1][:id] == 7
        @test alpine.nonconvex_terms[nlk2][:id] == 3
        @test alpine.nonconvex_terms[nlk3][:id] == 4
        @test alpine.nonconvex_terms[nlk4][:id] == 6
        @test alpine.nonconvex_terms[nlk5][:id] == 2
        @test alpine.nonconvex_terms[nlk6][:id] == 5
        @test alpine.nonconvex_terms[nlk7][:id] == 1
        @test alpine.nonconvex_terms[nlk8][:id] == 9
        @test alpine.nonconvex_terms[nlk9][:id] == 8

        @test alpine.nonconvex_terms[nlk1][:lifted_var_ref].args[2] == 13
        @test alpine.nonconvex_terms[nlk2][:lifted_var_ref].args[2] == 6
        @test alpine.nonconvex_terms[nlk3][:lifted_var_ref].args[2] == 7
        @test alpine.nonconvex_terms[nlk4][:lifted_var_ref].args[2] == 11
        @test alpine.nonconvex_terms[nlk5][:lifted_var_ref].args[2] == 5
        @test alpine.nonconvex_terms[nlk6][:lifted_var_ref].args[2] == 10
        @test alpine.nonconvex_terms[nlk7][:lifted_var_ref].args[2] == 4
        @test alpine.nonconvex_terms[nlk8][:lifted_var_ref].args[2] == 17
        @test alpine.nonconvex_terms[nlk9][:lifted_var_ref].args[2] == 15

        @test alpine.nonconvex_terms[nlk1][:nonlinear_type] == :MULTILINEAR
        @test alpine.nonconvex_terms[nlk2][:nonlinear_type] == :MONOMIAL
        @test alpine.nonconvex_terms[nlk3][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[nlk4][:nonlinear_type] == :MONOMIAL
        @test alpine.nonconvex_terms[nlk5][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[nlk6][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[nlk7][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[nlk8][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[nlk9][:nonlinear_type] == :MONOMIAL

        @test alpine.nonconvex_terms[nlk1][:var_idxs] == [8, 9, 12]
        @test alpine.nonconvex_terms[nlk2][:var_idxs] == [2, 2]
        @test alpine.nonconvex_terms[nlk3][:var_idxs] == [2, 3]
        @test alpine.nonconvex_terms[nlk4][:var_idxs] == [8]
        @test alpine.nonconvex_terms[nlk5][:var_idxs] == [1, 3]
        @test alpine.nonconvex_terms[nlk6][:var_idxs] == [8, 9]
        @test alpine.nonconvex_terms[nlk7][:var_idxs] == [1, 2]
        @test alpine.nonconvex_terms[nlk8][:var_idxs] == [16, 15]
        @test alpine.nonconvex_terms[nlk9][:var_idxs] == [14]
    end

    @testset "Expression Parsing || Linear Lifting || brainpc3" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "partition_scaling_factor" => 8,
            "log_level" => 100,
        )

        m = brainpc3(solver = test_solver)

        alpine = _build(m)

        @test alpine.nonconvex_terms[Expr[:(x[6912]), :(x[6912])]][:y_idx] == 6913
        @test alpine.nonconvex_terms[Expr[:(x[6912]), :(x[6912])]][:id] == 2
        @test alpine.nonconvex_terms[Expr[:(x[6912]), :(x[6912])]][:lifted_constr_ref] ==
              :(x[6913] == (*)(x[6912]))
        @test alpine.nonconvex_terms[Expr[:(x[6912]), :(x[6912])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6912]), :(x[6912])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6912]), :(x[6912])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6969])]][:y_idx] == 6970
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6969])]][:id] == 25
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6969])]][:lifted_constr_ref] ==
              :(x[6970] == x[6903] * x[6969])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6969])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6969])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6969])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6914])]][:y_idx] == 6915
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6914])]][:id] == 3
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6914])]][:lifted_constr_ref] ==
              :(x[6915] == x[6903] * x[6914])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6914])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6914])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6914])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6919])]][:y_idx] == 6920
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6919])]][:id] == 5
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6919])]][:lifted_constr_ref] ==
              :(x[6920] == x[6903] * x[6919])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6919])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6919])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6919])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6927]), :(x[6927])]][:y_idx] == 6928
        @test alpine.nonconvex_terms[Expr[:(x[6927]), :(x[6927])]][:id] == 8
        @test alpine.nonconvex_terms[Expr[:(x[6927]), :(x[6927])]][:lifted_constr_ref] ==
              :(x[6928] == (*)(x[6927]))
        @test alpine.nonconvex_terms[Expr[:(x[6927]), :(x[6927])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6927]), :(x[6927])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6927]), :(x[6927])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6952]), :(x[6952])]][:y_idx] == 6953
        @test alpine.nonconvex_terms[Expr[:(x[6952]), :(x[6952])]][:id] == 18
        @test alpine.nonconvex_terms[Expr[:(x[6952]), :(x[6952])]][:lifted_constr_ref] ==
              :(x[6953] == (*)(x[6952]))
        @test alpine.nonconvex_terms[Expr[:(x[6952]), :(x[6952])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6952]), :(x[6952])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6952]), :(x[6952])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6962]), :(x[6962])]][:y_idx] == 6963
        @test alpine.nonconvex_terms[Expr[:(x[6962]), :(x[6962])]][:id] == 22
        @test alpine.nonconvex_terms[Expr[:(x[6962]), :(x[6962])]][:lifted_constr_ref] ==
              :(x[6963] == (*)(x[6962]))
        @test alpine.nonconvex_terms[Expr[:(x[6962]), :(x[6962])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6962]), :(x[6962])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6962]), :(x[6962])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6974])]][:y_idx] == 6975
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6974])]][:id] == 27
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6974])]][:lifted_constr_ref] ==
              :(x[6975] == x[6903] * x[6974])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6974])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6974])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6974])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6934])]][:y_idx] == 6935
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6934])]][:id] == 11
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6934])]][:lifted_constr_ref] ==
              :(x[6935] == x[6903] * x[6934])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6934])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6934])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6934])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6959])]][:y_idx] == 6960
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6959])]][:id] == 21
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6959])]][:lifted_constr_ref] ==
              :(x[6960] == x[6903] * x[6959])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6959])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6959])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6959])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7014])]][:y_idx] == 7015
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7014])]][:id] == 43
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7014])]][:lifted_constr_ref] ==
              :(x[7015] == x[6903] * x[7014])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7014])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7014])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7014])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6939])]][:y_idx] == 6940
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6939])]][:id] == 13
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6939])]][:lifted_constr_ref] ==
              :(x[6940] == x[6903] * x[6939])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6939])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6939])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6939])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7017]), :(x[7017])]][:y_idx] == 7018
        @test alpine.nonconvex_terms[Expr[:(x[7017]), :(x[7017])]][:id] == 44
        @test alpine.nonconvex_terms[Expr[:(x[7017]), :(x[7017])]][:lifted_constr_ref] ==
              :(x[7018] == (*)(x[7017]))
        @test alpine.nonconvex_terms[Expr[:(x[7017]), :(x[7017])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7017]), :(x[7017])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7017]), :(x[7017])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6929])]][:y_idx] == 6930
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6929])]][:id] == 9
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6929])]][:lifted_constr_ref] ==
              :(x[6930] == x[6903] * x[6929])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6929])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6929])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6929])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7012]), :(x[7012])]][:y_idx] == 7013
        @test alpine.nonconvex_terms[Expr[:(x[7012]), :(x[7012])]][:id] == 42
        @test alpine.nonconvex_terms[Expr[:(x[7012]), :(x[7012])]][:lifted_constr_ref] ==
              :(x[7013] == (*)(x[7012]))
        @test alpine.nonconvex_terms[Expr[:(x[7012]), :(x[7012])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7012]), :(x[7012])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7012]), :(x[7012])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6947]), :(x[6947])]][:y_idx] == 6948
        @test alpine.nonconvex_terms[Expr[:(x[6947]), :(x[6947])]][:id] == 16
        @test alpine.nonconvex_terms[Expr[:(x[6947]), :(x[6947])]][:lifted_constr_ref] ==
              :(x[6948] == (*)(x[6947]))
        @test alpine.nonconvex_terms[Expr[:(x[6947]), :(x[6947])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6947]), :(x[6947])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6947]), :(x[6947])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7032]), :(x[7032])]][:y_idx] == 7033
        @test alpine.nonconvex_terms[Expr[:(x[7032]), :(x[7032])]][:id] == 50
        @test alpine.nonconvex_terms[Expr[:(x[7032]), :(x[7032])]][:lifted_constr_ref] ==
              :(x[7033] == (*)(x[7032]))
        @test alpine.nonconvex_terms[Expr[:(x[7032]), :(x[7032])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7032]), :(x[7032])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7032]), :(x[7032])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6997]), :(x[6997])]][:y_idx] == 6998
        @test alpine.nonconvex_terms[Expr[:(x[6997]), :(x[6997])]][:id] == 36
        @test alpine.nonconvex_terms[Expr[:(x[6997]), :(x[6997])]][:lifted_constr_ref] ==
              :(x[6998] == (*)(x[6997]))
        @test alpine.nonconvex_terms[Expr[:(x[6997]), :(x[6997])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6997]), :(x[6997])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6997]), :(x[6997])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7027]), :(x[7027])]][:y_idx] == 7028
        @test alpine.nonconvex_terms[Expr[:(x[7027]), :(x[7027])]][:id] == 48
        @test alpine.nonconvex_terms[Expr[:(x[7027]), :(x[7027])]][:lifted_constr_ref] ==
              :(x[7028] == (*)(x[7027]))
        @test alpine.nonconvex_terms[Expr[:(x[7027]), :(x[7027])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7027]), :(x[7027])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7027]), :(x[7027])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7037]), :(x[7037])]][:y_idx] == 7038
        @test alpine.nonconvex_terms[Expr[:(x[7037]), :(x[7037])]][:id] == 52
        @test alpine.nonconvex_terms[Expr[:(x[7037]), :(x[7037])]][:lifted_constr_ref] ==
              :(x[7038] == (*)(x[7037]))
        @test alpine.nonconvex_terms[Expr[:(x[7037]), :(x[7037])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7037]), :(x[7037])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7037]), :(x[7037])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7007]), :(x[7007])]][:y_idx] == 7008
        @test alpine.nonconvex_terms[Expr[:(x[7007]), :(x[7007])]][:id] == 40
        @test alpine.nonconvex_terms[Expr[:(x[7007]), :(x[7007])]][:lifted_constr_ref] ==
              :(x[7008] == (*)(x[7007]))
        @test alpine.nonconvex_terms[Expr[:(x[7007]), :(x[7007])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7007]), :(x[7007])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7007]), :(x[7007])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6964])]][:y_idx] == 6965
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6964])]][:id] == 23
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6964])]][:lifted_constr_ref] ==
              :(x[6965] == x[6903] * x[6964])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6964])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6964])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6964])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6924])]][:y_idx] == 6925
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6924])]][:id] == 7
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6924])]][:lifted_constr_ref] ==
              :(x[6925] == x[6903] * x[6924])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6924])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6924])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6924])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6979])]][:y_idx] == 6980
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6979])]][:id] == 29
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6979])]][:lifted_constr_ref] ==
              :(x[6980] == x[6903] * x[6979])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6979])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6979])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6979])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6994])]][:y_idx] == 6995
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6994])]][:id] == 35
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6994])]][:lifted_constr_ref] ==
              :(x[6995] == x[6903] * x[6994])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6994])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6994])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6994])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6972]), :(x[6972])]][:y_idx] == 6973
        @test alpine.nonconvex_terms[Expr[:(x[6972]), :(x[6972])]][:id] == 26
        @test alpine.nonconvex_terms[Expr[:(x[6972]), :(x[6972])]][:lifted_constr_ref] ==
              :(x[6973] == (*)(x[6972]))
        @test alpine.nonconvex_terms[Expr[:(x[6972]), :(x[6972])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6972]), :(x[6972])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6972]), :(x[6972])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7019])]][:y_idx] == 7020
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7019])]][:id] == 45
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7019])]][:lifted_constr_ref] ==
              :(x[7020] == x[6903] * x[7019])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7019])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7019])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7019])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6992]), :(x[6992])]][:y_idx] == 6993
        @test alpine.nonconvex_terms[Expr[:(x[6992]), :(x[6992])]][:id] == 34
        @test alpine.nonconvex_terms[Expr[:(x[6992]), :(x[6992])]][:lifted_constr_ref] ==
              :(x[6993] == (*)(x[6992]))
        @test alpine.nonconvex_terms[Expr[:(x[6992]), :(x[6992])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6992]), :(x[6992])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6992]), :(x[6992])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7002]), :(x[7002])]][:y_idx] == 7003
        @test alpine.nonconvex_terms[Expr[:(x[7002]), :(x[7002])]][:id] == 38
        @test alpine.nonconvex_terms[Expr[:(x[7002]), :(x[7002])]][:lifted_constr_ref] ==
              :(x[7003] == (*)(x[7002]))
        @test alpine.nonconvex_terms[Expr[:(x[7002]), :(x[7002])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7002]), :(x[7002])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7002]), :(x[7002])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[7022]), :(x[7022])]][:y_idx] == 7023
        @test alpine.nonconvex_terms[Expr[:(x[7022]), :(x[7022])]][:id] == 46
        @test alpine.nonconvex_terms[Expr[:(x[7022]), :(x[7022])]][:lifted_constr_ref] ==
              :(x[7023] == (*)(x[7022]))
        @test alpine.nonconvex_terms[Expr[:(x[7022]), :(x[7022])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[7022]), :(x[7022])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[7022]), :(x[7022])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6908])]][:y_idx] == 6909
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6908])]][:id] == 1
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6908])]][:lifted_constr_ref] ==
              :(x[6909] == x[6903] * x[6908])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6908])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6908])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6908])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6949])]][:y_idx] == 6950
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6949])]][:id] == 17
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6949])]][:lifted_constr_ref] ==
              :(x[6950] == x[6903] * x[6949])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6949])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6949])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6949])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7004])]][:y_idx] == 7005
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7004])]][:id] == 39
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7004])]][:lifted_constr_ref] ==
              :(x[7005] == x[6903] * x[7004])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7004])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7004])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7004])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6917]), :(x[6917])]][:y_idx] == 6918
        @test alpine.nonconvex_terms[Expr[:(x[6917]), :(x[6917])]][:id] == 4
        @test alpine.nonconvex_terms[Expr[:(x[6917]), :(x[6917])]][:lifted_constr_ref] ==
              :(x[6918] == (*)(x[6917]))
        @test alpine.nonconvex_terms[Expr[:(x[6917]), :(x[6917])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6917]), :(x[6917])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6917]), :(x[6917])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6937]), :(x[6937])]][:y_idx] == 6938
        @test alpine.nonconvex_terms[Expr[:(x[6937]), :(x[6937])]][:id] == 12
        @test alpine.nonconvex_terms[Expr[:(x[6937]), :(x[6937])]][:lifted_constr_ref] ==
              :(x[6938] == (*)(x[6937]))
        @test alpine.nonconvex_terms[Expr[:(x[6937]), :(x[6937])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6937]), :(x[6937])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6937]), :(x[6937])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6932]), :(x[6932])]][:y_idx] == 6933
        @test alpine.nonconvex_terms[Expr[:(x[6932]), :(x[6932])]][:id] == 10
        @test alpine.nonconvex_terms[Expr[:(x[6932]), :(x[6932])]][:lifted_constr_ref] ==
              :(x[6933] == (*)(x[6932]))
        @test alpine.nonconvex_terms[Expr[:(x[6932]), :(x[6932])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6932]), :(x[6932])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6932]), :(x[6932])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6989])]][:y_idx] == 6990
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6989])]][:id] == 33
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6989])]][:lifted_constr_ref] ==
              :(x[6990] == x[6903] * x[6989])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6989])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6989])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6989])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6977]), :(x[6977])]][:y_idx] == 6978
        @test alpine.nonconvex_terms[Expr[:(x[6977]), :(x[6977])]][:id] == 28
        @test alpine.nonconvex_terms[Expr[:(x[6977]), :(x[6977])]][:lifted_constr_ref] ==
              :(x[6978] == (*)(x[6977]))
        @test alpine.nonconvex_terms[Expr[:(x[6977]), :(x[6977])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6977]), :(x[6977])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6977]), :(x[6977])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6987]), :(x[6987])]][:y_idx] == 6988
        @test alpine.nonconvex_terms[Expr[:(x[6987]), :(x[6987])]][:id] == 32
        @test alpine.nonconvex_terms[Expr[:(x[6987]), :(x[6987])]][:lifted_constr_ref] ==
              :(x[6988] == (*)(x[6987]))
        @test alpine.nonconvex_terms[Expr[:(x[6987]), :(x[6987])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6987]), :(x[6987])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6987]), :(x[6987])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7034])]][:y_idx] == 7035
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7034])]][:id] == 51
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7034])]][:lifted_constr_ref] ==
              :(x[7035] == x[6903] * x[7034])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7034])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7034])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7034])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6967]), :(x[6967])]][:y_idx] == 6968
        @test alpine.nonconvex_terms[Expr[:(x[6967]), :(x[6967])]][:id] == 24
        @test alpine.nonconvex_terms[Expr[:(x[6967]), :(x[6967])]][:lifted_constr_ref] ==
              :(x[6968] == (*)(x[6967]))
        @test alpine.nonconvex_terms[Expr[:(x[6967]), :(x[6967])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6967]), :(x[6967])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6967]), :(x[6967])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6957]), :(x[6957])]][:y_idx] == 6958
        @test alpine.nonconvex_terms[Expr[:(x[6957]), :(x[6957])]][:id] == 20
        @test alpine.nonconvex_terms[Expr[:(x[6957]), :(x[6957])]][:lifted_constr_ref] ==
              :(x[6958] == (*)(x[6957]))
        @test alpine.nonconvex_terms[Expr[:(x[6957]), :(x[6957])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6957]), :(x[6957])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6957]), :(x[6957])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7009])]][:y_idx] == 7010
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7009])]][:id] == 41
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7009])]][:lifted_constr_ref] ==
              :(x[7010] == x[6903] * x[7009])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7009])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7009])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7009])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6942]), :(x[6942])]][:y_idx] == 6943
        @test alpine.nonconvex_terms[Expr[:(x[6942]), :(x[6942])]][:id] == 14
        @test alpine.nonconvex_terms[Expr[:(x[6942]), :(x[6942])]][:lifted_constr_ref] ==
              :(x[6943] == (*)(x[6942]))
        @test alpine.nonconvex_terms[Expr[:(x[6942]), :(x[6942])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6942]), :(x[6942])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6942]), :(x[6942])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6982]), :(x[6982])]][:y_idx] == 6983
        @test alpine.nonconvex_terms[Expr[:(x[6982]), :(x[6982])]][:id] == 30
        @test alpine.nonconvex_terms[Expr[:(x[6982]), :(x[6982])]][:lifted_constr_ref] ==
              :(x[6983] == (*)(x[6982]))
        @test alpine.nonconvex_terms[Expr[:(x[6982]), :(x[6982])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6982]), :(x[6982])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6982]), :(x[6982])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6999])]][:y_idx] == 7000
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6999])]][:id] == 37
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6999])]][:lifted_constr_ref] ==
              :(x[7000] == x[6903] * x[6999])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6999])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6999])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6999])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6944])]][:y_idx] == 6945
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6944])]][:id] == 15
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6944])]][:lifted_constr_ref] ==
              :(x[6945] == x[6903] * x[6944])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6944])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6944])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6944])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7024])]][:y_idx] == 7025
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7024])]][:id] == 47
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7024])]][:lifted_constr_ref] ==
              :(x[7025] == x[6903] * x[7024])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7024])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7024])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7024])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6954])]][:y_idx] == 6955
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6954])]][:id] == 19
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6954])]][:lifted_constr_ref] ==
              :(x[6955] == x[6903] * x[6954])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6954])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6954])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6954])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6922]), :(x[6922])]][:y_idx] == 6923
        @test alpine.nonconvex_terms[Expr[:(x[6922]), :(x[6922])]][:id] == 6
        @test alpine.nonconvex_terms[Expr[:(x[6922]), :(x[6922])]][:lifted_constr_ref] ==
              :(x[6923] == (*)(x[6922]))
        @test alpine.nonconvex_terms[Expr[:(x[6922]), :(x[6922])]][:nonlinear_type] ==
              :MONOMIAL
        @test alpine.nonconvex_terms[Expr[:(x[6922]), :(x[6922])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6922]), :(x[6922])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6984])]][:y_idx] == 6985
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6984])]][:id] == 31
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6984])]][:lifted_constr_ref] ==
              :(x[6985] == x[6903] * x[6984])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6984])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6984])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[6984])]][:constr_id] ==
              Set(Any[0])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7029])]][:y_idx] == 7030
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7029])]][:id] == 49
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7029])]][:lifted_constr_ref] ==
              :(x[7030] == x[6903] * x[7029])
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7029])]][:nonlinear_type] ==
              :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7029])]][:y_type] == :Cont
        @test alpine.nonconvex_terms[Expr[:(x[6903]), :(x[7029])]][:constr_id] ==
              Set(Any[0])
        lk1 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 6910), (-1.0, 6909)])),
        )
        @test alpine.linear_terms[lk1][:y_idx] == 6911
        @test alpine.linear_terms[lk1][:id] == 3
        @test alpine.linear_terms[lk1][:y_type] == :(Cont)
        lk2 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3467), (1.0, 16)])),
        )
        @test alpine.linear_terms[lk2][:y_idx] == 6908
        @test alpine.linear_terms[lk2][:id] == 1
        @test alpine.linear_terms[lk2][:y_type] == :(Cont)
        lk3 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(0.001548, 6903), (1.0, 7016), (1.0, 5702)]),
            ),
        )
        @test alpine.linear_terms[lk3][:y_idx] == 7017
        @test alpine.linear_terms[lk3][:id] == 67
        @test alpine.linear_terms[lk3][:y_type] == :(Cont)
        lk4 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 5162), (1.0, 1711)])),
        )
        @test alpine.linear_terms[lk4][:y_idx] == 7004
        @test alpine.linear_terms[lk4][:id] == 59
        @test alpine.linear_terms[lk4][:y_type] == :(Cont)
        lk5 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 7021), (0.001435, 6903), (1.0, 6002)]),
            ),
        )
        @test alpine.linear_terms[lk5][:y_idx] == 7022
        @test alpine.linear_terms[lk5][:id] == 70
        @test alpine.linear_terms[lk5][:y_type] == :(Cont)
        lk6 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6935), (1.0, 166)])),
        )
        @test alpine.linear_terms[lk6][:y_idx] == 6936
        @test alpine.linear_terms[lk6][:id] == 18
        @test alpine.linear_terms[lk6][:y_type] == :(Cont)
        lk7 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 4262), (0.00247, 6903), (1.0, 6981)]),
            ),
        )
        @test alpine.linear_terms[lk7][:y_idx] == 6982
        @test alpine.linear_terms[lk7][:id] == 46
        @test alpine.linear_terms[lk7][:y_type] == :(Cont)
        lk8 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 7005), (1.0, 1711)])),
        )
        @test alpine.linear_terms[lk8][:y_idx] == 7006
        @test alpine.linear_terms[lk8][:id] == 60
        @test alpine.linear_terms[lk8][:y_type] == :(Cont)
        lk9 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 1951), (1.0, 5402)])),
        )
        @test alpine.linear_terms[lk9][:y_idx] == 7009
        @test alpine.linear_terms[lk9][:id] == 62
        @test alpine.linear_terms[lk9][:y_type] == :(Cont)
        lk10 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 226), (-1.0, 6945)])),
        )
        @test alpine.linear_terms[lk10][:y_idx] == 6946
        @test alpine.linear_terms[lk10][:id] == 24
        @test alpine.linear_terms[lk10][:y_type] == :(Cont)
        lk11 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 7030), (1.0, 3151)])),
        )
        @test alpine.linear_terms[lk11][:y_idx] == 7031
        @test alpine.linear_terms[lk11][:id] == 75
        @test alpine.linear_terms[lk11][:y_type] == :(Cont)
        lk12 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 6991), (1.0, 4622), (0.002066, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk12][:y_idx] == 6992
        @test alpine.linear_terms[lk12][:id] == 52
        @test alpine.linear_terms[lk12][:y_type] == :(Cont)
        lk13 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 7026), (1.0, 6302), (0.001323, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk13][:y_idx] == 7027
        @test alpine.linear_terms[lk13][:id] == 73
        @test alpine.linear_terms[lk13][:y_type] == :(Cont)
        lk14 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 46), (1.0, 3497)])),
        )
        @test alpine.linear_terms[lk14][:y_idx] == 6914
        @test alpine.linear_terms[lk14][:id] == 5
        @test alpine.linear_terms[lk14][:y_type] == :(Cont)
        lk15 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6960), (1.0, 391)])),
        )
        @test alpine.linear_terms[lk15][:y_idx] == 6961
        @test alpine.linear_terms[lk15][:id] == 33
        @test alpine.linear_terms[lk15][:y_type] == :(Cont)
        lk16 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 631), (-1.0, 6975)])),
        )
        @test alpine.linear_terms[lk16][:y_idx] == 6976
        @test alpine.linear_terms[lk16][:id] == 42
        @test alpine.linear_terms[lk16][:y_type] == :(Cont)
        lk17 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 1351), (-1.0, 6995)])),
        )
        @test alpine.linear_terms[lk17][:y_idx] == 6996
        @test alpine.linear_terms[lk17][:id] == 54
        @test alpine.linear_terms[lk17][:y_type] == :(Cont)
        lk18 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3557), (1.0, 106)])),
        )
        @test alpine.linear_terms[lk18][:y_idx] == 6924
        @test alpine.linear_terms[lk18][:id] == 11
        @test alpine.linear_terms[lk18][:y_type] == :(Cont)
        lk19 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 3647), (1.0, 6941), (0.004795, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk19][:y_idx] == 6942
        @test alpine.linear_terms[lk19][:id] == 22
        @test alpine.linear_terms[lk19][:y_type] == :(Cont)
        lk20 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3722), (1.0, 271)])),
        )
        @test alpine.linear_terms[lk20][:y_idx] == 6949
        @test alpine.linear_terms[lk20][:id] == 26
        @test alpine.linear_terms[lk20][:y_type] == :(Cont)
        lk21 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3647), (1.0, 196)])),
        )
        @test alpine.linear_terms[lk21][:y_idx] == 6939
        @test alpine.linear_terms[lk21][:id] == 20
        @test alpine.linear_terms[lk21][:y_type] == :(Cont)
        lk22 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 3467), (1.0, 6911), (6.34e-6, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk22][:y_idx] == 6912
        @test alpine.linear_terms[lk22][:id] == 4
        @test alpine.linear_terms[lk22][:y_type] == :(Cont)
        lk23 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 1531), (1.0, 4982)])),
        )
        @test alpine.linear_terms[lk23][:y_idx] == 6999
        @test alpine.linear_terms[lk23][:id] == 56
        @test alpine.linear_terms[lk23][:y_type] == :(Cont)
        lk24 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 106), (-1.0, 6925)])),
        )
        @test alpine.linear_terms[lk24][:y_idx] == 6926
        @test alpine.linear_terms[lk24][:id] == 12
        @test alpine.linear_terms[lk24][:y_type] == :(Cont)
        lk25 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 2251), (-1.0, 7015)])),
        )
        @test alpine.linear_terms[lk25][:y_idx] == 7016
        @test alpine.linear_terms[lk25][:id] == 66
        @test alpine.linear_terms[lk25][:y_type] == :(Cont)
        lk26 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 6936), (0.004985, 6903), (1.0, 3617)]),
            ),
        )
        @test alpine.linear_terms[lk26][:y_idx] == 6937
        @test alpine.linear_terms[lk26][:id] == 19
        @test alpine.linear_terms[lk26][:y_type] == :(Cont)
        lk27 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6915), (1.0, 46)])),
        )
        @test alpine.linear_terms[lk27][:y_idx] == 6916
        @test alpine.linear_terms[lk27][:id] == 6
        @test alpine.linear_terms[lk27][:y_type] == :(Cont)
        lk28 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 3557), (0.005968, 6903), (1.0, 6926)]),
            ),
        )
        @test alpine.linear_terms[lk28][:y_idx] == 6927
        @test alpine.linear_terms[lk28][:id] == 13
        @test alpine.linear_terms[lk28][:y_type] == :(Cont)
        lk29 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 271), (-1.0, 6950)])),
        )
        @test alpine.linear_terms[lk29][:y_idx] == 6951
        @test alpine.linear_terms[lk29][:id] == 27
        @test alpine.linear_terms[lk29][:y_type] == :(Cont)
        lk30 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(0.002971, 6903), (1.0, 6971), (1.0, 3962)]),
            ),
        )
        @test alpine.linear_terms[lk30][:y_idx] == 6972
        @test alpine.linear_terms[lk30][:id] == 40
        @test alpine.linear_terms[lk30][:y_type] == :(Cont)
        lk31 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 511), (-1.0, 6970)])),
        )
        @test alpine.linear_terms[lk31][:y_idx] == 6971
        @test alpine.linear_terms[lk31][:id] == 39
        @test alpine.linear_terms[lk31][:y_type] == :(Cont)
        lk32 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 7031), (1.0, 6602), (0.00121, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk32][:y_idx] == 7032
        @test alpine.linear_terms[lk32][:id] == 76
        @test alpine.linear_terms[lk32][:y_type] == :(Cont)
        lk33 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(0.00166, 6903), (1.0, 7011), (1.0, 5402)]),
            ),
        )
        @test alpine.linear_terms[lk33][:y_idx] == 7012
        @test alpine.linear_terms[lk33][:id] == 64
        @test alpine.linear_terms[lk33][:y_type] == :(Cont)
        lk34 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, -0.003214),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 16)])),
        )
        @test alpine.linear_terms[lk34][:y_idx] == 6910
        @test alpine.linear_terms[lk34][:id] == 2
        @test alpine.linear_terms[lk34][:y_type] == :(Cont)
        lk35 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 7035), (1.0, 3451)])),
        )
        @test alpine.linear_terms[lk35][:y_idx] == 7036
        @test alpine.linear_terms[lk35][:id] == 78
        @test alpine.linear_terms[lk35][:y_type] == :(Cont)
        lk36 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 2551), (1.0, 6002)])),
        )
        @test alpine.linear_terms[lk36][:y_idx] == 7019
        @test alpine.linear_terms[lk36][:id] == 68
        @test alpine.linear_terms[lk36][:y_type] == :(Cont)
        lk37 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3842), (1.0, 391)])),
        )
        @test alpine.linear_terms[lk37][:y_idx] == 6959
        @test alpine.linear_terms[lk37][:id] == 32
        @test alpine.linear_terms[lk37][:y_type] == :(Cont)
        lk38 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 6966), (0.00307, 6903), (1.0, 3902)]),
            ),
        )
        @test alpine.linear_terms[lk38][:y_idx] == 6967
        @test alpine.linear_terms[lk38][:id] == 37
        @test alpine.linear_terms[lk38][:y_type] == :(Cont)
        lk39 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 3722), (0.003829, 6903), (1.0, 6951)]),
            ),
        )
        @test alpine.linear_terms[lk39][:y_idx] == 6952
        @test alpine.linear_terms[lk39][:id] == 28
        @test alpine.linear_terms[lk39][:y_type] == :(Cont)
        lk40 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 451), (1.0, 3902)])),
        )
        @test alpine.linear_terms[lk40][:y_idx] == 6964
        @test alpine.linear_terms[lk40][:id] == 35
        @test alpine.linear_terms[lk40][:y_type] == :(Cont)
        lk41 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 7006), (1.0, 5162), (0.001713, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk41][:y_idx] == 7007
        @test alpine.linear_terms[lk41][:id] == 61
        @test alpine.linear_terms[lk41][:y_type] == :(Cont)
        lk42 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 811), (-1.0, 6980)])),
        )
        @test alpine.linear_terms[lk42][:y_idx] == 6981
        @test alpine.linear_terms[lk42][:id] == 45
        @test alpine.linear_terms[lk42][:y_type] == :(Cont)
        lk43 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 7001), (1.0, 4982), (0.00173, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk43][:y_idx] == 7002
        @test alpine.linear_terms[lk43][:id] == 58
        @test alpine.linear_terms[lk43][:y_type] == :(Cont)
        lk44 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6920), (1.0, 76)])),
        )
        @test alpine.linear_terms[lk44][:y_idx] == 6921
        @test alpine.linear_terms[lk44][:id] == 9
        @test alpine.linear_terms[lk44][:y_type] == :(Cont)
        lk45 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 4622), (1.0, 1171)])),
        )
        @test alpine.linear_terms[lk45][:y_idx] == 6989
        @test alpine.linear_terms[lk45][:id] == 50
        @test alpine.linear_terms[lk45][:y_type] == :(Cont)
        lk46 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 991), (1.0, 4442)])),
        )
        @test alpine.linear_terms[lk46][:y_idx] == 6984
        @test alpine.linear_terms[lk46][:id] == 47
        @test alpine.linear_terms[lk46][:y_type] == :(Cont)
        lk47 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6930), (1.0, 136)])),
        )
        @test alpine.linear_terms[lk47][:y_idx] == 6931
        @test alpine.linear_terms[lk47][:id] == 15
        @test alpine.linear_terms[lk47][:y_type] == :(Cont)
        lk48 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 4802), (0.001891, 6903), (1.0, 6996)]),
            ),
        )
        @test alpine.linear_terms[lk48][:y_idx] == 6997
        @test alpine.linear_terms[lk48][:id] == 55
        @test alpine.linear_terms[lk48][:y_type] == :(Cont)
        lk49 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 511), (1.0, 3962)])),
        )
        @test alpine.linear_terms[lk49][:y_idx] == 6969
        @test alpine.linear_terms[lk49][:id] == 38
        @test alpine.linear_terms[lk49][:y_type] == :(Cont)
        lk50 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 811), (1.0, 4262)])),
        )
        @test alpine.linear_terms[lk50][:y_idx] == 6979
        @test alpine.linear_terms[lk50][:id] == 44
        @test alpine.linear_terms[lk50][:y_type] == :(Cont)
        lk51 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(0.01551, 6903), (1.0, 6916), (1.0, 3497)]),
            ),
        )
        @test alpine.linear_terms[lk51][:y_idx] == 6917
        @test alpine.linear_terms[lk51][:id] == 7
        @test alpine.linear_terms[lk51][:y_type] == :(Cont)
        lk52 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 451), (-1.0, 6965)])),
        )
        @test alpine.linear_terms[lk52][:y_idx] == 6966
        @test alpine.linear_terms[lk52][:id] == 36
        @test alpine.linear_terms[lk52][:y_type] == :(Cont)
        lk53 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(0.005773, 6903), (1.0, 3587), (1.0, 6931)]),
            ),
        )
        @test alpine.linear_terms[lk53][:y_idx] == 6932
        @test alpine.linear_terms[lk53][:id] == 16
        @test alpine.linear_terms[lk53][:y_type] == :(Cont)
        lk54 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 631), (1.0, 4082)])),
        )
        @test alpine.linear_terms[lk54][:y_idx] == 6974
        @test alpine.linear_terms[lk54][:id] == 41
        @test alpine.linear_terms[lk54][:y_type] == :(Cont)
        lk55 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 991), (-1.0, 6985)])),
        )
        @test alpine.linear_terms[lk55][:y_idx] == 6986
        @test alpine.linear_terms[lk55][:id] == 48
        @test alpine.linear_terms[lk55][:y_type] == :(Cont)
        lk56 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 4802), (1.0, 1351)])),
        )
        @test alpine.linear_terms[lk56][:y_idx] == 6994
        @test alpine.linear_terms[lk56][:id] == 53
        @test alpine.linear_terms[lk56][:y_type] == :(Cont)
        lk57 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 6946), (0.004409, 6903), (1.0, 3677)]),
            ),
        )
        @test alpine.linear_terms[lk57][:y_idx] == 6947
        @test alpine.linear_terms[lk57][:id] == 25
        @test alpine.linear_terms[lk57][:y_type] == :(Cont)
        lk58 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 2251), (1.0, 5702)])),
        )
        @test alpine.linear_terms[lk58][:y_idx] == 7014
        @test alpine.linear_terms[lk58][:id] == 65
        @test alpine.linear_terms[lk58][:y_type] == :(Cont)
        lk59 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 7020), (1.0, 2551)])),
        )
        @test alpine.linear_terms[lk59][:y_idx] == 7021
        @test alpine.linear_terms[lk59][:id] == 69
        @test alpine.linear_terms[lk59][:y_type] == :(Cont)
        lk60 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6940), (1.0, 196)])),
        )
        @test alpine.linear_terms[lk60][:y_idx] == 6941
        @test alpine.linear_terms[lk60][:id] == 21
        @test alpine.linear_terms[lk60][:y_type] == :(Cont)
        lk61 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 3527), (1.0, 6921), (0.008919, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk61][:y_idx] == 6922
        @test alpine.linear_terms[lk61][:id] == 10
        @test alpine.linear_terms[lk61][:y_type] == :(Cont)
        lk62 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 7025), (1.0, 2851)])),
        )
        @test alpine.linear_terms[lk62][:y_idx] == 7026
        @test alpine.linear_terms[lk62][:id] == 72
        @test alpine.linear_terms[lk62][:y_type] == :(Cont)
        lk63 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 6986), (1.0, 4442), (0.002252, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk63][:y_idx] == 6987
        @test alpine.linear_terms[lk63][:id] == 49
        @test alpine.linear_terms[lk63][:y_type] == :(Cont)
        lk64 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(0.002765, 6903), (1.0, 6976), (1.0, 4082)]),
            ),
        )
        @test alpine.linear_terms[lk64][:y_idx] == 6977
        @test alpine.linear_terms[lk64][:id] == 43
        @test alpine.linear_terms[lk64][:y_type] == :(Cont)
        lk65 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 6956), (0.003269, 6903), (1.0, 3782)]),
            ),
        )
        @test alpine.linear_terms[lk65][:y_idx] == 6957
        @test alpine.linear_terms[lk65][:id] == 31
        @test alpine.linear_terms[lk65][:y_type] == :(Cont)
        lk66 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3587), (1.0, 136)])),
        )
        @test alpine.linear_terms[lk66][:y_idx] == 6929
        @test alpine.linear_terms[lk66][:id] == 14
        @test alpine.linear_terms[lk66][:y_type] == :(Cont)
        lk67 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 166), (1.0, 3617)])),
        )
        @test alpine.linear_terms[lk67][:y_idx] == 6934
        @test alpine.linear_terms[lk67][:id] == 17
        @test alpine.linear_terms[lk67][:y_type] == :(Cont)
        lk68 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 7010), (1.0, 1951)])),
        )
        @test alpine.linear_terms[lk68][:y_idx] == 7011
        @test alpine.linear_terms[lk68][:id] == 63
        @test alpine.linear_terms[lk68][:y_type] == :(Cont)
        lk69 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 7036), (0.001098, 6903), (1.0, 6902)]),
            ),
        )
        @test alpine.linear_terms[lk69][:y_idx] == 7037
        @test alpine.linear_terms[lk69][:id] == 79
        @test alpine.linear_terms[lk69][:y_type] == :(Cont)
        lk70 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3527), (1.0, 76)])),
        )
        @test alpine.linear_terms[lk70][:y_idx] == 6919
        @test alpine.linear_terms[lk70][:id] == 8
        @test alpine.linear_terms[lk70][:y_type] == :(Cont)
        lk71 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(
                :coef_var,
                Set(Any[(1.0, 6961), (1.0, 3842), (0.00317, 6903)]),
            ),
        )
        @test alpine.linear_terms[lk71][:y_idx] == 6962
        @test alpine.linear_terms[lk71][:id] == 34
        @test alpine.linear_terms[lk71][:y_type] == :(Cont)
        lk72 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6990), (1.0, 1171)])),
        )
        @test alpine.linear_terms[lk72][:y_idx] == 6991
        @test alpine.linear_terms[lk72][:id] == 51
        @test alpine.linear_terms[lk72][:y_type] == :(Cont)
        lk73 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3451), (1.0, 6902)])),
        )
        @test alpine.linear_terms[lk73][:y_idx] == 7034
        @test alpine.linear_terms[lk73][:id] == 77
        @test alpine.linear_terms[lk73][:y_type] == :(Cont)
        lk74 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 6302), (1.0, 2851)])),
        )
        @test alpine.linear_terms[lk74][:y_idx] == 7024
        @test alpine.linear_terms[lk74][:id] == 71
        @test alpine.linear_terms[lk74][:y_type] == :(Cont)
        lk75 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 1531), (-1.0, 7000)])),
        )
        @test alpine.linear_terms[lk75][:y_idx] == 7001
        @test alpine.linear_terms[lk75][:id] == 57
        @test alpine.linear_terms[lk75][:y_type] == :(Cont)
        lk76 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3151), (1.0, 6602)])),
        )
        @test alpine.linear_terms[lk76][:y_idx] == 7029
        @test alpine.linear_terms[lk76][:id] == 74
        @test alpine.linear_terms[lk76][:y_type] == :(Cont)
        lk77 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 3782), (1.0, 331)])),
        )
        @test alpine.linear_terms[lk77][:y_idx] == 6954
        @test alpine.linear_terms[lk77][:id] == 29
        @test alpine.linear_terms[lk77][:y_type] == :(Cont)
        lk78 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(-1.0, 6955), (1.0, 331)])),
        )
        @test alpine.linear_terms[lk78][:y_idx] == 6956
        @test alpine.linear_terms[lk78][:id] == 30
        @test alpine.linear_terms[lk78][:y_type] == :(Cont)
        lk79 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 226), (1.0, 3677)])),
        )
        @test alpine.linear_terms[lk79][:y_idx] == 6944
        @test alpine.linear_terms[lk79][:id] == 23
        @test alpine.linear_terms[lk79][:y_type] == :(Cont)
    end
end

@testset "Expression Parsing || Basic Multiplication Operators (Machine Generated for diffs)" begin
    test_solver = optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => JUNIPER,
        "mip_solver" => HIGHS,
        "log_level" => 100,
    )

    m = operator_basic(solver = test_solver)
    JuMP.set_optimize_hook(m, MOI.Utilities.attach_optimizer)
    JuMP.optimize!(m)
    JuMP.set_optimize_hook(m, nothing)
    alpine = JuMP.backend(m).optimizer.model
    Alpine.load!(alpine)

    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4])]][:y_idx] == 31
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4])]][:id] == 27
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4])]][:lifted_constr_ref] ==
          :(x[31] == x[3] * x[4])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[76])]][:y_idx] == 83
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[76])]][:id] == 79
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[76])]][:lifted_constr_ref] ==
          :(x[83] == x[4] * x[5] * x[76])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[76])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[2])]][:y_idx] == 9
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[2])]][:id] == 5
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[2])]][:lifted_constr_ref] ==
          :(x[9] == (*)(x[2]))
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[2])]][:nonlinear_type] == :MONOMIAL
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7])]][:y_idx] == 19
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7])]][:id] == 15
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7])]][:lifted_constr_ref] ==
          :(x[19] == x[5] * x[7])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[31])]][:y_idx] == 32
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[31])]][:id] == 28
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[31])]][:lifted_constr_ref] ==
          :(x[32] == x[2] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[31])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10])]][:y_idx] == 49
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10])]][:id] == 45
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10])]][:lifted_constr_ref] ==
          :(x[49] == x[1] * x[2] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5]), :(x[9])]][:y_idx] == 50
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5]), :(x[9])]][:id] == 46
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5]), :(x[9])]][:lifted_constr_ref] ==
          :(x[50] == x[3] * x[5] * x[9])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[5]), :(x[9])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[47])]][:y_idx] == 69
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[47])]][:id] == 65
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[47])]][:lifted_constr_ref] ==
          :(x[69] == x[4] * x[47])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[47])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[4])]][:y_idx] == 28
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[4])]][:id] == 24
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[4])]][:lifted_constr_ref] ==
          :(x[28] == (*)(x[4]))
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[4])]][:nonlinear_type] == :MONOMIAL
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[10])]][:y_idx] == 37
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[10])]][:id] == 33
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[10])]][:lifted_constr_ref] ==
          :(x[37] == x[4] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[10])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[1])]][:y_idx] == 5
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[1])]][:id] == 1
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[1])]][:lifted_constr_ref] ==
          :(x[5] == (*)(x[1]))
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[1])]][:nonlinear_type] == :MONOMIAL
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[95])]][:y_idx] == 96
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[95])]][:id] == 92
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[95])]][:lifted_constr_ref] ==
          :(x[96] == x[5] * x[95])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[95])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[40])]][:y_idx] == 41
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[40])]][:id] == 37
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[40])]][:lifted_constr_ref] ==
          :(x[41] == x[2] * x[40])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[40])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10])]][:y_idx] == 26
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10])]][:id] == 22
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10])]][:lifted_constr_ref] ==
          :(x[26] == x[6] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[78]), :(x[28])]][:y_idx] == 84
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[78]), :(x[28])]][:id] == 80
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[78]), :(x[28])]][:lifted_constr_ref] ==
          :(x[84] == x[1] * x[78] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[78]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[43])]][:y_idx] == 58
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[43])]][:id] == 54
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[43])]][:lifted_constr_ref] ==
          :(x[58] == x[6] * x[43])
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[43])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[6]), :(x[10])]][:y_idx] == 106
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[6]), :(x[10])]][:id] == 102
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[6]), :(x[10])]][:lifted_constr_ref] ==
          :(x[106] == x[4] * x[6] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[6]), :(x[10])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4]), :(x[10])]][:y_idx] == 90
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4]), :(x[10])]][:id] == 86
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4]), :(x[10])]][:lifted_constr_ref] ==
          :(x[90] == x[2] * x[4] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[4]), :(x[10])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[41])]][:y_idx] == 42
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[41])]][:id] == 38
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[41])]][:lifted_constr_ref] ==
          :(x[42] == x[1] * x[41])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[41])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[37])]][:y_idx] == 38
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[37])]][:id] == 34
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[37])]][:lifted_constr_ref] ==
          :(x[38] == x[2] * x[37])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[37])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[85])]][:y_idx] == 87
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[85])]][:id] == 83
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[85])]][:lifted_constr_ref] ==
          :(x[87] == x[5] * x[85])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[85])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5]), :(x[28])]][:y_idx] == 66
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5]), :(x[28])]][:id] == 62
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5]), :(x[28])]][:lifted_constr_ref] ==
          :(x[66] == x[2] * x[3] * x[5] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10])]][:y_idx] == 53
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10])]][:id] == 49
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10])]][:lifted_constr_ref] ==
          :(x[53] == x[5] * x[9] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6]), :(x[28])]][:y_idx] == 107
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6]), :(x[28])]][:id] == 103
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6]), :(x[28])]][:lifted_constr_ref] ==
          :(x[107] == x[3] * x[6] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5])]][:y_idx] == 17
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5])]][:id] == 13
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5])]][:lifted_constr_ref] ==
          :(x[17] == x[2] * x[5])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[37])]][:y_idx] == 57
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[37])]][:id] == 53
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[37])]][:lifted_constr_ref] ==
          :(x[57] == x[6] * x[37])
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[37])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7]), :(x[28])]][:y_idx] == 81
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7]), :(x[28])]][:id] == 77
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7]), :(x[28])]][:lifted_constr_ref] ==
          :(x[81] == x[5] * x[7] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[7]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[38])]][:y_idx] == 39
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[38])]][:id] == 35
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[38])]][:lifted_constr_ref] ==
          :(x[39] == x[1] * x[38])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[38])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[9])]][:y_idx] == 48
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[9])]][:id] == 44
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[9])]][:lifted_constr_ref] ==
          :(x[48] == x[1] * x[3] * x[9])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[9])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[23])]][:y_idx] == 24
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[23])]][:id] == 20
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[23])]][:lifted_constr_ref] ==
          :(x[24] == x[4] * x[23])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[23])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[17])]][:y_idx] == 23
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[17])]][:id] == 19
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[17])]][:lifted_constr_ref] ==
          :(x[23] == x[3] * x[17])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[17])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[10])]][:y_idx] == 51
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[10])]][:id] == 47
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[10])]][:lifted_constr_ref] ==
          :(x[51] == x[1] * x[9] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[10])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[7])]][:y_idx] == 75
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[7])]][:id] == 71
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[7])]][:lifted_constr_ref] ==
          :(x[75] == x[4] * x[5] * x[7])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[5]), :(x[7])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[28])]][:y_idx] == 95
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[28])]][:id] == 91
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[28])]][:lifted_constr_ref] ==
          :(x[95] == x[9] * x[10] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10])]][:y_idx] == 11
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10])]][:id] == 7
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10])]][:lifted_constr_ref] ==
          :(x[11] == x[9] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[10])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[37])]][:y_idx] == 100
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[37])]][:id] == 96
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[37])]][:lifted_constr_ref] ==
          :(x[100] == x[1] * x[2] * x[37])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[37])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4]), :(x[5])]][:y_idx] == 62
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4]), :(x[5])]][:id] == 58
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4]), :(x[5])]][:lifted_constr_ref] ==
          :(x[62] == x[2] * x[3] * x[4] * x[5])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4]), :(x[5])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[9]), :(x[10])]][:y_idx] == 65
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[9]), :(x[10])]][:id] == 61
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[9]), :(x[10])]][:lifted_constr_ref] ==
          :(x[65] == x[1] * x[4] * x[9] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[9]), :(x[10])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7]), :(x[28])]][:y_idx] == 80
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7]), :(x[28])]][:id] == 76
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7]), :(x[28])]][:lifted_constr_ref] ==
          :(x[80] == x[1] * x[7] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3])]][:y_idx] == 46
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3])]][:id] == 42
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3])]][:lifted_constr_ref] ==
          :(x[46] == x[1] * x[2] * x[3])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[40])]][:y_idx] == 59
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[40])]][:id] == 55
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[40])]][:lifted_constr_ref] ==
          :(x[59] == x[17] * x[40])
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[40])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[85])]][:y_idx] == 86
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[85])]][:id] == 82
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[85])]][:lifted_constr_ref] ==
          :(x[86] == x[1] * x[85])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[85])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[31])]][:y_idx] == 97
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[31])]][:id] == 93
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[31])]][:lifted_constr_ref] ==
          :(x[97] == x[1] * x[2] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[31])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[28])]][:y_idx] == 29
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[28])]][:id] == 25
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[28])]][:lifted_constr_ref] ==
          :(x[29] == x[13] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[13]), :(x[28])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[28])]][:y_idx] == 92
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[28])]][:id] == 88
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[28])]][:lifted_constr_ref] ==
          :(x[92] == x[2] * x[3] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9])]][:y_idx] == 20
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9])]][:id] == 16
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9])]][:lifted_constr_ref] ==
          :(x[20] == x[1] * x[9])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10]), :(x[28])]][:y_idx] == 109
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10]), :(x[28])]][:id] == 105
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10]), :(x[28])]][:lifted_constr_ref] ==
          :(x[109] == x[14] * x[10] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[92])]][:y_idx] == 93
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[92])]][:id] == 89
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[92])]][:lifted_constr_ref] ==
          :(x[93] == x[1] * x[92])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[92])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4])]][:y_idx] == 85
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4])]][:id] == 81
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4])]][:lifted_constr_ref] ==
          :(x[85] == x[2] * x[3] * x[4])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[4])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[11])]][:y_idx] == 16
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[11])]][:id] == 12
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[11])]][:lifted_constr_ref] ==
          :(x[16] == x[1] * x[11])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[11])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[21])]][:y_idx] == 25
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[21])]][:id] == 21
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[21])]][:lifted_constr_ref] ==
          :(x[25] == x[4] * x[21])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[21])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[53]), :(x[28])]][:y_idx] == 73
    @test alpine.nonconvex_terms[Expr[:(x[53]), :(x[28])]][:id] == 69
    @test alpine.nonconvex_terms[Expr[:(x[53]), :(x[28])]][:lifted_constr_ref] ==
          :(x[73] == x[53] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[53]), :(x[28])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[32])]][:y_idx] == 34
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[32])]][:id] == 30
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[32])]][:lifted_constr_ref] ==
          :(x[34] == x[5] * x[32])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[32])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[28])]][:y_idx] == 40
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[28])]][:id] == 36
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[28])]][:lifted_constr_ref] ==
          :(x[40] == x[3] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[28])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10]), :(x[28])]][:y_idx] == 67
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10]), :(x[28])]][:id] == 63
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10]), :(x[28])]][:lifted_constr_ref] ==
          :(x[67] == x[5] * x[9] * x[10] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[10]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[43])]][:y_idx] == 102
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[43])]][:id] == 98
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[43])]][:lifted_constr_ref] ==
          :(x[102] == x[5] * x[9] * x[43])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9]), :(x[43])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[26])]][:y_idx] == 27
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[26])]][:id] == 23
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[26])]][:lifted_constr_ref] ==
          :(x[27] == x[4] * x[26])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[26])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[20]), :(x[31])]][:y_idx] == 56
    @test alpine.nonconvex_terms[Expr[:(x[20]), :(x[31])]][:id] == 52
    @test alpine.nonconvex_terms[Expr[:(x[20]), :(x[31])]][:lifted_constr_ref] ==
          :(x[56] == x[20] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[20]), :(x[31])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[4]), :(x[9])]][:y_idx] == 63
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[4]), :(x[9])]][:id] == 59
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[4]), :(x[9])]][:lifted_constr_ref] ==
          :(x[63] == x[1] * x[3] * x[4] * x[9])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[3]), :(x[4]), :(x[9])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10])]][:y_idx] == 15
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10])]][:id] == 11
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10])]][:lifted_constr_ref] ==
          :(x[15] == x[14] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[10])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[76])]][:y_idx] == 77
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[76])]][:id] == 73
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[76])]][:lifted_constr_ref] ==
          :(x[77] == x[1] * x[4] * x[76])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[76])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[88])]][:y_idx] == 89
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[88])]][:id] == 85
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[88])]][:lifted_constr_ref] ==
          :(x[89] == x[1] * x[88])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[88])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[90])]][:y_idx] == 94
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[90])]][:id] == 90
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[90])]][:lifted_constr_ref] ==
          :(x[94] == x[5] * x[90])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[90])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10]), :(x[28])]][:y_idx] == 108
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10]), :(x[28])]][:id] == 104
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10]), :(x[28])]][:lifted_constr_ref] ==
          :(x[108] == x[6] * x[10] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[10]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[48])]][:y_idx] == 70
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[48])]][:id] == 66
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[48])]][:lifted_constr_ref] ==
          :(x[70] == x[4] * x[48])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[48])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[31])]][:y_idx] == 54
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[31])]][:id] == 50
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[31])]][:lifted_constr_ref] ==
          :(x[54] == x[6] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[31])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[31])]][:y_idx] == 99
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[31])]][:id] == 95
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[31])]][:lifted_constr_ref] ==
          :(x[99] == x[1] * x[9] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[9]), :(x[31])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[35])]][:y_idx] == 36
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[35])]][:id] == 32
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[35])]][:lifted_constr_ref] ==
          :(x[36] == x[1] * x[35])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[35])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9])]][:y_idx] == 14
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9])]][:id] == 10
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9])]][:lifted_constr_ref] ==
          :(x[14] == x[5] * x[9])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[9])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[13])]][:y_idx] == 22
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[13])]][:id] == 18
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[13])]][:lifted_constr_ref] ==
          :(x[22] == x[4] * x[13])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[13])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10]), :(x[28])]][:y_idx] == 64
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10]), :(x[28])]][:id] == 60
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10]), :(x[28])]][:lifted_constr_ref] ==
          :(x[64] == x[1] * x[2] * x[10] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[10]), :(x[28])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[46]), :(x[28])]][:y_idx] == 72
    @test alpine.nonconvex_terms[Expr[:(x[46]), :(x[28])]][:id] == 68
    @test alpine.nonconvex_terms[Expr[:(x[46]), :(x[28])]][:lifted_constr_ref] ==
          :(x[72] == x[46] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[46]), :(x[28])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[31])]][:y_idx] == 55
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[31])]][:id] == 51
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[31])]][:lifted_constr_ref] ==
          :(x[55] == x[17] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[31])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[31])]][:y_idx] == 98
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[31])]][:id] == 94
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[31])]][:lifted_constr_ref] ==
          :(x[98] == x[2] * x[5] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[31])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[28])]][:y_idx] == 43
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[28])]][:id] == 39
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[28])]][:lifted_constr_ref] ==
          :(x[43] == x[10] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[10]), :(x[28])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[10])]][:y_idx] == 78
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[10])]][:id] == 74
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[10])]][:lifted_constr_ref] ==
          :(x[78] == x[2] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[10])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[10])]][:y_idx] == 52
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[10])]][:id] == 48
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[10])]][:lifted_constr_ref] ==
          :(x[52] == x[2] * x[5] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[5]), :(x[10])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[90])]][:y_idx] == 91
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[90])]][:id] == 87
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[90])]][:lifted_constr_ref] ==
          :(x[91] == x[1] * x[90])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[90])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[17])]][:y_idx] == 104
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[17])]][:id] == 100
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[17])]][:lifted_constr_ref] ==
          :(x[104] == x[3] * x[4] * x[17])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[17])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[9])]][:y_idx] == 76
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[9])]][:id] == 72
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[9])]][:lifted_constr_ref] ==
          :(x[76] == x[3] * x[9])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[9])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[78])]][:y_idx] == 79
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[78])]][:id] == 75
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[78])]][:lifted_constr_ref] ==
          :(x[79] == x[1] * x[4] * x[78])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[78])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[3])]][:y_idx] == 10
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[3])]][:id] == 6
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[3])]][:lifted_constr_ref] ==
          :(x[10] == (*)(x[3]))
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[3])]][:nonlinear_type] == :MONOMIAL
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[49])]][:y_idx] == 71
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[49])]][:id] == 67
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[49])]][:lifted_constr_ref] ==
          :(x[71] == x[4] * x[49])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[49])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[9])]][:y_idx] == 88
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[9])]][:id] == 84
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[9])]][:lifted_constr_ref] ==
          :(x[88] == x[3] * x[4] * x[9])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[9])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[15]), :(x[28])]][:y_idx] == 30
    @test alpine.nonconvex_terms[Expr[:(x[15]), :(x[28])]][:id] == 26
    @test alpine.nonconvex_terms[Expr[:(x[15]), :(x[28])]][:lifted_constr_ref] ==
          :(x[30] == x[15] * x[28])
    @test alpine.nonconvex_terms[Expr[:(x[15]), :(x[28])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[46])]][:y_idx] == 68
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[46])]][:id] == 64
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[46])]][:lifted_constr_ref] ==
          :(x[68] == x[4] * x[46])
    @test alpine.nonconvex_terms[Expr[:(x[4]), :(x[46])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[11])]][:y_idx] == 12
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[11])]][:id] == 8
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[11])]][:lifted_constr_ref] ==
          :(x[12] == x[5] * x[11])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[11])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[7])]][:y_idx] == 74
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[7])]][:id] == 70
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[7])]][:lifted_constr_ref] ==
          :(x[74] == x[1] * x[4] * x[7])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[7])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[20])]][:y_idx] == 105
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[20])]][:id] == 101
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[20])]][:lifted_constr_ref] ==
          :(x[105] == x[3] * x[4] * x[20])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[20])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[11])]][:y_idx] == 82
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[11])]][:id] == 78
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[11])]][:lifted_constr_ref] ==
          :(x[82] == x[1] * x[4] * x[11])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[4]), :(x[11])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[43])]][:y_idx] == 44
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[43])]][:id] == 40
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[43])]][:lifted_constr_ref] ==
          :(x[44] == x[9] * x[43])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[43])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:y_idx] == 61
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:id] == 57
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:lifted_constr_ref] ==
          :(x[61] == x[1] * x[2] * x[3] * x[4])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3]), :(x[4])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[10])]][:y_idx] == 18
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[10])]][:id] == 14
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[10])]][:lifted_constr_ref] ==
          :(x[18] == x[17] * x[10])
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[10])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7])]][:y_idx] == 8
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7])]][:id] == 4
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7])]][:lifted_constr_ref] ==
          :(x[8] == x[1] * x[7])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[7])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2])]][:y_idx] == 6
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2])]][:id] == 2
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2])]][:lifted_constr_ref] ==
          :(x[6] == x[1] * x[2])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[40])]][:y_idx] == 101
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[40])]][:id] == 97
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[40])]][:lifted_constr_ref] ==
          :(x[101] == x[1] * x[2] * x[40])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[40])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[37])]][:y_idx] == 60
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[37])]][:id] == 56
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[37])]][:lifted_constr_ref] ==
          :(x[60] == x[17] * x[37])
    @test alpine.nonconvex_terms[Expr[:(x[17]), :(x[37])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[6])]][:y_idx] == 103
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[6])]][:id] == 99
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[6])]][:lifted_constr_ref] ==
          :(x[103] == x[3] * x[4] * x[6])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[4]), :(x[6])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3])]][:y_idx] == 7
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3])]][:id] == 3
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3])]][:lifted_constr_ref] ==
          :(x[7] == x[2] * x[3])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5])]][:y_idx] == 47
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5])]][:id] == 43
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5])]][:lifted_constr_ref] ==
          :(x[47] == x[2] * x[3] * x[5])
    @test alpine.nonconvex_terms[Expr[:(x[2]), :(x[3]), :(x[5])]][:nonlinear_type] ==
          :MULTILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6])]][:y_idx] == 13
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6])]][:id] == 9
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6])]][:lifted_constr_ref] ==
          :(x[13] == x[3] * x[6])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[6])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[31])]][:y_idx] == 35
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[31])]][:id] == 31
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[31])]][:lifted_constr_ref] ==
          :(x[35] == x[9] * x[31])
    @test alpine.nonconvex_terms[Expr[:(x[9]), :(x[31])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[32])]][:y_idx] == 33
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[32])]][:id] == 29
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[32])]][:lifted_constr_ref] ==
          :(x[33] == x[1] * x[32])
    @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[32])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[20])]][:y_idx] == 21
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[20])]][:id] == 17
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[20])]][:lifted_constr_ref] ==
          :(x[21] == x[3] * x[20])
    @test alpine.nonconvex_terms[Expr[:(x[3]), :(x[20])]][:nonlinear_type] == :BILINEAR
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[44])]][:y_idx] == 45
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[44])]][:id] == 41
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[44])]][:lifted_constr_ref] ==
          :(x[45] == x[5] * x[44])
    @test alpine.nonconvex_terms[Expr[:(x[5]), :(x[44])]][:nonlinear_type] == :BILINEAR

    @test alpine.bounding_constr_mip[1][:rhs] == 1.0
    @test alpine.bounding_constr_mip[1][:vars] == Any[:(x[5])]
    @test alpine.bounding_constr_mip[1][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[1][:sense] == :(>=)
    @test alpine.bounding_constr_mip[1][:cnt] == 1
    @test alpine.bounding_constr_mip[2][:rhs] == 1.0
    @test alpine.bounding_constr_mip[2][:vars] == Any[:(x[6])]
    @test alpine.bounding_constr_mip[2][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[2][:sense] == :(<=)
    @test alpine.bounding_constr_mip[2][:cnt] == 1
    @test alpine.bounding_constr_mip[3][:rhs] == 1.0
    @test alpine.bounding_constr_mip[3][:vars] == Any[:(x[5]), :(x[7])]
    @test alpine.bounding_constr_mip[3][:coefs] == Any[1.0, 1.0]
    @test alpine.bounding_constr_mip[3][:sense] == :(<=)
    @test alpine.bounding_constr_mip[3][:cnt] == 2
    @test alpine.bounding_constr_mip[4][:rhs] == 1.0
    @test alpine.bounding_constr_mip[4][:vars] == Any[:(x[8])]
    @test alpine.bounding_constr_mip[4][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[4][:sense] == :(>=)
    @test alpine.bounding_constr_mip[4][:cnt] == 1
    @test alpine.bounding_constr_mip[5][:rhs] == 1.0
    @test alpine.bounding_constr_mip[5][:vars] == Any[:(x[12])]
    @test alpine.bounding_constr_mip[5][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[5][:sense] == :(<=)
    @test alpine.bounding_constr_mip[5][:cnt] == 1
    @test alpine.bounding_constr_mip[6][:rhs] == 1.0
    @test alpine.bounding_constr_mip[6][:vars] == Any[:(x[13])]
    @test alpine.bounding_constr_mip[6][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[6][:sense] == :(>=)
    @test alpine.bounding_constr_mip[6][:cnt] == 1
    @test alpine.bounding_constr_mip[7][:rhs] == 1.0
    @test alpine.bounding_constr_mip[7][:vars] == Any[:(x[15])]
    @test alpine.bounding_constr_mip[7][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[7][:sense] == :(<=)
    @test alpine.bounding_constr_mip[7][:cnt] == 1
    @test alpine.bounding_constr_mip[8][:rhs] == 1.0
    @test alpine.bounding_constr_mip[8][:vars] == Any[:(x[16])]
    @test alpine.bounding_constr_mip[8][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[8][:sense] == :(>=)
    @test alpine.bounding_constr_mip[8][:cnt] == 1
    @test alpine.bounding_constr_mip[9][:rhs] == 1.0
    @test alpine.bounding_constr_mip[9][:vars] == Any[:(x[18])]
    @test alpine.bounding_constr_mip[9][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[9][:sense] == :(<=)
    @test alpine.bounding_constr_mip[9][:cnt] == 1
    @test alpine.bounding_constr_mip[10][:rhs] == 1.0
    @test alpine.bounding_constr_mip[10][:vars] == Any[:(x[19])]
    @test alpine.bounding_constr_mip[10][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[10][:sense] == :(>=)
    @test alpine.bounding_constr_mip[10][:cnt] == 1
    @test alpine.bounding_constr_mip[11][:rhs] == 1.0
    @test alpine.bounding_constr_mip[11][:vars] == Any[:(x[21])]
    @test alpine.bounding_constr_mip[11][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[11][:sense] == :(<=)
    @test alpine.bounding_constr_mip[11][:cnt] == 1
    @test alpine.bounding_constr_mip[12][:rhs] == 1.0
    @test alpine.bounding_constr_mip[12][:vars] == Any[:(x[22])]
    @test alpine.bounding_constr_mip[12][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[12][:sense] == :(>=)
    @test alpine.bounding_constr_mip[12][:cnt] == 1
    @test alpine.bounding_constr_mip[13][:rhs] == 1.0
    @test alpine.bounding_constr_mip[13][:vars] == Any[:(x[24])]
    @test alpine.bounding_constr_mip[13][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[13][:sense] == :(<=)
    @test alpine.bounding_constr_mip[13][:cnt] == 1
    @test alpine.bounding_constr_mip[14][:rhs] == 1.0
    @test alpine.bounding_constr_mip[14][:vars] == Any[:(x[25])]
    @test alpine.bounding_constr_mip[14][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[14][:sense] == :(>=)
    @test alpine.bounding_constr_mip[14][:cnt] == 1
    @test alpine.bounding_constr_mip[15][:rhs] == 1.0
    @test alpine.bounding_constr_mip[15][:vars] == Any[:(x[27])]
    @test alpine.bounding_constr_mip[15][:coefs] == Any[1.0]
    @test alpine.bounding_constr_mip[15][:sense] == :(<=)
    @test alpine.bounding_constr_mip[15][:cnt] == 1
end

@testset "Expression Parsing || corner cases" begin
    @testset "Corner Cases - 1 : sign convertor special case" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "minlp_solver" => JUNIPER,
            "log_level" => 100,
        )

        m = Model(test_solver)
        @variable(m, 0 <= x[1:5] <= 1, Bin)
        @NLconstraint(m, x[1] + -x[2] >= 2)
        @objective(m, Min, x[1] + x[2])
        alpine = _build(m)

        @test alpine.bounding_constr_mip[1][:rhs] == 2.0
        @test alpine.bounding_constr_mip[1][:vars] == Any[:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[1][:coefs] == Any[1.0, -1.0]
        @test alpine.bounding_constr_mip[1][:sense] == :(>=)
        @test alpine.bounding_constr_mip[1][:cnt] == 2
    end

    @testset "Corner Cases - 2 : full sub-expression" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        )

        m = Model(test_solver)
        @variable(m, x[1:5] >= 0)
        @NLconstraint(m, (x[1] + 10 + 4 * x[2] + 200) * 5 >= 2 * 5)
        @constraint(m, x[1] + x[2] + 200 >= 2)
        @objective(m, Min, x[1] + x[2])
        alpine = _build(m)

        @test alpine.bounding_constr_mip[1][:rhs] == -198.0
        @test alpine.bounding_constr_mip[1][:vars] == Any[:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[1][:coefs] == Any[1.0, 1.0]
        @test alpine.bounding_constr_mip[1][:sense] == :(>=)
        @test alpine.bounding_constr_mip[1][:cnt] == 2
        @test alpine.bounding_constr_mip[2][:rhs] == -1040.0
        @test alpine.bounding_constr_mip[2][:vars] == Any[:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[2][:coefs] == Any[5.0, 20.0]
        @test alpine.bounding_constr_mip[2][:sense] == :(>=)
        @test alpine.bounding_constr_mip[2][:cnt] == 2
    end

    @testset "Corner Cases - 2 : full sub-expression" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        )

        m = Model(test_solver)
        @variable(m, x[1:5] >= 0)
        @NLconstraint(m, (x[1] + 10 + 4 * x[2] + 200) * 5 >= 2 * 5)
        @constraint(m, x[1] + x[2] + 200 >= 2)
        @objective(m, Min, x[1] + x[2])
        alpine = _build(m)

        @test alpine.bounding_constr_mip[1][:rhs] == -198.0
        @test alpine.bounding_constr_mip[1][:vars] == Any[:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[1][:coefs] == Any[1.0, 1.0]
        @test alpine.bounding_constr_mip[1][:sense] == :(>=)
        @test alpine.bounding_constr_mip[1][:cnt] == 2
        @test alpine.bounding_constr_mip[2][:rhs] == -1040.0
        @test alpine.bounding_constr_mip[2][:vars] == Any[:(x[1]), :(x[2])]
        @test alpine.bounding_constr_mip[2][:coefs] == Any[5.0, 20.0]
        @test alpine.bounding_constr_mip[2][:sense] == :(>=)
        @test alpine.bounding_constr_mip[2][:cnt] == 2
    end
end

@testset "Expression Parsing || Discrete Multilinear" begin
    @testset "Expression Parsing || bmpl && binlin && binprod" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "minlp_solver" => JUNIPER,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        )

        m = bpml(solver = test_solver)

        alpine = _build(m) # Setup internal model

        @test length(keys(alpine.nonconvex_terms)) == 12

        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[6])]][:y_idx] == 11
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2])]][:y_idx] == 12
        @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[6])]][:y_idx] == 13
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3])]][:y_idx] == 14
        @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[6])]][:y_idx] == 15
        @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[7])]][:y_idx] == 16
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[16])]][:y_idx] == 17
        @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[7]), :(x[8])]][:y_idx] == 18
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[18])]][:y_idx] == 19
        @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[18])]][:y_idx] == 20
        @test alpine.nonconvex_terms[Expr[
            :(x[1]),
            :(x[2]),
            :(x[3]),
            :(x[4]),
            :(x[5]),
        ]][:y_idx] == 21
        @test alpine.nonconvex_terms[Expr[
            :(x[6]),
            :(x[7]),
            :(x[9]),
            :(x[10]),
            :(x[6]),
        ]][:y_idx] == 22

        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[6])]][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2])]][:nonlinear_type] == :BINPROD
        @test alpine.nonconvex_terms[Expr[:(x[12]), :(x[6])]][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[2]), :(x[3])]][:nonlinear_type] ==
              :BINPROD
        @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[6])]][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[7])]][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[16])]][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[Expr[:(x[6]), :(x[7]), :(x[8])]][:nonlinear_type] ==
              :MULTILINEAR
        @test alpine.nonconvex_terms[Expr[:(x[1]), :(x[18])]][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[Expr[:(x[14]), :(x[18])]][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[Expr[
            :(x[1]),
            :(x[2]),
            :(x[3]),
            :(x[4]),
            :(x[5]),
        ]][:nonlinear_type] == :BINPROD
        @test alpine.nonconvex_terms[Expr[
            :(x[6]),
            :(x[7]),
            :(x[9]),
            :(x[10]),
            :(x[6]),
        ]][:nonlinear_type] == :MULTILINEAR

        @test length(alpine.var_type) == 22
        @test alpine.var_type[11] == :Cont
        @test alpine.var_type[12] == :Bin
        @test alpine.var_type[13] == :Cont
        @test alpine.var_type[14] == :Bin
        @test alpine.var_type[15] == :Cont
        @test alpine.var_type[16] == :Cont
        @test alpine.var_type[17] == :Cont
        @test alpine.var_type[18] == :Cont
        @test alpine.var_type[19] == :Cont
        @test alpine.var_type[20] == :Cont
        @test alpine.var_type[21] == :Bin
        @test alpine.var_type[22] == :Cont
    end

    @testset "Expression Parsing || bmpl && binlin && binprod with linear lifting and coefficients" begin
        test_solver = optimizer_with_attributes(
            Alpine.Optimizer,
            "minlp_solver" => JUNIPER,
            "nlp_solver" => IPOPT,
            "mip_solver" => HIGHS,
            "log_level" => 100,
        )

        m = bmpl_linearlifting(solver = test_solver)

        alpine = _build(m)

        lk1 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 1), (1.0, 17)])),
        )
        lk2 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 11), (1.0, 12)])),
        )
        lk3 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 7), (2.0, 6)])),
        )
        lk4 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 6), (1.0, 19)])),
        )
        lk5 = Dict{Symbol,Any}(
            Pair{Symbol,Any}(:sign, :+),
            Pair{Symbol,Any}(:scalar, 0.0),
            Pair{Symbol,Any}(:coef_var, Set(Any[(1.0, 6), (1.0, 25)])),
        )

        @test haskey(alpine.linear_terms, lk1)
        @test haskey(alpine.linear_terms, lk2)
        @test haskey(alpine.linear_terms, lk3)
        @test haskey(alpine.linear_terms, lk4)
        @test haskey(alpine.linear_terms, lk5)

        @test alpine.linear_terms[lk1][:lifted_constr_ref] == :(x[20] == x[1] + x[17])
        @test alpine.linear_terms[lk2][:lifted_constr_ref] == :(x[13] == x[11] + x[12])
        @test alpine.linear_terms[lk3][:lifted_constr_ref] == :(x[15] == 2 * x[6] + x[7])
        @test alpine.linear_terms[lk4][:lifted_constr_ref] == :(x[21] == x[6] + x[19])
        @test alpine.linear_terms[lk5][:lifted_constr_ref] == :(x[26] == x[6] + x[25])

        @test alpine.linear_terms[lk1][:y_idx] == 20
        @test alpine.linear_terms[lk2][:y_idx] == 13
        @test alpine.linear_terms[lk3][:y_idx] == 15
        @test alpine.linear_terms[lk4][:y_idx] == 21
        @test alpine.linear_terms[lk5][:y_idx] == 26

        @test alpine.linear_terms[lk1][:y_type] == :Cont
        @test alpine.linear_terms[lk2][:y_type] == :Cont
        @test alpine.linear_terms[lk3][:y_type] == :Cont
        @test alpine.linear_terms[lk4][:y_type] == :Cont
        @test alpine.linear_terms[lk5][:y_type] == :Cont

        nlk1 = Expr[:(x[18]), :(x[7])]
        nlk2 = Expr[:(x[6]), :(x[7]), :(x[8])]
        nlk3 = Expr[:(x[7]), :(x[10])]
        nlk4 = Expr[:(x[2]), :(x[26])]
        nlk5 = Expr[:(x[1]), :(x[13])]
        nlk6 = Expr[:(x[1]), :(x[15])]
        nlk7 = Expr[:(x[2]), :(x[6])]
        nlk8 = Expr[:(x[24]), :(x[23])]
        nlk9 = Expr[:(x[1]), :(x[2])]
        nlk10 = Expr[:(x[2]), :(x[3])]
        nlk11 = Expr[:(x[20]), :(x[21])]
        nlk12 = Expr[:(x[3]), :(x[4])]

        @test haskey(alpine.nonconvex_terms, nlk1)
        @test haskey(alpine.nonconvex_terms, nlk2)
        @test haskey(alpine.nonconvex_terms, nlk3)
        @test haskey(alpine.nonconvex_terms, nlk4)
        @test haskey(alpine.nonconvex_terms, nlk5)
        @test haskey(alpine.nonconvex_terms, nlk6)
        @test haskey(alpine.nonconvex_terms, nlk7)
        @test haskey(alpine.nonconvex_terms, nlk8)
        @test haskey(alpine.nonconvex_terms, nlk9)
        @test haskey(alpine.nonconvex_terms, nlk10)
        @test haskey(alpine.nonconvex_terms, nlk11)
        @test haskey(alpine.nonconvex_terms, nlk12)

        @test alpine.nonconvex_terms[nlk1][:id] == 7
        @test alpine.nonconvex_terms[nlk2][:id] == 1
        @test alpine.nonconvex_terms[nlk3][:id] == 9
        @test alpine.nonconvex_terms[nlk4][:id] == 12
        @test alpine.nonconvex_terms[nlk5][:id] == 3
        @test alpine.nonconvex_terms[nlk6][:id] == 4
        @test alpine.nonconvex_terms[nlk7][:id] == 5
        @test alpine.nonconvex_terms[nlk8][:id] == 11
        @test alpine.nonconvex_terms[nlk9][:id] == 6
        @test alpine.nonconvex_terms[nlk10][:id] == 2
        @test alpine.nonconvex_terms[nlk11][:id] == 8
        @test alpine.nonconvex_terms[nlk12][:id] == 10

        @test alpine.nonconvex_terms[nlk1][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk2][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk3][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk4][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk5][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk6][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk7][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk8][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk9][:y_type] == :Bin
        @test alpine.nonconvex_terms[nlk10][:y_type] == :Bin
        @test alpine.nonconvex_terms[nlk11][:y_type] == :Cont
        @test alpine.nonconvex_terms[nlk12][:y_type] == :Bin

        @test alpine.nonconvex_terms[nlk1][:y_idx] == 19
        @test alpine.nonconvex_terms[nlk2][:y_idx] == 11
        @test alpine.nonconvex_terms[nlk3][:y_idx] == 23
        @test alpine.nonconvex_terms[nlk4][:y_idx] == 27
        @test alpine.nonconvex_terms[nlk5][:y_idx] == 14
        @test alpine.nonconvex_terms[nlk6][:y_idx] == 16
        @test alpine.nonconvex_terms[nlk7][:y_idx] == 17
        @test alpine.nonconvex_terms[nlk8][:y_idx] == 25
        @test alpine.nonconvex_terms[nlk9][:y_idx] == 18
        @test alpine.nonconvex_terms[nlk10][:y_idx] == 12
        @test alpine.nonconvex_terms[nlk11][:y_idx] == 22
        @test alpine.nonconvex_terms[nlk12][:y_idx] == 24

        @test alpine.nonconvex_terms[nlk1][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[nlk2][:nonlinear_type] == :MULTILINEAR
        @test alpine.nonconvex_terms[nlk3][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[nlk4][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[nlk5][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[nlk6][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[nlk7][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[nlk8][:nonlinear_type] == :BINLIN
        @test alpine.nonconvex_terms[nlk9][:nonlinear_type] == :BINPROD
        @test alpine.nonconvex_terms[nlk10][:nonlinear_type] == :BINPROD
        @test alpine.nonconvex_terms[nlk11][:nonlinear_type] == :BILINEAR
        @test alpine.nonconvex_terms[nlk12][:nonlinear_type] == :BINPROD
    end
end

@testset "Expr dereferencing for @NLexpression" begin
    # Taken from Juniper.jl
    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "minlp_solver" => JUNIPER,
        "nlp_solver" => IPOPT,
        "mip_solver" => HIGHS,
        "presolve_bt" => true,
    )

    m = Model(test_solver)
    @variable(m, 0 <= x <= 1)
    @variable(m, 0 <= z <= 1, Bin)
    b_expr = @NLexpression(m, z / 1)
    @NLconstraint(m, 1.1 >= b_expr)
    an_expr = @NLexpression(m, x / 1)
    @NLobjective(m, Max, z + an_expr)
    JuMP.optimize!(m)

    @test isapprox(JuMP.objective_value(m), 2.0; atol = 1E-6)
    @test isapprox(JuMP.value(z), 1; atol = 1e-6)
    @test isapprox(JuMP.value(x), 1; atol = 1e-6)
end

@testset "@NLexpression from quadratic @expression (Issue #221)" begin
    @testset "Unit tests for `expr_is_emptysum`" begin
        # Empty sum
        @test Alpine.expr_is_emptysum(:(+()))
        # Not empty sum zero int
        @test !Alpine.expr_is_emptysum(:(+(0, 0)))
        # Not empty sum zero float
        @test !Alpine.expr_is_emptysum(:(+(0.0, 0.0)))
        # Not empty sum int with zero
        @test !Alpine.expr_is_emptysum(:(+(1, 0)))
        # Not empty sum int
        @test !Alpine.expr_is_emptysum(:(+(1, 2)))
        # Not empty sum float with zero
        @test !Alpine.expr_is_emptysum(:(+(1.0, 0.0)))
        # Not empty sum float
        @test !Alpine.expr_is_emptysum(:(+(1.0, 3.0)))
        # Not empty sum of variables
        @test !Alpine.expr_is_emptysum(:(x + y))
        # Not empty sum of variable with int
        @test !Alpine.expr_is_emptysum(:(x + 1))
        # Not empty sum of variable with float
        @test !Alpine.expr_is_emptysum(:(x + 3.0))
        # Not empty expression with non-linear function evaluation
        @test !Alpine.expr_is_emptysum(:(sin(x)))
        # Not empty expression with anonimus function
        @test !Alpine.expr_is_emptysum(:(x -> log(x)))
        # Not empty expression with anonimus function
        @test !Alpine.expr_is_emptysum(:(x -> log(x)))
        # Not empty expression with empty sum
        @test !Alpine.expr_is_emptysum(:($(:(+())) + 1))
    end

    test_solver = JuMP.optimizer_with_attributes(
        Alpine.Optimizer,
        "nlp_solver" => IPOPT,
        "mip_solver" => PAVITO,
        "presolve_bt" => true,
        "apply_partitioning" => true,
    )

    m = JuMP.Model(test_solver)

    @variable(m, -2 ≤ x ≤ 2, start = 1)
    @expression(m, expr, x^2)
    @NLconstraint(m, expr >= 1)
    @NLconstraint(m, expr <= 2)
    @NLobjective(m, Min, x^3)

    JuMP.optimize!(m)
    @test JuMP.termination_status(m) == JuMP.MOI.OPTIMAL
    @test isapprox(JuMP.objective_value(m), -(sqrt(2))^3; atol = 1E-6)
    @test isapprox(JuMP.value(m[:x]), -sqrt(2); atol = 1E-6)
end

using Documenter, Alpine
using DocumenterTools: Themes

for w in ("light", "dark")
    header = read(joinpath(@__DIR__, "src/assets/themes/style.scss"), String)
    theme = read(joinpath(@__DIR__, "src/assets/themes/$(w)defs.scss"), String)
    write(joinpath(@__DIR__, "src/assets/themes/$(w).scss"), header * "\n" * theme)
end

Themes.compile(
    joinpath(@__DIR__, "src/assets/themes/documenter-light.css"),
    joinpath(@__DIR__, "src/assets/themes/light.scss"),
)
Themes.compile(
    joinpath(@__DIR__, "src/assets/themes/documenter-dark.css"),
    joinpath(@__DIR__, "src/assets/themes/dark.scss"),
)

makedocs(
    sitename = "Alpine",
    authors = "Harsha Nagarajan, Site Wang, Kaarthik Sundar and contributors",
    format = Documenter.HTML(
        mathengine = Documenter.MathJax(),
        prettyurls = get(ENV, "CI", nothing) == "true",
    ),
    # strict = true,
    pages = [
        "Introduction" => "index.md",
        "Choosing Sub-solvers" => "choosingsolver.md",
        # "Algorithm" => "algorithm.md",
        "Solver Options" => "parameters.md",
        "Methods" => "functions.md",
    ],
)

deploydocs(repo = "github.com/lanl-ansi/Alpine.jl.git", push_preview = true)

"""
    init_tight_bound(m::Optimizer)

Initialize internal bound vectors (placeholders) to be used in other places.
In this case, we don't have to mess with the original bound information.
"""
function init_tight_bound(m::Optimizer)
    m.l_var_tight = [
        m.l_var_orig
        fill(-Inf, m.num_var_linear_mip + m.num_var_nonlinear_mip)
    ]
    m.u_var_tight = [
        m.u_var_orig
        fill(Inf, m.num_var_linear_mip + m.num_var_nonlinear_mip)
    ]
    for i in 1:m.num_var_orig
        if m.var_type_orig[i] == :Bin
            m.l_var_tight[i] = 0.0
            m.u_var_tight[i] = 1.0
            # elseif m.var_type_orig[i] == :Int
            #     m.l_var_tight[i] = floor(m.l_var_tight[i])
            #     m.u_var_tight[i] = ceil(m.u_var_tight[i])
        end
    end

    return
end

"""
    init_disc(m::Optimizer)

This function initialize the dynamic discretization used for any bounding models. By default, it takes (.l_var_orig, .u_var_orig) as the base information. User is allowed to use alternative bounds for initializing the discretization dictionary.
The output is a dictionary with MathProgBase variable indices keys attached to the :Optimizer.discretization.
"""
function init_disc(m::Optimizer)
    for var in 1:(m.num_var_orig+m.num_var_linear_mip+m.num_var_nonlinear_mip)
        if m.var_type[var] in [:Bin, :Cont]
            lb = m.l_var_tight[var]
            ub = m.u_var_tight[var]
            m.discretization[var] = [lb, ub]
        else
            error(
                "[EXCEPTION] Unexpected variable type when initializing discretization dictionary.",
            )
        end
    end

    return
end

"""

    _get_discretization_dict(m::Optimizer, lbs::Vector{Float64}, ubs::Vector{Float64})

Utility functions to convert bounds vectors to Dictionary based structures that are more suitable for
partition operations.

"""
function _get_discretization_dict(
    m::Optimizer,
    lbs::Vector{Float64},
    ubs::Vector{Float64},
)
    @assert length(lbs) == length(ubs)

    var_discretization = Dict()
    total_var_cnt = m.num_var_orig + m.num_var_linear_mip + m.num_var_nonlinear_mip

    for var in 1:total_var_cnt
        if length(lbs) == total_var_cnt
            lb = lbs[var]
            ub = ubs[var]
        else
            lb = -Inf
            ub = Inf
        end
        var_discretization[var] = [lb, ub]
    end

    return var_discretization
end

"""
    flatten_discretization(discretization::Dict)

Utility functions to eliminate all partition on discretizing variable and keep the loose bounds.

"""
function flatten_discretization(discretization::Dict; kwargs...)
    flatten_discretization = Dict()
    for var in keys(discretization)
        flatten_discretization[var] = [discretization[var][1], discretization[var][end]]
    end

    return flatten_discretization
end

"""
    detect_bound_from_aff(m::Optimizer)

Detect bounds from parse affine constraint. This function examines the one variable constraints such as
x >= 5, x <= 5 or x == 5 and fetch the information to m.l_var_tight and m.u_var_tight.
"""
function bound_propagation(m::Optimizer)
    exhausted = false
    infeasible = false
    tol = get_option(m, :tol)

    while !exhausted
        exhausted = true
        for aff in m.bounding_constr_mip
            for i in 1:length(aff[:vars])
                var_idx = aff[:vars][i].args[2]
                var_coef = aff[:coefs][i]
                @assert (isa(var_idx, Float64) || isa(var_idx, Int))

                if aff[:sense] == :(==) && var_coef > 0.0
                    eval_l_bound = aff[:rhs] / var_coef
                    eval_u_bound = aff[:rhs] / var_coef
                    for j in 1:length(aff[:vars])
                        if j != i && aff[:coefs][j] * var_coef > 0.0     # same sign
                            (eval_l_bound != -Inf) && (
                                eval_l_bound -=
                                    abs(aff[:coefs][j] / var_coef) *
                                    m.u_var_tight[aff[:vars][j].args[2]]
                            )
                            (eval_u_bound != Inf) && (
                                eval_u_bound -=
                                    abs(aff[:coefs][j] / var_coef) *
                                    m.l_var_tight[aff[:vars][j].args[2]]
                            )
                        elseif j != i && aff[:coefs][j] * var_coef < 0.0  # different sign
                            (eval_l_bound != -Inf) && (
                                eval_l_bound +=
                                    abs(aff[:coefs][j] / var_coef) *
                                    m.l_var_tight[aff[:vars][j].args[2]]
                            )
                            (eval_u_bound != Inf) && (
                                eval_u_bound +=
                                    abs(aff[:coefs][j] / var_coef) *
                                    m.u_var_tight[aff[:vars][j].args[2]]
                            )
                        end
                    end

                    if eval_l_bound > m.l_var_tight[var_idx] + tol
                        exhausted = false
                        m.l_var_tight[var_idx] = eval_l_bound
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] LB $(m.l_var_tight[var_idx]) evaluated from constraint",
                        )
                    elseif eval_l_bound > m.u_var_tight[var_idx] + tol
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] Infeasibility detection during bound propagation",
                        )
                        infeasible = true
                        break
                    end

                    if eval_u_bound < m.u_var_tight[var_idx] - tol
                        exhausted = false
                        m.u_var_tight[var_idx] = eval_u_bound
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] UB $(m.u_var_tight[var_idx]) evaluated from constraints",
                        )
                    elseif eval_u_bound < m.l_var_tight[var_idx] - tol
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] Infeasibility detection during bound propagation",
                        )
                        infeasible = true
                        break
                    end

                elseif aff[:sense] == :(>=) && var_coef > 0.0  # a($) - by + cz >= 100, y∈[1,10], z∈[2,50], a,b,c > 0
                    eval_bound = aff[:rhs] / var_coef
                    for j in 1:length(aff[:vars])
                        if j != i && aff[:coefs][j] > 0.0
                            eval_bound -=
                                abs(aff[:coefs][j] / var_coef) *
                                m.u_var_tight[aff[:vars][j].args[2]]
                        elseif j != i
                            aff[:coefs][j] < 0.0
                            eval_bound +=
                                abs(aff[:coefs][j] / var_coef) *
                                m.l_var_tight[aff[:vars][j].args[2]]
                        end
                        (eval_bound == -Inf) && break
                    end

                    if eval_bound > m.l_var_tight[var_idx] + tol
                        exhausted = false
                        m.l_var_tight[var_idx] = eval_bound
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] LB $(m.l_var_tight[var_idx]) evaluated from constraints",
                        )
                    elseif eval_bound > m.u_var_tight[var_idx] + tol
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] Infeasibility detection during bound propagation",
                        )
                        infeasible = true
                        break
                    end

                elseif aff[:sense] == :(>=) && var_coef < 0.0  # -a($) - by + cz >= 100, y∈[1,10], z∈[2,50], a,b,c > 0
                    eval_bound = aff[:rhs] / var_coef
                    for j in 1:length(aff[:vars])
                        if j != i && aff[:coefs][j] > 0.0
                            eval_bound +=
                                abs(aff[:coefs][j] / var_coef) *
                                m.u_var_tight[aff[:vars][j].args[2]]
                        elseif j != i && aff[:coefs][j] < 0.0
                            eval_bound -=
                                abs(aff[:coefs][j] / var_coef) *
                                m.l_var_tight[aff[:vars][j].args[2]]
                        end
                        (eval_bound == Inf) && break
                    end

                    if eval_bound < m.u_var_tight[var_idx] - tol
                        exhausted = false
                        m.u_var_tight[var_idx] = eval_bound
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] UB $(m.u_var_tight[var_idx]) evaluated from constraints",
                        )
                    elseif eval_bound < m.l_var_tight[var_idx] - tol
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] Infeasibility detection during bound propagation",
                        )
                        infeasible = true
                        break
                    end

                elseif (aff[:sense] == :(<=) && aff[:coefs][i] > 0.0) # a($) - by + cz <= 100, y∈[1,10], z∈[2,50], a,b,c > 0
                    eval_bound = aff[:rhs] / var_coef
                    for j in 1:length(aff[:vars])
                        if j != i && aff[:coefs][j] > 0.0
                            eval_bound -=
                                abs(aff[:coefs][j] / var_coef) *
                                m.l_var_tight[aff[:vars][j].args[2]]
                        elseif j != i && aff[:coefs][j] < 0.0
                            eval_bound +=
                                abs(aff[:coefs][j] / var_coef) *
                                m.u_var_tight[aff[:vars][j].args[2]]
                        end
                        (eval_bound == Inf) && break
                    end

                    if eval_bound < m.u_var_tight[var_idx] - tol
                        exhausted = false
                        m.u_var_tight[var_idx] = eval_bound
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] UB $(m.u_var_tight[var_idx]) evaluated from constraints",
                        )
                    elseif eval_bound < m.l_var_tight[var_idx] - tol
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] Infeasibility detection during bound propagation",
                        )
                        infeasible = true
                        break
                    end
                elseif (aff[:sense] == :(<=) && aff[:coefs][i] < 0.0) # -a($) - by + cz <= 100, y∈[1,10], z∈[2,50], a,b,c > 0
                    eval_bound = aff[:rhs] / var_coef
                    for j in 1:length(aff[:vars])
                        if j != i && aff[:coefs][j] > 0.0
                            eval_bound +=
                                abs(aff[:coefs][j] / var_coef) *
                                m.l_var_tight[aff[:vars][j].args[2]]
                        elseif j != i && aff[:coefs][j] < 0.0
                            eval_bound -=
                                abs(aff[:coefs][j] / var_coef) *
                                m.u_var_tight[aff[:vars][j].args[2]]
                        end
                        (eval_bound == -Inf) && break
                    end

                    if eval_bound > m.l_var_tight[var_idx] + tol
                        exhausted = false
                        m.l_var_tight[var_idx] = eval_bound
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] LB $(m.l_var_tight[var_idx]) evaluated from constraints",
                        )
                    elseif eval_bound > m.u_var_tight[var_idx] + tol
                        (get_option(m, :log_level) > 199) && println(
                            "[VAR$(var_idx)] Infeasibility detection during bound propagation",
                        )
                        infeasible = true
                        break
                    end
                end
            end
        end
        (exhausted == true && get_option(m, :log_level) > 99) &&
            println("Initial constraint-based bound evaluation exhausted...")
    end

    if infeasible
        m.status[:bounding_solve] = MOI.INFEASIBLE
        @warn "[INFEASIBLE] Infeasibility detected via bound propagation"
    end

    return infeasible
end

"""
    Recategorize :Int variables to :Bin variables if variable bounds are [0,1]
"""
function recategorize_var(m::Optimizer)
    for i in 1:m.num_var_orig
        if m.var_type_orig[i] == :Int && m.l_var_orig[i] == 0.0 && m.u_var_orig[i] == 1.0
            m.var_type_orig[i] = :Bin
            m.var_type[i] = :Bin
        end
    end

    return
end

"""
    resolve_var_bounds(m::Optimizer)

Resolve the bounds of the lifted variable using the information in l_var_tight and u_var_tight. This method only takes
in known or trivial bounds information to deduce lifted variable bounds and to potentially avoid the cases of infinity bounds.
"""
function resolve_var_bounds(m::Optimizer)

    # Basic Bound propagation
    if get_option(m, :presolve_bp)
        setproperty!(m, :presolve_infeasible, bound_propagation(m)) # Fetch bounds from constraints
    end

    # Resolve unbounded variables in the original formulation
    resolve_inf_bounds(m)

    # Added sequential bound resolving process base on DFS process, which ensures all bounds are secured.
    # Increased complexity from linear to square but a reasonable amount
    # Potentially, additional mapping can be applied to reduce the complexity
    for i in 1:length(m.term_seq)
        k = m.term_seq[i]
        if haskey(m.nonconvex_terms, k)
            m.nonconvex_terms[k][:bound_resolver](m, k)
        elseif haskey(m.linear_terms, k)
            basic_linear_bounds(m, k)
        else
            error("Found homeless term key $(k) during bound resolution.")
        end
    end

    return
end

"""
    Resolving Inf variable bounds since Alpine relies on finite bounds to construct relaxations
"""
function resolve_inf_bounds(m::Optimizer)
    warnuser = false
    infcount_l = 0
    infcount_u = 0

    # Only specify necessary bounds
    for i in 1:length(m.l_var_orig)
        if m.l_var_tight[i] == -Inf
            warnuser = true
            m.l_var_tight[i] = -get_option(m, :large_bound)
            infcount_l += 1
        end
        if m.u_var_tight[i] == Inf
            warnuser = true
            m.u_var_tight[i] = get_option(m, :large_bound)
            infcount_u += 1
        end
    end
    infcount = min(infcount_l, infcount_u)
    if infcount == 1
        warnuser && println(
            "Warning: -/+Inf bounds detected on at least $infcount variable. Initializing with values -/+$(get_option(m, :large_bound)). This may affect global optimal values and run times.",
        )
    elseif infcount > 1
        warnuser && println(
            "Warning: -/+Inf bounds detected on at least $infcount variables. Initializing with values -/+$(get_option(m, :large_bound)). This may affect global optimal values and run times.",
        )
    end

    return
end

"""
    resolve_var_bounds(nonconvex_terms::Dict, discretization::Dict)

    For discretization to be performed, we do not allow a variable being discretized to have infinite bounds.
    The lifted/auxiliary variables may have infinite bounds and the function infers bounds on these variables. This process
    can help speed up the subsequent solve times.

    Only used in presolve bound tightening
"""
function resolve_var_bounds(m::Optimizer, d::Dict; kwargs...)
    # Added sequential bound resolving process base on DFS process, which ensures all bounds are accurate.
    # Potentially, additional mapping can be applied to reduce the complexity
    for i in 1:length(m.term_seq)
        k = m.term_seq[i]
        if haskey(m.nonconvex_terms, k)
            nlk = k
            if m.nonconvex_terms[nlk][:nonlinear_type] in ALPINE_C_MONOMIAL
                d = basic_monomial_bounds(m, nlk, d)
            elseif m.nonconvex_terms[nlk][:nonlinear_type] in [:BINPROD]
                d = basic_binprod_bounds(m, nlk, d)
            elseif m.nonconvex_terms[nlk][:nonlinear_type] in [:BINLIN]
                d = basic_binlin_bounds(m, nlk, d)
            else
                error("EXPECTED ERROR : NEED IMPLEMENTATION")
            end
        elseif haskey(m.linear_terms, k)
            d = basic_linear_bounds(m, k, d)
        else
            error(
                "Found a homeless term key $(k) during bound resolution im resolve_var_bounds.",
            )
        end
    end

    return d
end

"""
    update_var_bounds(m::Optimizer, discretization::Dict; len::Float64=length(keys(discretization)))

This function takes in a dictionary-based discretization information and convert them into two bounds vectors (l_var, u_var) by picking the smallest and largest numbers. User can specify a certain length that may contains variables that is out of the scope of discretization.

Output::

    l_var::Vector{Float64}, u_var::Vector{Float64}
"""
function update_var_bounds(discretization::Dict{Any,Any}; kwargs...)
    options = Dict(kwargs)

    haskey(options, :len) ? len = options[:len] : len = length(keys(discretization))

    l_var = fill(-Inf, len)
    u_var = fill(Inf, len)

    for var_idx in keys(discretization)
        l_var[var_idx] = discretization[var_idx][1]
        u_var[var_idx] = discretization[var_idx][end]
    end

    return l_var, u_var
end

# ================================================================= unused, but needs testing
# """
#     resolve_closed_var_bounds(m::Optimizer)

# This function seeks variable with tight bounds (by presolve_bt_width_tol) by checking .l_var_tight and .u_var_tight.
# If a variable is found to be within a sufficiently small interval then no discretization will be performed on this variable
# and the .discretization will be cleared with the tight bounds for basic McCormick operation if necessary.

# """
# function resolve_closed_var_bounds(m::Optimizer; kwargs...)
#     for var in m.candidate_disc_vars
#         if abs(m.l_var_tight[var] - m.u_var_tight[var]) <
#            get_option(m, :presolve_bt_width_tol)         # Closed Bound Criteria
#             deleteat!(m.disc_vars, findfirst(m.disc_vars, var)) # Clean nonconvex_terms by deleting the info
#             m.discretization[var] = [m.l_var_tight[var], m.u_var_tight[var]]              # Clean up the discretization for basic McCormick if necessary
#         end
#     end

#     return
# end

"""
    create_bounding_mip(m::Optimizer; use_disc = nothing)

Set up a MILP bounding model base on variable domain partitioning information stored in `use_disc`.
By default, if `use_disc` is not provided, it will use `m.discretizations` store in the Alpine model.
The basic idea of this MILP bounding model is to use piecewise polyhedral/convex relaxations to tighten the
basic relaxations of the original non-convex region. Among all presented partitions, the bounding model
will choose one specific partition as the lower bound solution. The more partitions there are, the
better or finer bounding model relax the original MINLP while the more efforts required to solve
this MILP is required.
"""
function create_bounding_mip(m::Optimizer; use_disc = nothing)
    if (use_disc === nothing)
        if (m.logs[:n_iter] == 1) &&
           (m.status[:local_solve] in union(STATUS_OPT, STATUS_LIMIT, STATUS_WARM_START))
            # Setting up an initial partition
            add_partition(m, use_solution = m.best_sol)
        elseif m.logs[:n_iter] >= 2
            # Add subsequent iteration partitions
            add_partition(m)
        end
        discretization = m.discretization
    else
        discretization = use_disc
    end

    m.model_mip = JuMP.Model(get_option(m, :mip_solver)) # Construct JuMP Model
    start_build = time()
    # ------- Model Construction ------ #
    amp_post_vars(m)                                                # Post original and lifted variables
    amp_post_lifted_constraints(m)                                  # Post original and lifted constraints
    amp_post_lifted_objective(m)                                    # Post original and/or objective
    amp_post_convexification(m, use_disc = discretization)          # Post convexification constraints
    # --------------------------------- #
    cputime_build = time() - start_build
    m.logs[:total_time] += cputime_build
    m.logs[:time_left] = max(0.0, get_option(m, :time_limit) - m.logs[:total_time])

    return
end

"""
    amp_post_convexification(m::Optimizer; use_disc = nothing)

Wrapper function to apply piecewise convexification of the problem for the bounding MIP model. This function talks to nonconvex_terms and convexification methods
to finish the last step required during the construction of bounding model.
"""
function amp_post_convexification(m::Optimizer; use_disc = nothing)
    use_disc === nothing ? discretization = m.discretization : discretization = use_disc

    amp_post_convhull(m, use_disc = discretization)  # convex hull representation
    _is_fully_convexified(m) # Ensure if all the non-linear terms are convexified

    return
end

function amp_post_vars(m::Optimizer; kwargs...)
    options = Dict(kwargs)

    if haskey(options, :use_disc)
        l_var = [
            options[:use_disc][i][1] for
            i in 1:(m.num_var_orig+m.num_var_linear_mip+m.num_var_nonlinear_mip)
        ]
        u_var = [
            options[:use_disc][i][end] for
            i in 1:(m.num_var_orig+m.num_var_linear_mip+m.num_var_nonlinear_mip)
        ]
    else
        l_var = m.l_var_tight
        u_var = m.u_var_tight
    end

    JuMP.@variable(
        m.model_mip,
        x[i = 1:(m.num_var_orig+m.num_var_linear_mip+m.num_var_nonlinear_mip)]
    )

    for i in 1:(m.num_var_orig+m.num_var_linear_mip+m.num_var_nonlinear_mip)
        # Interestingly, not enforcing category of lifted variables is able to improve performance
        if i <= m.num_var_orig
            if m.var_type_orig[i] == :Bin
                set_binary(x[i])
            elseif m.var_type_orig[i] == :Int
                set_integer(x[i])
            end
        end
        # Changed to tight bound, if no bound tightening is performed, will be just .l_var_orig
        l_var[i] > -Inf && JuMP.set_lower_bound(x[i], l_var[i])
        # Changed to tight bound, if no bound tightening is performed, will be just .u_var_orig
        u_var[i] < Inf && JuMP.set_upper_bound(x[i], u_var[i])

        m.var_type[i] == :Int && error(
            "Alpine does not support MINLPs with generic integer (non-binary) variables yet! Try Juniper.jl for finding a local feasible solution",
        )
    end

    return
end

function amp_post_lifted_constraints(m::Optimizer)
    for i in 1:m.num_constr_orig
        if m.constr_structure[i] == :affine
            amp_post_affine_constraint(m.model_mip, m.bounding_constr_mip[i])
        elseif m.constr_structure[i] == :convex
            amp_post_convex_constraint(m.model_mip, m.bounding_constr_mip[i])
        else
            error("Unknown constr_structure type $(m.constr_structure[i])")
        end
    end

    for i in keys(m.linear_terms)
        amp_post_linear_lift_constraints(m.model_mip, m.linear_terms[i])
    end

    return
end

function amp_post_affine_constraint(model_mip::JuMP.Model, affine::Dict)
    if affine[:sense] == :(>=)
        JuMP.@constraint(
            model_mip,
            sum(
                affine[:coefs][j] *
                _index_to_variable_ref(model_mip, affine[:vars][j].args[2]) for
                j in 1:affine[:cnt]
            ) >= affine[:rhs]
        )
    elseif affine[:sense] == :(<=)
        JuMP.@constraint(
            model_mip,
            sum(
                affine[:coefs][j] *
                _index_to_variable_ref(model_mip, affine[:vars][j].args[2]) for
                j in 1:affine[:cnt]
            ) <= affine[:rhs]
        )
    elseif affine[:sense] == :(==)
        JuMP.@constraint(
            model_mip,
            sum(
                affine[:coefs][j] *
                _index_to_variable_ref(model_mip, affine[:vars][j].args[2]) for
                j in 1:affine[:cnt]
            ) == affine[:rhs]
        )
    else
        error("Unkown sense.")
    end

    return
end

function amp_post_convex_constraint(model_mip::JuMP.Model, convex::Dict)
    !prod([i == 2 for i in convex[:powers]]) && error("No relaxation implementation for convex constraints $(convex[:expr])")

    if convex[:sense] == :(<=)
        JuMP.@constraint(
            model_mip,
            sum(
                convex[:coefs][j] *
                _index_to_variable_ref(model_mip, convex[:vars][j].args[2])^2 for
                j in 1:convex[:cnt]
            ) <= convex[:rhs]
        )
    elseif convex[:sense] == :(>=)
        JuMP.@constraint(
            model_mip,
            sum(
                convex[:coefs][j] *
                _index_to_variable_ref(model_mip, convex[:vars][j].args[2])^2 for
                j in 1:convex[:cnt]
            ) >= convex[:rhs]
        )
    else
        error(
            "No equality constraints should be recognized as supported convex constriants",
        )
    end

    return
end

function amp_post_linear_lift_constraints(model_mip::JuMP.Model, l::Dict)
    @assert l[:ref][:sign] == :+
    JuMP.@constraint(
        model_mip,
        _index_to_variable_ref(model_mip, l[:y_idx]) ==
        sum(i[1] * _index_to_variable_ref(model_mip, i[2]) for i in l[:ref][:coef_var]) +
        l[:ref][:scalar]
    )
    return
end

function amp_post_lifted_objective(m::Optimizer)

    #if isa(m.obj_expr_orig, Number)
    if m.obj_expr_orig == :(+())
        JuMP.@objective(m.model_mip, m.sense_orig, 0.0)
    elseif expr_isconst(m.obj_expr_orig)
        # This eval is okay because expr_isconst is true
        JuMP.@objective(m.model_mip, m.sense_orig, eval(m.obj_expr_orig))
    elseif m.obj_structure == :affine
        JuMP.@objective(
            m.model_mip,
            m.sense_orig,
            m.bounding_obj_mip[:rhs] + sum(
                m.bounding_obj_mip[:coefs][i] *
                _index_to_variable_ref(m.model_mip, m.bounding_obj_mip[:vars][i].args[2])
                for i in 1:m.bounding_obj_mip[:cnt]
            )
        )
    elseif m.obj_structure == :convex
        # This works only when the original objective is convex quadratic.
        # Higher-order convex monomials need implementation of outer-approximation (check resolve_convex_constr in operators.jl)
        JuMP.@objective(
            m.model_mip,
            m.sense_orig,
            m.bounding_obj_mip[:rhs] + sum(
                m.bounding_obj_mip[:coefs][i] *
                _index_to_variable_ref(
                    m.model_mip,
                    m.bounding_obj_mip[:vars][i].args[2],
                )^2 for i in 1:m.bounding_obj_mip[:cnt]
            )
        )
    else
        error("Unknown structural obj type $(m.obj_structure)")
    end
    return
end

function add_partition(m::Optimizer; kwargs...)
    options = Dict(kwargs)
    haskey(options, :use_disc) ? discretization = options[:use_disc] :
    discretization = m.discretization
    haskey(options, :use_solution) ? point_vec = options[:use_solution] :
    point_vec = m.best_bound_sol

    if isa(get_option(m, :disc_add_partition_method), Function)
        m.discretization = get_option(m, :disc_add_partition_method)(
            m,
            use_disc = discretization,
            use_solution = point_vec,
        )
    elseif get_option(m, :disc_add_partition_method) == "adaptive"
        m.discretization =
            add_adaptive_partition(m, use_disc = discretization, use_solution = point_vec)
    elseif get_option(m, :disc_add_partition_method) == "uniform"
        m.discretization = add_uniform_partition(m, use_disc = discretization)
    else
        error("Unknown input on how to add partitions.")
    end

    return
end

# TODO: also need to document the special diverted cases when new partition touches both corners
"""

    add_adaptive_partition(m::Optimizer; use_disc::Dict, use_solution::Vector)

A built-in method used to add a new partition on feasible domains of variables chosen for partitioning.

This can be illustrated by the following example. Let the previous iteration's partition vector on
variable "x" be given by [0, 3, 7, 9]. And say, the lower bounding solution has a value of 4 for variable "x".
In the case when `partition_scaling_factor = 4`, this function creates the new partition vector as follows: [0, 3, 3.5, 4, 4.5, 7, 9]

There are two options for this function,

    * `use_disc(default=m.discretization)`:: to regulate which is the base to add new partitions on
    * `use_solution(default=m.best_bound_sol)`:: to regulate which solution to use when adding new partitions on

This function can be accordingly modified by the user to change the behavior of the solver, and thus the convergence.

"""
function add_adaptive_partition(m::Optimizer; kwargs...)
    options = Dict(kwargs)

    haskey(options, :use_disc) ? discretization = options[:use_disc] :
    discretization = m.discretization
    haskey(options, :use_solution) ? point_vec = copy(options[:use_solution]) :
    point_vec = copy(m.best_bound_sol)
    haskey(options, :use_ratio) ? ratio = options[:use_ratio] :
    ratio = get_option(m, :partition_scaling_factor)
    haskey(options, :branching) ? branching = options[:branching] : branching = false

    if length(point_vec) < m.num_var_orig + m.num_var_linear_mip + m.num_var_nonlinear_mip
        point_vec = resolve_lifted_var_value(m, point_vec)  # Update the solution vector for lifted variable
    end

    if branching
        discretization = deepcopy(discretization)
    end

    processed = Set{Int}()

    # Perform discretization based on type of nonlinear terms #
    for i in m.disc_vars
        point = point_vec[i]                # Original Variable
        λCnt = length(discretization[i])

        # Built-in method based-on variable type
        if m.var_type[i] == :Cont
            i in processed && continue
            point = correct_point(m, discretization[i], point, i)
            for j in 1:λCnt
                if point >= discretization[i][j] && point <= discretization[i][j+1]  # Locating the right location
                    radius = calculate_radius(discretization[i], j, ratio)
                    insert_partition_helper(m, i, j, point, radius, discretization[i])
                    push!(processed, i)
                    break
                end
            end
        elseif m.var_type[i] == :Bin # This should never happen
            @warn "  Warning: Binary variable in m.disc_vars. Check out what is wrong..."
            continue  # No partition should be added to binary variable unless user specified
        elseif m.var_type[i] == :Int
            error(
                "Alpine does not support MINLPs with generic integer (non-binary) variables yet!",
            )
        else
            error("Unexpected variable types while inserting partitions")
        end
    end

    return discretization
end

"""
    This function targets to address unexpected numerical issues when adding partitions in tight regions.
"""
function correct_point(m::Optimizer, partvec::Vector, point::Float64, var::Int)
    tol = get_option(m, :tol)

    if point < partvec[1] - tol || point > partvec[end] + tol
        @warn "  Warning: VAR$(var) SOL=$(point) out of discretization [$(partvec[1]),$(partvec[end])]. Hence, taking the middle point."
        return 0.5 * (partvec[1] + partvec[end]) # Should choose the longest range
    end

    isapprox(point, partvec[1]; atol = tol) && return partvec[1]
    isapprox(point, partvec[end]; atol = tol) && return partvec[end]

    return point
end

function calculate_radius(partvec::Vector, part::Int, ratio::Any)
    lb_local = partvec[part]
    ub_local = partvec[part+1]

    distance = ub_local - lb_local
    if isa(ratio, Float64) || isa(ratio, Int)
        radius = distance / ratio
    elseif isa(ratio, Function)
        radius = distance / ratio(m)
    else
        error("Undetermined partition scaling factor")
    end

    return radius
end

function insert_partition_helper(
    m::Optimizer,
    var::Int,
    partidx::Int,
    point::Number,
    radius::Float64,
    partvec::Vector,
)
    abstol, reltol =
        get_option(m, :disc_abs_width_tol), get_option(m, :disc_rel_width_tol)

    lb_local, ub_local = partvec[partidx], partvec[partidx+1]
    ub_touch, lb_touch = true, true
    lb_new, ub_new = max(point - radius, lb_local), min(point + radius, ub_local)

    if ub_new < ub_local &&
       !isapprox(ub_new, ub_local; atol = abstol) &&
       abs(ub_new - ub_local) / (1e-8 + abs(ub_local)) > reltol # Insert new UB-based partition
        insert!(partvec, partidx + 1, ub_new)
        ub_touch = false
    end

    if lb_new > lb_local &&
       !isapprox(lb_new, lb_local; atol = abstol) &&
       abs(lb_new - lb_local) / (1e-8 + abs(lb_local)) > reltol # Insert new LB-based partition
        insert!(partvec, partidx + 1, lb_new)
        lb_touch = false
    end

    if (ub_touch && lb_touch) || check_solution_history(m, var)
        distvec = [(j, partvec[j+1] - partvec[j]) for j in 1:length(partvec)-1]
        sort!(distvec, by = x -> x[2])
        point_orig = point
        pos = distvec[end][1]
        lb_local = partvec[pos]
        ub_local = partvec[pos+1]
        isapprox(lb_local, ub_local; atol = get_option(m, :tol)) && return
        chunk = (ub_local - lb_local) / get_option(m, :disc_divert_chunks)
        point = lb_local + (ub_local - lb_local) / get_option(m, :disc_divert_chunks)
        for i in 2:get_option(m, :disc_divert_chunks)
            insert!(
                partvec,
                pos + 1,
                lb_local + chunk * (get_option(m, :disc_divert_chunks) - (i - 1)),
            )
        end
        (get_option(m, :log_level) > 199) && println(
            "[DEBUG] !D! VAR$(var): SOL=$(round(point_orig; digits = 4))=>$(point) |$(round(lb_local; digits = 4)) | $(get_option(m, :disc_divert_chunks)) SEGMENTS | $(round(ub_local; digits = 4))|",
        )
    else
        (get_option(m, :log_level) > 199) && println(
            "[DEBUG] VAR$(var): SOL=$(round(point; digits = 4)) RADIUS=$(radius), PARTITIONS=$(length(partvec)-1) |$(round(lb_local; digits = 4)) |$(round(lb_new; digits = 6)) <- * -> $(round(ub_new; digits = 6))| $(round(ub_local; digits = 4))|",
        )
    end

    return
end

function add_uniform_partition(m::Optimizer; kwargs...)
    options = Dict(kwargs)
    haskey(options, :use_disc) ? discretization = options[:use_disc] :
    discretization = m.discretization

    for i in m.disc_vars  # Only construct when discretized
        lb_local = discretization[i][1]
        ub_local = discretization[i][end]
        distance = ub_local - lb_local
        # chunk = distance / ((m.logs[:n_iter] + 1) * get_option(m, :disc_uniform_rate))
        chunk = distance / (m.logs[:n_iter] * get_option(m, :disc_uniform_rate))
        discretization[i] = [
            lb_local + chunk * (j - 1) for
            j in 1:(m.logs[:n_iter])*get_option(m, :disc_uniform_rate)
        ]
        push!(discretization[i], ub_local)   # Safety Scheme
    end

    return discretization
end

function update_partition_scaling_factor(m::Optimizer, presolve = false)
    m.logs[:n_iter] > 2 && return get_option(m, :partition_scaling_factor) # Stop branching after the second iterations

    ratio_pool = [8:2:20;]  # Built-in try range
    incumb_ratio = ratio_pool[1]
    is_min_sense(m) ? incumb_res = -Inf : incumb_res = Inf
    res_collector = Float64[]

    for r in ratio_pool
        st = time()
        if !isempty(m.best_sol)
            branch_disc = add_adaptive_partition(
                m,
                use_disc = m.discretization,
                branching = true,
                use_ratio = r,
                use_solution = m.best_sol,
            )
        else
            branch_disc = add_adaptive_partition(
                m,
                use_disc = m.discretization,
                branching = true,
                use_ratio = r,
            )
        end
        create_bounding_mip(m, use_disc = branch_disc)
        res = disc_branch_solve(m)
        push!(res_collector, res)
        if m.sense_orig == MOI.MAX_SENSE ? res < incumb_res : res > incumb_res
            incumb_res = res
            incumb_ratio = r
        end
        et = time() - st
        if et > 300  # 5 minutes limitation
            println("Expensive disc branching pass... Fixed at 8")
            return 8
        end
        get_option(m, :log_level) > 0 &&
            println("BRANCH RATIO = $(r), METRIC = $(res) || TIME = $(time()-st)")
    end

    if Statistics.std(res_collector) >= 1e-2    # Detect if all solutions are similar to each other
        get_option(m, :log_level) > 0 &&
            println("RATIO BRANCHING OFF due to solution variance test passed.")
        set_option(m, :partition_scaling_factor_branch, false) # If an incumbent ratio is selected, then stop the branching scheme
    end

    if !isempty(m.best_sol)
        m.discretization = add_adaptive_partition(
            m,
            use_disc = m.discretization,
            branching = true,
            use_ratio = incumb_ratio,
            use_solution = m.best_sol,
        )
    else
        m.discretization = add_adaptive_partition(
            m,
            use_disc = m.discretization,
            branching = true,
            use_ratio = incumb_ratio,
        )
    end

    get_option(m, :log_level) > 0 && println("INCUMB_RATIO = $(incumb_ratio)")

    return incumb_ratio
end

function disc_branch_solve(m::Optimizer)

    # ================= Solve Start ================ #
    set_mip_time_limit(m)
    start_bounding_solve = time()
    JuMP.optimize!(m.model_mip)
    status = MOI.get(m.model_mip, MOI.TerminationStatus())
    cputime_branch_bounding_solve = time() - start_bounding_solve
    m.logs[:total_time] += cputime_branch_bounding_solve
    m.logs[:time_left] = max(0.0, get_option(m, :time_limit) - m.logs[:total_time])
    # ================= Solve End ================ #

    if status in STATUS_OPT || status in STATUS_LIMIT
        return MOI.get(m.model_mip, MOI.ObjectiveBound())
    else
        @warn "  Warning: Unexpected solving condition $(status) during disc branching."
    end

    # Safety scheme
    if is_min_sense(m)
        return -Inf
    elseif is_max_sense(m)
        return Inf
    end
end

"""
    relaxation_bilinear(
    m::JuMP.Model, 
    z::JuMP.VariableRef, 
    x::JuMP.VariableRef, 
    y::JuMP.VariableRef, 
    lb_x::Number,
    ub_x::Number,
    lb_y::Number,
    ub_y::Number)

General relaxation of a binlinear term (McCormick relaxation). 
```
z >= JuMP.lower_bound(x)*y + JuMP.lower_bound(y)*x - JuMP.lower_bound(x)*JuMP.lower_bound(y)
z >= JuMP.upper_bound(x)*y + JuMP.upper_bound(y)*x - JuMP.upper_bound(x)*JuMP.upper_bound(y)
z <= JuMP.lower_bound(x)*y + JuMP.upper_bound(y)*x - JuMP.lower_bound(x)*JuMP.upper_bound(y)
z <= JuMP.upper_bound(x)*y + JuMP.lower_bound(y)*x - JuMP.upper_bound(x)*JuMP.lower_bound(y)
```
"""
function relaxation_bilinear(
    m::JuMP.Model,
    z::JuMP.VariableRef,
    x::JuMP.VariableRef,
    y::JuMP.VariableRef,
    lb_x::Number,
    ub_x::Number,
    lb_y::Number,
    ub_y::Number,
)
    JuMP.@constraint(m, z >= lb_x * y + lb_y * x - lb_x * lb_y)
    JuMP.@constraint(m, z >= ub_x * y + ub_y * x - ub_x * ub_y)
    JuMP.@constraint(m, z <= lb_x * y + ub_y * x - lb_x * ub_y)
    JuMP.@constraint(m, z <= ub_x * y + lb_y * x - ub_x * lb_y)

    return
end

"""
    relaxation_multilinear_binary(
    m::JuMP.Model, 
    z::JuMP.VariableRef, 
    x::Vector{VariableRef})

Applies Fortet linearization (see https://doi.org/10.1007/s10288-006-0015-3) for z = prod(x), 
where x is a vector of binary variables.
"""
function relaxation_multilinear_binary(
    m::JuMP.Model,
    z::JuMP.VariableRef,
    x::Vector{VariableRef},
)
    for i in x
        JuMP.@constraint(m, z <= i)
    end
    JuMP.@constraint(m, z >= sum(x) - (length(x) - 1))

    return
end

#=
"""
    relaxation_quadratic_univariate(
        m::JuMP.Model,
        z::JuMP.VariableRef,
        x::JuMP.VariableRef,
        lb_x::Number,
        ub_x::Number,
    )

Applies convex hull relaxation for z = x^2, where x is a variable.
"""
function relaxation_quadratic_univariate(
    m::JuMP.Model,
    z::JuMP.VariableRef,
    x::JuMP.VariableRef,
    lb_x::Number,
    ub_x::Number,
)
    JuMP.@constraint(m, z >= x^2)
    JuMP.@constraint(m, z <= (lb_x + ub_x) * x - (lb_x * ub_x))

    return
end
=#

"""
    bound_tightening_wrapper(m::Optimizer)

Entry point to the optimization-based bound-tightening (OBBT) algorithm. The aim of the OBBT algorithm
is to sequentially tighten the variable bounds until a fixed point is reached.

Currently, two OBBT methods are implemented in [`optimization_based_bound_tightening`](@ref).

    * Bound-tightening with polyhedral relaxations (McCormick, Lambda for convex-hull)
    * Bound-tightening with piecewise polyhedral relaxations: (with three partitions around the local feasible solution)
If no local feasible solution is obtained, the algorithm defaults to OBBT without partitions
"""
function bound_tightening_wrapper(m::Optimizer; use_bound = true, kwargs...)
    get_option(m, :presolve_bt) || return

    if get_option(m, :presolve_bt_algo) == 1
        optimization_based_bound_tightening(m, use_bound = use_bound)
    elseif get_option(m, :presolve_bt_algo) == 2
        optimization_based_bound_tightening(m, use_bound = use_bound, use_tmc = true)
    elseif isa(get_option(m, :presolve_bt_algo), Function)
        get_option(m, :presolve_bt_algo)(m)
    else
        error("Unrecognized bound tightening algorithm")
    end

    return
end

"""
    optimization_based_bound_tightening(m:Optimizer; use_bound::Bool=true, use_tmc::Bool)

This function implements the OBBT algorithm to tighten the variable bounds.
It utilizes either the basic polyhedral relaxations or the piecewise polyhedral relaxations (TMC)
to tighten the bounds. The TMC has additional binary variables while performing OBBT.

The algorithm as two main parameters. The first is the `use_tmc`, which when set to `true`
invokes the algorithm on the TMC relaxation. The second parameter `use_bound` takes in the
objective value of the local solve solution stored in `best_sol` for performing OBBT. The `use_bound` option is set
to `true` when the local solve is successful in obtaining a feasible solution, else this parameter
is set to `false`.

For details, refer to section 3.1.1 of
Nagarajan, Lu, Wang, Bent, Sundar, "An adaptive, multivariate partitioning algorithm for global optimization of nonconvex programs"
[link](https://doi.org/10.1007/s10898-018-00734-1).

Several other user-input options can be used to tune the OBBT algorithm.
For more details, see [Presolve Options](https://lanl-ansi.github.io/Alpine.jl/latest/parameters/#Presolve-Options).

"""
function optimization_based_bound_tightening(
    m::Optimizer;
    use_bound = true,
    time_limit = Inf,
    kwargs...,
)

    # Some functinal constants
    both_senses = [MOI.MIN_SENSE, MOI.MAX_SENSE]             # Senses during bound tightening procedures
    tell_side = Dict(MOI.MIN_SENSE => 1, MOI.MAX_SENSE => 2)     # Positional information
    tell_round = Dict(MOI.MIN_SENSE => floor, MOI.MAX_SENSE => ceil)

    options = Dict(kwargs)

    st = time() # Track start time
    if time_limit == Inf
        time_limit = get_option(m, :presolve_bt_time_limit)
    end

    # Regulating special input conditions: default use best feasible solution objective value
    (use_bound == true) ? bound = m.best_obj : bound = Inf
    l_var_orig = copy(m.l_var_tight)
    u_var_orig = copy(m.u_var_tight)

    discretization = _get_discretization_dict(m, m.l_var_tight, m.u_var_tight)
    if use_bound == false && haskey(options, :use_tmc)
        (get_option(m, :log_level) > 0) &&
            @warn " Local solve infeasible; defaulting to doing bound-tightening without partitions."
    end
    if use_bound == true && haskey(options, :use_tmc)
        discretization = add_adaptive_partition(
            m,
            use_solution = m.best_sol,
            use_disc = discretization,
        )
    end
    discretization = resolve_var_bounds(m, discretization) # recomputation of bounds for lifted_variables

    (get_option(m, :log_level) > 0) && println("  Starting bound-tightening")

    width_tol = get_option(m, :presolve_bt_width_tol)
    bound_tol = get_option(m, :presolve_bt_bound_tol)
    improv_tol = get_option(m, :presolve_bt_improv_tol)

    keep_tightening = true

    # start of the solve
    while keep_tightening &&
              (m.logs[:time_left] > get_option(m, :tol)) &&
              (m.logs[:bt_iter] < get_option(m, :presolve_bt_max_iter)) # Stopping criteria
        keep_tightening = false
        m.logs[:bt_iter] += 1
        get_option(m, :log_level) > 199 && println("  Iteration - $(m.logs[:bt_iter])")
        temp_bounds = Dict()

        avg_reduction = 0.0
        max_reduction = 0.0
        total_reduction = 0.0
        max_width = 0.0
        current_rel_gap = Inf

        # Sequential optimization-based bound tightening (OBBT)
        for var_idx in m.candidate_disc_vars
            temp_bounds[var_idx] =
                [discretization[var_idx][1], discretization[var_idx][end]]
            if (discretization[var_idx][end] - discretization[var_idx][1]) > width_tol
                create_obbt_model(m, discretization, bound)
                for sense in both_senses
                    JuMP.@objective(
                        m.model_mip,
                        sense,
                        _index_to_variable_ref(m.model_mip, var_idx)
                    )
                    stats = solve_obbt_model(m)
                    if stats["status"] in STATUS_OPT
                        temp_bounds[var_idx][tell_side[sense]] =
                            tell_round[sense](
                                JuMP.objective_value(m.model_mip) / bound_tol,
                            ) * bound_tol  # Objective truncation for numerical issues
                    elseif stats["status"] in STATUS_LIMIT
                        temp_bounds[var_idx][tell_side[sense]] =
                            tell_round[sense](
                                JuMP.objective_bound(m.model_mip) / bound_tol,
                            ) * bound_tol
                    elseif stats["status"] in STATUS_INF
                        @warn(
                            "Infeasible model detected within bound tightening - bounds not updated"
                        )
                    else
                        @warn("Unknown status within  bound tightening models")
                    end
                end
            end

            if (
                temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]] >
                temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]]
            )
                temp_bounds[var_idx] =
                    [discretization[var_idx][1], discretization[var_idx][end]]
            end
            if (
                temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]] >
                discretization[var_idx][end]
            )
                temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]] =
                    discretization[var_idx][1]
            end
            if (
                temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]] <
                discretization[var_idx][1]
            )
                temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]] =
                    discretization[var_idx][end]
            end

            bound_reduction = 0.0
            if (
                temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]] -
                temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]]
            ) <= width_tol
                midpoint = (temp_bounds[var_idx][1] + temp_bounds[var_idx][end]) / 2
                if (midpoint - discretization[var_idx][1] < width_tol / 2)
                    temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]] =
                        discretization[var_idx][1]
                    temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]] =
                        discretization[var_idx][1] + (width_tol)
                elseif (discretization[var_idx][end] - midpoint < width_tol / 2)
                    temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]] =
                        discretization[var_idx][end] - (width_tol)
                    temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]] =
                        discretization[var_idx][end]
                else
                    temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]] =
                        midpoint - (width_tol / 2)
                    temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]] =
                        midpoint + (width_tol / 2)
                end
            end

            new_range = round(
                temp_bounds[var_idx][tell_side[MOI.MAX_SENSE]] -
                temp_bounds[var_idx][tell_side[MOI.MIN_SENSE]],
                digits = 4,
            )
            old_range = discretization[var_idx][end] - discretization[var_idx][1]
            bound_reduction = old_range - new_range
            total_reduction += bound_reduction
            max_reduction = max(bound_reduction, max_reduction)
            max_width = max(new_range, max_width)

            (get_option(m, :log_level) > 99) && print("+")
            (get_option(m, :log_level) > 99) && println(
                "  VAR $(var_idx) LB contracted $(discretization[var_idx][1])=>$(temp_bounds[var_idx][1])",
            )
            (get_option(m, :log_level) > 99) && print("+")
            (get_option(m, :log_level) > 99) && println(
                "  VAR $(var_idx) UB contracted $(discretization[var_idx][end])=>$(temp_bounds[var_idx][end])",
            )

            discretization[var_idx][1] = temp_bounds[var_idx][1]
            discretization[var_idx][end] = temp_bounds[var_idx][end]
        end

        avg_reduction = total_reduction / length(keys(temp_bounds))

        bound_avg_reduction = (avg_reduction > improv_tol)
        bound_max_reduction = (max_reduction > improv_tol)
        bound_max_width = (max_width > width_tol)

        # Deactivate this termination criterion if it slows down the OBBT convergence
        stats = relaxation_model_obbt(m, discretization, bound)
        if is_min_sense(m)
            current_rel_gap = eval_opt_gap(m, stats["relaxed_obj"], bound)
        elseif is_max_sense(m)
            current_rel_gap = eval_opt_gap(m, bound, stats["relaxed_obj"])
        end

        keep_tightening =
            (bound_avg_reduction) &&
            (bound_max_reduction) &&
            (bound_max_width) &&
            (current_rel_gap > get_option(m, :rel_gap))

        if !isinf(current_rel_gap)
            m.presolve_best_rel_gap = current_rel_gap * 100
        end

        discretization = resolve_var_bounds(m, discretization)
        if haskey(options, :use_tmc)
            discretization = add_adaptive_partition(
                m,
                use_solution = m.best_sol,
                use_disc = flatten_discretization(discretization),
            )
        end

        time() - st > time_limit && break
    end

    (get_option(m, :log_level) > 1) && println("  Variables whose bounds were tightened:")
    (get_option(m, :log_level) > 0) &&
        println("  Actual iterations (OBBT): ", (m.logs[:bt_iter]))

    m.l_var_tight, m.u_var_tight = update_var_bounds(discretization)

    if haskey(options, :use_tmc)
        m.discretization = add_adaptive_partition(m, use_solution = m.best_sol)
    end

    for i in m.disc_vars
        contract_ratio =
            round(
                1 -
                abs(m.l_var_tight[i] - m.u_var_tight[i]) /
                abs(l_var_orig[i] - u_var_orig[i]);
                digits = 2,
            ) * 100
        if get_option(m, :log_level) > 0 && contract_ratio > 0.0001
            (get_option(m, :log_level) > 1) && (println(
                "    VAR $(i): $(contract_ratio)% contraction |$(round(l_var_orig[i]; digits=4)) --> | $(round(m.l_var_tight[i]; digits=4)) - $(round(m.u_var_tight[i]; digits=4)) | <-- $(round(u_var_orig[i]; digits=4)) |",
            ))
        end
    end
    return
end

"""
    create_obbt_model(m::Optimizer, discretization::Dict, bound::Float64)

This function takes in the initial discretization information and builds the OBBT model.
It is an algorithm specific function called by [`optimization_based_bound_tightening`](@ref).
"""
function create_obbt_model(m::Optimizer, discretization, bound::Number; kwargs...)

    # options = Dict(kwargs)
    start_build = time()
    m.model_mip = Model(get_option(m, :mip_solver)) # Construct JuMP model
    amp_post_vars(m, use_disc = discretization)
    amp_post_lifted_constraints(m)
    amp_post_convexification(m, use_disc = discretization)  # Convexify problem

    if !(isinf(bound))
        post_objective_bound(m, bound)
    else
        @warn "Dropping the objective bound constraint in presolve bound tightening"
    end

    cputime_build = time() - start_build
    m.logs[:total_time] += cputime_build
    m.logs[:time_left] = max(0.0, get_option(m, :time_limit) - m.logs[:total_time])

    return
end

function relaxation_model_obbt(m::Optimizer, discretization, bound::Number)
    create_obbt_model(m, discretization, bound)

    obj_expr = JuMP.@expression(
        m.model_mip,
        sum(
            m.bounding_obj_mip[:coefs][j] *
            _index_to_variable_ref(m.model_mip, m.bounding_obj_mip[:vars][j].args[2]) for
            j in 1:m.bounding_obj_mip[:cnt]
        ),
    )

    if is_min_sense(m)
        JuMP.@objective(m.model_mip, Min, obj_expr)
    elseif is_max_sense(m)
        JuMP.@objective(m.model_mip, Max, obj_expr)
    end

    return solve_obbt_model(m)
end

"""
    solve_obbt_model(m::Optimizer)

A function that solves the min and max OBBT model.
"""
function solve_obbt_model(m::Optimizer; kwargs...)
    stats = Dict()

    # ========= MILP Solve ========= #
    time_limit = max(
        0.0,
        if get_option(m, :presolve_bt_mip_time_limit) < Inf
            min(
                get_option(m, :presolve_bt_mip_time_limit),
                get_option(m, :time_limit) - m.logs[:total_time],
            )
        else
            get_option(m, :time_limit) - m.logs[:total_time]
        end,
    )
    MOI.set(m.model_mip, MOI.TimeLimitSec(), time_limit)

    start_solve = time()
    if get_option(m, :presolve_bt_relax_integrality)
        JuMP.relax_integrality(m.model_mip)
    end

    JuMP.optimize!(m.model_mip)
    status = MOI.get(m.model_mip, MOI.TerminationStatus())

    stats["status"] = status
    stats["relaxed_obj"] = JuMP.objective_value(m.model_mip)

    cputime_solve = time() - start_solve
    m.logs[:total_time] += cputime_solve
    m.logs[:time_left] = max(0.0, get_option(m, :time_limit) - m.logs[:total_time])
    # ========= MILP Solve ========= #

    return stats
end

"""
    post_objective_bound(m::Optimizer, bound::Float64; kwargs...)

This function adds the upper/lower bounding constraint on the objective function
for the optimization models solved within the OBBT algorithm.
"""
function post_objective_bound(m::Optimizer, bound::Number; kwargs...)
    obj_expr = JuMP.@expression(
        m.model_mip,
        sum(
            m.bounding_obj_mip[:coefs][j] *
            _index_to_variable_ref(m.model_mip, m.bounding_obj_mip[:vars][j].args[2]) for
            j in 1:m.bounding_obj_mip[:cnt]
        ),
    )

    obj_bound_tol = get_option(m, :presolve_bt_obj_bound_tol)

    if is_max_sense(m)
        JuMP.@constraint(
            m.model_mip,
            obj_expr >= floor(bound / obj_bound_tol) * obj_bound_tol
        )
    elseif is_min_sense(m)
        JuMP.@constraint(
            m.model_mip,
            obj_expr <= ceil(bound / obj_bound_tol) * obj_bound_tol
        )
    end

    return
end

# Alpine's Documentation

```@meta
CurrentModule = Alpine
```
## Overview
**[Alpine](https://github.com/lanl-ansi/Alpine.jl)** is a Julia/JuMP-based global optimization solver for non-convex programs. Alpine applies a two-stage approach to strengthen piecewise convex relaxations for mixed-integer nonlinear programs (MINLP) with multi-linear terms. In the first stage, Alpine exploits Constraint Programing techniques to contract the variable bounds. Further, it applies optimality-based bound tightening (OBBT) methods iteratively until a fixed point with respect to the bounds are achieved. In the second stage, Alpine partitions the variable domains using an adaptive multivariate partitioning scheme (a parametrized partition at the current solution of sequentially solved MILPs), leading to sparser but tighter relaxations. This approach decouples the number of partitions from the size of the variable domains, leading to a significant reduction in computation time, and limits the number of binary variables that are introduced by the partitioning. Alpine also applies polyhedral cutting plane methods to handle convex relaxations of higher-order monomial terms.

**Allowable nonlinearities**: Alpine can currently handle MINLPs with polynomials in constraints and/or in the objective. Currently, there is no support for exponential cones and Positive Semi-Definite (PSD) cones in MINLPs. Alpine is also a good fit for subsets of the MINLP family, e.g., Mixed-Integer Quadratically Constrainted Quadradic Programs (MIQCQPs), Non-Linear Programs (NLPs), etc.

For more details, check out this [video](https://www.youtube.com/watch?v=mwkhiEIS5JA) on Alpine at the [2nd Annual JuMP-dev Workshop](http://www.juliaopt.org/meetings/bordeaux2018/), held at the Institut de Mathématiques de Bordeaux, June 2018.

## Installation
To use Alpine, first [download and install](https://julialang.org/downloads/) Julia. Note that the current version of Alpine is compatible with Julia 1.0 and later. 

The latest stable release of Alpine can be installed using the Julia package manager with

```julia
import Pkg
Pkg.add("Alpine")
```

At least one local nonlinear-programming (NLP) solver and a convex mixed-integer programming (MIP) solver are required for running Alpine. If your problem is an NLP, we recommend [Ipopt](https://github.com/jump-dev/Ipopt.jl), and else if your problem is a mixed-integer NLP (MINLP), we recommend [Juniper](https://github.com/lanl-ansi/Juniper.jl). For the underlying MIP solver, [Gurobi](https://github.com/jump-dev/Gurobi.jl) is highly recommended, as it is fast, scaleable and can be used to solve on fairly large-scale non-convex programs. However, the open-source [HiGHS](https://github.com/jump-dev/HiGHS.jl) or [GLPK](https://github.com/jump-dev/GLPK.jl) solver is also compatible with Alpine. For example, Ipopt and Gurobi can be installed via the package manager with

```julia
import Pkg
Pkg.add("Ipopt")
Pkg.add("Gurobi")
```
For more details on choosing sub-solvers for Alpine, check out [here](https://lanl-ansi.github.io/Alpine.jl/latest/choosingsolver/). 

## Unit Tests
To run the tests in the package, run the following command after installing the Alpine package.

```julia
import Pkg
Pkg.test("Alpine")
```

## Citing Alpine
If you find Alpine useful in your work, we request you to cite the following paper [\[pdf\]](https://harshangrjn.github.io/pdf/JOGO_2018.pdf) [\[pdf\]](http://harshangrjn.github.io/pdf/CP_2016.pdf): 
```bibtex
@article{alpine_JOGO2019,
  title = {An adaptive, multivariate partitioning algorithm for global optimization of nonconvex programs},
  author = {Nagarajan, Harsha and Lu, Mowen and Wang, Site and Bent, Russell and Sundar, Kaarthik},
  journal = {Journal of Global Optimization},
  year = {2019},
  issn = {1573-2916},
  doi = {10.1007/s10898-018-00734-1},
}

@inproceedings{alpine_CP2016,
  title = {Tightening {McCormick} relaxations for nonlinear programs via dynamic multivariate partitioning},
  author = {Nagarajan, Harsha and Lu, Mowen and Yamangil, Emre and Bent, Russell},
  booktitle = {International Conference on Principles and Practice of Constraint Programming},
  pages = {369--387},
  year = {2016},
  organization = {Springer},
  doi = {10.1007/978-3-319-44953-1_24},
}
```
If you find the underlying piecewise polyhedral formulations implemented in Alpine useful in your work, we kindly request that you cite the following papers ([link-1](https://doi.org/10.1016/j.orl.2020.12.002), [link-2](http://www.optimization-online.org/DB_HTML/2022/07/8974.html)): 
```bibtex
@article{alpine_ORL2021,
  title = {Piecewise polyhedral formulations for a multilinear term},
  author = {Sundar, Kaarthik and Nagarajan, Harsha and Linderoth, Jeff and Wang, Site and Bent, Russell},
  journal = {Operations Research Letters},
  volume = {49},
  number = {1},
  pages = {144--149},
  year = {2021},
  publisher = {Elsevier}
}

@article{alpine_OptOnline2022,
  title={Piecewise Polyhedral Relaxations of Multilinear Optimization},
  author={Kim, Jongeun and Richard, Jean-Philippe P. and Tawarmalani, Mohit},
  eprinttype={Optimization Online},
  date={2022}
}
```

If you find the random families of non-convex QCQP instances (using generator files within this [folder](https://github.com/lanl-ansi/Alpine.jl/tree/master/examples/random_QCQPs)) useful for your research, we kindly request that you cite the following paper [arXiv link](https://arxiv.org/abs/2301.00306):
```bibtex
@article{alpine_learning_2022,
  title={Learning to Accelerate the Global Optimization of Quadratically-Constrained Quadratic Programs},
  author={Kannan, Rohit and Nagarajan, Harsha and Deka, Deepjyoti},
  journal={arXiv preprint:2301.00306},
  url={https://arxiv.org/abs/2301.00306},
  year={2022}
}
```

# Solver options for Alpine

```@meta
CurrentModule = Alpine
```

## General Options

Here are a few general solver options which control the performance of Alpine:

* `log_level (default = 0)`: verbosity level of Alpine; choose `1` for turning on logging, else `100` for detailed debugging mode.

* `time_limit (default = Inf)`: total limit on run time for Alpine in seconds.

* `max_iter (default = 999)`: total number of iterations allowed in the [`global_solve`](@ref).

* `rel_gap (default = 1e-4)`: relative gap considered for global convergence during [`global_solve`](@ref). Bounds are evaluated using ``\frac{UB-LB}{UB} \cdot 100 \%``.

* `tol (default = 1e-6)`: numerical tolerance used during the process of [`global_solve`](@ref).

## Adaptive Partitioning Options
* `apply_partitioning (default = true)`: applies Alpine's built-in MIP-based partitioning algorithm only when activated; else terminates with the presolve solution.

* `partition_scaling_factor (default = 10)`: used during [`add_adaptive_partition`](@ref) for scaling the width of new partitions relative to the active partition chosen in the sequentially-solved lower-bounding MIP models. This value can substantially affect the run time for global convergence; this value can be set to different integer values (>= 4) for various classes of problems.

* `disc_var_pick (default = 0)`: controls Alpine's algorithm used for selecting variables for partitioning; `0` is for max-cover, `1` is for minimum-vertex-cover. This parameter allows functional inputs.

* `disc_add_partition_method`: allows functional input on how new partitions could be constructed.

## Presolve Options

* `presolve_track_time (default = true)`: includes/excludes presolve run time in the total Alpine's run time.

* `presolve_bt (default = false)`: performs sequential, optimization-based bound tightening (OBBT) at the presolve step.

* `presolve_bt_max_iter (default = 9999)`: maximum number of iterations allowed using the sequential OBBT step.

* `presolve_bt_width_tol (default = 1e-3)`: numerical tolerance value used in the OBBT step. Note that smaller values of this tolerance can lead to inaccurate solutions.

* `presolve_bt_algo (default = 1)`: method chosen to perform the presolve step; choose `1` for the built-in OBBT, else `2` for user-input functions for presolve.

* `presolve_bt_relax_integrality (default = false)`: relaxes the integrality of the existing integer variables in the OBBT step, if the input problem is an MINLP.

* `presolve_bt_mip_time_limit (default = Inf)`: time limit for individual MILPs solved during the sequential OBBT procedure.

* `use_start_as_incumbent (default = false)`: if `true`, Alpine does not perform any local optimization during the presolve and uses the starting value instead (*warning*: Alpine assumes the feasibility of the starting value and does not check it).

Note that the above-mentioned list of solver options is not comprehensive, but can be found in [solver.jl](https://github.com/lanl-ansi/Alpine.jl/blob/master/src/solver.jl).

# Choosing Sub-Solvers

```@meta
CurrentModule = Alpine
```

Alpine's global optimization algorithm requires a few types of optimization problems to be solved efficiently. For its best performance, it is recommended that a dedicated solver is used for these purposes. The design of Alpine takes advantage of [MathOptInterface](https://github.com/jump-dev/MathOptInterface.jl) to seemlessly interface with a majority of optimization software. Currently, the following sub-solvers with Julia Interface are supported by Alpine:

| Solver                                                                         | Julia Package                                                |
|--------------------------------------------------------------------------------|--------------------------------------------------------------|
| [CPLEX](http://www-01.ibm.com/software/commerce/optimization/cplex-optimizer/) | [CPLEX.jl](https://github.com/JuliaOpt/CPLEX.jl)             |
| [Cbc](https://projects.coin-or.org/Cbc)                                        | [Cbc.jl](https://github.com/JuliaOpt/Clp.jl)                 |
| [Gurobi](http://gurobi.com/)                                                   | [Gurobi.jl](https://github.com/JuliaOpt/Gurobi.jl)           |
| [Ipopt](https://projects.coin-or.org/Ipopt)                                    | [Ipopt.jl](https://github.com/JuliaOpt/Ipopt.jl)             |
| [Bonmin](https://projects.coin-or.org/Bonmin)                                  | [Bonmin.jl](https://github.com/JackDunnNZ/AmplNLWriter.jl)   |
| [Artelys KNITRO](http://artelys.com/en/optimization-tools/knitro)              | [KNITRO.jl](https://github.com/JuliaOpt/KNITRO.jl)           |

As the development of Alpine continues, supports for solvers such as [Mosek](http://www.mosek.com/), [GLPK](http://www.gnu.org/software/glpk/), [NLopt](http://ab-initio.mit.edu/wiki/index.php/NLopt) and [Xpress](http://www.fico.com/en/products/fico-xpress-optimization-suite) are in the development roadmap.

!!! tip
    Performance of Alpine is significantly faster and robust while using [Gurobi](https://www.gurobi.com) as the underlying convex mixed-integer programming (MIP) solver. Note that Gurobi's individual-usage license is available [free](https://www.gurobi.com/academia/academic-program-and-licenses/) for academic purposes. 

To solve any continuous nonlinear program to global optimality, here is an example to utilize different sub-solvers with default options set for Alpine:

```julia
using Alpine
using JuMP 
using Gurobi 
using Ipopt

# MIP optimizer
const gurobi = optimizer_with_attributes(Gurobi.Optimizer, 
                                         MOI.Silent() => true,
                                         "Presolve"   => 1) 

# NLP optimizer
const ipopt = optimizer_with_attributes(Ipopt.Optimizer, 
                                        MOI.Silent() => true, 
                                        "sb" => "yes", 
                                        "max_iter"   => 9999)

# Global optimizer
const alpine = optimizer_with_attributes(Alpine.Optimizer, 
                                         "nlp_solver" => ipopt,
                                         "mip_solver" => gurobi)
m = Model(alpine)
```
Similarly, many such optimizer options and nonconvex problems (both NLPs and MINLPs) can be found in the [examples](https://github.com/lanl-ansi/Alpine.jl/tree/master/examples) folder. 

# Demo

```@meta
CurrentModule = Alpine
```

Consider the following [problem](https://link.springer.com/article/10.1007/s10898-012-0022-1) as an example.

```math
\min_{x}\, &c^Tx\\
s.t.     &a_i^Tx \text{ sense}_i \, b_i \forall\,\, i\\
         &l \leq x \leq u\\
```

# Functions

```@meta
CurrentModule = Alpine
```

## High-level Algorithmic Functions
These are the high-level algorithmic functions:
```@docs
presolve
global_solve
local_solve
bounding_solve
```

## Adapative Partitioning Methods
```@docs
create_bounding_mip
pick_disc_vars
fix_domains
min_vertex_cover
```

## Presolve Methods
```@docs
bound_tightening_wrapper
optimization_based_bound_tightening
create_obbt_model
solve_obbt_model
resolve_var_bounds
post_objective_bound
```

## Utility Methods
```@docs
update_var_bounds
discretization_to_bounds
init_disc
_get_discretization_dict
flatten_discretization
add_adaptive_partition
```
